/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/arrays","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","os","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","child_process","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/configuration/common/configurationRegistry","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","https","string_decoder","vs/code/electron-main/main"],te=function(G){for(var e=[],E=0,L=G.length;E<L;E++)e[E]=ee[G[E]];return e};define(ee[125],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,d){const c=Math.pow(10,d);return Math.round(P*c)/c}class L{constructor(d,c,p,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=E(Math.max(Math.min(1,m),0),3)}static equals(d,c){return d.r===c.r&&d.g===c.g&&d.b===c.b&&d.a===c.a}}e.RGBA=L;class n{constructor(d,c,p,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,c),0),3),this.l=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.l===c.l&&d.a===c.a}static fromRGBA(d){const c=d.r/255,p=d.g/255,m=d.b/255,b=d.a,f=Math.max(c,p,m),S=Math.min(c,p,m);let w=0,r=0;const g=(S+f)/2,l=f-S;if(l>0){switch(r=Math.min(g<=.5?l/(2*g):l/(2-2*g),1),f){case c:w=(p-m)/l+(p<m?6:0);break;case p:w=(m-c)/l+2;break;case m:w=(c-p)/l+4;break}w*=60,w=Math.round(w)}return new n(w,r,g,b)}static i(d,c,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?d+(c-d)*6*p:p<1/2?c:p<2/3?d+(c-d)*(2/3-p)*6:d}static toRGBA(d){const c=d.h/360,{s:p,l:m,a:b}=d;let f,S,w;if(p===0)f=S=w=m;else{const r=m<.5?m*(1+p):m+p-m*p,g=2*m-r;f=n.i(g,r,c+1/3),S=n.i(g,r,c),w=n.i(g,r,c-1/3)}return new L(Math.round(f*255),Math.round(S*255),Math.round(w*255),b)}}e.HSLA=n;class A{constructor(d,c,p,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,c),0),3),this.v=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.v===c.v&&d.a===c.a}static fromRGBA(d){const c=d.r/255,p=d.g/255,m=d.b/255,b=Math.max(c,p,m),f=Math.min(c,p,m),S=b-f,w=b===0?0:S/b;let r;return S===0?r=0:b===c?r=((p-m)/S%6+6)%6:b===p?r=(m-c)/S+2:r=(c-p)/S+4,new A(Math.round(r*60),w,b,d.a)}static toRGBA(d){const{h:c,s:p,v:m,a:b}=d,f=m*p,S=f*(1-Math.abs(c/60%2-1)),w=m-f;let[r,g,l]=[0,0,0];return c<60?(r=f,g=S):c<120?(r=S,g=f):c<180?(g=f,l=S):c<240?(g=S,l=f):c<300?(r=S,l=f):c<=360&&(r=f,l=S),r=Math.round((r+w)*255),g=Math.round((g+w)*255),l=Math.round((l+w)*255),new L(r,g,l,b)}}e.HSVA=A;class R{static fromHex(d){return R.Format.CSS.parseHex(d)||R.red}static equals(d,c){return!d&&!c?!0:!d||!c?!1:d.equals(c)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof L)this.rgba=d;else if(d instanceof n)this.i=d,this.rgba=n.toRGBA(d);else if(d instanceof A)this.j=d,this.rgba=A.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&L.equals(this.rgba,d.rgba)&&n.equals(this.hsla,d.hsla)&&A.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=R.k(this.rgba.r),c=R.k(this.rgba.g),p=R.k(this.rgba.b),m=.2126*d+.7152*c+.0722*p;return E(m,4)}static k(d){const c=d/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(d){const c=this.getRelativeLuminance(),p=d.getRelativeLuminance();return c>p?(c+.05)/(p+.05):(p+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const c=this.getRelativeLuminance(),p=d.getRelativeLuminance();return c>p}isDarkerThan(d){const c=this.getRelativeLuminance(),p=d.getRelativeLuminance();return c<p}lighten(d){return new R(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new R(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:c,g:p,b:m,a:b}=this.rgba;return new R(new L(c,p,m,b*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const c=d.rgba,p=this.rgba.a,m=c.a,b=p+m*(1-p);if(b<1e-6)return R.transparent;const f=this.rgba.r*p/b+c.r*m*(1-p)/b,S=this.rgba.g*p/b+c.g*m*(1-p)/b,w=this.rgba.b*p/b+c.b*m*(1-p)/b;return new R(new L(f,S,w,b))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:c,g:p,b:m,a:b}=this.rgba;return new R(new L(d.rgba.r-b*(d.rgba.r-c),d.rgba.g-b*(d.rgba.g-p),d.rgba.b-b*(d.rgba.b-m),1))}flatten(...d){const c=d.reduceRight((p,m)=>R.o(m,p));return R.o(this,c)}static o(d,c){const p=1-d.rgba.a;return new R(new L(p*c.rgba.r+d.rgba.a*d.rgba.r,p*c.rgba.g+d.rgba.a*d.rgba.g,p*c.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(d,c,p){if(d.isLighterThan(c))return d;p=p||.5;const m=d.getRelativeLuminance(),b=c.getRelativeLuminance();return p=p*(b-m)/b,d.lighten(p)}static getDarkerColor(d,c,p){if(d.isDarkerThan(c))return d;p=p||.5;const m=d.getRelativeLuminance(),b=c.getRelativeLuminance();return p=p*(m-b)/m,d.darken(p)}}e.Color=R,R.white=new R(new L(255,255,255,1)),R.black=new R(new L(0,0,0,1)),R.red=new R(new L(255,0,0,1)),R.blue=new R(new L(0,0,255,1)),R.green=new R(new L(0,255,0,1)),R.cyan=new R(new L(0,255,255,1)),R.lightgrey=new R(new L(211,211,211,1)),R.transparent=new R(new L(0,0,0,0)),function(P){let d;(function(c){let p;(function(m){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}m.formatRGB=b;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=f;function S(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}m.formatHSL=S;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=w;function r(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function g(t){return`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}`}m.formatHex=g;function l(t,a=!1){return a&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}${r(Math.round(t.rgba.a*255))}`}m.formatHexA=l;function v(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}m.format=v;function y(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),s=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new P(new L(i,s,o,1))}if(a===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),s=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),u=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new P(new L(i,s,o,u/255))}if(a===4){const i=D(t.charCodeAt(1)),s=D(t.charCodeAt(2)),o=D(t.charCodeAt(3));return new P(new L(16*i+i,16*s+s,16*o+o))}if(a===5){const i=D(t.charCodeAt(1)),s=D(t.charCodeAt(2)),o=D(t.charCodeAt(3)),u=D(t.charCodeAt(4));return new P(new L(16*i+i,16*s+s,16*o+o,(16*u+u)/255))}return null}m.parseHex=y;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=c.CSS||(c.CSS={}))})(d=P.Format||(P.Format={}))}(R||(e.Color=R={}))}),define(ee[55],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(R){return(P,d,c)=>{let p=null,m=null;if(typeof c.value=="function"?(p="value",m=c.value):typeof c.get=="function"&&(p="get",m=c.get),!m)throw new Error("not supported");c[p]=R(m,d)}}function L(R,P,d){let c=null,p=null;if(typeof d.value=="function"?(c="value",p=d.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",p=d.get),!p)throw new Error("not supported");const m=`$memoize$${P}`;d[c]=function(...b){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,b)}),this[m]}}e.memoize=L;function n(R,P,d){return E((c,p)=>{const m=`$debounce$${p}`,b=`$debounce$result$${p}`;return function(...f){this[b]||(this[b]=d?d():void 0),clearTimeout(this[m]),P&&(this[b]=P(this[b],...f),f=[this[b]]),this[m]=setTimeout(()=>{c.apply(this,f),this[b]=d?d():void 0},R)}})}e.debounce=n;function A(R,P,d){return E((c,p)=>{const m=`$throttle$timer$${p}`,b=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,S=`$throttle$pending$${p}`;return function(...w){if(this[b]||(this[b]=d?d():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...w)),this[S])return;const r=this[f]+R;r<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[b]]),this[b]=d?d():void 0):(this[S]=!0,this[m]=setTimeout(()=>{this[S]=!1,this[f]=Date.now(),c.apply(this,[this[b]]),this[b]=d?d():void 0},r-Date.now()))}})}e.throttle=A}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?y.isErrorNoTelemetry(a)?new y(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=E,e.errorHandler=new E;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function n(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function A(t){c(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function R(t){c(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function P(t){if(t instanceof Error){const{name:a,message:i}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:s,noTelemetry:y.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const d="Canceled";function c(t){return t instanceof p?!0:t instanceof Error&&t.name===d&&t.message===d}e.isCancellationError=c;class p extends Error{constructor(){super(d),this.name=this.message}}e.CancellationError=p;function m(){const t=new Error(d);return t.name=t.message,t}e.canceled=m;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function f(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=f;function S(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function w(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=w;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class g extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=g;class l extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=l;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class y extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof y)return a;const i=new y;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class D extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(ee[23],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L($,x=0){return $[$.length-(1+x)]}e.tail=L;function n($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=n;function A($,x,K=(se,de)=>se===de){if($===x)return!0;if(!$||!x||$.length!==x.length)return!1;for(let se=0,de=$.length;se<de;se++)if(!K($[se],x[se]))return!1;return!0}e.equals=A;function R($,x){const K=$.length-1;x<K&&($[x]=$[K]),$.pop()}e.removeFastWithoutKeepingOrder=R;function P($,x,K){return d($.length,se=>K($[se],x))}e.binarySearch=P;function d($,x){let K=0,se=$-1;for(;K<=se;){const de=(K+se)/2|0,Ee=x(de);if(Ee<0)K=de+1;else if(Ee>0)se=de-1;else return de}return-(K+1)}e.binarySearch2=d;function c($,x){let K=0,se=$.length;if(se===0)return 0;for(;K<se;){const de=Math.floor((K+se)/2);x($[de])?se=de:K=de+1}return K}e.findFirstInSorted=c;function p($,x,K){if($=$|0,$>=x.length)throw new TypeError("invalid index");const se=x[Math.floor(x.length*Math.random())],de=[],Ee=[],De=[];for(const Se of x){const Ae=K(Se,se);Ae<0?de.push(Se):Ae>0?Ee.push(Se):De.push(Se)}return $<de.length?p($,de,K):$<de.length+De.length?De[0]:p($-(de.length+De.length),Ee,K)}e.quickSelect=p;function m($,x){const K=[];let se;for(const de of $.slice(0).sort(x))!se||x(se[0],de)!==0?(se=[de],K.push(se)):se.push(de);return K}e.groupBy=m;function b($,x,K){const se=[];function de(Se,Ae,ze){if(Ae===0&&ze.length===0)return;const ge=se[se.length-1];ge&&ge.start+ge.deleteCount===Se?(ge.deleteCount+=Ae,ge.toInsert.push(...ze)):se.push({start:Se,deleteCount:Ae,toInsert:ze})}let Ee=0,De=0;for(;;){if(Ee===$.length){de(Ee,0,x.slice(De));break}if(De===x.length){de(Ee,$.length-Ee,[]);break}const Se=$[Ee],Ae=x[De],ze=K(Se,Ae);ze===0?(Ee+=1,De+=1):ze<0?(de(Ee,1,[]),Ee+=1):ze>0&&(de(Ee,0,[Ae]),De+=1)}return se}e.sortedDiff=b;function f($,x,K){const se=b($,x,K),de=[],Ee=[];for(const De of se)de.push(...$.slice(De.start,De.start+De.deleteCount)),Ee.push(...De.toInsert);return{removed:de,added:Ee}}e.delta=f;function S($,x,K){if(K===0)return[];const se=$.slice(0,K).sort(x);return r($,x,se,K,$.length),se}e.top=S;function w($,x,K,se,de){return K===0?Promise.resolve([]):new Promise((Ee,De)=>{(async()=>{const Se=$.length,Ae=$.slice(0,K).sort(x);for(let ze=K,ge=Math.min(K+se,Se);ze<Se;ze=ge,ge=Math.min(ge+se,Se)){if(ze>K&&await new Promise(we=>setTimeout(we)),de&&de.isCancellationRequested)throw new E.CancellationError;r($,x,Ae,ze,ge)}return Ae})().then(Ee,De)})}e.topAsync=w;function r($,x,K,se,de){for(const Ee=K.length;se<de;se++){const De=$[se];if(x(De,K[Ee-1])<0){K.pop();const Se=c(K,Ae=>x(De,Ae)<0);K.splice(Se,0,De)}}}function g($){return $.filter(x=>!!x)}e.coalesce=g;function l($){let x=0;for(let K=0;K<$.length;K++)$[K]&&($[x]=$[K],x+=1);$.length=x}e.coalesceInPlace=l;function v($,x,K){$.splice(K,0,$.splice(x,1)[0])}e.move=v;function y($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=y;function D($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=D;function t($,x=K=>K){const K=new Set;return $.filter(se=>{const de=x(se);return K.has(de)?!1:(K.add(de),!0)})}e.distinct=t;function a($){const x=new Set;return K=>{const se=$(K);return x.has(se)?!1:(x.add(se),!0)}}e.uniqueFilter=a;function i($,x){const K=s($,x);if(K!==-1)return $[K]}e.findLast=i;function s($,x){for(let K=$.length-1;K>=0;K--){const se=$[K];if(x(se))return K}return-1}e.lastIndex=s;function o($,x){return $.length>0?$[0]:x}e.firstOrDefault=o;function u($,x){return $.length>0?$[$.length-1]:x}e.lastOrDefault=u;function h($,x,K=(se,de)=>se===de){let se=0;for(let de=0,Ee=Math.min($.length,x.length);de<Ee&&K($[de],x[de]);de++)se++;return se}e.commonPrefixLength=h;function I($){return[].concat(...$)}e.flatten=I;function M($,x){let K=typeof x=="number"?$:0;typeof x=="number"?K=$:(K=0,x=$);const se=[];if(K<=x)for(let de=K;de<x;de++)se.push(de);else for(let de=K;de>x;de--)se.push(de);return se}e.range=M;function C($,x,K){return $.reduce((se,de)=>(se[x(de)]=K?K(de):de,se),Object.create(null))}e.index=C;function O($,x){return $.push(x),()=>W($,x)}e.insert=O;function W($,x){const K=$.indexOf(x);if(K>-1)return $.splice(K,1),x}e.remove=W;function q($,x,K){const se=$.slice(0,x),de=$.slice(x);return se.concat(K,de)}e.arrayInsert=q;function V($,x){let K;if(typeof x=="number"){let se=x;K=()=>{const de=Math.sin(se++)*179426549;return de-Math.floor(de)}}else K=Math.random;for(let se=$.length-1;se>0;se-=1){const de=Math.floor(K()*(se+1)),Ee=$[se];$[se]=$[de],$[de]=Ee}}e.shuffle=V;function _($,x){const K=$.indexOf(x);K>-1&&($.splice(K,1),$.unshift(x))}e.pushToStart=_;function ne($,x){const K=$.indexOf(x);K>-1&&($.splice(K,1),$.push(x))}e.pushToEnd=ne;function re($,x){for(const K of x)$.push(K)}e.pushMany=re;function ue($,x){return Array.isArray($)?$.map(x):x($)}e.mapArrayOrNot=ue;function ce($){return Array.isArray($)?$:[$]}e.asArray=ce;function J($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=J;function H($,x){for(const K of $){const se=x(K);if(se!==void 0)return se}}e.mapFind=H;function j($,x,K){const se=X($,x),de=$.length,Ee=K.length;$.length=de+Ee;for(let De=de-1;De>=se;De--)$[De+Ee]=$[De];for(let De=0;De<Ee;De++)$[De+se]=K[De]}e.insertInto=j;function z($,x,K,se){const de=X($,x),Ee=$.splice(de,K);return j($,de,se),Ee}e.splice=z;function X($,x){return x<0?Math.max(x+$.length,0):Math.min(x,$.length)}var Z;(function($){function x(de){return de<0}$.isLessThan=x;function K(de){return de>0}$.isGreaterThan=K;function se(de){return de===0}$.isNeitherLessOrGreaterThan=se,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function oe($,x){return(K,se)=>x($(K),$(se))}e.compareBy=oe;function ae(...$){return(x,K)=>{for(const se of $){const de=se(x,K);if(!Z.isNeitherLessOrGreaterThan(de))return de}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const B=($,x)=>$-x;e.numberComparator=B;function T($,x){if($.length===0)return;let K=$[0];for(let se=1;se<$.length;se++){const de=$[se];x(de,K)>0&&(K=de)}return K}e.findMaxBy=T;function k($,x){if($.length===0)return;let K=$[0];for(let se=1;se<$.length;se++){const de=$[se];x(de,K)>=0&&(K=de)}return K}e.findLastMaxBy=k;function F($,x){return T($,(K,se)=>-x(K,se))}e.findMinBy=F;class N{constructor(x){this.f=x,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(x){let K=this.c;for(;K<this.f.length&&x(this.f[K]);)K++;const se=K===this.c?null:this.f.slice(this.c,K);return this.c=K,se}takeFromEndWhile(x){let K=this.d;for(;K>=0&&x(this.f[K]);)K--;const se=K===this.d?null:this.f.slice(K+1,this.d+1);return this.d=K,se}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const x=this.f[this.c];return this.c++,x}removeLast(){const x=this.f[this.d];return this.d--,x}takeCount(x){const K=this.f.slice(this.c,this.c+x);return this.c+=x,K}}e.ArrayQueue=N;class U{constructor(x){this.iterate=x}forEach(x){this.iterate(K=>(x(K),!0))}toArray(){const x=[];return this.iterate(K=>(x.push(K),!0)),x}filter(x){return new U(K=>this.iterate(se=>x(se)?K(se):!0))}map(x){return new U(K=>this.iterate(se=>K(x(se))))}some(x){let K=!1;return this.iterate(se=>(K=x(se),!K)),K}findFirst(x){let K;return this.iterate(se=>x(se)?(K=se,!1):!0),K}findLast(x){let K;return this.iterate(se=>(x(se)&&(K=se),!0)),K}findLastMaxBy(x){let K,se=!0;return this.iterate(de=>((se||Z.isGreaterThan(x(de,K)))&&(se=!1,K=de),!0)),K}}e.CallbackIterable=U,U.empty=new U($=>{})}),define(ee[126],te([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=L;function n(d,c="Unreachable"){throw new Error(c)}e.assertNever=n;function A(d){if(!d)throw new E.BugIndicatingError("Assertion Failed")}e.assert=A;function R(d){if(!d()){debugger;d(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function P(d,c){let p=0;for(;p<d.length-1;){const m=d[p],b=d[p+1];if(!c(m,b))return!1;p++}return!0}e.checkAdjacentItems=P}),define(ee[48],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(L){const n=this;let A=!1,R;return function(){return A||(A=!0,R=L.apply(n,arguments)),R}}e.once=E}),define(ee[68],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(L){function n(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}L.is=n;const A=Object.freeze([]);function R(){return A}L.empty=R;function*P(y){yield y}L.single=P;function d(y){return n(y)?y:P(y)}L.wrap=d;function c(y){return y||A}L.from=c;function p(y){return!y||y[Symbol.iterator]().next().done===!0}L.isEmpty=p;function m(y){return y[Symbol.iterator]().next().value}L.first=m;function b(y,D){for(const t of y)if(D(t))return!0;return!1}L.some=b;function f(y,D){for(const t of y)if(D(t))return t}L.find=f;function*S(y,D){for(const t of y)D(t)&&(yield t)}L.filter=S;function*w(y,D){let t=0;for(const a of y)yield D(a,t++)}L.map=w;function*r(...y){for(const D of y)for(const t of D)yield t}L.concat=r;function g(y,D,t){let a=t;for(const i of y)a=D(a,i);return a}L.reduce=g;function*l(y,D,t=y.length){for(D<0&&(D+=y.length),t<0?t+=y.length:t>y.length&&(t=y.length);D<t;D++)yield y[D]}L.slice=l;function v(y,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,y];const a=y[Symbol.iterator]();for(let i=0;i<D;i++){const s=a.next();if(s.done)return[t,L.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return a}}]}L.consume=v})(E||(e.Iterable=E={}))}),define(ee[43],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n||(e.ParseErrorCode=n={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,a=!1){let i=0;const s=t.length;let o="",u=0,h=16,I=0;function M(ne){let re=0,ue=0;for(;re<ne;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)ue=ue*16+ce-48;else if(ce>=65&&ce<=70)ue=ue*16+ce-65+10;else if(ce>=97&&ce<=102)ue=ue*16+ce-97+10;else break;i++,re++}return re<ne&&(ue=-1),ue}function C(ne){i=ne,o="",u=0,h=16,I=0}function O(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return I=3,t.substring(ne,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;re=i}else I=3;return t.substring(ne,re)}function W(){let ne="",re=i;for(;;){if(i>=s){ne+=t.substring(re,i),I=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(re,i),i++;break}if(ue===92){if(ne+=t.substring(re,i),i++,i>=s){I=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const J=M(4);J>=0?ne+=String.fromCharCode(J):I=4;break}default:I=5}re=i;continue}if(ue>=0&&ue<=31)if(d(ue)){ne+=t.substring(re,i),I=2;break}else I=6;i++}return ne}function q(){if(o="",I=0,u=i,i>=s)return u=s,h=17;let ne=t.charCodeAt(i);if(P(ne)){do i++,o+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(P(ne));return h=15}if(d(ne))return i++,o+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),h=14;switch(ne){case 123:return i++,h=1;case 125:return i++,h=2;case 91:return i++,h=3;case 93:return i++,h=4;case 58:return i++,h=6;case 44:return i++,h=5;case 34:return i++,o=W(),h=10;case 47:{const re=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!d(t.charCodeAt(i));)i++;return o=t.substring(re,i),h=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=s-1;let ce=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,I=1),o=t.substring(re,i),h=13}return o+=String.fromCharCode(ne),i++,h=16}case 45:if(o+=String.fromCharCode(ne),i++,i===s||!c(t.charCodeAt(i)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),h=11;default:for(;i<s&&V(ne);)i++,ne=t.charCodeAt(i);if(u!==i){switch(o=t.substring(u,i),o){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return o+=String.fromCharCode(ne),i++,h=16}}function V(ne){if(P(ne)||d(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let ne;do ne=q();while(ne>=12&&ne<=15);return ne}return{setPosition:C,getPosition:()=>i,scan:a?_:q,getToken:()=>h,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>I}}e.createScanner=R;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function m(t,a){const i=[],s=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function I(M,C,O,W){u.value=M,u.offset=C,u.length=O,u.type=W,u.colonOffset=void 0,o=u}try{v(t,{onObjectBegin:(M,C)=>{if(a<=M)throw s;o=void 0,h=a>M,i.push("")},onObjectProperty:(M,C,O)=>{if(a<C||(I(M,C,O,"property"),i[i.length-1]=M,a<=C+O))throw s},onObjectEnd:(M,C)=>{if(a<=M)throw s;o=void 0,i.pop()},onArrayBegin:(M,C)=>{if(a<=M)throw s;o=void 0,i.push(0)},onArrayEnd:(M,C)=>{if(a<=M)throw s;o=void 0,i.pop()},onLiteralValue:(M,C,O)=>{if(a<C||(I(M,C,O,D(M)),a<=C+O))throw s},onSeparator:(M,C,O)=>{if(a<=C)throw s;if(M===":"&&o&&o.type==="property")o.colonOffset=C,h=!1,o=void 0;else if(M===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(h=!0,i[i.length-1]=""),o=void 0}}})}catch(M){if(M!==s)throw M}return{path:i,previousNode:o,isAtPropertyKey:h,matches:M=>{let C=0;for(let O=0;C<M.length&&O<i.length;O++)if(M[C]===i[O]||M[C]==="*")C++;else if(M[C]!=="**")return!1;return C===M.length}}}e.getLocation=m;function b(t,a=[],i=A.DEFAULT){let s=null,o=[];const u=[];function h(M){Array.isArray(o)?o.push(M):s!==null&&(o[s]=M)}return v(t,{onObjectBegin:()=>{const M={};h(M),u.push(o),o=M,s=null},onObjectProperty:M=>{s=M},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const M=[];h(M),u.push(o),o=M,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:h,onError:(M,C,O)=>{a.push({error:M,offset:C,length:O})}},i),o[0]}e.parse=b;function f(t,a=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){s.type==="property"&&(s.length=M-s.offset,s=s.parent)}function u(M){return s.children.push(M),M}v(t,{onObjectBegin:M=>{s=u({type:"object",offset:M,length:-1,parent:s,children:[]})},onObjectProperty:(M,C,O)=>{s=u({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:M,offset:C,length:O,parent:s})},onObjectEnd:(M,C)=>{s.length=M+C-s.offset,s=s.parent,o(M+C)},onArrayBegin:(M,C)=>{s=u({type:"array",offset:M,length:-1,parent:s,children:[]})},onArrayEnd:(M,C)=>{s.length=M+C-s.offset,s=s.parent,o(M+C)},onLiteralValue:(M,C,O)=>{u({type:D(M),offset:C,length:O,parent:s,value:M}),o(C+O)},onSeparator:(M,C,O)=>{s.type==="property"&&(M===":"?s.colonOffset=C:M===","&&o(C))},onError:(M,C,O)=>{a.push({error:M,offset:C,length:O})}},i);const I=s.children[0];return I&&delete I.parent,I}e.parseTree=f;function S(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===s){i=u.children[1],o=!0;break}if(!o)return}else{const o=s;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=S;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=w;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=r(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function g(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=g;function l(t,a,i=!1){if(g(t,a,i)){const s=t.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=a;o++){const u=l(s[o],a,i);if(u)return u}return t}}e.findNodeAtOffset=l;function v(t,a,i=A.DEFAULT){const s=R(t,!1);function o(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function u(oe){return oe?ae=>oe(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const h=o(a.onObjectBegin),I=u(a.onObjectProperty),M=o(a.onObjectEnd),C=o(a.onArrayBegin),O=o(a.onArrayEnd),W=u(a.onLiteralValue),q=u(a.onSeparator),V=o(a.onComment),_=u(a.onError),ne=i&&i.disallowComments,re=i&&i.allowTrailingComma;function ue(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ne||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(oe){case 12:case 13:ne?ce(10):V();break;case 16:ce(1);break;case 15:case 14:break;default:return oe}}}function ce(oe,ae=[],B=[]){if(_(oe),ae.length+B.length>0){let T=s.getToken();for(;T!==17;){if(ae.indexOf(T)!==-1){ue();break}else if(B.indexOf(T)!==-1)break;T=ue()}}}function J(oe){const ae=s.getTokenValue();return oe?W(ae):I(ae),ue(),!0}function H(){switch(s.getToken()){case 11:{let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(ce(2),oe=0)}catch{ce(2)}W(oe);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ue(),!0}function j(){return s.getToken()!==10?(ce(3,[],[2,5]),!1):(J(!1),s.getToken()===6?(q(":"),ue(),Z()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function z(){h(),ue();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||ce(4,[],[]),q(","),ue(),s.getToken()===2&&re)break}else oe&&ce(6,[],[]);j()||ce(4,[],[2,5]),oe=!0}return M(),s.getToken()!==2?ce(7,[2],[]):ue(),!0}function X(){C(),ue();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||ce(4,[],[]),q(","),ue(),s.getToken()===4&&re)break}else oe&&ce(6,[],[]);Z()||ce(4,[],[4,5]),oe=!0}return O(),s.getToken()!==4?ce(8,[4],[]):ue(),!0}function Z(){switch(s.getToken()){case 3:return X();case 1:return z();case 10:return J(!0);default:return H()}}return ue(),s.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):Z()?(s.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=v;function y(t,a){const i=R(t),s=[];let o,u=0,h;do switch(h=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:u!==h&&s.push(t.substring(u,h)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),u=i.getPosition();break}while(o!==17);return s.join("")}e.stripComments=y;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(ee[127],te([0,1,43]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(c,p,m){let b,f,S,w,r;if(p){for(w=p.offset,r=w+p.length,S=w;S>0&&!d(c,S-1);)S--;let h=r;for(;h<c.length&&!d(c,h);)h++;f=c.substring(S,h),b=R(f,m)}else f=c,b=0,S=0,w=0,r=c.length;const g=P(m,c);let l=!1,v=0,y;m.insertSpaces?y=A(" ",m.tabSize||4):y="	";const D=(0,E.createScanner)(f,!1);let t=!1;function a(){return g+A(y,b+v)}function i(){let h=D.scan();for(l=!1;h===15||h===14;)l=l||h===14,h=D.scan();return t=h===16||D.getTokenError()!==0,h}const s=[];function o(h,I,M){!t&&I<r&&M>w&&c.substring(I,M)!==h&&s.push({offset:I,length:M-I,content:h})}let u=i();if(u!==17){const h=D.getTokenOffset()+S,I=A(y,b);o(I,S,h)}for(;u!==17;){let h=D.getTokenOffset()+D.getTokenLength()+S,I=i(),M="";for(;!l&&(I===12||I===13);){const O=D.getTokenOffset()+S;o(" ",h,O),h=D.getTokenOffset()+D.getTokenLength()+S,M=I===12?a():"",I=i()}if(I===2)u!==1&&(v--,M=a());else if(I===4)u!==3&&(v--,M=a());else{switch(u){case 3:case 1:v++,M=a();break;case 5:case 12:M=a();break;case 13:l?M=a():M=" ";break;case 6:M=" ";break;case 10:if(I===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?M=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}l&&(I===12||I===13)&&(M=a())}const C=D.getTokenOffset()+S;o(M,h,C),u=I}return s}e.format=L;function n(c,p){const m=JSON.stringify(c,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?m.replace(/\r\n|\r|\n/g,p.eol):m}e.toFormattedString=n;function A(c,p){let m="";for(let b=0;b<p;b++)m+=c;return m}function R(c,p){let m=0,b=0;const f=p.tabSize||4;for(;m<c.length;){const S=c.charAt(m);if(S===" ")b++;else if(S==="	")b+=f;else break;m++}return Math.floor(b/f)}function P(c,p){for(let m=0;m<p.length;m++){const b=p.charAt(m);if(b==="\r")return m+1<p.length&&p.charAt(m+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return c&&c.eol||`
`}e.getEOL=P;function d(c,p){return`\r
`.indexOf(c.charAt(p))!==-1}e.isEOL=d}),define(ee[128],te([0,1,43,127]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(c,p,m){return A(c,p,void 0,m)}e.removeProperty=n;function A(c,p,m,b,f){const S=p.slice(),w=[],r=(0,E.parseTree)(c,w);let g,l;for(;S.length>0&&(l=S.pop(),g=(0,E.findNodeAtLocation)(r,S),g===void 0&&m!==void 0);)typeof l=="string"?m={[l]:m}:m=[m];if(g)if(g.type==="object"&&typeof l=="string"&&Array.isArray(g.children)){const v=(0,E.findNodeAtLocation)(g,[l]);if(v!==void 0)if(m===void 0){if(!v.parent)throw new Error("Malformed AST");const y=g.children.indexOf(v.parent);let D,t=v.parent.offset+v.parent.length;if(y>0){const a=g.children[y-1];D=a.offset+a.length}else D=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(c,{offset:D,length:t-D,content:""},b)}else return R(c,{offset:v.offset,length:v.length,content:JSON.stringify(m)},b);else{if(m===void 0)return[];const y=`${JSON.stringify(l)}: ${JSON.stringify(m)}`,D=f?f(g.children.map(a=>a.children[0].value)):g.children.length;let t;if(D>0){const a=g.children[D-1];t={offset:a.offset+a.length,length:0,content:","+y}}else g.children.length===0?t={offset:g.offset+1,length:0,content:y}:t={offset:g.offset+1,length:0,content:y+","};return R(c,t,b)}}else if(g.type==="array"&&typeof l=="number"&&Array.isArray(g.children))if(m!==void 0){const v=`${JSON.stringify(m)}`;let y;if(g.children.length===0||l===0)y={offset:g.offset+1,length:0,content:g.children.length===0?v:v+","};else{const D=l===-1||l>g.children.length?g.children.length:l,t=g.children[D-1];y={offset:t.offset+t.length,length:0,content:","+v}}return R(c,y,b)}else{const v=l,y=g.children[v];let D;if(g.children.length===1)D={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===v){const t=g.children[v-1],a=t.offset+t.length,i=g.offset+g.length;D={offset:a,length:i-2-a,content:""}}else D={offset:y.offset,length:g.children[v+1].offset-y.offset,content:""};return R(c,D,b)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${g.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return R(c,{offset:r?r.offset:0,length:r?r.length:0,content:JSON.stringify(m)},b)}}e.setProperty=A;function R(c,p,m){let b=P(c,p),f=p.offset,S=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;f>0&&!(0,L.isEOL)(b,f-1);)f--;for(;S<b.length&&!(0,L.isEOL)(b,S);)S++}const w=(0,L.format)(b,{offset:f,length:S-f},m);for(let g=w.length-1;g>=0;g--){const l=w[g];b=P(b,l),f=Math.min(f,l.offset),S=Math.max(S,l.offset+l.length),S+=l.content.length-l.length}const r=c.length-(b.length-S)-f;return[{offset:f,length:r,content:b.substring(f,S)}]}e.withFormatting=R;function P(c,p){return c.substring(0,p.offset)+p.content+c.substring(p.offset+p.length)}e.applyEdit=P;function d(c,p){const m=p.slice(0).sort((f,S)=>{const w=f.offset-S.offset;return w===0?f.length-S.length:w});let b=c.length;for(let f=m.length-1;f>=0;f--){const S=m[f];if(S.offset+S.length<=b)c=P(c,S);else throw new Error("Overlapping edit");b=S.offset}return c}e.applyEdits=d}),define(ee[129],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(ee[2],te([0,1,48,68]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let A=null;function R(u){A=u}if(e.setDisposableTracker=R,n){const u="__is_disposable_tracked__";R(new class{trackDisposable(h){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[u]||console.log(I)},3e3)}setParent(h,I){if(h&&h!==l.None)try{h[u]=!0}catch{}}markAsDisposed(h){if(h&&h!==l.None)try{h[u]=!0}catch{}}markAsSingleton(h){}})}function P(u){return A?.trackDisposable(u),u}function d(u){A?.markAsDisposed(u)}function c(u,h){A?.setParent(u,h)}function p(u,h){if(A)for(const I of u)A.setParent(I,h)}function m(u){return A?.markAsSingleton(u),u}e.markAsSingleton=m;function b(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=b;function f(u){if(L.Iterable.is(u)){const h=[];for(const I of u)if(I)try{I.dispose()}catch(M){h.push(M)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=f;function S(u){for(const h of u)b(h)&&h.dispose();return[]}e.disposeIfDisposable=S;function w(...u){const h=r(()=>f(u));return p(u,h),h}e.combinedDisposable=w;function r(u){const h=P({dispose:(0,E.once)(()=>{d(h),u()})});return h}e.toDisposable=r;class g{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return c(h,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(h),h}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this.q=new g,P(this),c(this.q,this)}dispose(){d(this),this.q.dispose()}B(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(h)}}e.Disposable=l,l.None=Object.freeze({dispose(){}});class v{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(h){this.b||h===this.a||(this.a?.dispose(),h&&c(h,this),this.a=h)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const h=this.a;return this.a=void 0,h&&c(h,null),h}}e.MutableDisposable=v;class y{constructor(h){this.b=h,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(h){let I=h;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,d(this))},this}}e.SafeDisposable=D;class t{constructor(){this.a=new Map}acquire(h,...I){let M=this.a.get(h);M||(M={counter:0,object:this.b(h,...I)},this.a.set(h,M));const{object:C}=M,O=(0,E.once)(()=>{--M.counter===0&&(this.c(h,M.object),this.a.delete(h))});return M.counter++,{object:C,dispose:O}}}e.ReferenceCollection=t;class a{constructor(h){this.a=h}async acquire(h,...I){const M=this.a.acquire(h,...I);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(C){throw M.dispose(),C}}}e.AsyncReferenceCollection=a;class i{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=i;function s(u){const h=new g;try{u(h)}finally{h.dispose()}}e.disposeOnReturn=s;class o{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(h){return this.a.has(h)}get(h){return this.a.get(h)}set(h,I,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(h)?.dispose(),this.a.set(h,I)}deleteAndDispose(h){this.a.get(h)?.dispose(),this.a.delete(h)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ee[99],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class L{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let A=this.a;for(;A!==E.Undefined;){const R=A.next;A.prev=E.Undefined,A.next=E.Undefined,A=R}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const P=new E(A);if(this.a===E.Undefined)this.a=P,this.b=P;else if(R){const c=this.b;this.b=P,P.prev=c,c.next=P}else{const c=this.a;this.a=P,P.next=c,c.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==E.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===E.Undefined&&A.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):A.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):A.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(ee[35],te([0,1]),function(G,e){"use strict";var E,L,n;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(w,r,g){let l=w.get(r);return l===void 0&&(l=g,w.set(r,l)),l}e.getOrSet=A;function R(w){const r=[];return w.forEach((g,l)=>{r.push(`${l} => ${g}`)}),`Map(${w.size}) {${r.join(", ")}}`}e.mapToString=R;function P(w){const r=[];return w.forEach(g=>{r.push(g)}),`Set(${w.size}) {${r.join(", ")}}`}e.setToString=P;class d{constructor(r,g){this.uri=r,this.value=g}}class c{constructor(r,g){this[E]="ResourceMap",r instanceof c?(this.b=new Map(r.b),this.c=g??c.a):(this.b=new Map,this.c=r??c.a)}set(r,g){return this.b.set(this.c(r),new d(r,g)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,g){typeof g<"u"&&(r=r.bind(g));for(const[l,v]of this.b)r(v.value,v.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.ResourceMap=c,c.a=w=>w.toString();class p{constructor(r,g){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new c(r):(this.a=new c(g),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,g){this.a.forEach((l,v)=>r.call(g,v,v,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var m;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class b{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,g=0){const l=this.a.get(r);if(l)return g!==0&&this.j(l,g),l.value}set(r,g,l=0){let v=this.a.get(r);if(v)v.value=g,l!==0&&this.j(v,l);else{switch(v={key:r,value:g,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(r,v),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const g=this.a.get(r);if(g)return this.a.delete(r),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,g){const l=this.e;let v=this.b;for(;v;){if(g?r.bind(g)(v.value,v.key,this):r(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const r=this,g=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}values(){const r=this,g=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}entries(){const r=this,g=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let g=this.b,l=this.size;for(;g&&l>r;)this.a.delete(g.key),g=g.next,l--;this.b=g,this.d=l,g&&(g.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const g=r.next,l=r.previous;if(!g||!l)throw new Error("Invalid list");g.previous=l,l.next=g}r.next=void 0,r.previous=void 0,this.e++}j(r,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(r===this.b)return;const l=r.next,v=r.previous;r===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(g===2){if(r===this.c)return;const l=r.next,v=r.previous;r===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((g,l)=>{r.push([l,g])}),r}fromJSON(r){this.clear();for(const[g,l]of r)this.set(g,l)}}e.LinkedMap=b;class f extends b{constructor(r,g=1){super(),this.k=r,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,g=2){return super.get(r,g)}peek(r){return super.get(r,0)}set(r,g){return super.set(r,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f;class S{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let g=this.a.get(r)||0;return g===0?!1:(g--,g===0?this.a.delete(r):this.a.set(r,g),!0)}has(r){return this.a.has(r)}}e.CounterSet=S}),define(ee[82],te([0,1,35]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new E.LRUCache(1e4);function n(c){return d(c,"NFC",L)}e.normalizeNFC=n;const A=new E.LRUCache(1e4);function R(c){return d(c,"NFD",A)}e.normalizeNFD=R;const P=/[^\u0000-\u0080]/;function d(c,p,m){if(!c)return c;const b=m.get(c);if(b)return b;let f;return P.test(c)?f=c.normalize(p):f=c,m.set(c,f),f}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(p){return R(p).replace(c,"")}}()}),define(ee[130],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,d,c){return Math.min(Math.max(P,d),c)}e.clamp=E;function L(P,d){return(d+P%d)%d}e.rot=L;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class A{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class R{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const c=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function G(n){const A=[];typeof n=="number"&&A.push("code/timeOrigin",n);function R(d){A.push(d,Date.now())}function P(){const d=[];for(let c=0;c<A.length;c+=2)d.push({name:A[c],startTime:A[c+1]});return d}return{mark:R,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(n+R.startTime)});return A}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:G)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function E(L){if(e[L])return e[L].exports;var n=e[L]={i:L,l:!1,exports:{}};return G[L].call(n.exports,n,n.exports,E),n.l=!0,n.exports}return E.m=G,E.c=e,E.d=function(L,n,A){E.o(L,n)||Object.defineProperty(L,n,{enumerable:!0,get:A})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,n){if(1&n&&(L=E(L)),8&n||4&n&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(E.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&n&&typeof L!="string")for(var R in L)E.d(A,R,function(P){return L[P]}.bind(null,R));return A},E.n=function(L){var n=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(n,"a",n),n},E.o=function(L,n){return Object.prototype.hasOwnProperty.call(L,n)},E.p="",E(E.s=0)}([function(G,e,E){(function(L){var n;e=G.exports=B,n=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],c=0,p=c++;d[p]="0|[1-9]\\d*";var m=c++;d[m]="[0-9]+";var b=c++;d[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;d[f]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var S=c++;d[S]="("+d[m]+")\\.("+d[m]+")\\.("+d[m]+")";var w=c++;d[w]="(?:"+d[p]+"|"+d[b]+")";var r=c++;d[r]="(?:"+d[m]+"|"+d[b]+")";var g=c++;d[g]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var l=c++;d[l]="(?:-?("+d[r]+"(?:\\."+d[r]+")*))";var v=c++;d[v]="[0-9A-Za-z-]+";var y=c++;d[y]="(?:\\+("+d[v]+"(?:\\."+d[v]+")*))";var D=c++,t="v?"+d[f]+d[g]+"?"+d[y]+"?";d[D]="^"+t+"$";var a="[v=\\s]*"+d[S]+d[l]+"?"+d[y]+"?",i=c++;d[i]="^"+a+"$";var s=c++;d[s]="((?:<|>)?=?)";var o=c++;d[o]=d[m]+"|x|X|\\*";var u=c++;d[u]=d[p]+"|x|X|\\*";var h=c++;d[h]="[v=\\s]*("+d[u]+")(?:\\.("+d[u]+")(?:\\.("+d[u]+")(?:"+d[g]+")?"+d[y]+"?)?)?";var I=c++;d[I]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[l]+")?"+d[y]+"?)?)?";var M=c++;d[M]="^"+d[s]+"\\s*"+d[h]+"$";var C=c++;d[C]="^"+d[s]+"\\s*"+d[I]+"$";var O=c++;d[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;d[W]="(?:~>?)";var q=c++;d[q]="(\\s*)"+d[W]+"\\s+",P[q]=new RegExp(d[q],"g");var V=c++;d[V]="^"+d[W]+d[h]+"$";var _=c++;d[_]="^"+d[W]+d[I]+"$";var ne=c++;d[ne]="(?:\\^)";var re=c++;d[re]="(\\s*)"+d[ne]+"\\s+",P[re]=new RegExp(d[re],"g");var ue=c++;d[ue]="^"+d[ne]+d[h]+"$";var ce=c++;d[ce]="^"+d[ne]+d[I]+"$";var J=c++;d[J]="^"+d[s]+"\\s*("+a+")$|^$";var H=c++;d[H]="^"+d[s]+"\\s*("+t+")$|^$";var j=c++;d[j]="(\\s*)"+d[s]+"\\s*("+a+"|"+d[h]+")",P[j]=new RegExp(d[j],"g");var z=c++;d[z]="^\\s*("+d[h]+")\\s+-\\s+("+d[h]+")\\s*$";var X=c++;d[X]="^\\s*("+d[I]+")\\s+-\\s+("+d[I]+")\\s*$";var Z=c++;d[Z]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)n(oe,d[oe]),P[oe]||(P[oe]=new RegExp(d[oe]));function ae(ie,he){if(ie instanceof B)return ie;if(typeof ie!="string"||ie.length>A||!(he?P[i]:P[D]).test(ie))return null;try{return new B(ie,he)}catch{return null}}function B(ie,he){if(ie instanceof B){if(ie.loose===he)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof B))return new B(ie,he);n("SemVer",ie,he),this.loose=he;var fe=ie.trim().match(he?P[i]:P[D]);if(!fe)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Ce=+Ie;if(Ce>=0&&Ce<R)return Ce}return Ie}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ie,he){var fe=ae(ie,he);return fe?fe.version:null},e.clean=function(ie,he){var fe=ae(ie.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(ie){return n("SemVer.compare",this.version,this.loose,ie),ie instanceof B||(ie=new B(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},B.prototype.compareMain=function(ie){return ie instanceof B||(ie=new B(ie,this.loose)),k(this.major,ie.major)||k(this.minor,ie.minor)||k(this.patch,ie.patch)},B.prototype.comparePre=function(ie){if(ie instanceof B||(ie=new B(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],Ie=ie.prerelease[he];if(n("prerelease compare",he,fe,Ie),fe===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ie)return k(fe,Ie)}while(++he)},B.prototype.inc=function(ie,he){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,he,fe,Ie){typeof fe=="string"&&(Ie=fe,fe=void 0);try{return new B(ie,fe).inc(he,Ie).version}catch{return null}},e.diff=function(ie,he){if($(ie,he))return null;var fe=ae(ie),Ie=ae(he);if(fe.prerelease.length||Ie.prerelease.length){for(var Ce in fe)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&fe[Ce]!==Ie[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in fe)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&fe[Ce]!==Ie[Ce])return Ce},e.compareIdentifiers=k;var T=/^[0-9]+$/;function k(ie,he){var fe=T.test(ie),Ie=T.test(he);return fe&&Ie&&(ie=+ie,he=+he),fe&&!Ie?-1:Ie&&!fe?1:ie<he?-1:ie>he?1:0}function F(ie,he,fe){return new B(ie,fe).compare(new B(he,fe))}function N(ie,he,fe){return F(ie,he,fe)>0}function U(ie,he,fe){return F(ie,he,fe)<0}function $(ie,he,fe){return F(ie,he,fe)===0}function x(ie,he,fe){return F(ie,he,fe)!==0}function K(ie,he,fe){return F(ie,he,fe)>=0}function se(ie,he,fe){return F(ie,he,fe)<=0}function de(ie,he,fe,Ie){var Ce;switch(he){case"===":typeof ie=="object"&&(ie=ie.version),typeof fe=="object"&&(fe=fe.version),Ce=ie===fe;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof fe=="object"&&(fe=fe.version),Ce=ie!==fe;break;case"":case"=":case"==":Ce=$(ie,fe,Ie);break;case"!=":Ce=x(ie,fe,Ie);break;case">":Ce=N(ie,fe,Ie);break;case">=":Ce=K(ie,fe,Ie);break;case"<":Ce=U(ie,fe,Ie);break;case"<=":Ce=se(ie,fe,Ie);break;default:throw new TypeError("Invalid operator: "+he)}return Ce}function Ee(ie,he){if(ie instanceof Ee){if(ie.loose===he)return ie;ie=ie.value}if(!(this instanceof Ee))return new Ee(ie,he);n("comparator",ie,he),this.loose=he,this.parse(ie),this.semver===De?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(ie,he){return k(he,ie)},e.major=function(ie,he){return new B(ie,he).major},e.minor=function(ie,he){return new B(ie,he).minor},e.patch=function(ie,he){return new B(ie,he).patch},e.compare=F,e.compareLoose=function(ie,he){return F(ie,he,!0)},e.rcompare=function(ie,he,fe){return F(he,ie,fe)},e.sort=function(ie,he){return ie.sort(function(fe,Ie){return e.compare(fe,Ie,he)})},e.rsort=function(ie,he){return ie.sort(function(fe,Ie){return e.rcompare(fe,Ie,he)})},e.gt=N,e.lt=U,e.eq=$,e.neq=x,e.gte=K,e.lte=se,e.cmp=de,e.Comparator=Ee;var De={};function Se(ie,he){if(ie instanceof Se)return ie.loose===he?ie:new Se(ie.raw,he);if(ie instanceof Ee)return new Se(ie.value,he);if(!(this instanceof Se))return new Se(ie,he);if(this.loose=he,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ae(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function ze(ie,he,fe,Ie,Ce,Oe,Fe,He,Ne,$e,qe,We,Y){return((he=Ae(fe)?"":Ae(Ie)?">="+fe+".0.0":Ae(Ce)?">="+fe+"."+Ie+".0":">="+he)+" "+(He=Ae(Ne)?"":Ae($e)?"<"+(+Ne+1)+".0.0":Ae(qe)?"<"+Ne+"."+(+$e+1)+".0":We?"<="+Ne+"."+$e+"."+qe+"-"+We:"<="+He)).trim()}function ge(ie,he){for(var fe=0;fe<ie.length;fe++)if(!ie[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<ie.length;fe++)if(n(ie[fe].semver),ie[fe].semver!==De&&ie[fe].semver.prerelease.length>0){var Ie=ie[fe].semver;if(Ie.major===he.major&&Ie.minor===he.minor&&Ie.patch===he.patch)return!0}return!1}return!0}function we(ie,he,fe){try{he=new Se(he,fe)}catch{return!1}return he.test(ie)}function Me(ie,he,fe,Ie){var Ce,Oe,Fe,He,Ne;switch(ie=new B(ie,Ie),he=new Se(he,Ie),fe){case">":Ce=N,Oe=se,Fe=U,He=">",Ne=">=";break;case"<":Ce=U,Oe=K,Fe=N,He="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(ie,he,Ie))return!1;for(var $e=0;$e<he.set.length;++$e){var qe=he.set[$e],We=null,Y=null;if(qe.forEach(function(le){le.semver===De&&(le=new Ee(">=0.0.0")),We=We||le,Y=Y||le,Ce(le.semver,We.semver,Ie)?We=le:Fe(le.semver,Y.semver,Ie)&&(Y=le)}),We.operator===He||We.operator===Ne||(!Y.operator||Y.operator===He)&&Oe(ie,Y.semver)||Y.operator===Ne&&Fe(ie,Y.semver))return!1}return!0}Ee.prototype.parse=function(ie){var he=this.loose?P[J]:P[H],fe=ie.match(he);if(!fe)throw new TypeError("Invalid comparator: "+ie);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new B(fe[2],this.loose):this.semver=De},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ie){return n("Comparator.test",ie,this.loose),this.semver===De||(typeof ie=="string"&&(ie=new B(ie,this.loose)),de(ie,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ie,he){if(!(ie instanceof Ee))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Se(ie.value,he),we(this.value,fe,he);if(ie.operator==="")return fe=new Se(this.value,he),we(ie.semver,fe,he);var Ie=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Oe=this.semver.version===ie.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),He=de(this.semver,"<",ie.semver,he)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ne=de(this.semver,">",ie.semver,he)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Ie||Ce||Oe&&Fe||He||Ne},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ie){var he=this.loose;ie=ie.trim(),n("range",ie,he);var fe=he?P[X]:P[z];ie=ie.replace(fe,ze),n("hyphen replace",ie),ie=ie.replace(P[j],"$1$2$3"),n("comparator trim",ie,P[j]),ie=(ie=(ie=ie.replace(P[q],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var Ie=he?P[J]:P[H],Ce=ie.split(" ").map(function(Oe){return function(Fe,He){return n("comp",Fe),Fe=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(qe){return function(We,Y){n("caret",We,Y);var le=Y?P[ce]:P[ue];return We.replace(le,function(pe,me,be,Le,Ue){var Ke;return n("caret",We,pe,me,be,Le,Ue),Ae(me)?Ke="":Ae(be)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Le)?Ke=me==="0"?">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":">="+me+"."+be+".0 <"+(+me+1)+".0.0":Ue?(n("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ke=me==="0"?be==="0"?">="+me+"."+be+"."+Le+Ue+" <"+me+"."+be+"."+(+Le+1):">="+me+"."+be+"."+Le+Ue+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+Le+Ue+" <"+(+me+1)+".0.0"):(n("no pr"),Ke=me==="0"?be==="0"?">="+me+"."+be+"."+Le+" <"+me+"."+be+"."+(+Le+1):">="+me+"."+be+"."+Le+" <"+me+"."+(+be+1)+".0":">="+me+"."+be+"."+Le+" <"+(+me+1)+".0.0"),n("caret return",Ke),Ke})}(qe,$e)}).join(" ")}(Fe,He),n("caret",Fe),Fe=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(qe){return function(We,Y){var le=Y?P[_]:P[V];return We.replace(le,function(pe,me,be,Le,Ue){var Ke;return n("tilde",We,pe,me,be,Le,Ue),Ae(me)?Ke="":Ae(be)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Le)?Ke=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0":Ue?(n("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ke=">="+me+"."+be+"."+Le+Ue+" <"+me+"."+(+be+1)+".0"):Ke=">="+me+"."+be+"."+Le+" <"+me+"."+(+be+1)+".0",n("tilde return",Ke),Ke})}(qe,$e)}).join(" ")}(Fe,He),n("tildes",Fe),Fe=function(Ne,$e){return n("replaceXRanges",Ne,$e),Ne.split(/\s+/).map(function(qe){return function(We,Y){We=We.trim();var le=Y?P[C]:P[M];return We.replace(le,function(pe,me,be,Le,Ue,Ke){n("xRange",We,pe,me,be,Le,Ue,Ke);var Ze=Ae(be),Ge=Ze||Ae(Le),Ye=Ge||Ae(Ue);return me==="="&&Ye&&(me=""),Ze?pe=me===">"||me==="<"?"<0.0.0":"*":me&&Ye?(Ge&&(Le=0),Ye&&(Ue=0),me===">"?(me=">=",Ge?(be=+be+1,Le=0,Ue=0):Ye&&(Le=+Le+1,Ue=0)):me==="<="&&(me="<",Ge?be=+be+1:Le=+Le+1),pe=me+be+"."+Le+"."+Ue):Ge?pe=">="+be+".0.0 <"+(+be+1)+".0.0":Ye&&(pe=">="+be+"."+Le+".0 <"+be+"."+(+Le+1)+".0"),n("xRange return",pe),pe})}(qe,$e)}).join(" ")}(Fe,He),n("xrange",Fe),Fe=function(Ne,$e){return n("replaceStars",Ne,$e),Ne.trim().replace(P[Z],"")}(Fe,He),n("stars",Fe),Fe}(Oe,he)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Oe){return!!Oe.match(Ie)})),Ce=Ce.map(function(Oe){return new Ee(Oe,he)})},Se.prototype.intersects=function(ie,he){if(!(ie instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ie){return ie.set.some(function(Ce){return Ce.every(function(Oe){return Ie.intersects(Oe,he)})})})})},e.toComparators=function(ie,he){return new Se(ie,he).set.map(function(fe){return fe.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new B(ie,this.loose));for(var he=0;he<this.set.length;he++)if(ge(this.set[he],ie))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(ie,he,fe){var Ie=null,Ce=null;try{var Oe=new Se(he,fe)}catch{return null}return ie.forEach(function(Fe){Oe.test(Fe)&&(Ie&&Ce.compare(Fe)!==-1||(Ce=new B(Ie=Fe,fe)))}),Ie},e.minSatisfying=function(ie,he,fe){var Ie=null,Ce=null;try{var Oe=new Se(he,fe)}catch{return null}return ie.forEach(function(Fe){Oe.test(Fe)&&(Ie&&Ce.compare(Fe)!==1||(Ce=new B(Ie=Fe,fe)))}),Ie},e.validRange=function(ie,he){try{return new Se(ie,he).range||"*"}catch{return null}},e.ltr=function(ie,he,fe){return Me(ie,he,"<",fe)},e.gtr=function(ie,he,fe){return Me(ie,he,">",fe)},e.outside=Me,e.prerelease=function(ie,he){var fe=ae(ie,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ie,he,fe){return ie=new Se(ie,fe),he=new Se(he,fe),ie.intersects(he)},e.coerce=function(ie){if(ie instanceof B)return ie;if(typeof ie!="string")return null;var he=ie.match(P[O]);return he==null?null:ae((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(G,e){var E,L,n=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function P(r){if(E===setTimeout)return setTimeout(r,0);if((E===A||!E)&&setTimeout)return E=setTimeout,setTimeout(r,0);try{return E(r,0)}catch{try{return E.call(null,r,0)}catch{return E.call(this,r,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:A}catch{E=A}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var d,c=[],p=!1,m=-1;function b(){p&&d&&(p=!1,d.length?c=d.concat(c):m=-1,c.length&&f())}function f(){if(!p){var r=P(b);p=!0;for(var g=c.length;g;){for(d=c,c=[];++m<g;)d&&d[m].run();m=-1,g=c.length}d=null,p=!1,function(l){if(L===clearTimeout)return clearTimeout(l);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(l);try{L(l)}catch{try{return L.call(null,l)}catch{return L.call(this,l)}}}(r)}}function S(r,g){this.fun=r,this.array=g}function w(){}n.nextTick=function(r){var g=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)g[l-1]=arguments[l];c.push(new S(r,g)),c.length!==1||p||P(f)},S.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=w,n.addListener=w,n.once=w,n.off=w,n.removeListener=w,n.removeAllListeners=w,n.emit=w,n.prependListener=w,n.prependOnceListener=w,n.listeners=function(r){return[]},n.binding=function(r){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(r){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ee[131],te([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(P,d,c){this.level=P,this.key=d,this.value=c,this.forward=[]}}const n=void 0;class A{constructor(P,d=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new L(this.c,n,n)}get size(){return this.f}clear(){this.e=new L(this.c,n,n)}has(P){return!!A.g(this,P,this.comparator)}get(P){return A.g(this,P,this.comparator)?.value}set(P,d){return A.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=A.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let c=this.e.forward[0];for(;c;)P.call(d,c.value,c.key,this),c=c.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,c){let p=P.e;for(let m=P.d-1;m>=0;m--)for(;p.forward[m]&&c(p.forward[m].key,d)<0;)p=p.forward[m];if(p=p.forward[0],p&&c(p.key,d)===0)return p}static h(P,d,c,p){const m=[];let b=P.e;for(let f=P.d-1;f>=0;f--){for(;b.forward[f]&&p(b.forward[f].key,d)<0;)b=b.forward[f];m[f]=b}if(b=b.forward[0],b&&p(b.key,d)===0)return b.value=c,!1;{const f=A.j(P);if(f>P.d){for(let S=P.d;S<f;S++)m[S]=P.e;P.d=f}b=new L(f,d,c);for(let S=0;S<f;S++)b.forward[S]=m[S].forward[S],m[S].forward[S]=b;return!0}}static j(P,d=.5){let c=1;for(;Math.random()<d&&c<P.c;)c+=1;return c}static k(P,d,c){const p=[];let m=P.e;for(let b=P.d-1;b>=0;b--){for(;m.forward[b]&&c(m.forward[b].key,d)<0;)m=m.forward[b];p[b]=m}if(m=m.forward[0],!m||c(m.key,d)!==0)return!1;for(let b=0;b<P.d&&p[b].forward[b]===m;b++)p[b].forward[b]=m.forward[b];for(;P.d>0&&P.e.forward[P.d-1]===n;)P.d-=1;return!0}}e.SkipList=A}),define(ee[60],te([0,1,13,2]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(y){const D=y;return D?typeof D.read=="function":!1}e.isReadable=n;function A(y){const D=y;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function R(y){const D=y;return D?A(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=R;function P(y,D){return new d(y,D)}e.newWriteableStream=P;class d{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,E.onUnexpectedError)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let a;switch(D){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(y,D){const t=[];let a;for(;(a=y.read())!==null;)t.push(a);return D(t)}e.consumeReadable=c;function p(y,D,t){const a=[];let i;for(;(i=y.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?D(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return y.read()}}}e.peekReadable=p;function m(y,D){return new Promise((t,a)=>{const i=[];b(y,{onData:s=>{D&&i.push(s)},onError:s=>{D?a(s):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=m;function b(y,D){let t=!1;return y.on("error",a=>{t||D.onError(a)}),y.on("end",()=>{t||D.onEnd()}),y.on("data",a=>{t||D.onData(a)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=b;function f(y,D){return new Promise((t,a)=>{const i=new L.DisposableStore,s=[],o=I=>{if(s.push(I),s.length>D)return i.dispose(),y.pause(),t({stream:y,buffer:s,ended:!1})},u=I=>a(I),h=()=>t({stream:y,buffer:s,ended:!0});i.add((0,L.toDisposable)(()=>y.removeListener("error",u))),y.on("error",u),i.add((0,L.toDisposable)(()=>y.removeListener("end",h))),y.on("end",h),i.add((0,L.toDisposable)(()=>y.removeListener("data",o))),y.on("data",o)})}e.peekStream=f;function S(y,D){const t=P(D);return t.end(y),t}e.toStream=S;function w(){const y=P(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=w;function r(y){let D=!1;return{read:()=>D?null:(D=!0,y)}}e.toReadable=r;function g(y,D,t){const a=P(t);return b(y,{onData:i=>a.write(D.data(i)),onError:i=>a.error(D.error?D.error(i):i),onEnd:()=>a.end()}),a}e.transform=g;function l(y,D,t){let a=!1;return{read:()=>{const i=D.read();return a?i:(a=!0,i!==null?t([y,i]):y)}}}e.prefixedReadable=l;function v(y,D,t){let a=!1;const i=P(t);return b(D,{onData:s=>a?i.write(s):(a=!0,i.write(t([y,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(y)),i.end()}}),i}e.prefixedStream=v}),define(ee[17],te([0,1,60]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let n,A;class R{static alloc(I){return L?new R(Buffer.allocUnsafe(I)):new R(new Uint8Array(I))}static wrap(I){return L&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new R(I)}static fromString(I,M){return!(M?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(I)):(n||(n=new TextEncoder),new R(n.encode(I)))}static fromByteArray(I){const M=R.alloc(I.length);for(let C=0,O=I.length;C<O;C++)M.buffer[C]=I[C];return M}static concat(I,M){if(typeof M>"u"){M=0;for(let W=0,q=I.length;W<q;W++)M+=I[W].byteLength}const C=R.alloc(M);let O=0;for(let W=0,q=I.length;W<q;W++){const V=I[W];C.set(V,O),O+=V.byteLength}return C}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=R.alloc(this.byteLength);return I.set(this),I}toString(){return L?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(I,M){return new R(this.buffer.subarray(I,M))}set(I,M){if(I instanceof R)this.buffer.set(I.buffer,M);else if(I instanceof Uint8Array)this.buffer.set(I,M);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),M);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return c(this.buffer,I)}writeUInt32BE(I,M){p(this.buffer,I,M)}readUInt32LE(I){return m(this.buffer,I)}writeUInt32LE(I,M){b(this.buffer,I,M)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,M){S(this.buffer,I,M)}}e.VSBuffer=R;function P(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0}e.readUInt16LE=P;function d(h,I,M){h[M+0]=I&255,I=I>>>8,h[M+1]=I&255}e.writeUInt16LE=d;function c(h,I){return h[I]*2**24+h[I+1]*2**16+h[I+2]*2**8+h[I+3]}e.readUInt32BE=c;function p(h,I,M){h[M+3]=I,I=I>>>8,h[M+2]=I,I=I>>>8,h[M+1]=I,I=I>>>8,h[M]=I}e.writeUInt32BE=p;function m(h,I){return h[I+0]<<0>>>0|h[I+1]<<8>>>0|h[I+2]<<16>>>0|h[I+3]<<24>>>0}e.readUInt32LE=m;function b(h,I,M){h[M+0]=I&255,I=I>>>8,h[M+1]=I&255,I=I>>>8,h[M+2]=I&255,I=I>>>8,h[M+3]=I&255}e.writeUInt32LE=b;function f(h,I){return h[I]}e.readUInt8=f;function S(h,I,M){h[M]=I}e.writeUInt8=S;function w(h){return E.consumeReadable(h,I=>R.concat(I))}e.readableToBuffer=w;function r(h){return E.toReadable(h)}e.bufferToReadable=r;function g(h){return E.consumeStream(h,I=>R.concat(I))}e.streamToBuffer=g;async function l(h){return h.ended?R.concat(h.buffer):R.concat([...h.buffer,await g(h.stream)])}e.bufferedStreamToBuffer=l;function v(h){return E.toStream(h,I=>R.concat(I))}e.bufferToStream=v;function y(h){return E.transform(h,{data:I=>typeof I=="string"?R.fromString(I):R.wrap(I)},I=>R.concat(I))}e.streamToBufferReadableStream=y;function D(h){return E.newWriteableStream(I=>R.concat(I),h)}e.newWriteableBufferStream=D;function t(h,I){return E.prefixedReadable(h,I,M=>R.concat(M))}e.prefixedBufferReadable=t;function a(h,I){return E.prefixedStream(h,I,M=>R.concat(M))}e.prefixedBufferStream=a;function i(h){let I=0,M=0,C=0;const O=new Uint8Array(Math.floor(h.length/4*3)),W=V=>{switch(M){case 3:O[C++]=I|V,M=0;break;case 2:O[C++]=I|V>>>2,I=V<<6,M=3;break;case 1:O[C++]=I|V>>>4,I=V<<4,M=2;break;default:I=V<<2,M=1}};for(let V=0;V<h.length;V++){const _=h.charCodeAt(V);if(_>=65&&_<=90)W(_-65);else if(_>=97&&_<=122)W(_-97+26);else if(_>=48&&_<=57)W(_-48+52);else if(_===43||_===45)W(62);else if(_===47||_===95)W(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${h[V]}`)}}const q=C;for(;M>0;)W(0);return R.wrap(O).slice(0,q)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:h},I=!0,M=!1){const C=M?o:s;let O="";const W=h.byteLength%3;let q=0;for(;q<h.byteLength-W;q+=3){const V=h[q+0],_=h[q+1],ne=h[q+2];O+=C[V>>>2],O+=C[(V<<4|_>>>4)&63],O+=C[(_<<2|ne>>>6)&63],O+=C[ne&63]}if(W===1){const V=h[q+0];O+=C[V>>>2],O+=C[V<<4&63],I&&(O+="==")}else if(W===2){const V=h[q+0],_=h[q+1];O+=C[V>>>2],O+=C[(V<<4|_>>>4)&63],O+=C[_<<2&63],I&&(O+="=")}return O}e.encodeBase64=u}),define(ee[132],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[11],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(a){return typeof a=="string"}e.isString=E;function L(a){return Array.isArray(a)&&a.every(i=>E(i))}e.isStringArray=L;function n(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=n;function A(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=A;function R(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=R;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=P;function d(a){return a===!0||a===!1}e.isBoolean=d;function c(a){return typeof a>"u"}e.isUndefined=c;function p(a){return!m(a)}e.isDefined=p;function m(a){return c(a)||a===null}e.isUndefinedOrNull=m;function b(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function f(a){if(m(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function S(...a){const i=[];for(let s=0;s<a.length;s++){const o=a[s];if(m(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(o)}return i}e.assertAllDefined=S;const w=Object.prototype.hasOwnProperty;function r(a){if(!n(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}e.isEmptyObject=r;function g(a){return typeof a=="function"}e.isFunction=g;function l(...a){return a.length>0&&a.every(g)}e.areFunctions=l;function v(a,i){const s=Math.min(a.length,i.length);for(let o=0;o<s;o++)y(a[o],i[o])}e.validateConstraints=v;function y(a,i){if(E(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(a instanceof i)return}catch{}if(!m(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function D(a){return a===null?void 0:a}e.withNullAsUndefined=D;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ee[133],te([0,1,11]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function n(P,d){if((0,E.isString)(d)){const c=L[d];if(c===void 0)throw new Error(`${P} references an unknown codicon: ${d}`);d=c}return L[P]=d,{id:P}}function A(){return L}e.getCodiconFontCharacters=A;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ee[40],te([0,1,11]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const l=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([v,y])=>{l[v]=y&&typeof y=="object"?L(y):y}),l}e.deepClone=L;function n(g){if(!g||typeof g!="object")return g;const l=[g];for(;l.length>0;){const v=l.shift();Object.freeze(v);for(const y in v)if(A.call(v,y)){const D=v[y];typeof D=="object"&&!Object.isFrozen(D)&&!(0,E.isTypedArray)(D)&&l.push(D)}}return g}e.deepFreeze=n;const A=Object.prototype.hasOwnProperty;function R(g,l){return P(g,l,new Set)}e.cloneAndChange=R;function P(g,l,v){if((0,E.isUndefinedOrNull)(g))return g;const y=l(g);if(typeof y<"u")return y;if(Array.isArray(g)){const D=[];for(const t of g)D.push(P(t,l,v));return D}if((0,E.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const D={};for(const t in g)A.call(g,t)&&(D[t]=P(g[t],l,v));return v.delete(g),D}return g}function d(g,l,v=!0){return(0,E.isObject)(g)?((0,E.isObject)(l)&&Object.keys(l).forEach(y=>{y in g?v&&((0,E.isObject)(g[y])&&(0,E.isObject)(l[y])?d(g[y],l[y],v):g[y]=l[y]):g[y]=l[y]}),g):l}e.mixin=d;function c(g,l){if(g===l)return!0;if(g==null||l===null||l===void 0||typeof g!=typeof l||typeof g!="object"||Array.isArray(g)!==Array.isArray(l))return!1;let v,y;if(Array.isArray(g)){if(g.length!==l.length)return!1;for(v=0;v<g.length;v++)if(!c(g[v],l[v]))return!1}else{const D=[];for(y in g)D.push(y);D.sort();const t=[];for(y in l)t.push(y);if(t.sort(),!c(D,t))return!1;for(v=0;v<D.length;v++)if(!c(g[D[v]],l[D[v]]))return!1}return!0}e.equals=c;function p(g){const l=new Set;return JSON.stringify(g,(v,y)=>{if((0,E.isObject)(y)||Array.isArray(y)){if(l.has(y))return"[Circular]";l.add(y)}return y})}e.safeStringify=p;function m(g,l){const v=Object.create(null);return!g||!l||Object.keys(l).forEach(D=>{const t=g[D],a=l[D];c(t,a)||(v[D]=a)}),v}e.distinct=m;function b(g,l){const v=l.toLowerCase(),y=Object.keys(g).find(D=>D.toLowerCase()===v);return y?g[y]:g[l]}e.getCaseInsensitive=b;function f(g,l){const v=Object.create(null);for(const[y,D]of Object.entries(g))l(y,D)&&(v[y]=D);return v}e.filter=f;function S(g){let l=[],v=Object.getPrototypeOf(g);for(;Object.prototype!==v;)l=l.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return l}e.getAllPropertyNames=S;function w(g){const l=[];for(const v of S(g))typeof g[v]=="function"&&l.push(v);return l}e.getAllMethodNames=w;function r(g,l){const v=D=>function(){const t=Array.prototype.slice.call(arguments,0);return l(D,t)},y={};for(const D of g)y[D]=v(D);return y}e.createProxyObject=r}),define(ee[134],te([0,1,133]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(R){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}R.isThemeColor=P})(L||(e.ThemeColor=L={}));function n(R){return{id:R}}e.themeColorFromId=n;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function d(l){const v=P.exec(l.id);if(!v)return d(E.Codicon.error);const[,y,D]=v,t=["codicon","codicon-"+y];return D&&t.push("codicon-modifier-"+D.substring(1)),t}R.asClassNameArray=d;function c(l){return d(l).join(" ")}R.asClassName=c;function p(l){return"."+d(l).join(".")}R.asCSSSelector=p;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||L.isThemeColor(l.color))}R.isThemeIcon=m;const b=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function f(l){const v=b.exec(l);if(!v)return;const[,y]=v;return{id:y}}R.fromString=f;function S(l){return{id:l}}R.fromId=S;function w(l,v){let y=l.id;const D=y.lastIndexOf("~");return D!==-1&&(y=y.substring(0,D)),v&&(y=`${y}~${v}`),{id:y}}R.modify=w;function r(l){const v=l.id.lastIndexOf("~");if(v!==-1)return l.id.substring(v+1)}R.getModifier=r;function g(l,v){return l.id===v.id&&l.color?.id===v.color?.id}R.isEqual=g})(A||(e.ThemeIcon=A={}))}),define(ee[31],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(n){return E.test(n)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),R=[];for(let P=0;P<256;P++)R.push(P.toString(16).padStart(2,"0"));return function(){n(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let d=0,c="";return c+=R[A[d++]],c+=R[A[d++]],c+=R[A[d++]],c+=R[A[d++]],c+="-",c+=R[A[d++]],c+=R[A[d++]],c+="-",c+=R[A[d++]],c+=R[A[d++]],c+="-",c+=R[A[d++]],c+=R[A[d++]],c+="-",c+=R[A[d++]],c+=R[A[d++]],c+=R[A[d++]],c+=R[A[d++]],c+=R[A[d++]],c+=R[A[d++]],c}}()}),define(ee[135],te([0,1,69,41,48]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function A(R,P){if(await new Promise((p,m)=>{const b=L.createReadStream(R),f=E.createHash("sha1");b.pipe(f);const S=(0,n.once)((w,r)=>{b.removeAllListeners(),f.removeAllListeners(),w?m(w):p(r)});b.once("error",S),b.once("end",S),f.once("error",S),f.once("data",w=>S(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=A}),define(ee[136],te([0,1,26]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(R){const P=R.replace(/\-/g,":").toLowerCase();return!L.has(P)}function A(){const R=(0,E.networkInterfaces)();for(const P in R){const d=R[P];if(d){for(const{mac:c}of d)if(n(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ee[100],te([0,1,70]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(P,d,c,p=1){let m=!1;return new Promise(b=>{const f=setTimeout(()=>{if(!m)return m=!0,b(0)},c);n(P,d,p,S=>{if(!m)return m=!0,clearTimeout(f),b(S)})})}e.findFreePort=L;function n(P,d,c,p){if(d===0)return p(0);const m=new E.Socket;m.once("connect",()=>(R(m),n(P+c,d-1,c,p))),m.once("data",()=>{}),m.once("error",b=>(R(m),b.code!=="ECONNREFUSED"?n(P+c,d-1,c,p):p(P))),m.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(P,d,c,p="127.0.0.1"){let m=!1,b,f=1;const S=E.createServer({pauseOnConnect:!0});function w(r,g){m||(m=!0,S.removeAllListeners(),S.close(),b&&clearTimeout(b),g(r))}return new Promise(r=>{b=setTimeout(()=>{w(0,r)},c),S.on("listening",()=>{w(P,r)}),S.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<d?(P++,f++,S.listen(P,p)):w(0,r)}),S.on("close",()=>{w(0,r)}),S.listen(P,p)})}e.findFreePortFaster=A;function R(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),define(ee[137],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[138],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(n,A){this.a=n,this.onMessage=A}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[42],te([0,1,14,13]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(R,P){const d=(c,...p)=>{this.b(R,c)&&P(c,...p)};return this.a.set(P,d),E.ipcMain.on(R,d),this}once(R,P){return E.ipcMain.once(R,(d,...c)=>{this.b(R,d)&&P(d,...c)}),this}handle(R,P){return E.ipcMain.handle(R,(d,...c)=>this.b(R,d)?P(d,...c):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return E.ipcMain.removeHandler(R),this}removeListener(R,P){const d=this.a.get(P);return d&&(E.ipcMain.removeListener(R,d),this.a.delete(P)),this}b(R,P){if(!R||!R.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const d=P.senderFrame,c=d.url;if(!c)return!0;let p="unknown";try{p=new URL(c).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${c}'.`),!1}return p!=="vscode-app"?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${p}'.`),!1):d.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ee[139],te([0,1,14,42,11,137]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){L.validatedIpcMain.on(A.CONTEXT_MENU_CHANNEL,(d,c,p,m,b)=>{const f=P(d,m,p);f.popup({window:(0,n.withNullAsUndefined)(E.BrowserWindow.fromWebContents(d.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{f&&d.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,c)}})})}e.registerContextMenuListener=R;function P(d,c,p){const m=new E.Menu;return p.forEach(b=>{let f;b.type==="separator"?f=new E.MenuItem({type:b.type}):Array.isArray(b.submenu)?f=new E.MenuItem({submenu:P(d,c,b.submenu),label:b.label}):f=new E.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(S,w,r)=>d.sender.send(c,b.id,r)}),m.append(f)}),m}}),define(ee[140],te([12,10]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[141],te([0,1,140]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,n=L*60,A=n*24,R=A*7,P=A*30,d=A*365;function c(m,b,f,S){typeof m!="number"&&(m=m.getTime());const w=Math.round((new Date().getTime()-m)/1e3);if(w<-30)return(0,E.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,E.localize)(1,null);let r;return w<L?(r=w,b?r===1?f?(0,E.localize)(2,null,r):(0,E.localize)(3,null,r):f?(0,E.localize)(4,null,r):(0,E.localize)(5,null,r):r===1?f?(0,E.localize)(6,null,r):(0,E.localize)(7,null,r):f?(0,E.localize)(8,null,r):(0,E.localize)(9,null,r)):w<n?(r=Math.floor(w/L),b?r===1?f?(0,E.localize)(10,null,r):(0,E.localize)(11,null,r):f?(0,E.localize)(12,null,r):(0,E.localize)(13,null,r):r===1?f?(0,E.localize)(14,null,r):(0,E.localize)(15,null,r):f?(0,E.localize)(16,null,r):(0,E.localize)(17,null,r)):w<A?(r=Math.floor(w/n),b?r===1?f?(0,E.localize)(18,null,r):(0,E.localize)(19,null,r):f?(0,E.localize)(20,null,r):(0,E.localize)(21,null,r):r===1?f?(0,E.localize)(22,null,r):(0,E.localize)(23,null,r):f?(0,E.localize)(24,null,r):(0,E.localize)(25,null,r)):w<R?(r=Math.floor(w/A),b?r===1?(0,E.localize)(26,null,r):(0,E.localize)(27,null,r):r===1?(0,E.localize)(28,null,r):(0,E.localize)(29,null,r)):w<P?(r=Math.floor(w/R),b?r===1?f?(0,E.localize)(30,null,r):(0,E.localize)(31,null,r):f?(0,E.localize)(32,null,r):(0,E.localize)(33,null,r):r===1?f?(0,E.localize)(34,null,r):(0,E.localize)(35,null,r):f?(0,E.localize)(36,null,r):(0,E.localize)(37,null,r)):w<d?(r=Math.floor(w/P),b?r===1?f?(0,E.localize)(38,null,r):(0,E.localize)(39,null,r):f?(0,E.localize)(40,null,r):(0,E.localize)(41,null,r):r===1?f?(0,E.localize)(42,null,r):(0,E.localize)(43,null,r):f?(0,E.localize)(44,null,r):(0,E.localize)(45,null,r)):(r=Math.floor(w/d),b?r===1?f?(0,E.localize)(46,null,r):(0,E.localize)(47,null,r):f?(0,E.localize)(48,null,r):(0,E.localize)(49,null,r):r===1?f?(0,E.localize)(50,null,r):(0,E.localize)(51,null,r):f?(0,E.localize)(52,null,r):(0,E.localize)(53,null,r))}e.fromNow=c;function p(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(ee[142],te([12,10]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[49],te([0,1,23,11,142]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(m,b){return b&&(m.stack||m.stacktrace)?n.localize(0,null,P(m),R(m.stack)||R(m.stacktrace)):P(m)}function R(m){return Array.isArray(m)?m.join(`
`):m}function P(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?n.localize(1,null,m.message):m.message||n.localize(2,null)}function d(m=null,b=!1){if(!m)return n.localize(3,null);if(Array.isArray(m)){const f=E.coalesce(m),S=d(f[0],b);return f.length>1?n.localize(4,null,S,f.length):S}if(L.isString(m))return m;if(m.detail){const f=m.detail;if(f.error)return A(f.error,b);if(f.exception)return A(f.exception,b)}return m.stack?A(m,b):m.message?m.message:n.localize(5,null)}e.toErrorMessage=d;function c(m){const b=m;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=c;function p(m,b){let f;return typeof m=="string"?f=new Error(m):f=m,f.actions=b,f}e.createErrorWithActions=p}),define(ee[143],te([12,10]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ee[144],te([0,1,143]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(n){switch(n){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ee[145],te([12,10]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,145]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,n=!1,A=!1,R=!1,P=!1,d=!1,c=!1,p=!1,m=!1,b=!1,f,S=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,r,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const v=typeof l?.versions?.electron=="string",y=v&&l?.type==="renderer";if(typeof navigator=="object"&&!y)g=navigator.userAgent,L=g.indexOf("Windows")>=0,n=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,b=g?.indexOf("Mobi")>=0,d=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,S=f,w=navigator.language;else if(typeof l=="object"){L=l.platform==="win32",n=l.platform==="darwin",A=l.platform==="linux",R=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,c=v,m=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const I=l.env.VSCODE_NLS_CONFIG;if(I)try{const M=JSON.parse(I),C=M.availableLanguages["*"];f=M.locale,w=M.osLocale,S=C||e.LANGUAGE_DEFAULT,r=M._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var D;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(D||(e.Platform=D={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let a=0;n?a=1:L?a=3:A&&(a=2),e.isWindows=L,e.isMacintosh=n,e.isLinux=A,e.isLinuxSnap=R,e.isNative=P,e.isElectron=c,e.isWeb=d,e.isWebWorker=d&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=b,e.isCI=m,e.platform=a,e.userAgent=g,e.language=S;var i;(function(I){function M(){return e.language}I.value=M;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=C;function O(){return e.language==="en"}I.isDefault=O})(i||(e.Language=i={})),e.locale=f,e.platformLocale=w,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let O=0,W=I.length;O<W;O++){const q=I[O];if(q.id===C.data.vscodeScheduleAsyncWork){I.splice(O,1),q.callback();return}}});let M=0;return C=>{const O=++M;I.push({id:O,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return I=>setTimeout(I)})();var s;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=n||p?2:L?1:3;let o=!0,u=!1;function h(){if(!u){u=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,o=new Uint16Array(I.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=h,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const n=E.globals.vscode.process;L={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ee[9],te([0,1,36]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,n=97,A=90,R=122,P=46,d=47,c=92,p=58,m=63;class b extends Error{constructor(a,i,s){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const u=a.indexOf(".")!==-1?"property":"argument";let h=`The "${a}" ${u} ${o} of type ${i}`;h+=`. Received type ${typeof s}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,a){if(t===null||typeof t!="object")throw new b(a,"Object",t)}function S(t,a){if(typeof t!="string")throw new b(a,"string",t)}const w=E.platform==="win32";function r(t){return t===d||t===c}function g(t){return t===d}function l(t){return t>=L&&t<=A||t>=n&&t<=R}function v(t,a,i,s){let o="",u=0,h=-1,I=0,M=0;for(let C=0;C<=t.length;++C){if(C<t.length)M=t.charCodeAt(C);else{if(s(M))break;M=d}if(s(M)){if(!(h===C-1||I===1))if(I===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const O=o.lastIndexOf(i);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(i)),h=C,I=0;continue}else if(o.length!==0){o="",u=0,h=C,I=0;continue}}a&&(o+=o.length>0?`${i}..`:"..",u=2)}else o.length>0?o+=`${i}${t.slice(h+1,C)}`:o=t.slice(h+1,C),u=C-h-1;h=C,I=0}else M===P&&I!==-1?++I:I=-1}return o}function y(t,a){f(a,"pathObject");const i=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${s}`:`${i}${t}${s}`:s}e.win32={resolve(...t){let a="",i="",s=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],S(u,"path"),u.length===0)continue}else a.length===0?u=E.cwd():(u=E.env[`=${a}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==a.toLowerCase()&&u.charCodeAt(2)===c)&&(u=`${a}\\`));const h=u.length;let I=0,M="",C=!1;const O=u.charCodeAt(0);if(h===1)r(O)&&(I=1,C=!0);else if(r(O))if(C=!0,r(u.charCodeAt(1))){let W=2,q=W;for(;W<h&&!r(u.charCodeAt(W));)W++;if(W<h&&W!==q){const V=u.slice(q,W);for(q=W;W<h&&r(u.charCodeAt(W));)W++;if(W<h&&W!==q){for(q=W;W<h&&!r(u.charCodeAt(W));)W++;(W===h||W!==q)&&(M=`\\\\${V}\\${u.slice(q,W)}`,I=W)}}}else I=1;else l(O)&&u.charCodeAt(1)===p&&(M=u.slice(0,2),I=2,h>2&&r(u.charCodeAt(2))&&(C=!0,I=3));if(M.length>0)if(a.length>0){if(M.toLowerCase()!==a.toLowerCase())continue}else a=M;if(s){if(a.length>0)break}else if(i=`${u.slice(I)}\\${i}`,s=C,C&&a.length>0)break}return i=v(i,!s,"\\",r),s?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){S(t,"path");const a=t.length;if(a===0)return".";let i=0,s,o=!1;const u=t.charCodeAt(0);if(a===1)return g(u)?"\\":t;if(r(u))if(o=!0,r(t.charCodeAt(1))){let I=2,M=I;for(;I<a&&!r(t.charCodeAt(I));)I++;if(I<a&&I!==M){const C=t.slice(M,I);for(M=I;I<a&&r(t.charCodeAt(I));)I++;if(I<a&&I!==M){for(M=I;I<a&&!r(t.charCodeAt(I));)I++;if(I===a)return`\\\\${C}\\${t.slice(M)}\\`;I!==M&&(s=`\\\\${C}\\${t.slice(M,I)}`,i=I)}}}else i=1;else l(u)&&t.charCodeAt(1)===p&&(s=t.slice(0,2),i=2,a>2&&r(t.charCodeAt(2))&&(o=!0,i=3));let h=i<a?v(t.slice(i),!o,"\\",r):"";return h.length===0&&!o&&(h="."),h.length>0&&r(t.charCodeAt(a-1))&&(h+="\\"),s===void 0?o?`\\${h}`:h:o?`${s}\\${h}`:`${s}${h}`},isAbsolute(t){S(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return r(i)||a>2&&l(i)&&t.charCodeAt(1)===p&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let u=0;u<t.length;++u){const h=t[u];S(h,"path"),h.length>0&&(a===void 0?a=i=h:a+=`\\${h}`)}if(a===void 0)return".";let s=!0,o=0;if(typeof i=="string"&&r(i.charCodeAt(0))){++o;const u=i.length;u>1&&r(i.charCodeAt(1))&&(++o,u>2&&(r(i.charCodeAt(2))?++o:s=!1))}if(s){for(;o<a.length&&r(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a)return"";const i=e.win32.resolve(t),s=e.win32.resolve(a);if(i===s||(t=i.toLowerCase(),a=s.toLowerCase(),t===a))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===c;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===c;)u--;const h=u-o;let I=0;for(;I<a.length&&a.charCodeAt(I)===c;)I++;let M=a.length;for(;M-1>I&&a.charCodeAt(M-1)===c;)M--;const C=M-I,O=h<C?h:C;let W=-1,q=0;for(;q<O;q++){const _=t.charCodeAt(o+q);if(_!==a.charCodeAt(I+q))break;_===c&&(W=q)}if(q!==O){if(W===-1)return s}else{if(C>O){if(a.charCodeAt(I+q)===c)return s.slice(I+q+1);if(q===2)return s.slice(I+q)}h>O&&(t.charCodeAt(o+q)===c?W=q:q===2&&(W=3)),W===-1&&(W=0)}let V="";for(q=o+W+1;q<=u;++q)(q===u||t.charCodeAt(q)===c)&&(V+=V.length===0?"..":"\\..");return I+=W,V.length>0?`${V}${s.slice(I,M)}`:(s.charCodeAt(I)===c&&++I,s.slice(I,M))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===c){if(a.charCodeAt(1)===c){const i=a.charCodeAt(2);if(i!==m&&i!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(l(a.charCodeAt(0))&&a.charCodeAt(1)===p&&a.charCodeAt(2)===c)return`\\\\?\\${a}`;return t},dirname(t){S(t,"path");const a=t.length;if(a===0)return".";let i=-1,s=0;const o=t.charCodeAt(0);if(a===1)return r(o)?t:".";if(r(o)){if(i=s=1,r(t.charCodeAt(1))){let I=2,M=I;for(;I<a&&!r(t.charCodeAt(I));)I++;if(I<a&&I!==M){for(M=I;I<a&&r(t.charCodeAt(I));)I++;if(I<a&&I!==M){for(M=I;I<a&&!r(t.charCodeAt(I));)I++;if(I===a)return t;I!==M&&(i=s=I+1)}}}}else l(o)&&t.charCodeAt(1)===p&&(i=a>2&&r(t.charCodeAt(2))?3:2,s=i);let u=-1,h=!0;for(let I=a-1;I>=s;--I)if(r(t.charCodeAt(I))){if(!h){u=I;break}}else h=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let i=0,s=-1,o=!0,u;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let h=a.length-1,I=-1;for(u=t.length-1;u>=i;--u){const M=t.charCodeAt(u);if(r(M)){if(!o){i=u+1;break}}else I===-1&&(o=!1,I=u+1),h>=0&&(M===a.charCodeAt(h)?--h===-1&&(s=u):(h=-1,s=I))}return i===s?s=I:s===-1&&(s=t.length),t.slice(i,s)}for(u=t.length-1;u>=i;--u)if(r(t.charCodeAt(u))){if(!o){i=u+1;break}}else s===-1&&(o=!1,s=u+1);return s===-1?"":t.slice(i,s)},extname(t){S(t,"path");let a=0,i=-1,s=0,o=-1,u=!0,h=0;t.length>=2&&t.charCodeAt(1)===p&&l(t.charCodeAt(0))&&(a=s=2);for(let I=t.length-1;I>=a;--I){const M=t.charCodeAt(I);if(r(M)){if(!u){s=I+1;break}continue}o===-1&&(u=!1,o=I+1),M===P?i===-1?i=I:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||o===-1||h===0||h===1&&i===o-1&&i===s+1?"":t.slice(i,o)},format:y.bind(null,"\\"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let s=0,o=t.charCodeAt(0);if(i===1)return r(o)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(r(o)){if(s=1,r(t.charCodeAt(1))){let W=2,q=W;for(;W<i&&!r(t.charCodeAt(W));)W++;if(W<i&&W!==q){for(q=W;W<i&&r(t.charCodeAt(W));)W++;if(W<i&&W!==q){for(q=W;W<i&&!r(t.charCodeAt(W));)W++;W===i?s=W:W!==q&&(s=W+1)}}}}else if(l(o)&&t.charCodeAt(1)===p){if(i<=2)return a.root=a.dir=t,a;if(s=2,r(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;s=3}}s>0&&(a.root=t.slice(0,s));let u=-1,h=s,I=-1,M=!0,C=t.length-1,O=0;for(;C>=s;--C){if(o=t.charCodeAt(C),r(o)){if(!M){h=C+1;break}continue}I===-1&&(M=!1,I=C+1),o===P?u===-1?u=C:O!==1&&(O=1):u!==-1&&(O=-1)}return I!==-1&&(u===-1||O===0||O===1&&u===I-1&&u===h+1?a.base=a.name=t.slice(h,I):(a.name=t.slice(h,u),a.base=t.slice(h,I),a.ext=t.slice(u,I))),h>0&&h!==s?a.dir=t.slice(0,h-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(w){const t=/\\/g;return()=>{const a=E.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let s=t.length-1;s>=-1&&!i;s--){const o=s>=0?t[s]:D();S(o,"path"),o.length!==0&&(a=`${o}/${a}`,i=o.charCodeAt(0)===d)}return a=v(a,!i,"/",g),i?`/${a}`:a.length>0?a:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===d,i=t.charCodeAt(t.length-1)===d;return t=v(t,!a,"/",g),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===d},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const s=t[i];S(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(S(t,"from"),S(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,s=t.length,o=s-i,u=1,h=a.length-u,I=o<h?o:h;let M=-1,C=0;for(;C<I;C++){const W=t.charCodeAt(i+C);if(W!==a.charCodeAt(u+C))break;W===d&&(M=C)}if(C===I)if(h>I){if(a.charCodeAt(u+C)===d)return a.slice(u+C+1);if(C===0)return a.slice(u+C)}else o>I&&(t.charCodeAt(i+C)===d?M=C:C===0&&(M=0));let O="";for(C=i+M+1;C<=s;++C)(C===s||t.charCodeAt(C)===d)&&(O+=O.length===0?"..":"/..");return`${O}${a.slice(u+M)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===d;let i=-1,s=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===d){if(!s){i=o;break}}else s=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&S(a,"ext"),S(t,"path");let i=0,s=-1,o=!0,u;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let h=a.length-1,I=-1;for(u=t.length-1;u>=0;--u){const M=t.charCodeAt(u);if(M===d){if(!o){i=u+1;break}}else I===-1&&(o=!1,I=u+1),h>=0&&(M===a.charCodeAt(h)?--h===-1&&(s=u):(h=-1,s=I))}return i===s?s=I:s===-1&&(s=t.length),t.slice(i,s)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===d){if(!o){i=u+1;break}}else s===-1&&(o=!1,s=u+1);return s===-1?"":t.slice(i,s)},extname(t){S(t,"path");let a=-1,i=0,s=-1,o=!0,u=0;for(let h=t.length-1;h>=0;--h){const I=t.charCodeAt(h);if(I===d){if(!o){i=h+1;break}continue}s===-1&&(o=!1,s=h+1),I===P?a===-1?a=h:u!==1&&(u=1):a!==-1&&(u=-1)}return a===-1||s===-1||u===0||u===1&&a===s-1&&a===i+1?"":t.slice(a,s)},format:y.bind(null,"/"),parse(t){S(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===d;let s;i?(a.root="/",s=1):s=0;let o=-1,u=0,h=-1,I=!0,M=t.length-1,C=0;for(;M>=s;--M){const O=t.charCodeAt(M);if(O===d){if(!I){u=M+1;break}continue}h===-1&&(I=!1,h=M+1),O===P?o===-1?o=M:C!==1&&(C=1):o!==-1&&(C=-1)}if(h!==-1){const O=u===0&&i?1:u;o===-1||C===0||C===1&&o===h-1&&o===u+1?a.base=a.name=t.slice(O,h):(a.name=t.slice(O,o),a.base=t.slice(O,h),a.ext=t.slice(o,h))}return u>0?a.dir=t.slice(0,u-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ee[71],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(L||(e.Source=L={}));var n;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(n||(e.TerminateResponseCode=n={}));function A(P,...d){const c=d.reduce((b,f)=>(b[f]=!0,b),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!c[b]).forEach(b=>{for(let f=0;f<p.length;f++)if(b.search(p[f])!==-1){delete P[b];break}})}e.sanitizeProcessEnvironment=A;function R(P){P&&(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ee[83],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=E.globals.performance&&typeof E.globals.performance.now=="function";class n{static create(R=!0){return new n(R)}constructor(R){this.a=L&&R,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=n}),define(ee[3],te([0,1,13,48,2,99,83]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,d=!1;var c;(function(u){u.None=()=>n.Disposable.None;function h(N){if(d){const{onDidAddListener:U}=N,$=S.create();let x=0;N.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$.print()),U?.()}}}function I(N,U){return re(N,()=>{},0,void 0,!0,void 0,U)}u.defer=I;function M(N){return(U,$=null,x)=>{let K=!1,se;return se=N(de=>{if(!K)return se?se.dispose():K=!0,U.call($,de)},null,x),K&&se.dispose(),se}}u.once=M;function C(N,U,$){return ne((x,K=null,se)=>N(de=>x.call(K,U(de)),null,se),$)}u.map=C;function O(N,U,$){return ne((x,K=null,se)=>N(de=>{U(de),x.call(K,de)},null,se),$)}u.forEach=O;function W(N,U,$){return ne((x,K=null,se)=>N(de=>U(de)&&x.call(K,de),null,se),$)}u.filter=W;function q(N){return N}u.signal=q;function V(...N){return(U,$=null,x)=>(0,n.combinedDisposable)(...N.map(K=>K(se=>U.call($,se),null,x)))}u.any=V;function _(N,U,$,x){let K=$;return C(N,se=>(K=U(K,se),K),x)}u.reduce=_;function ne(N,U){let $;const x={onWillAddFirstListener(){$=N(K.fire,K)},onDidRemoveLastListener(){$?.dispose()}};U||h(x);const K=new r(x);return U?.add(K),K.event}function re(N,U,$=100,x=!1,K=!1,se,de){let Ee,De,Se,Ae=0,ze;const ge={leakWarningThreshold:se,onWillAddFirstListener(){Ee=N(Me=>{Ae++,De=U(De,Me),x&&!Se&&(we.fire(De),De=void 0),ze=()=>{const ie=De;De=void 0,Se=void 0,(!x||Ae>1)&&we.fire(ie),Ae=0},typeof $=="number"?(clearTimeout(Se),Se=setTimeout(ze,$)):Se===void 0&&(Se=0,queueMicrotask(ze))})},onWillRemoveListener(){K&&Ae>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,Ee.dispose()}};de||h(ge);const we=new r(ge);return de?.add(we),we.event}u.debounce=re;function ue(N,U=0,$){return u.debounce(N,(x,K)=>x?(x.push(K),x):[K],U,void 0,!0,void 0,$)}u.accumulate=ue;function ce(N,U=(x,K)=>x===K,$){let x=!0,K;return W(N,se=>{const de=x||!U(se,K);return x=!1,K=se,de},$)}u.latch=ce;function J(N,U,$){return[u.filter(N,U,$),u.filter(N,x=>!U(x),$)]}u.split=J;function H(N,U=!1,$=[]){let x=$.slice(),K=N(Ee=>{x?x.push(Ee):de.fire(Ee)});const se=()=>{x?.forEach(Ee=>de.fire(Ee)),x=null},de=new r({onWillAddFirstListener(){K||(K=N(Ee=>de.fire(Ee)))},onDidAddFirstListener(){x&&(U?setTimeout(se):se())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return de.event}u.buffer=H;class j{constructor(U){this.event=U,this.c=new n.DisposableStore}map(U){return new j(C(this.event,U,this.c))}forEach(U){return new j(O(this.event,U,this.c))}filter(U){return new j(W(this.event,U,this.c))}reduce(U,$){return new j(_(this.event,U,$,this.c))}latch(){return new j(ce(this.event,void 0,this.c))}debounce(U,$=100,x=!1,K=!1,se){return new j(re(this.event,U,$,x,K,se,this.c))}on(U,$,x){return this.event(U,$,x)}once(U,$,x){return M(this.event)(U,$,x)}dispose(){this.c.dispose()}}function z(N){return new j(N)}u.chain=z;function X(N,U,$=x=>x){const x=(...Ee)=>de.fire($(...Ee)),K=()=>N.on(U,x),se=()=>N.removeListener(U,x),de=new r({onWillAddFirstListener:K,onDidRemoveLastListener:se});return de.event}u.fromNodeEventEmitter=X;function Z(N,U,$=x=>x){const x=(...Ee)=>de.fire($(...Ee)),K=()=>N.addEventListener(U,x),se=()=>N.removeEventListener(U,x),de=new r({onWillAddFirstListener:K,onDidRemoveLastListener:se});return de.event}u.fromDOMEventEmitter=Z;function oe(N){return new Promise(U=>M(N)(U))}u.toPromise=oe;function ae(N,U){return U(void 0),N($=>U($))}u.runAndSubscribe=ae;function B(N,U){let $=null;function x(se){$?.dispose(),$=new n.DisposableStore,U(se,$)}x(void 0);const K=N(se=>x(se));return(0,n.toDisposable)(()=>{K.dispose(),$?.dispose()})}u.runAndSubscribeWithStore=B;class T{constructor(U,$){this._observable=U,this.c=0,this.d=!1;const x={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};$||h(x),this.emitter=new r(x),$&&$.add(this.emitter)}beginUpdate(U){this.c++}handlePossibleChange(U){}handleChange(U,$){this.d=!0}endUpdate(U){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function k(N,U){return new T(N,U).emitter.event}u.fromObservable=k;function F(N){return U=>{let $=0,x=!1;const K={beginUpdate(){$++},endUpdate(){$--,$===0&&(N.reportChanges(),x&&(x=!1,U()))},handlePossibleChange(){},handleChange(){x=!0}};return N.addObserver(K),{dispose(){N.removeObserver(K)}}}}u.fromObservableLight=F})(c||(e.Event=c={}));class p{constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${p.c++}`,p.all.add(this)}start(h){this.d=new R.StopWatch(!0),this.listenerCount=h}stop(){if(this.d){const h=this.d.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=p,p.all=new Set,p.c=0;let m=-1;function b(u){const h=m;return m=u,{dispose(){m=h}}}e.setGlobalLeakWarningThreshold=b;class f{constructor(h,I=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=I,this.d=0}dispose(){this.c?.clear()}check(h,I){const M=this.threshold;if(M<=0||I<M)return;this.c||(this.c=new Map);const C=this.c.get(h.value)||0;if(this.c.set(h.value,C+1),this.d-=1,this.d<=0){this.d=M*.5;let O,W=0;for(const[q,V]of this.c)(!O||W<V)&&(O=q,W=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${W}):`),console.warn(O)}return()=>{const O=this.c.get(h.value)||0;this.c.set(h.value,O-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(h,I,M){this.callback=h,this.callbackThis=I,this.stack=M,this.subscription=new n.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class r{constructor(h){this.j=!1,this.d=h,this.f=m>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??m):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const h=Array.from(this.q);queueMicrotask(()=>{for(const I of h)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(h,I,M)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const C=this.q.isEmpty();C&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,W;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(W=S.create(),O=this.f.check(W,this.q.size+1)),P&&(W=W??S.create());const q=new w(h,I,W),V=this.q.push(q);C&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,h,I);const _=q.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof n.DisposableStore?M.add(_):Array.isArray(M)&&M.push(_),_}),this.l}fire(h){if(this.q){this.m||(this.m=new l(this.d?.onListenerError));for(const I of this.q)this.m.push(this,I,h);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class g{constructor(h=E.onUnexpectedError){this.d=h,this.c=new A.LinkedList}get size(){return this.c.size}push(h,I,M){this.c.push(new v(h,I,M))}clear(h){const I=new A.LinkedList;for(const M of this.c)M.emitter!==h&&I.push(M);this.c=I}deliver(){for(;this.c.size>0;){const h=this.c.shift();try{h.listener.invoke(h.event)}catch(I){this.d(I)}}}}e.EventDeliveryQueue=g;class l extends g{clear(h){this.c.clear()}}class v{constructor(h,I,M){this.emitter=h,this.listener=I,this.event=M}}class y extends r{async fireAsync(h,I,M){if(this.q){this.c||(this.c=new A.LinkedList);for(const C of this.q)this.c.push([C,h]);for(;this.c.size>0&&!I.isCancellationRequested;){const[C,O]=this.c.shift(),W=[],q={...O,token:I,waitUntil:V=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");M&&(V=M(V,C.callback)),W.push(V)}};try{C.invoke(q)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(W),await Promise.allSettled(W).then(V=>{for(const _ of V)_.status==="rejected"&&(0,E.onUnexpectedError)(_.reason)})}}}}e.AsyncEmitter=y;class D extends r{constructor(h){super(h),this.h=0,this.s=new A.LinkedList,this.t=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.t(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.q&&(this.h!==0?this.s.push(h):super.fire(h))}}e.PauseableEmitter=D;class t extends D{constructor(h){super(h),this.c=h.delay??100}fire(h){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(h)}}e.DebounceEmitter=t;class a extends r{constructor(h){super(h),this.c=[],this.h=h?.merge}fire(h){this.hasListeners()&&(this.c.push(h),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(I=>super.fire(I)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(h){const I={event:h,listener:null};this.f.push(I),this.d&&this.j(I);const M=()=>{this.d&&this.k(I);const C=this.f.indexOf(I);this.f.splice(C,1)};return(0,n.toDisposable)((0,L.once)(M))}g(){this.d=!0,this.f.forEach(h=>this.j(h))}h(){this.d=!1,this.f.forEach(h=>this.k(h))}j(h){h.listener=h.event(I=>this.c.fire(I))}k(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.c=[]}wrapEvent(h){return(I,M,C)=>h(O=>{const W=this.c[this.c.length-1];W?W.push(()=>I.call(M,O)):I.call(M,O)},void 0,C)}bufferEvents(h){const I=[];this.c.push(I);const M=h();return this.c.pop(),I.forEach(C=>C()),M}}e.EventBufferer=s;class o{constructor(){this.c=!1,this.d=c.None,this.f=n.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(h){this.d=h,this.c&&(this.f.dispose(),this.f=h(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ee[22],te([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,d){const c=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(c)}}});var n;(function(P){function d(c){return c===P.None||c===P.Cancelled||c instanceof A?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(n||(e.CancellationToken=n={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(d){this.a=void 0,this.b=void 0,this.b=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=n.Cancelled}dispose(d=!1){d&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=R}),define(ee[146],te([0,1,22]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=L;class n{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.LRUCachedFunction=n;class A{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.CachedFunction=A}),define(ee[27],te([0,1,146,129]),function(G,e,E,L){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=A;const R=/{(\d+)}/g;function P(Y,...le){return le.length===0?Y:Y.replace(R,function(pe,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=le.length?pe:le[be]})}e.format=P;const d=/{([^}]+)}/g;function c(Y,le){return Y.replace(d,(pe,me)=>le[me]??pe)}e.format2=c;function p(Y){return Y.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=p;function m(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function b(Y,le){let pe=0;const me=le.charCodeAt(0);for(let be=Y.length-1;be>=0;be--)Y.charCodeAt(be)===me&&pe++;return pe}e.count=b;function f(Y,le,pe="\u2026"){return Y.length<=le?Y:`${Y.substr(0,le)}${pe}`}e.truncate=f;function S(Y,le=" "){const pe=w(Y,le);return r(pe,le)}e.trim=S;function w(Y,le){if(!Y||!le)return Y;const pe=le.length;if(pe===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(le,me)===me;)me=me+pe;return Y.substring(me)}e.ltrim=w;function r(Y,le){if(!Y||!le)return Y;const pe=le.length,me=Y.length;if(pe===0||me===0)return Y;let be=me,Le=-1;for(;Le=Y.lastIndexOf(le,be-1),!(Le===-1||Le+pe!==be);){if(Le===0)return"";be=Le}return Y.substring(0,be)}e.rtrim=r;function g(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function l(Y){return Y.replace(/\*/g,"")}e.stripWildcards=l;function v(Y,le,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");le||(Y=m(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return pe.global&&(me+="g"),pe.matchCase||(me+="i"),pe.multiline&&(me+="m"),pe.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=v;function y(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function D(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=t;function a(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Y){for(let le=0,pe=Y.length;le<pe;le++){const me=Y.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function s(Y,le=0,pe=Y.length){for(let me=le;me<pe;me++){const be=Y.charCodeAt(me);if(be!==32&&be!==9)return Y.substring(le,me)}return Y.substring(le,pe)}e.getLeadingWhitespace=s;function o(Y,le=Y.length-1){for(let pe=le;pe>=0;pe--){const me=Y.charCodeAt(pe);if(me!==32&&me!==9)return pe}return-1}e.lastNonWhitespaceIndex=o;function u(Y,le,pe){const me=[];let be=0;for(const Le of Y.matchAll(le)){if(me.push(Y.slice(be,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");be=Le.index+Le[0].length,me.push(pe(Le[0],...Le.slice(1),Le.index,Y,Le.groups))}return me.push(Y.slice(be)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=u;function h(Y,le){return Y<le?-1:Y>le?1:0}e.compare=h;function I(Y,le,pe=0,me=Y.length,be=0,Le=le.length){for(;pe<me&&be<Le;pe++,be++){const Ze=Y.charCodeAt(pe),Ge=le.charCodeAt(be);if(Ze<Ge)return-1;if(Ze>Ge)return 1}const Ue=me-pe,Ke=Le-be;return Ue<Ke?-1:Ue>Ke?1:0}e.compareSubstring=I;function M(Y,le){return C(Y,le,0,Y.length,0,le.length)}e.compareIgnoreCase=M;function C(Y,le,pe=0,me=Y.length,be=0,Le=le.length){for(;pe<me&&be<Le;pe++,be++){let Ze=Y.charCodeAt(pe),Ge=le.charCodeAt(be);if(Ze===Ge)continue;if(Ze>=128||Ge>=128)return I(Y.toLowerCase(),le.toLowerCase(),pe,me,be,Le);W(Ze)&&(Ze-=32),W(Ge)&&(Ge-=32);const Ye=Ze-Ge;if(Ye!==0)return Ye}const Ue=me-pe,Ke=Le-be;return Ue<Ke?-1:Ue>Ke?1:0}e.compareSubstringIgnoreCase=C;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function W(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=W;function q(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=q;function V(Y,le){return Y.length===le.length&&C(Y,le)===0}e.equalsIgnoreCase=V;function _(Y,le){const pe=le.length;return le.length>Y.length?!1:C(Y,le,0,pe)===0}e.startsWithIgnoreCase=_;function ne(Y,le){const pe=Math.min(Y.length,le.length);let me;for(me=0;me<pe;me++)if(Y.charCodeAt(me)!==le.charCodeAt(me))return me;return pe}e.commonPrefixLength=ne;function re(Y,le){const pe=Math.min(Y.length,le.length);let me;const be=Y.length-1,Le=le.length-1;for(me=0;me<pe;me++)if(Y.charCodeAt(be-me)!==le.charCodeAt(Le-me))return me;return pe}e.commonSuffixLength=re;function ue(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ue;function ce(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=ce;function J(Y,le){return(Y-55296<<10)+(le-56320)+65536}e.computeCodePoint=J;function H(Y,le,pe){const me=Y.charCodeAt(pe);if(ue(me)&&pe+1<le){const be=Y.charCodeAt(pe+1);if(ce(be))return J(me,be)}return me}e.getNextCodePoint=H;function j(Y,le){const pe=Y.charCodeAt(le-1);if(ce(pe)&&le>1){const me=Y.charCodeAt(le-2);if(ue(me))return J(me,pe)}return pe}class z{get offset(){return this.e}constructor(le,pe=0){this.c=le,this.d=le.length,this.e=pe}setOffset(le){this.e=le}prevCodePoint(){const le=j(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=H(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=z;class X{get offset(){return this.c.offset}constructor(le,pe=0){this.c=new z(le,pe)}nextGraphemeLength(){const le=Ce.getInstance(),pe=this.c,me=pe.offset;let be=le.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Le=pe.offset,Ue=le.getGraphemeBreakType(pe.nextCodePoint());if(fe(be,Ue)){pe.setOffset(Le);break}be=Ue}return pe.offset-me}prevGraphemeLength(){const le=Ce.getInstance(),pe=this.c,me=pe.offset;let be=le.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Le=pe.offset,Ue=le.getGraphemeBreakType(pe.prevCodePoint());if(fe(Ue,be)){pe.setOffset(Le);break}be=Ue}return me-pe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=X;function Z(Y,le){return new X(Y,le).nextGraphemeLength()}e.nextCharLength=Z;function oe(Y,le){return new X(Y,le).prevGraphemeLength()}e.prevCharLength=oe;function ae(Y,le){le>0&&ce(Y.charCodeAt(le))&&le--;const pe=le+Z(Y,le);return[pe-oe(Y,pe),pe]}e.getCharContainingOffset=ae;function B(Y){const le=new X(Y);let pe=0;for(;!le.eol();)pe++,le.nextGraphemeLength();return pe}e.charCount=B;let T;function k(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(Y){return T||(T=k()),T.test(Y)}e.containsRTL=F;const N=/^[\t\n\r\x20-\x7E]*$/;function U(Y){return N.test(Y)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=$;function x(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=x;function K(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=K;function se(Y,le){if(Y.length<le)return Y;const pe=/\b/g;let me=0;for(;pe.test(Y)&&!(Y.length-pe.lastIndex<le);)me=pe.lastIndex,pe.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=se;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function De(Y){return Y&&(Y=Y.replace(de,"").replace(Ee,"")),Y}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Ae(Y){return Se(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ae;function ze(Y,le){if(!Y||!le||Y.length<le.length)return!1;const pe=le.length,me=Y.toLowerCase();let be=0,Le=-1;for(;be<pe;){const Ue=me.indexOf(le[be],Le+1);if(Ue<0)return!1;Le=Ue,be++}return!0}e.fuzzyContains=ze;function ge(Y,le=!1){return Y?(le&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ge;function we(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=we;function Me(Y,le=1){if(le===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),le--;while(le>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}e.getNLines=Me;function ie(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=ie;function he(Y){return Ce.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=he;function fe(Y,le){return Y===0?le!==5&&le!==7:Y===2&&le===3?!1:Y===4||Y===2||Y===3||le===4||le===2||le===3?!0:!(Y===8&&(le===8||le===9||le===11||le===12)||(Y===11||Y===9)&&(le===9||le===10)||(Y===12||Y===10)&&le===10||le===5||le===13||le===7||Y===1||Y===13&&le===14||Y===6&&le===6)}var Ie;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(e.GraphemeBreakType=Ie={}));class Ce{static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Oe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const pe=this.d,me=pe.length/3;let be=1;for(;be<=me;)if(le<pe[3*be])be=2*be;else if(le>pe[3*be+1])be=2*be+1;else return pe[3*be+2];return 0}}Ce.c=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(Y,le){if(Y===0)return 0;const pe=He(Y,le);if(pe!==void 0)return pe;const me=new z(le,Y);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Fe;function He(Y,le){const pe=new z(le,Y);let me=pe.prevCodePoint();for(;Ne(me)||me===65039||me===8419;){if(pe.offset===0)return;me=pe.prevCodePoint()}if(!K(me))return;let be=pe.offset;return be>0&&pe.prevCodePoint()===8205&&(be=pe.offset),be}function Ne(Y){return 127995<=Y&&Y<=127999}var $e;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class qe{static getInstance(le){return qe.d.get(Array.from(le))}static getLocales(){return qe.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=qe,n=qe,qe.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new E.LRUCachedFunction(Y=>{function le(Ge){const Ye=new Map;for(let tt=0;tt<Ge.length;tt+=2)Ye.set(Ge[tt],Ge[tt+1]);return Ye}function pe(Ge,Ye){const tt=new Map(Ge);for(const[ot,lt]of Ye)tt.set(ot,lt);return tt}function me(Ge,Ye){if(!Ge)return Ye;const tt=new Map;for(const[ot,lt]of Ge)Ye.has(ot)&&tt.set(ot,lt);return tt}const be=n.c.value;let Le=Y.filter(Ge=>!Ge.startsWith("_")&&Ge in be);Le.length===0&&(Le=["_default"]);let Ue;for(const Ge of Le){const Ye=le(be[Ge]);Ue=me(Ue,Ye)}const Ke=le(be._common),Ze=pe(Ke,Ue);return new qe(Ze)}),qe.e=new L.Lazy(()=>Object.keys(qe.c.value).filter(Y=>!Y.startsWith("_")));class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(le){return We.e().has(le)}static get codePoints(){return We.e()}}e.InvisibleCharacters=We,We.d=void 0}),define(ee[32],te([0,1,9,4,27,11]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(u){return u===47||u===92}e.isPathSeparator=R;function P(u){return u.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function d(u){return u.indexOf("/")===-1&&(u=P(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=d;function c(u,h=E.posix.sep){if(!u)return"";const I=u.length,M=u.charCodeAt(0);if(R(M)){if(R(u.charCodeAt(1))&&!R(u.charCodeAt(2))){let O=3;const W=O;for(;O<I&&!R(u.charCodeAt(O));O++);if(W!==O&&!R(u.charCodeAt(O+1))){for(O+=1;O<I;O++)if(R(u.charCodeAt(O)))return u.slice(0,O+1).replace(/[\\/]/g,h)}}return h}else if(g(M)&&u.charCodeAt(1)===58)return R(u.charCodeAt(2))?u.slice(0,2)+h:u.slice(0,2);let C=u.indexOf("://");if(C!==-1){for(C+=3;C<I;C++)if(R(u.charCodeAt(C)))return u.slice(0,C+1)}return""}e.getRoot=c;function p(u){if(!L.isWindows||!u||u.length<5)return!1;let h=u.charCodeAt(0);if(h!==92||(h=u.charCodeAt(1),h!==92))return!1;let I=2;const M=I;for(;I<u.length&&(h=u.charCodeAt(I),h!==92);I++);return!(M===I||(h=u.charCodeAt(I+1),isNaN(h)||h===92))}e.isUNC=p;const m=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(u,h=L.isWindows){const I=h?m:b;return!(!u||u.length===0||/^\s+$/.test(u)||(I.lastIndex=0,I.test(u))||h&&f.test(u)||u==="."||u===".."||h&&u[u.length-1]==="."||h&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=S;function w(u,h,I){const M=u===h;return!I||M?M:!u||!h?!1:(0,n.equalsIgnoreCase)(u,h)}e.isEqual=w;function r(u,h,I,M=E.sep){if(u===h)return!0;if(!u||!h||h.length>u.length)return!1;if(I){if(!(0,n.startsWithIgnoreCase)(u,h))return!1;if(h.length===u.length)return!0;let O=h.length;return h.charAt(h.length-1)===M&&O--,u.charAt(O)===M}return h.charAt(h.length-1)!==M&&(h+=M),u.indexOf(h)===0}e.isEqualOrParent=r;function g(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=g;function l(u,h){return L.isWindows&&u.endsWith(":")&&(u+=E.sep),(0,E.isAbsolute)(u)||(u=(0,E.join)(h,u)),u=(0,E.normalize)(u),L.isWindows?(u=(0,n.rtrim)(u,E.sep),u.endsWith(":")&&(u+=E.sep)):(u=(0,n.rtrim)(u,E.sep),u||(u=E.sep)),u}e.sanitizeFilePath=l;function v(u){const h=(0,E.normalize)(u);return L.isWindows?u.length>3?!1:y(h)&&(u.length===2||h.charCodeAt(2)===92):h===E.posix.sep}e.isRootOrDriveLetter=v;function y(u,h=L.isWindows){return h?g(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function D(u){return y(u)?u[0]:void 0}e.getDriveLetter=D;function t(u,h,I){return h.length>u.length?-1:u===h?0:(I&&(u=u.toLowerCase(),h=h.toLowerCase()),u.indexOf(h))}e.indexOfPath=t;function a(u){const h=u.split(":");let I,M,C;for(const O of h){const W=Number(O);(0,A.isNumber)(W)?M===void 0?M=W:C===void 0&&(C=W):I=I?[I,O].join(":"):O}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:M!==void 0?M:void 0,column:C!==void 0?C:M!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,h,I=8){let M="";for(let O=0;O<I;O++){let W;O===0&&L.isWindows&&!h&&(I===3||I===4)?W=s:W=i,M+=W.charAt(Math.floor(Math.random()*W.length))}let C;return h?C=`${h}-${M}`:C=M,u?(0,E.join)(u,C):C}e.randomPath=o}),define(ee[56],te([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return n(g,0)}e.hash=L;function n(g,l){switch(typeof g){case"object":return g===null?A(349,l):Array.isArray(g)?d(g,l):c(g,l);case"string":return P(g,l);case"boolean":return R(g,l);case"number":return A(g,l);case"undefined":return A(937,l);default:return A(617,l)}}e.doHash=n;function A(g,l){return(l<<5)-l+g|0}e.numberHash=A;function R(g,l){return A(g?433:863,l)}function P(g,l){l=A(149417,l);for(let v=0,y=g.length;v<y;v++)l=A(g.charCodeAt(v),l);return l}e.stringHash=P;function d(g,l){return l=A(104579,l),g.reduce((v,y)=>n(y,v),l)}function c(g,l){return l=A(181387,l),Object.keys(g).sort().reduce((v,y)=>(v=P(y,v),n(g[y],v)),l)}class p{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=n(l,this.g),this.g}}e.Hasher=p;var m;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function b(g,l,v=32){const y=v-l,D=~((1<<y)-1);return(g<<l|(D&g)>>>y)>>>0}function f(g,l=0,v=g.byteLength,y=0){for(let D=0;D<v;D++)g[l+D]=y}function S(g,l,v="0"){for(;g.length<l;)g=v+g;return g}function w(g,l=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(v=>v.toString(16).padStart(2,"0")).join(""):S((g>>>0).toString(16),l/4)}e.toHexString=w;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const v=l.length;if(v===0)return;const y=this.p;let D=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=l.charCodeAt(0),i=0);;){let s=a;if(E.isHighSurrogate(a))if(i+1<v){const o=l.charCodeAt(i+1);E.isLowSurrogate(o)?(i++,s=E.computeCodePoint(a,o)):s=65533}else{t=a;break}else E.isLowSurrogate(a)&&(s=65533);if(D=this.w(y,D,s),i++,i<v)a=l.charCodeAt(i);else break}this.r=D,this.u=t}w(l,v,y){return y<128?l[v++]=y:y<2048?(l[v++]=192|(y&1984)>>>6,l[v++]=128|(y&63)>>>0):y<65536?(l[v++]=224|(y&61440)>>>12,l[v++]=128|(y&4032)>>>6,l[v++]=128|(y&63)>>>0):(l[v++]=240|(y&1835008)>>>18,l[v++]=128|(y&258048)>>>12,l[v++]=128|(y&4032)>>>6,l[v++]=128|(y&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=r.g,v=this.q;for(let h=0;h<64;h+=4)l.setUint32(h,v.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)l.setUint32(h,b(l.getUint32(h-12,!1)^l.getUint32(h-32,!1)^l.getUint32(h-56,!1)^l.getUint32(h-64,!1),1),!1);let y=this.h,D=this.l,t=this.m,a=this.n,i=this.o,s,o,u;for(let h=0;h<80;h++)h<20?(s=D&t|~D&a,o=1518500249):h<40?(s=D^t^a,o=1859775393):h<60?(s=D&t|D&a|t&a,o=2400959708):(s=D^t^a,o=3395469782),u=b(y,5)+s+i+o+l.getUint32(h*4,!1)&4294967295,i=a,a=t,t=b(D,30),D=y,y=u;this.h=this.h+y&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=r,r.g=new DataView(new ArrayBuffer(320))}),define(ee[72],te([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(L||(L={})),function(n){const A="error",R="warning",P="warn",d="info",c="ignore";function p(b){return b?E.equalsIgnoreCase(A,b)?n.Error:E.equalsIgnoreCase(R,b)||E.equalsIgnoreCase(P,b)?n.Warning:E.equalsIgnoreCase(d,b)?n.Info:n.Ignore:n.Ignore}n.fromValue=p;function m(b){switch(b){case n.Error:return A;case n.Warning:return R;case n.Info:return d;default:return c}}n.toString=m}(L||(L={})),e.default=L}),define(ee[61],te([0,1,23,27]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const S=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return S-w}value(){return this.b[this.c]}}e.StringIterator=n;class A{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,L.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class R{constructor(f=!0,S=!0){this.f=f,this.g=S}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let S=f.length-1;S>=0;S--,this.c--){const w=this.b.charCodeAt(S);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,L.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(f,S){this.f=f,this.g=S,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,L.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=d;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(p||(p={}));class m{static forUris(f=()=>!1,S=()=>!1){return new m(new d(f,S))}static forPaths(f=!1){return new m(new R(void 0,!f))}static forStrings(){return new m(new n)}static forConfigKeys(){return new m(new A)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,S){if(S){const w=S.slice(0);(0,E.shuffle)(w);for(const r of w)this.set(r,f)}else{const w=f.slice(0);(0,E.shuffle)(w);for(const r of w)this.set(r[0],r[1])}}set(f,S){const w=this.b.reset(f);let r;this.c||(this.c=new c,this.c.segment=w.value());const g=[];for(r=this.c;;){const v=w.cmp(r.segment);if(v>0)r.left||(r.left=new c,r.left.segment=w.value()),g.push([-1,r]),r=r.left;else if(v<0)r.right||(r.right=new c,r.right.segment=w.value()),g.push([1,r]),r=r.right;else if(w.hasNext())w.next(),r.mid||(r.mid=new c,r.mid.segment=w.value()),g.push([0,r]),r=r.mid;else break}const l=r.value;r.value=S,r.key=f;for(let v=g.length-1;v>=0;v--){const y=g[v][1];y.updateHeight();const D=y.balanceFactor();if(D<-1||D>1){const t=g[v][0],a=g[v+1][0];if(t===1&&a===1)g[v][1]=y.rotateLeft();else if(t===-1&&a===-1)g[v][1]=y.rotateRight();else if(t===1&&a===-1)y.right=g[v+1][1]=g[v+1][1].rotateRight(),g[v][1]=y.rotateLeft();else if(t===-1&&a===1)y.left=g[v+1][1]=g[v+1][1].rotateLeft(),g[v][1]=y.rotateRight();else throw new Error;if(v>0)switch(g[v-1][0]){case-1:g[v-1][1].left=g[v][1];break;case 1:g[v-1][1].right=g[v][1];break;case 0:g[v-1][1].mid=g[v][1];break}else this.c=g[0][1]}}return l}get(f){return this.d(f)?.value}d(f){const S=this.b.reset(f);let w=this.c;for(;w;){const r=S.cmp(w.segment);if(r>0)w=w.left;else if(r<0)w=w.right;else if(S.hasNext())S.next(),w=w.mid;else break}return w}has(f){const S=this.d(f);return!(S?.value===void 0&&S?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,S){const w=this.b.reset(f),r=[];let g=this.c;for(;g;){const l=w.cmp(g.segment);if(l>0)r.push([-1,g]),g=g.left;else if(l<0)r.push([1,g]),g=g.right;else if(w.hasNext())w.next(),r.push([0,g]),g=g.mid;else break}if(g){if(S?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const l=this.f(g.right);if(l.key){const{key:v,value:y,segment:D}=l;this.e(l.key,!1),g.key=v,g.value=y,g.segment=D}}else{const l=g.left??g.right;if(r.length>0){const[v,y]=r[r.length-1];switch(v){case-1:y.left=l;break;case 0:y.mid=l;break;case 1:y.right=l;break}}else this.c=l}for(let l=r.length-1;l>=0;l--){const v=r[l][1];v.updateHeight();const y=v.balanceFactor();if(y>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),r[l][1]=v.rotateLeft()):y<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),r[l][1]=v.rotateRight()),l>0)switch(r[l-1][0]){case-1:r[l-1][1].left=r[l][1];break;case 1:r[l-1][1].right=r[l][1];break;case 0:r[l-1][1].mid=r[l][1];break}else this.c=r[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const S=this.b.reset(f);let w=this.c,r;for(;w;){const g=S.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(S.hasNext())S.next(),r=w.value||r,w=w.mid;else break}return w&&w.value||r}findSuperstr(f){return this.g(f,!1)}g(f,S){const w=this.b.reset(f);let r=this.c;for(;r;){const g=w.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(w.hasNext())w.next(),r=r.mid;else return r.mid?this.h(r.mid):S?r.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[S,w]of this)f(w,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const S=[];return this.j(f,S),S[Symbol.iterator]()}j(f,S){f&&(f.left&&this.j(f.left,S),f.value&&S.push([f.key,f.value]),f.mid&&this.j(f.mid,S),f.right&&this.j(f.right,S))}_isBalanced(){const f=S=>{if(!S)return!0;const w=S.balanceFactor();return w<-1||w>1?!1:f(S.left)&&f(S.right)};return f(this.c)}}e.TernarySearchTree=m}),define(ee[8],te([0,1,9,4]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==m&&(s=m+s):s=m;break}return s}const p="",m="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(s){return s instanceof f?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,u,h,I,M=!1){typeof s=="object"?(this.scheme=s.scheme||p,this.authority=s.authority||p,this.path=s.path||p,this.query=s.query||p,this.fragment=s.fragment||p):(this.scheme=d(s,M),this.authority=o||p,this.path=c(this.scheme,u||p),this.query=h||p,this.fragment=I||p,P(this,M))}get fsPath(){return v(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:u,path:h,query:I,fragment:M}=s;return o===void 0?o=this.scheme:o===null&&(o=p),u===void 0?u=this.authority:u===null&&(u=p),h===void 0?h=this.path:h===null&&(h=p),I===void 0?I=this.query:I===null&&(I=p),M===void 0?M=this.fragment:M===null&&(M=p),o===this.scheme&&u===this.authority&&h===this.path&&I===this.query&&M===this.fragment?this:new w(o,u,h,I,M)}static parse(s,o=!1){const u=b.exec(s);return u?new w(u[2]||p,a(u[4]||p),a(u[5]||p),a(u[7]||p),a(u[9]||p),o):new w(p,p,p,p,p)}static file(s){let o=p;if(L.isWindows&&(s=s.replace(/\\/g,m)),s[0]===m&&s[1]===m){const u=s.indexOf(m,2);u===-1?(o=s.substring(2),s=m):(o=s.substring(2,u),s=s.substring(u)||m)}return new w("file",o,s,p,p)}static from(s){const o=new w(s.scheme,s.authority,s.path,s.query,s.fragment);return P(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return L.isWindows&&s.scheme==="file"?u=f.file(E.win32.join(v(s,!0),...o)).path:u=E.posix.join(s.path,...o),s.with({path:u})}toString(s=!1){return y(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof f)return s;{const o=new w(s);return o._formatted=s.external,o._fsPath=s._sep===S?s.fsPath:null,o}}else return s}}e.URI=f;const S=L.isWindows?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(s=!1){return s?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=S),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,s,o){let u,h=-1;for(let I=0;I<i.length;I++){const M=i.charCodeAt(I);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||s&&M===47||o&&M===91||o&&M===93||o&&M===58)h!==-1&&(u+=encodeURIComponent(i.substring(h,I)),h=-1),u!==void 0&&(u+=i.charAt(I));else{u===void 0&&(u=i.substr(0,I));const C=r[M];C!==void 0?(h!==-1&&(u+=encodeURIComponent(i.substring(h,I)),h=-1),u+=C):h===-1&&(h=I)}}return h!==-1&&(u+=encodeURIComponent(i.substring(h))),u!==void 0?u:i}function l(i){let s;for(let o=0;o<i.length;o++){const u=i.charCodeAt(o);u===35||u===63?(s===void 0&&(s=i.substr(0,o)),s+=r[u]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function v(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=v;function y(i,s){const o=s?l:g;let u="",{scheme:h,authority:I,path:M,query:C,fragment:O}=i;if(h&&(u+=h,u+=":"),(I||h==="file")&&(u+=m,u+=m),I){let W=I.indexOf("@");if(W!==-1){const q=I.substr(0,W);I=I.substr(W+1),W=q.lastIndexOf(":"),W===-1?u+=o(q,!1,!1):(u+=o(q.substr(0,W),!1,!1),u+=":",u+=o(q.substr(W+1),!1,!0)),u+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?u+=o(I,!1,!0):(u+=o(I.substr(0,W),!1,!0),u+=I.substr(W))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const W=M.charCodeAt(1);W>=65&&W<=90&&(M=`/${String.fromCharCode(W+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const W=M.charCodeAt(0);W>=65&&W<=90&&(M=`${String.fromCharCode(W+32)}:${M.substr(2)}`)}u+=o(M,!0,!1)}return C&&(u+="?",u+=o(C,!1,!1)),O&&(u+="#",u+=s?O:g(O,!1,!1)),u}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,s=>D(s)):i}}),define(ee[147],te([0,1,8]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(c){const p=c;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=L;function n(c){const p=[];let m;try{const b=JSON.parse(c.arguments),f=b[b.length-1];f&&f.__$stack&&(b.pop(),m=f.__$stack),p.push(...b)}catch{p.push("Unable to log remote console arguments",c.arguments)}return{args:p,stack:m}}e.parse=n;function A(c){if(typeof c!="string")return A(n(c).stack);const p=c;if(p){const m=R(p),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(b&&b.length===4)return{uri:E.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=A;function R(c){if(!c)return c;const p=c.indexOf(`
`);return p===-1?c:c.substring(0,p)}function P(c,p){const{args:m,stack:b}=n(c),f=typeof m[0]=="string"&&m.length===1;let S=R(b);S&&(S=`(${S.trim()})`);let w=[];if(typeof m[0]=="string"?S&&f?w=[`%c[${p}] %c${m[0]} %c${S}`,d("blue"),d(""),d("grey")]:w=[`%c[${p}] %c${m[0]}`,d("blue"),d(""),...m.slice(1)]:w=[`%c[${p}]%`,d("blue"),...m],S&&!f&&w.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=P;function d(c){return`color: ${c}`}}),define(ee[84],te([0,1,17,27,8]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(c){return JSON.stringify(c,P)}e.stringify=A;function R(c){let p=JSON.parse(c);return p=d(p),p}e.parse=R;function P(c,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,L.regExpFlags)(p)}:p}function d(c,p=0){if(!c||p>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return n.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof E.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let m=0;m<c.length;++m)c[m]=d(c[m],p+1);else for(const m in c)Object.hasOwnProperty.call(c,m)&&(c[m]=d(c[m],p+1))}return c}e.revive=d}),define(ee[15],te([0,1,13,4,8]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractive="vscode-interactive",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeInteractiveSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${A.vscodeRemoteResource}`}set(p,m,b){this.a[p]=m,this.b[p]=b}setConnectionToken(p,m){this.c[p]=m}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(r){return E.onUnexpectedError(r),p}const m=p.authority;let b=this.a[m];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const f=this.b[m],S=this.c[m];let w=`path=${encodeURIComponent(p.path)}`;return typeof S=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),n.URI.from({scheme:L.isWeb?this.d:A.vscodeRemoteResource,authority:`${b}:${f}`,path:this.f,query:w})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(p){const m=this.b(p,G);return this.uriToBrowserUri(m)}uriToBrowserUri(p){return p.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${P.a}`)?p.with({scheme:A.vscodeFileResource,authority:p.authority||P.a,query:null,fragment:null}):p}asFileUri(p){const m=this.b(p,G);return this.uriToFileUri(m)}uriToFileUri(p){return p.scheme===A.vscodeFileResource?p.with({scheme:A.file,authority:p.authority!==P.a?p.authority:null,query:null,fragment:null}):p}b(p,m){return n.URI.isUri(p)?p:n.URI.parse(m.toUrl(p))}}P.a="vscode-app",e.FileAccess=new P;var d;(function(c){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(p.get("3"));const m="vscode-coi";function b(S){let w;typeof S=="string"?w=new URL(S).searchParams:S instanceof URL?w=S.searchParams:n.URI.isUri(S)&&(w=new URL(S.toString(!0)).searchParams);const r=w?.get(m);if(r)return p.get(r)}c.getHeadersFromQuery=b;function f(S,w,r){if(!globalThis.crossOriginIsolated)return;const g=w&&r?"3":r?"2":"1";S instanceof URLSearchParams?S.set(m,g):S[m]=g}c.addSearchParam=f})(d||(e.COI=d={}))}),define(ee[18],te([0,1,32,15,9,4,27,8]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=d;class c{constructor(S){this.a=S}compare(S,w,r=!1){return S===w?0:(0,R.compare)(this.getComparisonKey(S,r),this.getComparisonKey(w,r))}isEqual(S,w,r=!1){return S===w?!0:!S||!w?!1:this.getComparisonKey(S,r)===this.getComparisonKey(w,r)}getComparisonKey(S,w=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,w,r=!1){if(S.scheme===w.scheme){if(S.scheme===L.Schemas.file)return E.isEqualOrParent(d(S),d(w),this.a(S))&&S.query===w.query&&(r||S.fragment===w.fragment);if((0,e.isEqualAuthority)(S.authority,w.authority))return E.isEqualOrParent(S.path,w.path,this.a(S),"/")&&S.query===w.query&&(r||S.fragment===w.fragment)}return!1}joinPath(S,...w){return P.URI.joinPath(S,...w)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return n.posix.basename(S.path)}extname(S){return n.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let w;return S.scheme===L.Schemas.file?w=P.URI.file(n.dirname(d(S))).path:(w=n.posix.dirname(S.path),S.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),w="/")),S.with({path:w})}normalizePath(S){if(!S.path.length)return S;let w;return S.scheme===L.Schemas.file?w=P.URI.file(n.normalize(d(S))).path:w=n.posix.normalize(S.path),S.with({path:w})}relativePath(S,w){if(S.scheme!==w.scheme||!(0,e.isEqualAuthority)(S.authority,w.authority))return;if(S.scheme===L.Schemas.file){const l=n.relative(d(S),d(w));return A.isWindows?E.toSlashes(l):l}let r=S.path||"/";const g=w.path||"/";if(this.a(S)){let l=0;for(const v=Math.min(r.length,g.length);l<v&&!(r.charCodeAt(l)!==g.charCodeAt(l)&&r.charAt(l).toLowerCase()!==g.charAt(l).toLowerCase());l++);r=g.substr(0,l)+r.substr(l)}return n.posix.relative(r,g)}resolvePath(S,w){if(S.scheme===L.Schemas.file){const r=P.URI.file(n.resolve(d(S),w));return S.with({authority:r.authority,path:r.path})}return w=E.toPosixPath(w),S.with({path:n.posix.resolve(S.path,w)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,w){return S===w||S!==void 0&&w!==void 0&&(0,R.equalsIgnoreCase)(S,w)}hasTrailingPathSeparator(S,w=n.sep){if(S.scheme===L.Schemas.file){const r=d(S);return r.length>E.getRoot(r).length&&r[r.length-1]===w}else{const r=S.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,w=n.sep){return(0,e.hasTrailingPathSeparator)(S,w)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,w=n.sep){let r=!1;if(S.scheme===L.Schemas.file){const g=d(S);r=g!==void 0&&g.length===E.getRoot(g).length&&g[g.length-1]===w}else{w="/";const g=S.path;r=g.length===1&&g.charCodeAt(g.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(S,w)?S.with({path:S.path+"/"}):S}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(f=>f.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new c(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(f,S){const w=[];for(let r=0;r<f.length;r++){const g=S(f[r]);f.some((l,v)=>v===r?!1:(0,e.isEqualOrParent)(g,S(l)))||w.push(f[r])}return w}e.distinctParents=p;var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function S(w){const r=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(v=>{const[y,D]=v.split(":");y&&D&&r.set(y,D)});const l=w.path.substring(0,w.path.indexOf(";"));return l&&r.set(f.META_DATA_MIME,l),r}f.parseMetaData=S})(m||(e.DataUri=m={}));function b(f,S,w){if(S){let r=f.path;return r&&r[0]!==n.posix.sep&&(r=n.posix.sep+r),f.with({scheme:w,authority:S,path:r})}return f.with({scheme:w})}e.toLocalResource=b}),define(ee[7],te([0,1,22,13,3,2,18,4,132]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function c(B){return!!B&&typeof B.then=="function"}e.isThenable=c;function p(B){const T=new E.CancellationTokenSource,k=B(T.token),F=new Promise((N,U)=>{const $=T.token.onCancellationRequested(()=>{$.dispose(),T.dispose(),U(new L.CancellationError)});Promise.resolve(k).then(x=>{$.dispose(),T.dispose(),N(x)},x=>{$.dispose(),T.dispose(),U(x)})});return new class{cancel(){T.cancel()}then(N,U){return F.then(N,U)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=p;function m(B,T,k){return new Promise((F,N)=>{const U=T.onCancellationRequested(()=>{U.dispose(),F(k)});B.then(F,N).finally(()=>U.dispose())})}e.raceCancellation=m;function b(B,T){return new Promise((k,F)=>{const N=T.onCancellationRequested(()=>{N.dispose(),F(new L.CancellationError)});B.then(k,F).finally(()=>N.dispose())})}e.raceCancellationError=b;async function f(B){let T=-1;const k=B.map((F,N)=>F.then(U=>(T=N,U)));try{return await Promise.race(k)}finally{B.forEach((F,N)=>{N!==T&&F.cancel()})}}e.raceCancellablePromises=f;function S(B,T,k){let F;const N=setTimeout(()=>{F?.(void 0),k?.()},T);return Promise.race([B.finally(()=>clearTimeout(N)),new Promise(U=>F=U)])}e.raceTimeout=S;function w(B){return new Promise((T,k)=>{const F=B();c(F)?F.then(T,k):T(F)})}e.asPromise=w;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(T){if(this.a){if(this.d=T,!this.b){const k=()=>{this.b=null;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(k,k).then(F)})}return new Promise((k,F)=>{this.b.then(k,F)})}return this.a=T(),new Promise((k,F)=>{this.a.then(N=>{this.a=null,k(N)},N=>{this.a=null,F(N)})})}}e.Throttler=r;class g{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.Sequencer=g;class l{constructor(){this.a=new Map}queue(T,k){const N=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.a.get(T)===N&&this.a.delete(T)});return this.a.set(T,N),N}}e.SequencerByKey=l;const v=(B,T)=>{let k=!0;const F=setTimeout(()=>{k=!1,T()},B);return{isTriggered:()=>k,dispose:()=>{clearTimeout(F),k=!1}}},y=B=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,B())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class D{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,k=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((N,U)=>{this.d=N,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=k===d.MicrotaskDelay?y(F):v(k,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(T){this.a=new D(T),this.b=new r}trigger(T,k){return this.a.trigger(()=>this.b.queue(T),k)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((T,k)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function s(B,T){return T?new Promise((k,F)=>{const N=setTimeout(()=>{U.dispose(),k()},B),U=T.onCancellationRequested(()=>{clearTimeout(N),U.dispose(),F(new L.CancellationError)})}):p(k=>s(B,k))}e.timeout=s;function o(B,T=0){const k=setTimeout(B,T);return(0,A.toDisposable)(()=>clearTimeout(k))}e.disposableTimeout=o;function u(B){const T=[];let k=0;const F=B.length;function N(){return k<F?B[k++]():null}function U($){$!=null&&T.push($);const x=N();return x?x.then(U):Promise.resolve(T)}return Promise.resolve(null).then(U)}e.sequence=u;function h(B,T=F=>!!F,k=null){let F=0;const N=B.length,U=()=>{if(F>=N)return Promise.resolve(k);const $=B[F++];return Promise.resolve($()).then(K=>T(K)?Promise.resolve(K):U())};return U()}e.first=h;function I(B,T=F=>!!F,k=null){if(B.length===0)return Promise.resolve(k);let F=B.length;const N=()=>{F=-1;for(const U of B)U.cancel?.()};return new Promise((U,$)=>{for(const x of B)x.then(K=>{--F>=0&&T(K)?(N(),U(K)):F===0&&U(k)}).catch(K=>{--F>=0&&(N(),$(K))})})}e.firstParallel=I;class M{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((k,F)=>{this.f.push({factory:T,c:k,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const k=T.factory();k.then(T.c,T.e),k.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=M;class C extends M{constructor(){super(1)}}e.Queue=C;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const T=new j;return this.b.add(T),T.p}d(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,k=R.extUri){const F=k.getComparisonKey(T);let N=this.a.get(F);return N||(N=new C,n.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(F),this.f()}),this.a.set(F,N)),N}f(){this.d()&&this.g()}g(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class W{constructor(T,k){this.a=-1,typeof T=="function"&&typeof k=="number"&&this.setIfNotSet(T,k)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,k){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},k)}setIfNotSet(T,k){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},k))}}e.TimeoutTimer=W;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,k){this.cancel(),this.a=setInterval(()=>{T()},k)}}e.IntervalTimer=q;class V{constructor(T,k){this.b=-1,this.a=T,this.d=k,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class _{constructor(T,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.a=T,this.b=k,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=_;class ne extends V{constructor(T,k){super(T,k),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ne;class re extends A.Disposable{constructor(T,k){super(),this.g=T,this.h=k,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const k of T)this.a.push(k);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,P.setTimeout0)(()=>{if(T)return;const k=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(B,T)=>{const k=requestIdleCallback(B,typeof T=="number"?{timeout:T}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(k))}}}}();class ue{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(k){this.g=k}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ue;async function ce(B,T,k){let F;for(let N=0;N<k;N++)try{return await B()}catch(U){F=U,await s(T)}throw F}e.retry=ce;class J{hasPending(T){return this.a?typeof T=="number"?this.a.taskId===T:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(T,k,F){return this.a={taskId:T,cancel:()=>F?.(),promise:k},k.then(()=>this.d(T),()=>this.d(T)),k}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this.b)this.b.run=T;else{let k,F;const N=new Promise((U,$)=>{k=U,F=$});this.b={run:T,promise:N,promiseResolve:k,promiseReject:F}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=J;class H{constructor(T,k=()=>Date.now()){this.d=T,this.f=k,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.IntervalCounter=H;class j{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((T,k)=>{this.a=T,this.b=k})}complete(T){return new Promise(k=>{this.a(T),this.f=!0,k()})}error(T){return new Promise(k=>{this.b(T),this.d=!0,k()})}cancel(){new Promise(T=>{this.b(new L.CancellationError),this.d=!0,T()})}}e.DeferredPromise=j;var z;(function(B){async function T(F){let N;const U=await Promise.all(F.map($=>$.then(x=>x,x=>{N||(N=x)})));if(typeof N<"u")throw N;return U}B.settled=T;function k(F){return new Promise(async(N,U)=>{try{await F(N,U)}catch($){U($)}})}B.withAsyncBody=k})(z||(e.Promises=z={}));var X;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(X||(X={}));class Z{static fromArray(T){return new Z(k=>{k.emitMany(T)})}static fromPromise(T){return new Z(async k=>{k.emitMany(await T)})}static fromPromises(T){return new Z(async k=>{await Promise.all(T.map(async F=>k.emitOne(await F)))})}static merge(T){return new Z(async k=>{await Promise.all(T.map(async F=>{for await(const N of F)k.emitOne(N)}))})}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const k={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(T(k)),this.j()}catch(F){this.k(F)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(T,k){return new Z(async F=>{for await(const N of T)F.emitOne(k(N))})}map(T){return Z.map(this,T)}static filter(T,k){return new Z(async F=>{for await(const N of T)k(N)&&F.emitOne(N)})}filter(T){return Z.filter(this,T)}static coalesce(T){return Z.filter(T,k=>!!k)}coalesce(){return Z.coalesce(this)}static async toPromise(T){const k=[];for await(const F of T)k.push(F);return k}toPromise(){return Z.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class oe extends Z{constructor(T,k){super(k),this.l=T}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function ae(B){const T=new E.CancellationTokenSource,k=B(T.token);return new oe(T,async F=>{const N=T.token.onCancellationRequested(()=>{N.dispose(),T.dispose(),F.reject(new L.CancellationError)});try{for await(const U of k){if(T.token.isCancellationRequested)return;F.emitOne(U)}N.dispose(),T.dispose()}catch(U){N.dispose(),T.dispose(),F.reject(U)}})}e.createCancelableAsyncIterable=ae}),define(ee[101],te([0,1,23,7,32,35,9,4,27]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function c(){return Object.create(null)}e.getEmptyExpression=c,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",m="[^/\\\\]",b=/\//g;function f(H,j){switch(H){case 0:return"";case 1:return`${m}*?`;default:return`(?:${p}|${m}+${p}${j?`|${p}${m}+`:""})*?`}}function S(H,j){if(!H)return[];const z=[];let X=!1,Z=!1,oe="";for(const ae of H){switch(ae){case j:if(!X&&!Z){z.push(oe),oe="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}oe+=ae}return oe&&z.push(oe),z}e.splitGlobAware=S;function w(H){if(!H)return"";let j="";const z=S(H,e.GLOB_SPLIT);if(z.every(X=>X===e.GLOBSTAR))j=".*";else{let X=!1;z.forEach((Z,oe)=>{if(Z===e.GLOBSTAR){if(X)return;j+=f(2,oe===z.length-1)}else{let ae=!1,B="",T=!1,k="";for(const F of Z){if(F!=="}"&&ae){B+=F;continue}if(T&&(F!=="]"||!k)){let N;F==="-"?N=F:(F==="^"||F==="!")&&!k?N="^":F===e.GLOB_SPLIT?N="":N=(0,d.escapeRegExpCharacters)(F),k+=N;continue}switch(F){case"{":ae=!0;continue;case"[":T=!0;continue;case"}":{const U=`(?:${S(B,",").map($=>w($)).join("|")})`;j+=U,ae=!1,B="";break}case"]":{j+="["+k+"]",T=!1,k="";break}case"?":j+=m;continue;case"*":j+=f(1);continue;default:j+=(0,d.escapeRegExpCharacters)(F)}}oe<z.length-1&&(z[oe+1]!==e.GLOBSTAR||oe+2<z.length)&&(j+=p)}X=Z===e.GLOBSTAR})}return j}const r=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),a=function(){return!1},i=function(){return null};function s(H,j){if(!H)return i;let z;typeof H!="string"?z=H.pattern:z=H,z=z.trim();const X=`${z}_${!!j.trimForExclusions}`;let Z=t.get(X);if(Z)return o(Z,H);let oe;return r.test(z)?Z=h(z.substr(4),z):(oe=g.exec(u(z,j)))?Z=I(oe[1],z):(j.trimForExclusions?v:l).test(z)?Z=M(z,j):(oe=y.exec(u(z,j)))?Z=C(oe[1].substr(1),z,!0):(oe=D.exec(u(z,j)))?Z=C(oe[1],z,!1):Z=O(z),t.set(X,Z),o(Z,H)}function o(H,j){if(typeof j=="string")return H;const z=function(X,Z){return(0,n.isEqualOrParent)(X,j.base,!P.isLinux)?H((0,d.ltrim)(X.substr(j.base.length),R.sep),Z):null};return z.allBasenames=H.allBasenames,z.allPaths=H.allPaths,z.basenames=H.basenames,z.patterns=H.patterns,z}function u(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function h(H,j){return function(z,X){return typeof z=="string"&&z.endsWith(H)?j:null}}function I(H,j){const z=`/${H}`,X=`\\${H}`,Z=function(ae,B){return typeof ae!="string"?null:B?B===H?j:null:ae===H||ae.endsWith(z)||ae.endsWith(X)?j:null},oe=[H];return Z.basenames=oe,Z.patterns=[j],Z.allBasenames=oe,Z}function M(H,j){const z=ce(H.slice(1,-1).split(",").map(B=>s(B,j)).filter(B=>B!==i),H),X=z.length;if(!X)return i;if(X===1)return z[0];const Z=function(B,T){for(let k=0,F=z.length;k<F;k++)if(z[k](B,T))return H;return null},oe=z.find(B=>!!B.allBasenames);oe&&(Z.allBasenames=oe.allBasenames);const ae=z.reduce((B,T)=>T.allPaths?B.concat(T.allPaths):B,[]);return ae.length&&(Z.allPaths=ae),Z}function C(H,j,z){const X=R.sep===R.posix.sep,Z=X?H:H.replace(b,R.sep),oe=R.sep+Z,ae=R.posix.sep+H;let B;return z?B=function(T,k){return typeof T=="string"&&(T===Z||T.endsWith(oe)||!X&&(T===H||T.endsWith(ae)))?j:null}:B=function(T,k){return typeof T=="string"&&(T===Z||!X&&T===H)?j:null},B.allPaths=[(z?"*/":"./")+H],B}function O(H){try{const j=new RegExp(`^${w(H)}$`);return function(z){return j.lastIndex=0,typeof z=="string"&&j.test(z)?H:null}}catch{return i}}function W(H,j,z){return!H||typeof j!="string"?!1:q(H)(j,void 0,z)}e.match=W;function q(H,j={}){if(!H)return a;if(typeof H=="string"||V(H)){const z=s(H,j);if(z===i)return a;const X=function(Z,oe){return!!z(Z,oe)};return z.allBasenames&&(X.allBasenames=z.allBasenames),z.allPaths&&(X.allPaths=z.allPaths),X}return re(H,j)}e.parse=q;function V(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=V;function _(H){return H.allBasenames||[]}e.getBasenameTerms=_;function ne(H){return H.allPaths||[]}e.getPathTerms=ne;function re(H,j){const z=ce(Object.getOwnPropertyNames(H).map(B=>ue(B,H[B],j)).filter(B=>B!==i)),X=z.length;if(!X)return i;if(!z.some(B=>!!B.requiresSiblings)){if(X===1)return z[0];const B=function(F,N){let U;for(let $=0,x=z.length;$<x;$++){const K=z[$](F,N);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(U||(U=[]),U.push(K))}return U?(async()=>{for(const $ of U){const x=await $;if(typeof x=="string")return x}return null})():null},T=z.find(F=>!!F.allBasenames);T&&(B.allBasenames=T.allBasenames);const k=z.reduce((F,N)=>N.allPaths?F.concat(N.allPaths):F,[]);return k.length&&(B.allPaths=k),B}const Z=function(B,T,k){let F,N;for(let U=0,$=z.length;U<$;U++){const x=z[U];x.requiresSiblings&&k&&(T||(T=(0,R.basename)(B)),F||(F=T.substr(0,T.length-(0,R.extname)(B).length)));const K=x(B,T,F,k);if(typeof K=="string")return K;(0,L.isThenable)(K)&&(N||(N=[]),N.push(K))}return N?(async()=>{for(const U of N){const $=await U;if(typeof $=="string")return $}return null})():null},oe=z.find(B=>!!B.allBasenames);oe&&(Z.allBasenames=oe.allBasenames);const ae=z.reduce((B,T)=>T.allPaths?B.concat(T.allPaths):B,[]);return ae.length&&(Z.allPaths=ae),Z}function ue(H,j,z){if(j===!1)return i;const X=s(H,z);if(X===i)return i;if(typeof j=="boolean")return X;if(j){const Z=j.when;if(typeof Z=="string"){const oe=(ae,B,T,k)=>{if(!k||!X(ae,B))return null;const F=Z.replace("$(basename)",()=>T),N=k(F);return(0,L.isThenable)(N)?N.then(U=>U?H:null):N?H:null};return oe.requiresSiblings=!0,oe}}return X}function ce(H,j){const z=H.filter(B=>!!B.basenames);if(z.length<2)return H;const X=z.reduce((B,T)=>{const k=T.basenames;return k?B.concat(k):B},[]);let Z;if(j){Z=[];for(let B=0,T=X.length;B<T;B++)Z.push(j)}else Z=z.reduce((B,T)=>{const k=T.patterns;return k?B.concat(k):B},[]);const oe=function(B,T){if(typeof B!="string")return null;if(!T){let F;for(F=B.length;F>0;F--){const N=B.charCodeAt(F-1);if(N===47||N===92)break}T=B.substr(F)}const k=X.indexOf(T);return k!==-1?Z[k]:null};oe.basenames=X,oe.patterns=Z,oe.allBasenames=X;const ae=H.filter(B=>!B.basenames);return ae.push(oe),ae}function J(H,j){return(0,E.equals)(H,j,(z,X)=>typeof z=="string"&&typeof X=="string"?z===X:typeof z!="string"&&typeof X!="string"?z.base===X.base&&z.pattern===X.pattern:!1)}e.patternsEquals=J}),define(ee[44],te([0,1,23,32,9,4,18,27]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function d(i,s){const{os:o,tildify:u,relative:h}=s;if(h){const C=c(i,h,o);if(typeof C=="string")return C}let I=i.fsPath;if(o===1&&!A.isWindows?I=I.replace(/\//g,"\\"):o!==1&&A.isWindows&&(I=I.replace(/\\/g,"/")),o!==1&&u?.userHome){const C=u.userHome.fsPath;let O;i.scheme!==u.userHome.scheme&&i.path.startsWith(n.posix.sep)?O=u.userHome.with({path:i.path}).fsPath:O=i.fsPath,I=b(O,C,o)}return(o===1?n.win32:n.posix).normalize(p(I,o===1))}e.getPathLabel=d;function c(i,s,o){const u=o===1?n.win32:n.posix,h=o===3?R.extUri:R.extUriIgnorePathCase,I=s.getWorkspace(),M=(0,E.firstOrDefault)(I.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=M.uri.with({path:i.path}));const C=s.getWorkspaceFolder(i);if(!C)return;let O;if(h.isEqual(C.uri,i)?O="":O=h.relativePath(C.uri,i)??"",O&&(O=u.normalize(O)),I.folders.length>1&&!s.noPrefix){const W=C.name?C.name:h.basenameOrAuthority(C.uri);O=O?`${W} \u2022 ${O}`:W}return O}function p(i,s=A.isWindows){return(0,L.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=p;let m=Object.create(null);function b(i,s,o=A.OS){if(o===1||!i||!s)return i;let u=m.original===s?m.normalized:void 0;u||(u=s,A.isWindows&&(u=(0,L.toSlashes)(u)),u=`${(0,P.rtrim)(u,n.posix.sep)}${n.posix.sep}`,m={original:s,normalized:u});let h=i;return A.isWindows&&(h=(0,L.toSlashes)(h)),(o===3?h.startsWith(u):(0,P.startsWithIgnoreCase)(h,u))?`~/${h.substr(u.length)}`:i}e.tildify=b;function f(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=f;const S="\u2026",w="\\\\",r="~";function g(i,s=n.sep){const o=new Array(i.length);let u=!1;for(let h=0;h<i.length;h++){const I=i[h];if(I===""){o[h]=`.${s}`;continue}if(!I){o[h]=I;continue}u=!0;let M="",C=I;C.indexOf(w)===0?(M=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(s)===0?(M=C.substr(0,C.indexOf(s)+s.length),C=C.substr(C.indexOf(s)+s.length)):C.indexOf(r)===0&&(M=C.substr(0,C.indexOf(r)+r.length),C=C.substr(C.indexOf(r)+r.length));const O=C.split(s);for(let W=1;u&&W<=O.length;W++)for(let q=O.length-W;u&&q>=0;q--){u=!1;let V=O.slice(q,q+W).join(s);for(let _=0;!u&&_<i.length;_++)if(_!==h&&i[_]&&i[_].indexOf(V)>-1){const ne=q+W===O.length,re=q>0&&i[_].indexOf(s)>-1?s+V:V,ue=i[_].endsWith(re);u=!ne||ue}if(!u){let _="";(O[0].endsWith(":")||M!=="")&&(q===1&&(q=0,W++,V=O[0]+s+V),q>0&&(_=O[0]+s),_=M+_),q>0&&(_=_+S+s),_=_+V,q+W<O.length&&(_=_+s+S),o[h]=_}}u&&(o[h]=I)}return o}e.shorten=g;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function v(i,s=Object.create(null)){const o=[];let u=!1,h="";for(const I of i)if(I==="$"||u&&I==="{")h&&o.push({value:h,type:l.TEXT}),h="",u=!0;else if(I==="}"&&u){const M=s[h];if(typeof M=="string")M.length&&o.push({value:M,type:l.VARIABLE});else if(M){const C=o[o.length-1];(!C||C.type!==l.SEPARATOR)&&o.push({value:M.label,type:l.SEPARATOR})}h="",u=!1}else h+=I;return h&&!u&&o.push({value:h,type:l.TEXT}),o.filter((I,M)=>{if(I.type===l.SEPARATOR){const C=o[M-1],O=o[M+1];return[C,O].every(W=>W&&(W.type===l.VARIABLE||W.type===l.TEXT)&&W.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=v;function y(i,s){return A.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function D(i,s){return A.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const s=i.indexOf("/")!==-1?n.posix:n.win32,o=s.basename(i),u=s.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=a}),define(ee[148],te([0,1,17,8]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(m){return m.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const f=this.a.transformIncoming(b);return f===b?b:n(L.URI.from(f))}transformOutgoing(b){const f=this.a.transformOutgoing(b);return f===b?b:n(L.URI.from(f))}transformOutgoingURI(b){const f=this.a.transformOutgoing(b);return f===b?b:L.URI.from(f)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function R(m,b,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof L.URI)return b.transformOutgoing(m);for(const S in m)if(Object.hasOwnProperty.call(m,S)){const w=R(m[S],b,f+1);w!==null&&(m[S]=w)}}return null}function P(m,b){const f=R(m,b,0);return f===null?m:f}e.transformOutgoingURIs=P;function d(m,b,f,S){if(!m||S>200)return null;if(typeof m=="object"){if(m.$mid===1)return f?L.URI.revive(b.transformIncoming(m)):b.transformIncoming(m);if(m instanceof E.VSBuffer)return null;for(const w in m)if(Object.hasOwnProperty.call(m,w)){const r=d(m[w],b,f,S+1);r!==null&&(m[w]=r)}}return null}function c(m,b){const f=d(m,b,!1,0);return f===null?m:f}e.transformIncomingURIs=c;function p(m,b){const f=d(m,b,!0,0);return f===null?m:f}e.transformAndReviveIncomingURIs=p}),define(ee[85],te([0,1,26,61,31,136]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(c){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,p=0;const m=(0,E.networkInterfaces)();for(const b in m){const f=m[b];if(f)for(const{mac:S,internal:w}of f)w||(p+=1,this.c(S.toUpperCase())&&(c+=1))}this.b=p>0?c/p:0}return this.b}};let R;async function P(c){return R||(R=(async()=>await d(c)||n.generateUuid())()),R}e.getMachineId=P;async function d(c){try{const p=await new Promise((b,f)=>{G(["crypto"],b,f)}),m=(0,A.getMac)();return p.createHash("sha256").update(m,"utf8").digest("hex")}catch(p){c(p);return}}}),define(ee[24],te([0,1,41,26,149,7,32,82,9,4,18,8]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function f(re,ue=b.UNLINK){if((0,R.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===b.UNLINK?w(re):S(re)}async function S(re){try{const ue=(0,R.randomPath)((0,L.tmpdir)());try{await E.promises.rename(re,ue)}catch(ce){return ce.code==="ENOENT"?void 0:w(re)}w(ue).catch(ce=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function w(re){return(0,n.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function r(re){if((0,R.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function g(re,ue){return y(await(ue?l(re):(0,n.promisify)(E.readdir)(re)))}async function l(re){try{return await(0,n.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const ue=[],ce=await g(re);for(const J of ce){let H=!1,j=!1,z=!1;try{const X=await e.Promises.lstat((0,d.join)(re,J));H=X.isFile(),j=X.isDirectory(),z=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}ue.push({name:J,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>z})}return ue}function v(re){return y(E.readdirSync(re))}e.readdirSync=v;function y(re){return re.map(ue=>typeof ue=="string"?c.isMacintosh?(0,P.normalizeNFC)(ue):ue:(ue.name=c.isMacintosh?(0,P.normalizeNFC)(ue.name):ue.name,ue))}async function D(re){const ue=await g(re),ce=[];for(const J of ue)await a.existsDirectory((0,d.join)(re,J))&&ce.push(J);return ce}function t(re,ue=1e3){return new Promise(ce=>{let J=!1;const H=setInterval(()=>{J||(J=!0,E.access(re,j=>{J=!1,j&&(clearInterval(H),ce(void 0))}))},ue)})}e.whenDeleted=t;var a;(function(re){async function ue(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw z}}re.stat=ue;async function ce(H){try{const{stat:j,symbolicLink:z}=await re.stat(H);return j.isFile()&&z?.dangling!==!0}catch{}return!1}re.existsFile=ce;async function J(H){try{const{stat:j,symbolicLink:z}=await re.stat(H);return j.isDirectory()&&z?.dangling!==!0}catch{}return!1}re.existsDirectory=J})(a||(e.SymlinkSupport=a={}));const i=new A.ResourceQueue;function s(re,ue,ce){return i.queueFor(m.URI.file(re),p.extUriBiasedIgnorePathCase).queue(()=>{const J=M(ce);return new Promise((H,j)=>h(re,ue,J,z=>z?j(z):H()))})}let o=!0;function u(re){o=re}e.configureFlushOnWrite=u;function h(re,ue,ce,J){if(!o)return E.writeFile(re,ue,{mode:ce.mode,flag:ce.flag},J);E.open(re,ce.flag,ce.mode,(H,j)=>{if(H)return J(H);E.writeFile(j,ue,z=>{if(z)return E.close(j,()=>J(z));E.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),u(!1)),E.close(j,Z=>J(Z))))})})}function I(re,ue,ce){const J=M(ce);if(!o)return E.writeFileSync(re,ue,{mode:J.mode,flag:J.flag});const H=E.openSync(re,J.flag,J.mode);try{E.writeFileSync(H,ue);try{E.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),u(!1)}}finally{E.closeSync(H)}}e.writeFileSync=I;function M(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function C(re,ue){if(re!==ue)try{await e.Promises.rename(re,ue)}catch(ce){if(re.toLowerCase()!==ue.toLowerCase()&&ce.code==="EXDEV"||re.endsWith("."))await O(re,ue,{preserveSymlinks:!1}),await f(re,b.MOVE);else throw ce}}async function O(re,ue,ce){return q(re,ue,{root:{source:re,target:ue},options:ce,handledSourcePaths:new Set})}const W=511;async function q(re,ue,ce){if(ce.handledSourcePaths.has(re))return;ce.handledSourcePaths.add(re);const{stat:J,symbolicLink:H}=await a.stat(re);if(H){if(ce.options.preserveSymlinks)try{return await ne(re,ue,ce)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(H.dangling)return}return J.isDirectory()?V(re,ue,J.mode&W,ce):_(re,ue,J.mode&W)}async function V(re,ue,ce,J){await e.Promises.mkdir(ue,{recursive:!0,mode:ce});const H=await g(re);for(const j of H)await q((0,d.join)(re,j),(0,d.join)(ue,j),J)}async function _(re,ue,ce){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,ce)}async function ne(re,ue,ce){let J=await e.Promises.readlink(re);(0,R.isEqualOrParent)(J,ce.root.source,!c.isLinux)&&(J=(0,d.join)(ce.root.target,J.substr(ce.root.source.length+1))),await e.Promises.symlink(J,ue)}e.Promises=new class{get access(){return(0,n.promisify)(E.access)}get stat(){return(0,n.promisify)(E.stat)}get lstat(){return(0,n.promisify)(E.lstat)}get utimes(){return(0,n.promisify)(E.utimes)}get read(){return(re,ue,ce,J,H)=>new Promise((j,z)=>{E.read(re,ue,ce,J,H,(X,Z,oe)=>X?z(X):j({bytesRead:Z,buffer:oe}))})}get readFile(){return(0,n.promisify)(E.readFile)}get write(){return(re,ue,ce,J,H)=>new Promise((j,z)=>{E.write(re,ue,ce,J,H,(X,Z,oe)=>X?z(X):j({bytesWritten:Z,buffer:oe}))})}get appendFile(){return(0,n.promisify)(E.appendFile)}get fdatasync(){return(0,n.promisify)(E.fdatasync)}get truncate(){return(0,n.promisify)(E.truncate)}get rename(){return(0,n.promisify)(E.rename)}get copyFile(){return(0,n.promisify)(E.copyFile)}get open(){return(0,n.promisify)(E.open)}get close(){return(0,n.promisify)(E.close)}get symlink(){return(0,n.promisify)(E.symlink)}get readlink(){return(0,n.promisify)(E.readlink)}get chmod(){return(0,n.promisify)(E.chmod)}get mkdir(){return(0,n.promisify)(E.mkdir)}get unlink(){return(0,n.promisify)(E.unlink)}get rmdir(){return(0,n.promisify)(E.rmdir)}get realpath(){return(0,n.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return D}get writeFile(){return s}get rm(){return f}get move(){return C}get copy(){return O}}}),define(ee[102],te([0,1,41,9,4,27,24]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(b){if(n.isLinux)return b;const f=(0,L.dirname)(b);if(b===f)return b;const S=((0,L.basename)(b)||b).toLowerCase();try{const r=(0,R.readdirSync)(f).filter(g=>g.toLowerCase()===S);if(r.length===1){const g=P(f);if(g)return(0,L.join)(g,r[0])}else if(r.length>1){const g=r.indexOf(S);if(g>=0){const l=P(f);if(l)return(0,L.join)(l,r[g])}}}catch{}return null}e.realcaseSync=P;async function d(b){if(n.isLinux)return b;const f=(0,L.dirname)(b);if(b===f)return b;const S=((0,L.basename)(b)||b).toLowerCase();try{const r=(await R.Promises.readdir(f)).filter(g=>g.toLowerCase()===S);if(r.length===1){const g=await d(f);if(g)return(0,L.join)(g,r[0])}else if(r.length>1){const g=r.indexOf(S);if(g>=0){const l=await d(f);if(l)return(0,L.join)(l,r[g])}}}catch{}return null}e.realcase=d;async function c(b){try{return await R.Promises.realpath(b)}catch{const S=m(b);return await R.Promises.access(S,E.constants.R_OK),S}}e.realpath=c;function p(b){try{return E.realpathSync(b)}catch{const S=m(b);return E.accessSync(S,E.constants.R_OK),S}}e.realpathSync=p;function m(b){return(0,A.rtrim)((0,L.normalize)(b),L.sep)}}),define(ee[150],te([0,1,26,9,24]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class m{constructor(D,t,a){this.exePath=D,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:y=!1}={}){return y?c===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:y=!1,findPreview:D=!1}={}){const t=b({useAlternateBitness:y});if(!t)return null;const a=L.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const h of await n.Promises.readdir(a)){let I=-1;if(D){const C=h.indexOf("-");if(C<0)continue;const O=h.substring(0,C);if(!A.test(O)||h.substring(C+1)!=="preview")continue;I=parseInt(O,10)}else{if(!A.test(h))continue;I=parseInt(h,10)}if(I<=i)continue;const M=L.join(a,h,"pwsh.exe");await n.SymlinkSupport.existsFile(M)&&(s=M,i=I)}if(!s)return null;const o=t.includes("x86")?" (x86)":"",u=D?" Preview":"";return new m(s,`PowerShell${u}${o}`,!0)}async function S({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const D=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=y?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(D))if(t.test(i)){const s=L.join(D,i,"pwsh.exe");return new m(s,a)}return null}function w(){const y=L.join(E.homedir(),".dotnet","tools","pwsh.exe");return new m(y,".NET Core PowerShell Global Tool")}function r(){const y=L.join(process.env.windir,c===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(y,"Windows PowerShell",!0)}async function*g(){let y=await f();y&&(yield y),y=await f({useAlternateBitness:!0}),y&&(yield y),y=await S(),y&&(yield y),y=w(),y&&(yield y),y=await f({findPreview:!0}),y&&(yield y),y=await S({findPreview:!0}),y&&(yield y),y=await f({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=r(),y&&(yield y)}async function*l(){for await(const y of g())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=l;async function v(){for await(const y of l())return y;return null}e.getFirstAvailablePowerShellInstallation=v}),define(ee[86],te([0,1,9,4,36,71,11,24]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function d(m=n.env){return m.comspec||"cmd.exe"}e.getWindowsShell=d;function c(m){let b=[],f=!1;const S=function(w){if(f){b.push(w);return}(!m.send(w,g=>{if(g&&console.error(g),f=!1,b.length>0){const l=b.slice(0);b=[],l.forEach(v=>S(v))}})||L.isWindows)&&(f=!0)};return{send:S}}e.createQueuedSender=c;var p;(function(m){async function b(f,S,w){if(E.isAbsolute(f))return f;if(S===void 0&&(S=n.cwd()),E.dirname(f)!=="."||(w===void 0&&R.isString(n.env.PATH)&&(w=n.env.PATH.split(E.delimiter)),w===void 0||w.length===0))return E.join(S,f);async function g(l){if(await P.Promises.exists(l)){let v;try{v=await P.Promises.stat(l)}catch(y){y.message.startsWith("EACCES")&&(v=await P.Promises.lstat(l))}return v?!v.isDirectory():!1}return!1}for(const l of w){let v;if(E.isAbsolute(l)?v=E.join(l,f):v=E.join(S,l,f),await g(v))return v;let y=v+".com";if(await g(y)||(y=v+".exe",await g(y)))return y}return E.join(S,f)}m.findExecutable=b})(p||(e.win32=p={}))}),define(ee[103],te([0,1,50,15]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(R){return new Promise((P,d)=>{let c;const p=new Map;function m(f,S,w,r,g){const l=p.get(S);if(f===R||l){const v={name:b(w),cmd:w,pid:f,ppid:S,load:r,mem:g};p.set(f,v),f===R&&(c=v),l&&(l.children||(l.children=[]),l.children.push(v),l.children.length>1&&(l.children=l.children.sort((y,D)=>y.pid-D.pid)))}}function b(f){const S=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,l=/conhost\.exe/i,v=/--type=([a-zA-Z-]+)/;if(r.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-process";if(l.exec(f))return"console-window-host (Windows internal process)";let y=v.exec(f);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?S.exec(f)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const D=/[a-zA-Z-]+\.js/g;let t="";do y=D.exec(f),y&&(t+=y+" ");while(y);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=S=>S.indexOf("\\\\?\\")===0||S.indexOf("\\??\\")===0?S.substr(4):S.indexOf('"\\\\?\\')===0||S.indexOf('"\\??\\')===0?'"'+S.substr(5):S;new Promise((S,w)=>{G(["@vscode/windows-process-tree"],S,w)}).then(S=>{S.getProcessList(R,w=>{if(!w){d(new Error(`Root process ${R} not found`));return}S.getProcessCpuUsage(w,r=>{const g=new Map;r.forEach(l=>{const v=f(l.commandLine||"");g.set(l.pid,{name:b(v),cmd:v,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),c=g.get(R),c?(g.forEach(l=>{const v=g.get(l.ppid);v&&(v.children||(v.children=[]),v.children.push(l))}),g.forEach(l=>{l.children&&(l.children=l.children.sort((v,y)=>v.pid-y.pid))}),P(c)):d(new Error(`Root process ${R} not found`))})},S.ProcessDataFlag.CommandLine|S.ProcessDataFlag.Memory)})}else{let f=function(){let S=[c];const w=[];for(;S.length;){const g=S.shift();g&&(w.push(g.pid),g.children&&(S=S.concat(g.children)))}let r=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+w.join(" "),(0,E.exec)(r,{},(g,l,v)=>{if(g||v)d(g||new Error(v.toString()));else{const y=l.toString().split(`
`);for(let D=0;D<w.length;D++){const t=p.get(w[D]);t.load=parseFloat(y[D])}if(!c){d(new Error(`Root process ${R} not found`));return}P(c)}})};(0,E.exec)("which ps",{},(S,w,r)=>{if(S||r)if(process.platform!=="linux")d(S||new Error(r.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(g,{},(l,v,y)=>{l||y?d(l||new Error(y.toString())):(A(v,m),f())})}else{const g=w.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${g} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,y,D)=>{v||D&&!D.includes("screen size is bogus")?d(v||new Error(D.toString())):(A(y,m),process.platform==="linux"?f():c?P(c):d(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=n;function A(R,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=R.toString().split(`
`);for(const p of c){const m=d.exec(p.trim());m&&m.length===6&&P(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(ee[151],te([0,1,26,4,150,86]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(m,b){return m===1?L.isWindows?p():A.getWindowsShell(b):d(m,b)}e.getSystemShell=R;let P=null;function d(m,b){if(L.isLinux&&m===2||L.isMacintosh&&m===3)return"/bin/bash";if(!P){let f;if(L.isWindows)f="/bin/bash";else{if(f=b.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let c=null;async function p(){return c||(c=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),c}});var ye=this&&this.__decorate||function(G,e,E,L){var n=arguments.length,A=n<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,E,L);else for(var P=G.length-1;P>=0;P--)(R=G[P])&&(A=(n<3?R(A):n>3?R(e,E,A):R(e,E))||A);return n>3&&A&&Object.defineProperty(e,E,A),A};define(ee[45],te([0,1,23,7,17,22,55,13,3,2,84,27,11]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(f||(f={}));function S(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(w||(w={}));function r(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(g||(g={}));function l(j){let z=0;for(let X=0;;X+=7){const Z=j.read(1);if(z|=(Z.buffer[0]&127)<<X,!(Z.buffer[0]&128))return z}}const v=i(0);function y(j,z){if(z===0){j.write(v);return}let X=0;for(let oe=z;oe!==0;oe=oe>>>7)X++;const Z=n.VSBuffer.alloc(X);for(let oe=0;z!==0;oe++)Z.buffer[oe]=z&127,z=z>>>7,z>0&&(Z.buffer[oe]|=128);j.write(Z)}class D{constructor(z){this.b=z,this.a=0}read(z){const X=this.b.slice(this.a,this.a+z);return this.a+=X.byteLength,X}}e.BufferReader=D;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(z){this.a.push(z)}}e.BufferWriter=t;var a;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(a||(a={}));function i(j){const z=n.VSBuffer.alloc(1);return z.writeUInt8(j,0),z}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},o=typeof Buffer<"u";function u(j,z){if(typeof z>"u")j.write(s.Undefined);else if(typeof z=="string"){const X=n.VSBuffer.fromString(z);j.write(s.String),y(j,X.byteLength),j.write(X)}else if(o&&Buffer.isBuffer(z)){const X=n.VSBuffer.wrap(z);j.write(s.Buffer),y(j,X.byteLength),j.write(X)}else if(z instanceof n.VSBuffer)j.write(s.VSBuffer),y(j,z.byteLength),j.write(z);else if(Array.isArray(z)){j.write(s.Array),y(j,z.length);for(const X of z)u(j,X)}else if(typeof z=="number"&&(z|0)===z)j.write(s.Uint),y(j,z);else{const X=n.VSBuffer.fromString(JSON.stringify(z));j.write(s.Object),y(j,X.byteLength),j.write(X)}}e.serialize=u;function h(j){switch(j.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return j.read(l(j)).toString();case a.Buffer:return j.read(l(j)).buffer;case a.VSBuffer:return j.read(l(j));case a.Array:{const X=l(j),Z=[];for(let oe=0;oe<X;oe++)Z.push(h(j));return Z}case a.Object:return JSON.parse(j.read(l(j)).toString());case a.Int:return l(j)}}e.deserialize=h;class I{constructor(z,X,Z=null,oe=1e3){this.h=z,this.j=X,this.k=Z,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(z,X){this.b.set(z,X),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const X=this.o([z.type]);this.k?.logOutgoing(X,0,1,r(z.type));return}case 201:case 202:case 204:case 203:{const X=this.o([z.type,z.id],z.data);this.k?.logOutgoing(X,z.id,1,r(z.type),z.data);return}}}o(z,X=void 0){const Z=new t;return u(Z,z),u(Z,X),this.p(Z.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const X=new D(z),Z=h(X),oe=h(X),ae=Z[0];switch(ae){case 100:return this.k?.logIncoming(z.byteLength,Z[1],1,`${S(ae)}: ${Z[2]}.${Z[3]}`,oe),this.s({type:ae,id:Z[1],channelName:Z[2],name:Z[3],arg:oe});case 102:return this.k?.logIncoming(z.byteLength,Z[1],1,`${S(ae)}: ${Z[2]}.${Z[3]}`,oe),this.t({type:ae,id:Z[1],channelName:Z[2],name:Z[3],arg:oe});case 101:return this.k?.logIncoming(z.byteLength,Z[1],1,`${S(ae)}`),this.u({type:ae,id:Z[1]});case 103:return this.k?.logIncoming(z.byteLength,Z[1],1,`${S(ae)}`),this.u({type:ae,id:Z[1]})}}s(z){const X=this.b.get(z.channelName);if(!X){this.v(z);return}const Z=new A.CancellationTokenSource;let oe;try{oe=X.call(this.j,z.name,z.arg,Z.token)}catch(T){oe=Promise.reject(T)}const ae=z.id;oe.then(T=>{this.m({id:ae,data:T,type:201}),this.d.delete(z.id)},T=>{T instanceof Error?this.m({id:ae,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:ae,data:T,type:203}),this.d.delete(z.id)});const B=(0,c.toDisposable)(()=>Z.cancel());this.d.set(z.id,B)}t(z){const X=this.b.get(z.channelName);if(!X){this.v(z);return}const Z=z.id,ae=X.listen(this.j,z.name,z.arg)(B=>this.m({id:Z,data:B,type:204}));this.d.set(z.id,ae)}u(z){const X=this.d.get(z.id);X&&(X.dispose(),this.d.delete(z.id))}v(z){let X=this.g.get(z.channelName);X||(X=[],this.g.set(z.channelName,X));const Z=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:z,timeoutTimer:Z})}w(z){const X=this.g.get(z);if(X){for(const Z of X)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=I;var M;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class C{constructor(z,X=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=X}getChannel(z){const X=this;return{call(Z,oe,ae){return X.a?Promise.reject(new P.CancellationError):X.m(z,Z,oe,ae)},listen(Z,oe){return X.a?d.Event.None:X.o(z,Z,oe)}}}m(z,X,Z,oe=A.CancellationToken.None){const ae=this.g++,T={id:ae,type:100,channelName:z,name:X,arg:Z};if(oe.isCancellationRequested)return Promise.reject(new P.CancellationError);let k;return new Promise((N,U)=>{if(oe.isCancellationRequested)return U(new P.CancellationError);const $=()=>{const de=Ee=>{switch(Ee.type){case 201:this.f.delete(ae),N(Ee.data);break;case 202:{this.f.delete(ae);const De=new Error(Ee.data.message);De.stack=Array.isArray(Ee.data.stack)?Ee.data.stack.join(`
`):Ee.data.stack,De.name=Ee.data.name,U(De);break}case 203:this.f.delete(ae),U(Ee.data);break}};this.f.set(ae,de),this.p(T)};let x=null;this.b===g.Idle?$():(x=(0,L.createCancelablePromise)(de=>this.u()),x.then(()=>{x=null,$()}));const K=()=>{x?(x.cancel(),x=null):this.p({id:ae,type:101}),U(new P.CancellationError)},se=oe.onCancellationRequested(K);k=(0,c.combinedDisposable)((0,c.toDisposable)(K),se),this.d.add(k)}).finally(()=>{this.d.delete(k)})}o(z,X,Z){const oe=this.g++,B={id:oe,type:102,channelName:z,name:X,arg:Z};let T=null;const k=new d.Emitter({onWillAddFirstListener:()=>{T=(0,L.createCancelablePromise)(N=>this.u()),T.then(()=>{T=null,this.d.add(k),this.p(B)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(k),this.p({id:oe,type:103}))}}),F=N=>k.fire(N.data);return this.f.set(oe,F),k.event}p(z){switch(z.type){case 100:case 102:{const X=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(X,z.id,0,`${S(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const X=this.q([z.type,z.id]);this.j?.logOutgoing(X,z.id,0,S(z.type));return}}}q(z,X=void 0){const Z=new t;return u(Z,z),u(Z,X),this.r(Z.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const X=new D(z),Z=h(X),oe=h(X),ae=Z[0];switch(ae){case 200:return this.j?.logIncoming(z.byteLength,0,0,r(ae)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,Z[1],0,r(ae),oe),this.t({type:Z[0],id:Z[1],data:oe})}}t(z){if(z.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=C,ye([R.memoize],C.prototype,"onDidInitializePromise",null);class O{get connections(){const z=[];return this.f.forEach(X=>z.push(X)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,z(({protocol:X,onDidClientDisconnect:Z})=>{d.Event.once(X.onMessage)(ae=>{const B=new D(ae),T=h(B),k=new I(X,T),F=new C(X);this.a.forEach((U,$)=>k.registerChannel($,U));const N={channelServer:k,channelClient:F,ctx:T};this.f.add(N),this.g.fire(N),Z(()=>{k.dispose(),F.dispose(),this.f.delete(N),this.h.fire(N)})})})}getChannel(z,X){const Z=this;return{call(oe,ae,B){let T;if((0,b.isFunction)(X)){const F=(0,E.getRandomElement)(Z.connections.filter(X));T=F?Promise.resolve(F):d.Event.toPromise(d.Event.filter(Z.onDidAddConnection,X))}else T=X.routeCall(Z,oe,ae);const k=T.then(F=>F.channelClient.getChannel(z));return q(k).call(oe,ae,B)},listen(oe,ae){if((0,b.isFunction)(X))return Z.j(z,X,oe,ae);const B=X.routeEvent(Z,oe,ae).then(T=>T.channelClient.getChannel(z));return q(B).listen(oe,ae)}}}j(z,X,Z,oe){const ae=this;let B=new c.DisposableStore;const T=new d.Emitter({onWillAddFirstListener:()=>{B=new c.DisposableStore;const k=new d.EventMultiplexer,F=new Map,N=$=>{const K=$.channelClient.getChannel(z).listen(Z,oe),se=k.add(K);F.set($,se)},U=$=>{const x=F.get($);x&&(x.dispose(),F.delete($))};ae.connections.filter(X).forEach(N),d.Event.filter(ae.onDidAddConnection,X)(N,void 0,B),ae.onDidRemoveConnection(U,void 0,B),k.event(T.fire,T,B),B.add(k)},onDidRemoveLastListener:()=>{B.dispose()}});return T.event}registerChannel(z,X){this.a.set(z,X),this.f.forEach(Z=>{Z.channelServer.registerChannel(z,X)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class W{constructor(z,X,Z=null){const oe=new t;u(oe,X),z.send(oe.buffer),this.a=new C(z,Z),this.d=new I(z,X,Z)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,X){this.d.registerChannel(z,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=W;function q(j){return{call(z,X,Z){return j.then(oe=>oe.call(z,X,Z))},listen(z,X){const Z=new d.Relay;return j.then(oe=>Z.input=oe.listen(z,X)),Z.event}}}e.getDelayedChannel=q;function V(j){let z=!1;return{call(X,Z,oe){return z?j.call(X,Z,oe):(0,L.timeout)(0).then(()=>z=!0).then(()=>j.call(X,Z,oe))},listen(X,Z){if(z)return j.listen(X,Z);const oe=new d.Relay;return(0,L.timeout)(0).then(()=>z=!0).then(()=>oe.input=j.listen(X,Z)),oe.event}}}e.getNextTickChannel=V;class _{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const X of z.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await d.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.StaticRouter=_;var ne;(function(j){function z(ae,B){const T=ae,k=B&&B.disableMarshalling,F=new Map;for(const N in T)Z(N)&&F.set(N,d.Event.buffer(T[N],!0));return new class{listen(N,U,$){const x=F.get(U);if(x)return x;if(oe(U)){const K=T[U];if(typeof K=="function")return K.call(T,$)}throw new Error(`Event not found: ${U}`)}call(N,U,$){const x=T[U];if(typeof x=="function"){if(!k&&Array.isArray($))for(let K=0;K<$.length;K++)$[K]=(0,p.revive)($[K]);return x.apply(T,$)}throw new Error(`Method not found: ${U}`)}}}j.fromService=z;function X(ae,B){const T=B&&B.disableMarshalling;return new Proxy({},{get(k,F){if(typeof F=="string")return B?.properties?.has(F)?B.properties.get(F):oe(F)?function(N){return ae.listen(F,N)}:Z(F)?ae.listen(F):async function(...N){let U;B&&!(0,b.isUndefinedOrNull)(B.context)?U=[B.context,...N]:U=N;const $=await ae.call(F,U);return T?$:(0,p.revive)($)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=X;function Z(ae){return ae[0]==="o"&&ae[1]==="n"&&m.isUpperAsciiLetter(ae.charCodeAt(2))}function oe(ae){return/^onDynamic/.test(ae)&&m.isUpperAsciiLetter(ae.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const z=j.toString();if(z!=="[object Object]")return z}return j}function ce(j){return Array.isArray(j)?j.map(ue):ue(j)}function J(j,z,X,Z,oe,ae,B){B=ce(B);const T=re[oe],k=T[Z%T.length];let F=[`%c[${j}]%c[${String(z).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(ae)?(F=F.concat(B),F.push(")")):F.push(B),console.log.apply(console,F)}class H{constructor(z,X){this.d=z,this.f=X,this.a=0,this.b=0}logOutgoing(z,X,Z,oe,ae){this.b+=z,J(this.d,this.b,z,X,Z,oe,ae)}logIncoming(z,X,Z,oe,ae){this.a+=z,J(this.f,this.a,z,X,Z,oe,ae)}}e.IPCLogger=H}),define(ee[152],te([0,1,17,3,45]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(d){this.a=d,this.onMessage=L.Event.fromDOMEventEmitter(this.a,"message",c=>E.VSBuffer.wrap(c.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class R extends n.IPCClient{constructor(d,c){const p=new A(d);super(p,c),this.b=p}dispose(){this.b.disconnect()}}e.Client=R}),define(ee[104],te([0,1,7,17,3,2,45]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(C){C.Created="created",C.Read="read",C.Write="write",C.Open="open",C.Error="error",C.Close="close",C.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",C.NodeEndReceived="nodeEndReceived",C.NodeEndSent="nodeEndSent",C.NodeDrainBegin="nodeDrainBegin",C.NodeDrainEnd="nodeDrainEnd",C.zlibInflateError="zlibInflateError",C.zlibInflateData="zlibInflateData",C.zlibInflateInitialWrite="zlibInflateInitialWrite",C.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",C.zlibInflateWrite="zlibInflateWrite",C.zlibInflateFlushFired="zlibInflateFlushFired",C.zlibDeflateError="zlibDeflateError",C.zlibDeflateData="zlibDeflateData",C.zlibDeflateWrite="zlibDeflateWrite",C.zlibDeflateFlushFired="zlibDeflateFlushFired",C.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",C.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",C.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",C.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",C.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",C.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",C.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",C.ProtocolHeaderRead="protocolHeaderRead",C.ProtocolMessageRead="protocolMessageRead",C.ProtocolHeaderWrite="protocolHeaderWrite",C.ProtocolMessageWrite="protocolMessageWrite",C.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var d;(function(C){C.enableDiagnostics=!1,C.records=[];const O=new WeakMap;let W=0;function q(_,ne){if(!O.has(_)){const re=String(++W);O.set(_,re)}return O.get(_)}function V(_,ne,re,ue){if(!C.enableDiagnostics)return;const ce=q(_,ne);if(ue instanceof L.VSBuffer||ue instanceof Uint8Array||ue instanceof ArrayBuffer||ArrayBuffer.isView(ue)){const J=L.VSBuffer.alloc(ue.byteLength);J.set(ue),C.records.push({timestamp:Date.now(),id:ce,label:ne,type:re,buff:J})}else C.records.push({timestamp:Date.now(),id:ce,label:ne,type:re,data:ue})}C.traceSocketEvent=V})(d||(e.SocketDiagnostics=d={}));var c;(function(C){C[C.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",C[C.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(c||(e.SocketCloseEventType=c={}));let p=null;function m(){return p||(p=L.VSBuffer.alloc(0)),p}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,W){if(O===0)return m();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ne=this.a[0];return W&&(this.a.shift(),this.b-=O),ne}if(this.a[0].byteLength>O){const ne=this.a[0].slice(0,O);return W&&(this.a[0]=this.a[0].slice(O),this.b-=O),ne}const q=L.VSBuffer.alloc(O);let V=0,_=0;for(;O>0;){const ne=this.a[_];if(ne.byteLength>O){const re=ne.slice(0,O);q.set(re,V),V+=O,W&&(this.a[_]=ne.slice(O),this.b-=O),O-=O}else q.set(ne,V),V+=ne.byteLength,W?(this.a.shift(),this.b-=ne.byteLength):_++,O-=ne.byteLength}return q}}e.ChunkStream=b;var f;(function(C){C[C.None=0]="None",C[C.Regular=1]="Regular",C[C.Control=2]="Control",C[C.Ack=3]="Ack",C[C.Disconnect=5]="Disconnect",C[C.ReplayRequest=6]="ReplayRequest",C[C.Pause=7]="Pause",C[C.Resume=8]="Resume",C[C.KeepAlive=9]="KeepAlive",C[C.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",C[C.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function S(C){switch(C){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(C){C[C.HeaderLength=13]="HeaderLength",C[C.AcknowledgeTime=2e3]="AcknowledgeTime",C[C.TimeoutTime=2e4]="TimeoutTime",C[C.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",C[C.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",C[C.KeepAliveSendTime=5e3]="KeepAliveSendTime",C[C.LatencySampleTime=6e4]="LatencySampleTime",C[C.LatencySampleCount=5]="LatencySampleCount",C[C.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",C[C.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w||(e.ProtocolConstants=w={}));class r{constructor(O,W,q,V){this.type=O,this.id=W,this.ack=q,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.Disposable{constructor(O){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new b,this.B(this.a.onData(W=>this.acceptChunk(W))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const W=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=W.readUInt32BE(9),this.g.messageType=W.readUInt8(0),this.g.id=W.readUInt32BE(1),this.g.ack=W.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const q=this.g.messageType,V=this.g.id,_=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",W),this.f.fire(new r(q,V,_,W)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const W=L.VSBuffer.alloc(13);W.writeUInt8(O.type,0),W.writeUInt32BE(O.id,1),W.writeUInt32BE(O.ack,5),W.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(W,O.data)}g(O,W){const q=this.f===0;return this.d.push(O,W),this.f+=O.byteLength+W.byteLength,q}h(){const O=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,W){this.g(O,W)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class v extends A.Disposable{constructor(O){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new l(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(W=>{W.type===1&&this.f.fire(W.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new r(1,0,0,O))}}e.Protocol=v;class y extends R.IPCClient{static fromSocket(O,W){return new y(new v(O),W)}get onDidDispose(){return this.b.onDidDispose}constructor(O,W,q=null){super(O,W,q),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=y;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class t{constructor(O){this.data=O,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let O=0,W=this.a;for(;W;)W=W.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let W=0,q=this.a;for(;q;)O[W++]=q.data,q=q.next;return O}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const W=new t(O);if(!this.a){this.a=W,this.b=W;return}this.b.next=W,this.b=W}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let W=0;W<i.a;W++)this.c[W]=O-1e3*W;setInterval(()=>{for(let W=i.a;W>=1;W--)this.c[W]=this.c[W-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),W=(1+i.a)*1e3;let q=0;for(let V=0;V<i.a;V++)O-this.c[V]<=W&&q++;return 1-q/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var s;(function(C){C[C.Good=0]="Good",C[C.Poor=1]="Poor"})(s||(e.ConnectionHealth=s={}));function o(C){switch(C){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class u{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=u;class h{constructor(O,W){this.roundTripTime=O,this.recentHighRoundTripCount=W}}e.HighRoundTripTimeEvent=h;class I{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=O.socket,this.p=this.t.add(new l(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage(W=>this.E(W))),this.t.add(this.o.onClose(W=>this.A.fire(W))),this.r=this.t.add(new M),this.t.add(this.r.onSendLatencyRequest(W=>this.J(W))),this.t.add(this.r.onHighRoundTripTime(W=>this.C.fire(W))),this.t.add(this.r.onDidChangeConnectionHealth(W=>this.D.fire(W))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new r(5,0,0,m());this.p.write(O),this.p.flush()}sendPause(){const O=new r(7,0,0,m());this.p.write(O)}sendResume(){const O=new r(8,0,0,m());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,W){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new l(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage(q=>this.E(q))),this.t.add(this.o.onClose(q=>this.A.fire(q))),this.r=this.t.add(new M),this.t.add(this.r.onSendLatencyRequest(q=>this.J(q))),this.t.add(this.r.onHighRoundTripTime(q=>this.C.fire(q))),this.t.add(this.r.onDidChangeConnectionHealth(q=>this.D.fire(q))),this.q.acceptChunk(W)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new r(3,0,this.h,m());this.p.write(O);const W=this.b.toArray();for(let q=0,V=W.length;q<V;q++)this.p.write(W[q]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const W=this.b.peek();if(W&&W.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const W=Date.now();W-this.m>1e4&&(this.m=W,this.p.write(new r(6,0,0,m())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const W=this.b.toArray();for(let q=0,V=W.length;q<V;q++)this.p.write(W[q]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const W=++this.c;this.h=this.g;const q=new r(1,W,this.h,O);this.b.push(q),this.a||(this.p.write(q),this.G())}sendControl(O){const W=new r(2,0,0,O);this.p.write(W)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),W=Date.now()-O.writtenTime,q=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(W>=2e4&&q>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:W,timeSinceLastReceivedSomeData:q});return}const _=Math.max(2e4-W,2e4-q,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},_)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new r(3,0,this.h,m());this.p.write(O)}I(){this.h=this.g;const O=new r(9,0,this.h,m());this.p.write(O)}J(O){this.h=this.g;const W=new r(10,0,this.h,O);this.p.write(W)}K(O){this.h=this.g;const W=new r(11,0,this.h,O);this.p.write(W)}}e.PersistentProtocol=I;class M extends A.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,W=L.VSBuffer.alloc(4);W.writeUInt32BE(O,0),this.a.fire(W)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const W=O.readUInt32BE(0);if(this.g<=0||W!==this.h)return;const q=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=q;const _=this.l,ne=this.j.filter(re=>re>=1e3).length;this.l=ne>=3?1:0,q>1e3&&this.b.fire(new h(q,ne)),_!==this.l&&this.c.fire(this.l)}}}),define(ee[153],te([0,1,42,17,3,2,45,138]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(p,m){const b=n.Event.fromNodeEventEmitter(E.validatedIpcMain,m,(S,w)=>({event:S,message:w})),f=n.Event.filter(b,({event:S})=>S.sender.id===p);return n.Event.map(f,({message:S})=>S&&L.VSBuffer.wrap(S))}class c extends R.IPCServer{static d(){const m=n.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:b})=>b);return n.Event.map(m,b=>{const f=b.id;c.b.get(f)?.dispose();const w=new n.Emitter;c.b.set(f,(0,A.toDisposable)(()=>w.fire()));const r=d(f,"vscode:message"),g=n.Event.any(n.Event.signal(d(f,"vscode:disconnect")),w.event);return{protocol:new P.Protocol(b,r),onDidClientDisconnect:g}})}constructor(){super(c.d())}}e.Server=c,c.b=new Map}),define(ee[154],te([0,1,42,3,31,152]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends A.Client{constructor(c,p){super({addEventListener:(m,b)=>c.addListener(m,b),removeEventListener:(m,b)=>c.removeListener(m,b),postMessage:m=>c.postMessage(m),start:()=>c.start(),close:()=>c.close()},p)}}e.Client=R;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,n.generateUuid)();d.webContents.send("vscode:createMessageChannel",c);const p=L.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(b,f)=>({nonce:f,port:b.ports[0]})),{port:m}=await L.Event.toPromise(L.Event.once(L.Event.filter(p,b=>b.nonce===c)));return m}e.connect=P}),define(ee[155],te([0,1,50,7,17,22,147,13,3,2,40,86,71,45]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends f.ChannelServer{constructor(g){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",l=>n.VSBuffer.wrap(Buffer.from(l,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=S;class w{constructor(g,l){this.i=g,this.j=l,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const v=l&&l.timeout?l.timeout:6e4;this.b=new L.Delayer(v),this.d=null,this.f=null}getChannel(g){const l=this;return{call(v,y,D){return l.k(g,v,y,D)},listen(v,y){return l.l(g,v,y)}}}k(g,l,v,y=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const D=this.n(g),t=(0,L.createCancelablePromise)(s=>D.call(l,v,s)),a=y.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,l,v){if(!this.b)return d.Event.None;this.b.cancel();let y;const D=new d.Emitter({onWillAddFirstListener:()=>{y=this.n(g).listen(l,v)(D.fire,D),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(l.env),this.d=(0,E.fork)(this.i,g,l);const v=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,R.isRemoteConsoleLog)(o)){(0,R.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(n.VSBuffer.wrap(Buffer.from(o,"base64")))});const D=this.j.useQueue?(0,m.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&D.send(o.buffer.toString("base64")),a=v.event,i={send:t,onMessage:a};this.f=new f.ChannelClient(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",s),this.c.forEach(h=>(0,c.dispose)(h)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(g){let l=this.g.get(g);return l||(l=this.m.getChannel(g),this.g.set(g,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(ee[105],te([0,1,7,3,2,11]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function P(m){const b=m;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var d;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(d||(e.StorageState=d={}));class c extends n.Disposable{constructor(b,f=Object.create(null)){super(),this.m=b,this.n=f,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new E.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((f,S)=>this.s(S,f)),b.deleted?.forEach(f=>this.s(f,void 0))}s(b,f){if(this.c===d.Closed)return;let S=!1;(0,A.isUndefinedOrNull)(f)?S=this.f.delete(b):this.f.get(b)!==f&&(this.f.set(b,f),S=!0),S&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,f){const S=this.f.get(b);return(0,A.isUndefinedOrNull)(S)?f:S}getBoolean(b,f){const S=this.get(b);return(0,A.isUndefinedOrNull)(S)?f:S==="true"}getNumber(b,f){const S=this.get(b);return(0,A.isUndefinedOrNull)(S)?f:parseInt(S,10)}async set(b,f){if(this.c===d.Closed)return;if((0,A.isUndefinedOrNull)(f))return this.delete(b);const S=String(f);if(this.f.get(b)!==S)return this.f.set(b,S),this.j.set(b,S),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===d.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=c,c.a=100;class p{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((f,S)=>this.a.set(S,f)),b.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=p}),define(ee[156],te([0,1,7,3,35,9,24]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return L.Event.None}constructor(p,m=Object.create(null)){this.g=p,this.h=m,this.c=(0,A.basename)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,m=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(p){const m=await this.f;return this.j(m,p)}j(p,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,n.mapToString)(m.insert):"0"}), delete(${m.delete?(0,n.setToString)(m.delete):"0"})`),this.t(p,()=>{const b=m.insert,f=m.delete;if(b&&b.size>0){const S=[];S.push([]);let w=0;b.forEach((r,g)=>{let l=S[w];l.length>P.b&&(w++,l=[],S.push(l)),l.push(g,r)}),S.forEach(r=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(r.length/2).fill("(?,?)").join(",")}`,g=>g.run(r),()=>{const g=[];let l=0;return b.forEach((v,y)=>{g.push(y),l+=v.length}),`Keys: ${g.join(", ")} Length: ${l}`})})}if(f&&f.size){const S=[];S.push([]);let w=0;f.forEach(r=>{let g=S[w];g.length>P.b&&(w++,g=[],S.push(g)),g.push(r)}),S.forEach(r=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(r.length).fill("?").join(",")})`,g=>g.run(r),()=>{const g=[];return f.forEach(l=>{g.push(l)}),`Keys: ${g.join(", ")}`})})}})}async close(p){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,p)}k(p,m){return new Promise((b,f)=>{p.db.close(S=>(S&&this.o(p,`[storage ${this.c}] close(): ${S}`),this.g===P.IN_MEMORY_PATH?b():!p.isErroneous&&!p.isInMemory?this.l().then(b,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),b())):typeof m=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const r=()=>this.k(w,void 0);return this.j(w,{insert:m()}).then(()=>r(),g=>(r(),Promise.reject(g)))})).then(b,f):f(S||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return R.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const m=await this.f,b=await this.r(m,p?"PRAGMA integrity_check":"PRAGMA quick_check"),f=p?b.integrity_check:b.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async n(p,m=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${m})`);try{return await this.p(p)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&m)return await(0,E.timeout)(P.a),this.n(p,!1);try{await R.Promises.unlink(p);try{await R.Promises.rename(this.m(p),p)}catch{}return await this.p(p)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(P.IN_MEMORY_PATH)}}}o(p,m){p.isErroneous=!0,p.lastError=m,this.d.error(m)}p(p){return new Promise((m,b)=>{new Promise((f,S)=>{G(["@vscode/sqlite3"],f,S)}).then(f=>{const S={db:new(this.d.isTracing?f.verbose().Database:f.Database)(p,w=>w?S.db&&w.code!=="SQLITE_CANTOPEN"?S.db.close(()=>b(w)):b(w):this.q(S,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(S),r=>S.db.close(()=>b(r)))),isInMemory:p===P.IN_MEMORY_PATH};S.db.on("error",w=>this.o(S,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&S.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},b)})}q(p,m){return new Promise((b,f)=>{p.db.exec(m,S=>S?(this.o(p,`[storage ${this.c}] exec(): ${S}`),f(S)):b())})}r(p,m){return new Promise((b,f)=>{p.db.get(m,(S,w)=>S?(this.o(p,`[storage ${this.c}] get(): ${S}`),f(S)):b(w))})}s(p,m){return new Promise((b,f)=>{p.db.all(m,(S,w)=>S?(this.o(p,`[storage ${this.c}] all(): ${S}`),f(S)):b(w))})}t(p,m){return new Promise((b,f)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),m(),p.db.run("END TRANSACTION",S=>S?(this.o(p,`[storage ${this.c}] transaction(): ${S}`),f(S)):b())})})}u(p,m,b,f){const S=p.db.prepare(m),w=r=>{this.o(p,`[storage ${this.c}] prepare(): ${r} (${m}). Details: ${f()}`)};S.on("error",w),b(S),S.finalize(r=>{r&&w(r),S.removeListener("error",w)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class d{constructor(p){p&&typeof p.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.a=p.logTrace),p&&typeof p.logError=="function"&&(this.b=p.logError)}get isTracing(){return!!this.a}trace(p){this.a?.(p)}error(p){this.b?.(p)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[157],te([12,10]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ee[158],te([12,10]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[159],te([12,10]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ee[160],te([12,10]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ee[161],te([12,10]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(ee[162],te([12,10]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[163],te([12,10]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ee[164],te([12,10]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ee[165],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[166],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[167],te([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[168],te([12,10]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[169],te([12,10]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[170],te([12,10]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[171],te([12,10]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[172],te([12,10]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[173],te([12,10]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[174],te([12,10]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[175],te([12,10]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[176],te([12,10]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[177],te([12,10]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[178],te([12,10]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[179],te([12,10]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ee[180],te([12,10]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[181],te([12,10]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[182],te([12,10]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[183],te([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[184],te([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[185],te([12,10]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ee[186],te([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[187],te([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[188],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function L(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ee[189],te([0,1,8]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function n(R){let P=[];try{Array.isArray(R.workspaces)&&(P=R.workspaces.map(d=>({workspace:{id:d.id,configPath:E.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=n;function A(R){let P=[];try{Array.isArray(R.folders)&&(P=R.folders.map(d=>({folderUri:E.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=A}),define(ee[190],te([0,1,13,160]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var n;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(n||(e.TokenType=n={}));function A(...c){switch(c.length){case 1:return(0,L.localize)(0,null,c[0]);case 2:return(0,L.localize)(1,null,c[0],c[1]);case 3:return(0,L.localize)(2,null,c[0],c[1],c[2]);default:return}}const R=(0,L.localize)(3,null),P=(0,L.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const m=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:m})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const m=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:m})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const m=this.d,b=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:b};this.g.push({offset:m,lexeme:b,additionalInfo:p}),this.f.push(f)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const m=this.c.substring(this.d,this.e),b=d.b.get(m);b?this.k(b):this.f.push({type:17,lexeme:m,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,m=!1,b=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(P);return}const S=this.c.charCodeAt(p);if(m)m=!1;else if(S===47&&!b){p++;break}else S===91?b=!0:S===92?m=!0:S===93&&(b=!1);p++}for(;p<this.c.length&&d.a.has(this.c.charCodeAt(p));)p++;this.e=p;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=d,d.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0))),d.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(ee[191],te([0,1,3,2]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,d,c){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(P,d,c){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=n,n.ChannelName="extensionhostdebugservice";class A extends L.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,c){this.b.call("attach",[P,d,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.ExtensionHostDebugChannelClient=A}),define(ee[192],te([0,1,141,55,15,9,36,18,8]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(d.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=R.env.VSCODE_PORTABLE;return f?d.URI.file((0,A.join)(f,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?d.URI.file((0,A.resolve)(f)):d.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const S=R.env.VSCODE_EXTENSIONS;if(S)return S;const w=R.env.VSCODE_PORTABLE;return w?(0,A.join)(w,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(S=>/^[^:/?#]+?:\/\//.test(S)?d.URI.parse(S):d.URI.file((0,A.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const S of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=R.env.VSCODE_PORTABLE;return f?d.URI.file((0,A.join)(f,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,S,w){this.a=f,this.b=S,this.c=w,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,ye([L.memoize],c.prototype,"appRoot",null),ye([L.memoize],c.prototype,"userHome",null),ye([L.memoize],c.prototype,"userDataPath",null),ye([L.memoize],c.prototype,"appSettingsHome",null),ye([L.memoize],c.prototype,"tmpDir",null),ye([L.memoize],c.prototype,"cacheHome",null),ye([L.memoize],c.prototype,"stateResource",null),ye([L.memoize],c.prototype,"userRoamingDataHome",null),ye([L.memoize],c.prototype,"userDataSyncHome",null),ye([L.memoize],c.prototype,"sync",null),ye([L.memoize],c.prototype,"machineSettingsResource",null),ye([L.memoize],c.prototype,"workspaceStorageHome",null),ye([L.memoize],c.prototype,"localHistoryHome",null),ye([L.memoize],c.prototype,"keyboardLayoutResource",null),ye([L.memoize],c.prototype,"argvResource",null),ye([L.memoize],c.prototype,"isExtensionDevelopment",null),ye([L.memoize],c.prototype,"untitledWorkspacesHome",null),ye([L.memoize],c.prototype,"builtinExtensionsPath",null),ye([L.memoize],c.prototype,"extensionsPath",null),ye([L.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ye([L.memoize],c.prototype,"extensionDevelopmentKind",null),ye([L.memoize],c.prototype,"extensionTestsLocationURI",null),ye([L.memoize],c.prototype,"debugExtensionHost",null),ye([L.memoize],c.prototype,"logLevel",null),ye([L.memoize],c.prototype,"extensionLogLevel",null),ye([L.memoize],c.prototype,"serviceMachineIdResource",null),ye([L.memoize],c.prototype,"disableTelemetry",null),ye([L.memoize],c.prototype,"disableWorkspaceTrust",null),ye([L.memoize],c.prototype,"policyFile",null);function p(b,f){return m(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId,b.extensionEnvironment)}e.parseExtensionHostDebugPort=p;function m(b,f,S,w,r,g){const v=Number(f||b)||(w?null:S),y=v?!!f:!1;let D;if(g)try{D=JSON.parse(g)}catch{}return{port:v,break:y,debugId:r,env:D}}e.parseDebugParams=m}),define(ee[106],te([0,1,291,4,163]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,r,g=R){const l=w.find(u=>u.length>0&&u[0]!=="-"),v={},y=["_"],D=[],t={};let a;for(const u in r){const h=r[u];h.type==="subcommand"?u===l&&(a=h):(h.alias&&(v[u]=h.alias),h.type==="string"||h.type==="string[]"?(y.push(u),h.deprecates&&y.push(...h.deprecates)):h.type==="boolean"&&(D.push(u),h.deprecates&&D.push(...h.deprecates)),h.global&&(t[u]=h))}if(a&&l){const u=t;for(const C in a.options)u[C]=a.options[C];const h=w.filter(C=>C!==l),I=g.getSubcommandReporter?g.getSubcommandReporter(l):void 0,M=P(h,u,I);return{[l]:M,_:[]}}const i=E(w,{string:y,boolean:D,alias:v}),s={},o=i;s._=i._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in r){const h=r[u];if(h.type==="subcommand")continue;h.alias&&delete o[h.alias];let I=o[u];if(h.deprecates)for(const M of h.deprecates)o.hasOwnProperty(M)&&(I||(I=o[M],I&&g.onDeprecatedOption(M,h.deprecationMessage||(0,n.localize)(35,null,u))),delete o[M]);if(typeof I<"u"){if(h.type==="string[]"){if(Array.isArray(I)||(I=[I]),!h.allowEmptyValue){const M=I.filter(C=>C.length>0);M.length!==I.length&&(g.onEmptyValue(u),I=M.length>0?M:void 0)}}else h.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(u,I)):!I&&!h.allowEmptyValue&&(g.onEmptyValue(u),I=void 0));s[u]=I,h.deprecationMessage&&g.onDeprecatedOption(u,h.deprecationMessage)}delete o[u]}for(const u in o)g.onUnknownOption(u);return s}e.parseArgs=P;function d(w,r){let g="";return r.args&&(Array.isArray(r.args)?g=` <${r.args.join("> <")}>`:g=` <${r.args}>`),r.alias?`-${r.alias} --${w}${g}`:`--${w}${g}`}function c(w,r){const g=[];for(const l in w){const v=w[l],y=d(l,v);g.push([y,v.description])}return p(g,r)}e.formatOptions=c;function p(w,r){const l=w.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(r-l<25)return w.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=r-l-1,y=[];for(const D of w){const t=D[0],a=b(D[1],v),i=m(l-t.length-2);y.push("  "+t+i+a[0]);for(let s=1;s<a.length;s++)y.push(m(l)+a[s])}return y}function m(w){return" ".repeat(w)}function b(w,r){const g=[];for(;w.length;){const l=w.length<r?w.length:w.lastIndexOf(" ",r),v=w.slice(0,l).trim();w=w.slice(l),g.push(v)}return g}function f(w,r,g,l,v){const y=process.stdout.isTTY&&process.stdout.columns||80,D=v?.noInputFiles!==!0?`[${(0,n.localize)(36,null)}...]`:"",t=[`${w} ${g}`];t.push(""),t.push(`${(0,n.localize)(37,null)}: ${r} [${(0,n.localize)(38,null)}]${D}`),t.push(""),v?.noPipe!==!0&&(L.isWindows?t.push((0,n.localize)(39,null,r)):t.push((0,n.localize)(40,null,r)),t.push(""));const a={},i=[];for(const s in l){const o=l[s];if(o.type==="subcommand")o.description&&i.push({command:s,description:o.description});else if(o.description&&o.cat){let u=a[o.cat];u||(a[o.cat]=u={}),u[s]=o}}for(const s in a){const o=s,u=a[o];u&&(t.push(A[o]),t.push(...c(u,y)),t.push(""))}return i.length&&(t.push((0,n.localize)(41,null)),t.push(...p(i.map(s=>[s.command,s.description]),y)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function S(w,r){return`${w||(0,n.localize)(42,null)}
${r||(0,n.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=S}),define(ee[193],te([0,1,70,191,106]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class A extends L.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,d,c){return d==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(P,d,c)}async g(P,d){const c=(0,n.parseArgs)(P,n.OPTIONS);c.debugRenderer=d;const p=c.extensionDevelopmentPath;if(!p)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!d)return{success:!0};const b=m.win;if(!b)return{success:!0};const f=b.webContents.debugger;let S=f.isAttached()?1/0:0;const w=(0,E.createServer)(r=>{S++===0&&f.attach();let g=!1;const l=D=>{g||r.write(JSON.stringify(D)+"\0")},v=(D,t,a,i)=>l({method:t,params:a,sessionId:i});b.on("close",()=>{f.removeListener("message",v),r.end(),g=!0}),f.addListener("message",v);let y=Buffer.alloc(0);r.on("data",D=>{y=Buffer.concat([y,D]);for(let t=y.indexOf(0);t!==-1;t=y.indexOf(0)){let a;try{const i=y.slice(0,t).toString("utf8");y=y.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(a.method,a.params,a.sessionId).then(i=>l({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>l({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),r.on("error",D=>{console.error("error on cdp pipe:",D)}),r.on("close",()=>{g=!0,--S===0&&f.detach()})});return await new Promise(r=>w.listen(0,r)),b.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=A}),define(ee[62],te([0,1,292,164,106]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(m,b){const f=(v,y)=>{console.warn((0,L.localize)(0,null,v,y))},S=v=>{console.warn((0,L.localize)(1,null,v))},w=(v,y)=>{console.warn((0,L.localize)(2,null,v,y))},r=v=>({onUnknownOption:y=>{v!=="tunnel"&&console.warn((0,L.localize)(3,null,y,v))},onMultipleValues:f,onEmptyValue:S,onDeprecatedOption:w,getSubcommandReporter:v!=="tunnel"?r:void 0}),g={onUnknownOption:v=>{console.warn((0,L.localize)(4,null,v))},onMultipleValues:f,onEmptyValue:S,onDeprecatedOption:w,getSubcommandReporter:r},l=(0,n.parseArgs)(m,n.OPTIONS,b?g:void 0);return l.goto&&l._.forEach(v=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,L.localize)(5,null))),l}function R(m){const b=m.findIndex(f=>!/^-/.test(f));if(b>-1)return[...m.slice(0,b),...m.slice(b+1)]}function P(m){let[,...b]=m;process.env.VSCODE_DEV&&(b=R(b)||[]);const f=!p(process.env);return A(b,f)}e.parseMainProcessArgv=P;function d(m){let[,,...b]=m;return process.env.VSCODE_DEV&&(b=R(b)||[]),A(b,!0)}e.parseCLIProcessArgv=d;function c(m,...b){const f=m.indexOf("--");return f===-1?m.push(...b):m.splice(f,0,...b),m}e.addArg=c;function p(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=p}),function(){"use strict";function G(e,E,L){function n(R,P){const d=A(R,P),c=[d];return e.isAbsolute(d)||c.unshift(L),e.resolve(...c)}function A(R,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const p=R["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(m,"AppData","Roaming")}break;case"darwin":c=e.join(E.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:n}}if(typeof define=="function")define(ee[194],te([195,26,36]),function(e,E,L){return G(e,E,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=G(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[107],te([0,1,26,192,194]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(c,p){super(c,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,n.getUserDataPath)(c,p.nameShort)},p)}}e.NativeEnvironmentService=A;function R(d,c){return(0,L.parseDebugParams)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,c,d.extensionEnvironment)}e.parsePtyHostDebugPort=R;function P(d,c){return(0,L.parseDebugParams)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,c,d.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(ee[196],te([0,1,41,26,32]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function A(R){const P=(0,n.randomPath)((0,L.tmpdir)());try{return(0,E.writeFileSync)(P,""),R&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){R&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFileSync=A}),define(ee[197],te([0,1,11,166]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(R,P,d){try{A(R,P,d)}catch(c){console.error(c?.message??c)}return R}e.localizeManifest=n;function A(R,P,d){const c=(p,m,b)=>{const f=p[m];if((0,E.isString)(f)){const S=f,w=S.length;if(w>1&&S[0]==="%"&&S[w-1]==="%"){const r=S.substr(1,w-2);let g=P[r];g===void 0&&d&&(g=d[r]);const l=typeof g=="string"?g:g?.message,v=d?.[r],y=typeof v=="string"?v:v?.message;if(!l){y||console.warn(`[${R.name}]: ${(0,L.localize)(0,null,r)}`);return}if(b&&(m==="title"||m==="category")&&y&&y!==l){const D={value:l,original:y};p[m]=D}else p[m]=l}}else if((0,E.isObject)(f))for(const S in f)f.hasOwnProperty(S)&&(S==="commands"?c(f,S,!0):c(f,S,b));else if(Array.isArray(f))for(let S=0;S<f.length;S++)c(f,S,b)};for(const p in R)R.hasOwnProperty(p)&&c(R,p)}}),define(ee[198],te([0,1,18,72,168,199]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=d;function c(g){if(!d(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=g.match(R);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.parseVersion=c;function p(g){if(!g)return null;const l=g.majorBase,v=g.majorMustEqual,y=g.minorBase;let D=g.minorMustEqual;const t=g.patchBase;let a=g.patchMustEqual;g.hasCaret&&(l===0||(D=!1),a=!1);let i=0;if(g.preRelease){const s=P.exec(g.preRelease);if(s){const[,o,u,h]=s;i=Date.UTC(Number(o),Number(u)-1,Number(h))}}return{majorBase:l,majorMustEqual:v,minorBase:y,minorMustEqual:D,patchBase:t,patchMustEqual:a,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=p;function m(g,l,v){let y;typeof g=="string"?y=p(c(g)):y=g;let D;l instanceof Date?D=l.getTime():typeof l=="string"&&(D=new Date(l).getTime());let t;if(typeof v=="string"?t=p(c(v)):t=v,!y||!t)return!1;const a=y.majorBase,i=y.minorBase,s=y.patchBase;let o=t.majorBase,u=t.minorBase,h=t.patchBase;const I=t.notBefore;let M=t.majorMustEqual,C=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?a>o?!0:a<o?!1:i>u?!0:i<u||D&&D<I?!1:s>=h:(a===1&&o===0&&(!M||!C||!O)&&(o=1,u=0,h=0,M=!0,C=!1,O=!1),a<o?!1:a>o?!M:i<u?!1:i>u?!C:s<h?!1:s>h?!O:!(D&&D<I))}e.isValidVersion=m;function b(g,l,v,y,D){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([L.default.Error,n.localize(0,null)]),t;if(typeof y.name!="string")return t.push([L.default.Error,n.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([L.default.Error,n.localize(2,null,"version")]),t;if(!y.engines)return t.push([L.default.Error,n.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([L.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!r(y.extensionDependencies))return t.push([L.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!r(y.activationEvents))return t.push([L.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([L.default.Error,n.localize(7,null,"activationEvents","main","browser")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([L.default.Warning,n.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([L.default.Error,n.localize(9,null,"main")]),t;{const s=(0,E.joinPath)(v,y.main);(0,E.isEqualOrParent)(s,v)||t.push([L.default.Warning,n.localize(10,null,s.path,v.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([L.default.Error,n.localize(11,null,"browser")]),t;{const s=(0,E.joinPath)(v,y.browser);(0,E.isEqualOrParent)(s,v)||t.push([L.default.Warning,n.localize(12,null,s.path,v.path)])}}if(!A.valid(y.version))return t.push([L.default.Error,n.localize(13,null)]),t;const a=[];if(!f(g,l,y,D,a))for(const s of a)t.push([L.default.Error,s]);return t}e.validateExtensionManifest=b;function f(g,l,v,y,D){return y||typeof v.main>"u"&&typeof v.browser>"u"?!0:w(g,l,v.engines.vscode,D)}e.isValidExtensionVersion=f;function S(g,l,v){return g==="*"||w(l,v,g)}e.isEngineValid=S;function w(g,l,v,y=[]){const D=p(c(v));if(!D)return y.push(n.localize(14,null,v)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return y.push(n.localize(15,null,v)),!1}else if(!D.majorMustEqual)return y.push(n.localize(16,null,v)),!1;return m(g,l,D)?!0:(y.push(n.localize(17,null,g,v)),!1)}function r(g){if(!Array.isArray(g))return!1;for(let l=0,v=g.length;l<v;l++)if(typeof g[l]!="string")return!1;return!0}}),define(ee[200],te([0,1,17,31]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(A,R,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const p=(await R.readFile(A.serviceMachineIdResource)).value.toString();d=(0,L.isUUID)(p)?p:null}catch{d=null}if(!d){d=(0,L.generateUuid)();try{await R.writeFile(A.serviceMachineIdResource,E.VSBuffer.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=n}),define(ee[73],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(n,A=[],R=!1){this.ctor=n,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=E}),define(ee[201],te([0,1,73]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var n;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(n||(e.InstantiationType=n={}));function A(P,d,c){d instanceof E.SyncDescriptor||(d=new E.SyncDescriptor(d,[],!!c)),L.push([P,d])}e.registerSingleton=A;function R(){return L}e.getSingletonServiceDescriptors=R}),define(ee[202],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const P=this.lookupOrInsertNode(A),d=this.lookupOrInsertNode(R);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const P of this.a.values())P.outgoing.delete(R),P.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let P=this.a.get(R);return P||(P=new E(R,A),this.a.set(R,P)),P}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,P]of this.a)A.push(`${R}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const P=new Set([A]),d=this.c(R,P);if(d)return d}}c(A,R){for(const[P,d]of A.outgoing){if(R.has(P))return[...R,P].join(" -> ");R.add(P);const c=this.c(d,R);if(c)return c;R.delete(P)}}}e.Graph=L}),define(ee[6],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=P})(E||(e._util=E={})),e.IInstantiationService=n("instantiationService");function L(R,P,d){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:R,index:d}):(P[E.DI_DEPENDENCIES]=[{id:R,index:d}],P[E.DI_TARGET]=P)}function n(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const P=function(d,c,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,d,p)};return P.toString=()=>R,E.serviceIds.set(R,P),P}e.createDecorator=n;function A(R){return R}e.refineServiceDecorator=A}),define(ee[63],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[19],te([0,1,11,8,6]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=R;var P;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function d(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function c(r,g){const l=Object.create(null);for(const v in r)p(l,v,r[v],g);return l}e.toValuesTree=c;function p(r,g,l,v){const y=g.split("."),D=y.pop();let t=r;for(let a=0;a<y.length;a++){const i=y[a];let s=t[i];switch(typeof s){case"undefined":s=t[i]=Object.create(null);break;case"object":break;default:v(`Ignoring ${g} as ${y.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}t=s}if(typeof t=="object"&&t!==null)try{t[D]=l}catch{v(`Ignoring ${g} as ${y.join(".")} is ${JSON.stringify(t)}`)}else v(`Ignoring ${g} as ${y.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=p;function m(r,g){const l=g.split(".");b(r,l)}e.removeFromValueTree=m;function b(r,g){const l=g.shift();if(g.length===0){delete r[l];return}if(Object.keys(r).indexOf(l)!==-1){const v=r[l];typeof v=="object"&&!Array.isArray(v)&&(b(v,g),Object.keys(v).length===0&&delete r[l])}}function f(r,g,l){function v(t,a){let i=t;for(const s of a){if(typeof i!="object"||i===null)return;i=i[s]}return i}const y=g.split("."),D=v(r,y);return typeof D>"u"?l:D}e.getConfigurationValue=f;function S(r,g,l){Object.keys(g).forEach(v=>{v!=="__proto__"&&(v in r?E.isObject(r[v])&&E.isObject(g[v])?S(r[v],g[v],l):l&&(r[v]=g[v]):r[v]=g[v])})}e.merge=S;function w(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ee[203],te([0,1,4,27,190,6,159,13]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",E.isMacintosh),d.set("isLinux",E.isLinux),d.set("isWindows",E.isWindows),d.set("isWeb",E.isWeb),d.set("isMacNative",E.isMacintosh&&!E.isWeb),d.set("isEdge",E.isEdge),d.set("isFirefox",E.isFirefox),d.set("isChrome",E.isChrome),d.set("isSafari",E.isSafari);function c(T,k){if(d.get(T)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(T,k)}e.setConstant=c;const p=Object.prototype.hasOwnProperty;var m;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const b={regexParsingWithErrorRecovery:!0},f=(0,R.localize)(0,null),S=(0,R.localize)(1,null),w=(0,R.localize)(2,null),r=(0,R.localize)(3,null),g=(0,R.localize)(4,null),l=(0,R.localize)(5,null),v=(0,R.localize)(6,null),y=(0,R.localize)(7,null);class D{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=b){this.k=k,this.d=new n.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const N=this.D(),U=N.type===17?l:void 0;throw this.h.push({message:g,offset:N.offset,lexeme:n.Scanner.getLexeme(N),additionalInfo:U}),D.c}return F}catch(F){if(F!==D.c)throw F;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const F=this.o();k.push(F)}return k.length===1?k[0]:t.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const F=this.s();k.push(F)}return k.length===1?k[0]:t.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,r),F?.negate()}case 17:return this.z(),W.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,r),F}case 17:{const F=k.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const $=U.lexeme,x=$.lastIndexOf("/"),K=x===$.length-1?void 0:this.w($.substring(x+1));let se;try{se=new RegExp($.substring(1,x),K)}catch{throw this.B("REGEX",U)}return ue.create(F,se)}switch(U.type){case 10:case 19:{const $=[U.lexeme];this.z();let x=this.D(),K=0;for(let Se=0;Se<U.lexeme.length;Se++)U.lexeme.charCodeAt(Se)===40?K++:U.lexeme.charCodeAt(Se)===41&&K--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:K++;break;case 1:K--;break;case 10:case 18:for(let Se=0;Se<x.lexeme.length;Se++)x.lexeme.charCodeAt(Se)===40?K++:U.lexeme.charCodeAt(Se)===41&&K--}if(K<0)break;$.push(n.Scanner.getLexeme(x)),this.z(),x=this.D()}const se=$.join(""),de=se.lastIndexOf("/"),Ee=de===se.length-1?void 0:this.w(se.substring(de+1));let De;try{De=new RegExp(se.substring(1,de),Ee)}catch{throw this.B("REGEX",U)}return t.regex(F,De)}case 18:{const $=U.lexeme;this.z();let x=null;if(!(0,L.isFalsyOrWhitespace)($)){const K=$.indexOf("/"),se=$.lastIndexOf("/");if(K!==se&&K>=0){const de=$.slice(K+1,se),Ee=$[se+1]==="i"?"i":"";try{x=new RegExp(de,Ee)}catch{throw this.B("REGEX",U)}}}if(x===null)throw this.B("REGEX",U);return ue.create(F,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const U=this.u();return t.notIn(F,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return t.equals(F,U);switch(U){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return t.notEquals(F,U);switch(U){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,U)}}case 5:return this.z(),ne.create(F,this.u());case 6:return this.z(),re.create(F,this.u());case 7:return this.z(),V.create(F,this.u());case 8:return this.z(),_.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:v,offset:k.offset,lexeme:"",additionalInfo:y}),D.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,F){if(this.C(k))return this.z();throw this.B(F,this.D())}B(k,F,N){const U=(0,R.localize)(8,null,k,n.Scanner.getLexeme(F)),$=F.offset,x=n.Scanner.getLexeme(F);return this.h.push({message:U,offset:$,lexeme:x,additionalInfo:N}),D.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=D,D.c=new Error;class t{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(k){return h.create(k)}static equals(k,F){return I.create(k,F)}static notEquals(k,F){return O.create(k,F)}static regex(k,F){return ue.create(k,F)}static in(k,F){return M.create(k,F)}static notIn(k,F){return C.create(k,F)}static not(k){return W.create(k)}static and(...k){return H.create(k,null,!0)}static or(...k){return j.create(k,null,!0)}static greater(k,F){return V.create(k,F)}static greaterEquals(k,F){return _.create(k,F)}static smaller(k,F){return ne.create(k,F)}static smallerEquals(k,F){return re.create(k,F)}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.ContextKeyExpr=t,t.c=new D({regexParsingWithErrorRecovery:!1});function a(T){const k=new D({regexParsingWithErrorRecovery:!1});return T.map(F=>(k.parse(F),k.lexingErrors.length>0?k.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,R.localize)(9,null,N.additionalInfo):(0,R.localize)(10,null),offset:N.offset,length:N.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}e.validateWhenClauses=a;function i(T,k){const F=T?T.substituteConstants():void 0,N=k?k.substituteConstants():void 0;return!F&&!N?!0:!F||!N?!1:F.equals(N)}e.expressionsAreEqualWithConstantSubstitution=i;function s(T,k){return T.cmp(k)}class o{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=o,o.INSTANCE=new o;class u{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class h{static create(k,F=null){const N=d.get(k);return typeof N=="boolean"?N?u.INSTANCE:o.INSTANCE:new h(k,F)}constructor(k,F){this.key=k,this.c=F,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:X(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=d.get(this.key);return typeof k=="boolean"?k?u.INSTANCE:o.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=h;class I{static create(k,F,N=null){if(typeof F=="boolean")return F?h.create(k,N):W.create(k,N);const U=d.get(k);return typeof U=="boolean"?F===(U?"true":"false")?u.INSTANCE:o.INSTANCE:new I(k,F,N)}constructor(k,F,N){this.c=k,this.d=F,this.f=N,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=d.get(this.c);if(typeof k=="boolean"){const F=k?"true":"false";return this.d===F?u.INSTANCE:o.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=I;class M{static create(k,F){return new M(k,F)}constructor(k,F){this.d=k,this.f=F,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.f),N=k.getValue(this.d);return Array.isArray(F)?F.includes(N):typeof N=="string"&&typeof F=="object"&&F!==null?p.call(F,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=M;class C{static create(k,F){return new C(k,F)}constructor(k,F){this.d=k,this.f=F,this.type=11,this.c=M.create(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=C;class O{static create(k,F,N=null){if(typeof F=="boolean")return F?W.create(k,N):h.create(k,N);const U=d.get(k);return typeof U=="boolean"?F===(U?"true":"false")?o.INSTANCE:u.INSTANCE:new O(k,F,N)}constructor(k,F,N){this.c=k,this.d=F,this.f=N,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=d.get(this.c);if(typeof k=="boolean"){const F=k?"true":"false";return this.d===F?o.INSTANCE:u.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=O;class W{static create(k,F=null){const N=d.get(k);return typeof N=="boolean"?N?o.INSTANCE:u.INSTANCE:new W(k,F)}constructor(k,F){this.c=k,this.d=F,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:X(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=d.get(this.c);return typeof k=="boolean"?k?o.INSTANCE:u.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.ContextKeyNotExpr=W;function q(T,k){if(typeof T=="string"){const F=parseFloat(T);isNaN(F)||(T=F)}return typeof T=="string"||typeof T=="number"?k(T):o.INSTANCE}class V{static create(k,F,N=null){return q(F,U=>new V(k,U,N))}constructor(k,F,N){this.c=k,this.d=F,this.f=N,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=V;class _{static create(k,F,N=null){return q(F,U=>new _(k,U,N))}constructor(k,F,N){this.c=k,this.d=F,this.f=N,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=_;class ne{static create(k,F,N=null){return q(F,U=>new ne(k,U,N))}constructor(k,F,N){this.c=k,this.d=F,this.f=N,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ne;class re{static create(k,F,N=null){return q(F,U=>new re(k,U,N))}constructor(k,F,N){this.c=k,this.d=F,this.f=N,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:Z(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=re;class ue{static create(k,F){return new ue(k,F)}constructor(k,F){this.d=k,this.f=F,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const F=this.f?this.f.source:"",N=k.f?k.f.source:"";return F<N?-1:F>N?1:0}equals(k){if(k.type===this.type){const F=this.f?this.f.source:"",N=k.f?k.f.source:"";return this.d===k.d&&F===N}return!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.ContextKeyRegexExpr=ue;class ce{static create(k){return new ce(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new ce(this.c.map(k))}negate(){return this.c}}e.ContextKeyNotRegexExpr=ce;function J(T){let k=null;for(let F=0,N=T.length;F<N;F++){const U=T[F].substituteConstants();if(T[F]!==U&&k===null){k=[];for(let $=0;$<F;$++)k[$]=T[$]}k!==null&&(k[F]=U)}return k===null?T:k}class H{static create(k,F,N){return H.d(k,F,N)}constructor(k,F){this.expr=k,this.c=F,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const U=s(this.expr[F],k.expr[F]);if(U!==0)return U}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=J(this.expr);return k===this.expr?this:H.create(k,this.c,!1)}evaluate(k){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(k))return!1;return!0}static d(k,F,N){const U=[];let $=!1;for(const x of k)if(x){if(x.type===1){$=!0;continue}if(x.type===0)return o.INSTANCE;if(x.type===6){U.push(...x.expr);continue}U.push(x)}if(U.length===0&&$)return u.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(s);for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];for(;U.length>1;){const x=U[U.length-1];if(x.type!==9)break;U.pop();const K=U.pop(),se=U.length===0,de=j.create(x.expr.map(Ee=>H.create([Ee,K],null,N)),null,se);de&&(U.push(de),U.sort(s))}if(U.length===1)return U[0];if(N){for(let x=0;x<U.length;x++)for(let K=x+1;K<U.length;K++)if(U[x].negate().equals(U[K]))return o.INSTANCE;if(U.length===1)return U[0]}return new H(U,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const F of this.expr)k.push(...F.keys());return k}map(k){return new H(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.c){const k=[];for(const F of this.expr)k.push(F.negate());this.c=j.create(k,this,!0)}return this.c}}e.ContextKeyAndExpr=H;class j{static create(k,F,N){return j.d(k,F,N)}constructor(k,F){this.expr=k,this.c=F,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const U=s(this.expr[F],k.expr[F]);if(U!==0)return U}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=J(this.expr);return k===this.expr?this:j.create(k,this.c,!1)}evaluate(k){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(k))return!0;return!1}static d(k,F,N){let U=[],$=!1;if(k){for(let x=0,K=k.length;x<K;x++){const se=k[x];if(se){if(se.type===0){$=!0;continue}if(se.type===1)return u.INSTANCE;if(se.type===9){U=U.concat(se.expr);continue}U.push(se)}}if(U.length===0&&$)return o.INSTANCE;U.sort(s)}if(U.length!==0){if(U.length===1)return U[0];for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];if(N){for(let x=0;x<U.length;x++)for(let K=x+1;K<U.length;K++)if(U[x].negate().equals(U[K]))return u.INSTANCE;if(U.length===1)return U[0]}return new j(U,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const F of this.expr)k.push(...F.keys());return k}map(k){return new j(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.c){const k=[];for(const F of this.expr)k.push(F.negate());for(;k.length>1;){const F=k.shift(),N=k.shift(),U=[];for(const $ of B(F))for(const x of B(N))U.push(H.create([$,x],null,!1));k.unshift(j.create(U,null,!1))}this.c=j.create(k,this,!0)}return this.c}}e.ContextKeyOrExpr=j;class z extends h{static all(){return z.d.values()}constructor(k,F,N){super(k,null),this.f=F,typeof N=="object"?z.d.push({...N,key:k}):N!==!0&&z.d.push({key:k,description:N,type:F!=null?typeof F:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return I.create(this.key,k)}notEqualsTo(k){return O.create(this.key,k)}}e.RawContextKey=z,z.d=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function X(T,k){return T<k?-1:T>k?1:0}function Z(T,k,F,N){return T<F?-1:T>F?1:k<N?-1:k>N?1:0}function oe(T,k){if(T.type===0||k.type===1)return!0;if(T.type===9)return k.type===9?ae(T.expr,k.expr):!1;if(k.type===9){for(const F of k.expr)if(oe(T,F))return!0;return!1}if(T.type===6){if(k.type===6)return ae(k.expr,T.expr);for(const F of T.expr)if(oe(F,k))return!0;return!1}return T.equals(k)}e.implies=oe;function ae(T,k){let F=0,N=0;for(;F<T.length&&N<k.length;){const U=T[F].cmp(k[N]);if(U<0)return!1;U===0&&F++,N++}return F===T.length}function B(T){return T.type===9?T.expr:[T]}}),define(ee[74],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(A,R){return this.a[A]?.[R]??null}async setPassword(A,R,P){this.a[A]=this.a[A]??{},this.a[A][R]=P}async deletePassword(A,R){return this.a[A]?.[R]?(delete this.a[A][R],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const R=[];for(const P of Object.keys(this.a[A]||{}))R.push({account:P,password:this.a[A][P]});return R}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(ee[87],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class n{async getPerformanceInfo(R,P){return{}}async getSystemInfo(R,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,P){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=n}),define(ee[88],te([0,1,18,72,161,6,44,4,40]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,A.createDecorator)("dialogService");var c;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(c||(c={}));class p{a(r){return this.d(r,c.Confirmation)}b(r){return this.d(r,c.Prompt)}c(r){return this.d(r,c.Input)}d(r,g){const l=[];switch(g){case c.Confirmation:{const v=r;v.primaryButton?l.push(v.primaryButton):l.push((0,n.localize)(0,null)),v.cancelButton?l.push(v.cancelButton):l.push((0,n.localize)(1,null));break}case c.Prompt:{const v=r;Array.isArray(v.buttons)&&v.buttons.length>0&&l.push(...v.buttons.map(y=>y.label)),v.cancelButton&&(v.cancelButton===!0?l.push((0,n.localize)(2,null)):typeof v.cancelButton=="string"?l.push(v.cancelButton):v.cancelButton.label?l.push(v.cancelButton.label):l.push((0,n.localize)(3,null))),l.length===0&&l.push((0,n.localize)(4,null));break}case c.Input:{const v=r;v.primaryButton?l.push(v.primaryButton):l.push((0,n.localize)(5,null)),v.cancelButton?l.push(v.cancelButton):l.push((0,n.localize)(6,null));break}}return l}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===L.default.Info?"info":r===L.default.Error?"error":r===L.default.Warning?"warning":"none"}async f(r,g,l){const v=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&v.push(r.cancelButton),{result:await v[g]?.run({checkboxChecked:l}),checkboxChecked:l}}}e.AbstractDialogHandler=p,e.IFileDialogService=(0,A.createDecorator)("fileDialogService");var m;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(m||(e.ConfirmResult=m={}));const b=10;function f(w){const r=[];return r.push(...w.slice(0,b).map(g=>typeof g=="string"?g:(0,E.basename)(g))),w.length>b&&(w.length-b===1?r.push((0,n.localize)(7,null)):r.push((0,n.localize)(8,null,w.length-b))),r.push(""),r.join(`
`)}e.getFileNamesMessage=f;function S(w,r){const g=(0,d.deepClone)(w);let l=(g.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),v=(w.buttons||[]).map((t,a)=>a),y=0,D=g.cancelId??l.length-1;if(l.length>1){const t=typeof D=="number"?l[D]:void 0;if(P.isLinux||P.isMacintosh){if(typeof t=="string"&&l.length>1&&D!==1){l.splice(D,1),l.splice(1,0,t);const a=v[D];v.splice(D,1),v.splice(1,0,a),D=1}P.isLinux&&l.length>1&&(l=l.reverse(),v=v.reverse(),y=l.length-1,typeof t=="string"&&(D=y-1))}else if(P.isWindows&&typeof t=="string"&&l.length>1&&D!==l.length-1){l.splice(D,1),l.push(t);const a=v[D];v.splice(D,1),v.push(a),D=l.length-1}}return g.buttons=l,g.defaultId=y,g.cancelId=D,g.noLink=!0,g.title=g.title||r.nameLong,{options:g,buttonIndeces:v}}e.massageMessageBoxOptions=S}),define(ee[108],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[109],te([0,1,165,6]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function n(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function R(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function P(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function d(l,v,y){return P(v,y)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===y?!0:c(y).includes(l)}e.isTargetPlatformCompatible=d;function c(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function p(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=p;var m;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var b;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var f;(function(l){l.Install="install",l.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var S;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var w;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var r;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class g extends Error{constructor(v,y){super(v),this.code=y,this.name=y}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(ee[204],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[205],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[110],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[206],te([0,1,50,15,9,4,71,24,86,169,110]),function(G,e,E,L,n,A,R,P,d,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=c.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends b{openTerminal(y,D){return this.spawnTerminal(E,y,d.getWindowsShell(),D)}spawnTerminal(y,D,t,a){const i=D.windowsExec||f.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=n.basename(i,".exe").toLowerCase();if(s==="cmder")return y.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),s==="wt"&&o.push("-d ."),new Promise((u,h)=>{const I=r(process),M=y.spawn(t,o,{cwd:a,env:I});M.on("error",h),M.on("exit",()=>u())})}runInTerminal(y,D,t,a,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,u)=>{const h=`"${D} - ${m}"`,I=`""${t.join('" "')}" & pause"`,M=Object.assign({},r(process),a);Object.keys(M).filter(V=>M[V]===null).forEach(V=>delete M[V]);const C={cwd:D,env:M,windowsVerbatimArguments:!0};let O,W;n.basename(s,".exe")==="wt"?(O=s,W=["-d",".",f.b,"/c",I]):(O=f.b,W=["/c","start",h,"/wait",s,"/c",I]),E.spawn(O,W,C).on("error",V=>{u(g(V))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class S extends b{openTerminal(y,D){return this.spawnTerminal(E,y,D)}runInTerminal(y,D,t,a,i){const s=i.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((o,u)=>{if(s===p.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const h=s===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`).fsPath,"-t",y||m,"-w",D];for(const W of t)M.push("-a"),M.push(W);if(a){const W=Object.assign({},r(process),a);for(const q in W){const V=W[q];V===null?(M.push("-u"),M.push(q)):(M.push("-e"),M.push(`${q}=${V}`))}}let C="";const O=E.spawn(S.b,M);O.on("error",W=>{u(g(W))}),O.stderr.on("data",W=>{C+=W.toString()}),O.on("exit",W=>{if(W===0)o(void 0);else if(C){const q=C.split(`
`,1);u(new Error(q[0]))}else u(new Error(c.localize(1,null,h,W)))})}else u(new Error(c.localize(2,null,s)))})}spawnTerminal(y,D,t){const a=D.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const o=["-a",a];t&&o.push(t);const u=r(process),h=y.spawn("/usr/bin/open",o,{cwd:t,env:u});h.on("error",s),h.on("exit",()=>i())})}}e.MacExternalTerminalService=S,S.b="/usr/bin/osascript";class w extends b{openTerminal(y,D){return this.spawnTerminal(E,y,D)}runInTerminal(y,D,t,a,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{const h=[];s.then(I=>{I.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const M=`${l(t)}; echo; read -p "${w.b}" -n1;`;h.push(`''${M}''`);const C=Object.assign({},r(process),a);Object.keys(C).filter(V=>C[V]===null).forEach(V=>delete C[V]);const O={cwd:D,env:C};let W="";const q=E.spawn(I,h,O);q.on("error",V=>{u(g(V))}),q.stderr.on("data",V=>{W+=V.toString()}),q.on("exit",V=>{if(V===0)o(void 0);else if(W){const _=W.split(`
`,1);u(new Error(_[0]))}else u(new Error(c.localize(4,null,I,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!A.isLinux)w.d=Promise.resolve("xterm");else{const y=await P.Promises.exists("/etc/debian_version");w.d=new Promise(D=>{y?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return w.d}spawnTerminal(y,D,t){const a=D.linuxExec?Promise.resolve(D.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{a.then(o=>{const u=r(process),h=y.spawn(o,[],{cwd:t,env:u});h.on("error",s),h.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.b=c.localize(3,null);function r(v){const y={...v.env};return(0,R.sanitizeProcessEnvironment)(y),y}function g(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(c.localize(5,null,v.path)):v}function l(v){let y="";for(const D of v)D.indexOf(" ")>=0?y+='"'+D+'"':y+=D,y+=" ";return y}}),define(ee[16],te([0,1,61,9,27,11,8,171,6,4,15]),function(G,e,E,L,n,A,R,P,d,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function m(H){return H.create===!0}e.isFileOpenForWriteOptions=m;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(H){H[H.Readonly=1]="Readonly"})(f||(e.FilePermission=f={}));var S;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function w(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=w;function r(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=r;function g(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=g;function l(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=v;function y(H){return w(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var D;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class t extends Error{static create(j,z){const X=new t(j.toString(),z);return s(X,z),X}constructor(j,z){super(j),this.code=z}}e.FileSystemProviderError=t;function a(H,j){return t.create(H,j)}e.createFileSystemProviderError=a;function i(H){return H||a((0,P.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function s(H,j){return H.name=j?`${j} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function o(H){if(!H)return D.Unknown;if(H instanceof t)return H.code;const j=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!j)return D.Unknown;switch(j[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=o;function u(H){if(H instanceof W)return H.fileOperationResult;switch(o(H)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 9;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=u;var h;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class I{constructor(j,z,X){this.resource=j,this.operation=z,this.target=X}isOperation(j){return this.operation===j}}e.FileOperationEvent=I;var M;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class C{constructor(j,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const X=new Map;for(const Z of j){const oe=X.get(Z.type);switch(oe?oe.push([Z.resource,Z]):X.set(Z.type,[[Z.resource,Z]]),Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}}for(const[Z,oe]of X)switch(Z){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(oe);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(oe);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(oe);break}}contains(j,...z){return this.d(j,{includeChildren:!1},...z)}affects(j,...z){return this.d(j,{includeChildren:!0},...z)}d(j,z,...X){if(!j)return!1;const Z=X.length>0;return!!((!Z||X.includes(1))&&(this.a?.get(j)||z.includeChildren&&this.a?.findSuperstr(j))||(!Z||X.includes(0))&&(this.b?.get(j)||z.includeChildren&&this.b?.findSuperstr(j))||(!Z||X.includes(2))&&(this.c?.findSubstr(j)||z.includeChildren&&this.c?.findSuperstr(j)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=C;function O(H,j,z){return!H||!j||H===j||j.length>H.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),z?(0,n.startsWithIgnoreCase)(H,j):H.indexOf(j)===0)}e.isParent=O;class W extends Error{constructor(j,z,X){super(j),this.fileOperationResult=z,this.options=X}}e.FileOperationError=W;class q extends W{constructor(j,z,X,Z){super(j,z,Z),this.fileOperationResult=z,this.size=X}}e.TooLargeFileOperationError=q;class V extends W{constructor(j,z,X){super(j,2,X),this.stat=z}}e.NotModifiedSinceFileOperationError=V;var _;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(_||(e.FileOperationResult=_={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ne;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.ETAG_DISABLED="";function re(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=re;async function ue(H,j){if(!j.hasProvider(R.URI.from({scheme:H.scheme})))return new Promise(z=>{const X=j.onDidChangeFileSystemProviderRegistrations(Z=>{Z.scheme===H.scheme&&Z.added&&(X.dispose(),z())})})}e.whenProviderRegistered=ue;class ce{static formatSize(j){return(0,A.isNumber)(j)||(j=0),j<ce.KB?(0,P.localize)(1,null,j.toFixed(0)):j<ce.MB?(0,P.localize)(2,null,(j/ce.KB).toFixed(2)):j<ce.GB?(0,P.localize)(3,null,(j/ce.MB).toFixed(2)):j<ce.TB?(0,P.localize)(4,null,(j/ce.GB).toFixed(2)):(0,P.localize)(5,null,(j/ce.TB).toFixed(2))}}e.ByteSize=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;function J(H){const j=typeof H=="string"||H?.scheme===p.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===p.Schemas.file?1024*ce.MB:j?10*ce.MB:c.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=J}),define(ee[207],te([0,1,17,49,13,3,2,60,8,31,16]),function(G,e,E,L,n,A,R,P,d,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class m extends R.Disposable{constructor(f,S){super(),this.a=f,this.b=S,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,c.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,S){const{buffer:w}=await this.a.call("readFile",[f,S]);return w}readFileStream(f,S,w){const r=(0,P.newWriteableStream)(l=>E.VSBuffer.concat(l.map(v=>E.VSBuffer.wrap(v))).buffer),g=this.a.listen("readFileStream",[f,S])(l=>{if(l instanceof E.VSBuffer)r.write(l.buffer);else{if(l==="end")r.end();else{let v;if(l instanceof Error)v=l;else{const y=l;v=(0,p.createFileSystemProviderError)(y.message??(0,L.toErrorMessage)(y),y.code??p.FileSystemProviderErrorCode.Unknown)}r.error(v),r.end()}g.dispose()}});return w.onCancellationRequested(()=>{r.error((0,n.canceled)()),r.end(),g.dispose()}),r}writeFile(f,S,w){return this.a.call("writeFile",[f,E.VSBuffer.wrap(S),w])}open(f,S){return this.a.call("open",[f,S])}close(f){return this.a.call("close",[f])}async read(f,S,w,r,g){const[l,v]=await this.a.call("read",[f,S,g]);return w.set(l.buffer.slice(0,v),r),v}write(f,S,w,r,g){return this.a.call("write",[f,S,E.VSBuffer.wrap(w),r,g])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,S){return this.a.call("delete",[f,S])}rename(f,S,w){return this.a.call("rename",[f,S,w])}copy(f,S,w){return this.a.call("copy",[f,S,w])}cloneFile(f,S){return this.a.call("cloneFile",[f,S])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const S=f;this.f.fire(S.map(w=>({resource:d.URI.revive(w.resource),type:w.type})))}else{const S=f;this.g.fire(S)}}))}watch(f,S){const w=(0,c.generateUuid)();return this.a.call("watch",[this.h,w,f,S]),(0,R.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=m}),define(ee[111],te([0,1,17,13,172,16]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(p,m,b,f,S,w){let r;try{await P(p,m,b,f,S,w)}catch(g){r=g}finally{r&&S.errorTransformer&&(r=S.errorTransformer(r)),typeof r<"u"&&b.error(r),b.end()}}e.readFileIntoStream=R;async function P(p,m,b,f,S,w){d(w);const r=await p.open(m,{create:!1});try{d(w);let g=0,l=0,v=S&&typeof S.length=="number"?S.length:void 0,y=E.VSBuffer.alloc(Math.min(S.bufferSize,typeof v=="number"?v:S.bufferSize)),D=S&&typeof S.position=="number"?S.position:0,t=0;do l=await p.read(r,D,y.buffer,t,y.byteLength-t),D+=l,t+=l,g+=l,typeof v=="number"&&(v-=l),t===y.byteLength&&(await b.write(f(y)),y=E.VSBuffer.alloc(Math.min(S.bufferSize,typeof v=="number"?v:S.bufferSize)),t=0);while(l>0&&(typeof v!="number"||v>0)&&d(w)&&c(g,S));if(t>0){let a=t;typeof v=="number"&&(a=Math.min(t,v)),b.write(f(y.slice(0,a)))}}catch(g){throw(0,A.ensureFileSystemProviderError)(g)}finally{await p.close(r)}}function d(p){if(p.isCancellationRequested)throw(0,L.canceled)();return!0}function c(p,m){if(typeof m?.limits?.size=="number"&&p>m.limits.size)throw(0,A.createFileSystemProviderError)((0,n.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ee[75],te([0,1,101,2,9,4,8,16]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function d(g){return g.recursive===!0}e.isRecursiveWatchRequest=d;class c extends L.Disposable{constructor(l,v,y,D){super(),this.h=l,this.i=v,this.j=y,this.k=D,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const l=new L.DisposableStore;this.c.value=l,this.b=this.l(l),this.b.setVerboseLogging(this.j),l.add(this.b.onDidChangeFile(v=>this.h(v))),l.add(this.b.onDidLogMessage(v=>this.i(v))),l.add(this.b.onDidError(v=>this.n(v)))}n(l){this.k.restartOnError?this.g<c.a&&this.f?(this.r(`restarting watcher after error: ${l}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${l}`):this.r(l)}p(l){this.g++,this.m(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.j=l,await this.b?.setVerboseLogging(l)}r(l){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${l}`})}s(l){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=c,c.a=5;class p extends c{constructor(l,v,y){super(l,v,y,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class m extends c{constructor(l,v,y){super(l,v,y,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function b(g){return g.map(l=>({type:l.type,resource:R.URI.file(l.path)}))}e.toFileChanges=b;function f(g){const l=new r;for(const v of g)l.processEvent(v);return l.coalesce()}e.coalesceEvents=f;function S(g,l){return typeof l=="string"&&!l.startsWith(E.GLOBSTAR)&&!(0,n.isAbsolute)(l)?{base:g,pattern:l}:l}e.normalizeWatcherPattern=S;function w(g,l){const v=[];for(const y of l)v.push((0,E.parse)(S(g,y)));return v}e.parseWatcherPatterns=w;class r{constructor(){this.a=new Set,this.b=new Map}c(l){return A.isLinux?l.path:l.path.toLowerCase()}processEvent(l){const v=this.b.get(this.c(l));let y=!1;if(v){const D=v.type,t=l.type;v.path!==l.path&&(l.type===2||l.type===1)?y=!0:D===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(v)):D===2&&t===1?v.type=0:D===1&&t===0||(v.type=t)}else y=!0;y&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],v=[];return Array.from(this.a).filter(y=>y.type!==2?(l.push(y),!1):!0).sort((y,D)=>y.path.length-D.path.length).filter(y=>v.some(D=>(0,P.isParent)(y.path,D,!A.isLinux))?!1:(v.push(y.path),!0)).concat(l)}}}),define(ee[208],te([0,1,41,7,22,32,2,82,9,4,102,24,75]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends R.Disposable{constructor(r,g,l,v){super(),this.j=r,this.k=g,this.l=l,this.m=v,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.k(y))),this.f=this.B(new L.RunOnceWorker(y=>this.u(y),f.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await m.Promises.stat(r);this.B(await this.s(r,g.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let g=r.path;try{g=await m.Promises.realpath(r.path),r.path===g&&(g=await(0,p.realcase)(r.path)??r.path),r.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${g})`)}catch{}return g}async s(r,g){if(c.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const l=new n.CancellationTokenSource(this.i.token),v=new R.DisposableStore;try{const y=(0,d.basename)(r),D=(0,E.watch)(r);v.add((0,R.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(g)try{for(const i of await m.Promises.readdir(r))t.add(i)}catch(i){this.w(i)}const a=new Map;v.add((0,R.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),D.on("error",(i,s)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),D.on("change",(i,s)=>{if(l.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),c.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){a.get(o)?.dispose();const u=setTimeout(async()=>{if(a.delete(o),o===y&&!await m.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.v((0,d.join)(r,o));if(l.token.isCancellationRequested)return;let I;h?t.has(o)?I=0:(I=1,t.add(o)):(t.delete(o),I=2),this.t({path:(0,d.join)(this.j.path,o),type:I})},f.a);a.set(o,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(o)?u=0:(u=1,t.add(o)),this.t({path:(0,d.join)(this.j.path,o),type:u})}else if(i==="rename"||o!==y){const u=setTimeout(async()=>{const h=await m.Promises.exists(r);l.token.isCancellationRequested||(h?(this.t({path:this.j.path,type:0},!0),v.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);v.clear(),v.add((0,R.toDisposable)(()=>clearTimeout(u)))}else this.t({path:this.j.path,type:0},!0)})}catch(y){await m.Promises.exists(r)&&!l.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${y.toString()})`)}return(0,R.toDisposable)(()=>{l.dispose(!0),v.dispose()})}t(r,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!g&&this.g.some(l=>l(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(l=>l(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const g=(0,b.coalesceEvents)(r);if(g.length>0){if(this.m)for(const v of g)this.z(`>> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(c.isLinux)return m.Promises.exists(r);try{const g=(0,d.basename)(r);return(await m.Promises.readdir((0,d.dirname)(r))).some(v=>v===g)}catch(g){return this.z(g),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=75;async function S(w,r,g,l,v=512){const y=await m.Promises.open(w,"r"),D=Buffer.allocUnsafe(v),t=new n.CancellationTokenSource(l);let a,i=!1;const s={path:w,excludes:[],recursive:!1},o=new f(s,u=>{(async()=>{for(const{type:h}of u)if(h===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(y,D,0,v,null);if(!I||t.token.isCancellationRequested)break;r(D.slice(0,I))}}catch(I){a=new Error(I),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,g(),new Promise((u,h)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await m.Promises.close(y)}catch(I){a=new Error(I)}a?h(a):u()})})}e.watchFileContents=S}),define(ee[209],te([0,1,3,101,2,4,208]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(c){const p=this.i(c),m=p.filter(f=>{const S=this.c.get(f.path);return S?!(0,L.patternsEquals)(S.request.excludes,f.excludes)||!(0,L.patternsEquals)(S.request.includes,f.includes):!0}),b=Array.from(this.c.values()).filter(({request:f})=>!p.find(S=>S.path===f.path&&(0,L.patternsEquals)(S.excludes,f.excludes)&&(0,L.patternsEquals)(S.includes,f.includes))).map(({request:f})=>f.path);m.length&&this.j(`Request to start watching: ${m.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const f of b)this.h(f);for(const f of m)this.g(f)}g(c){const p=new R.NodeJSFileWatcherLibrary(c,b=>this.a.fire(b),b=>this.b.fire(b),this.f),m={request:c,instance:p};this.c.set(c.path,m)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const p=this.c.get(c);p&&(this.c.delete(c),p.instance.dispose())}i(c){const p=new Map;for(const m of c){const b=A.isLinux?m.path:m.path.toLowerCase();p.set(b,m)}return Array.from(p.values())}async setVerboseLogging(c){this.f=c;for(const[,p]of this.c)p.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,p){return p?`[File Watcher (node.js)] ${c} (path: ${p.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=P}),define(ee[210],te([0,1,75,209]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends E.AbstractNonRecursiveWatcherClient{constructor(R,P,d){super(R,P,d),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ee[211],te([0,1,15,45,155,75]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends A.AbstractUniversalWatcherClient{constructor(d,c,p){super(d,c,p),this.m()}l(d){const c=d.add(new n.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:p,signal:m})=>this.n(`terminated by itself with code ${p}, signal: ${m}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ee[89],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...n){this.a=new Map;for(const[A,R]of n)this.set(A,R)}set(n,A){const R=this.a.get(n);return this.a.set(n,A),R}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=E}),define(ee[212],te([0,1,7,13,2,73,202,6,89,99]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class m extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class b{constructor(r=new d.ServiceCollection,g=!1,l,v=p){this.f=r,this.g=g,this.h=l,this.i=v,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=v?l?._globalGraph??new R.Graph(y=>y):void 0}createChild(r){return new b(r,this.g,this,this.i)}invokeFunction(r,...g){const l=S.traceInvocation(this.i,r);let v=!1;try{return r({get:D=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(D,l);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...g)}finally{v=!0,l.stop()}}createInstance(r,...g){let l,v;return r instanceof A.SyncDescriptor?(l=S.traceCreation(this.i,r.ctor),v=this.j(r.ctor,r.staticArguments.concat(g),l)):(l=S.traceCreation(this.i,r),v=this.j(r,g,l)),l.stop(),v}j(r,g=[],l){const v=P._util.getServiceDependencies(r).sort((t,a)=>t.index-a.index),y=[];for(const t of v){const a=this.m(t.id,l);a||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(a)}const D=v.length>0?v[0].index:g.length;if(g.length!==D){console.trace(`[createInstance] First service dependency of ${r.name} at position ${D+1} conflicts with ${g.length} static arguments`);const t=D-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,D)}return Reflect.construct(r,g.concat(y))}k(r,g){if(this.f.get(r)instanceof A.SyncDescriptor)this.f.set(r,g);else if(this.h)this.h.k(r,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const g=this.f.get(r);return!g&&this.h?this.h.l(r):g}m(r,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const l=this.l(r);return l instanceof A.SyncDescriptor?this.q(r,l,g.branch(r,!0)):(g.branch(r,!1),l)}q(r,g,l){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,g,l)}finally{this.o.delete(r)}}r(r,g,l){const v=new R.Graph(t=>t.id.toString());let y=0;const D=[{id:r,desc:g,_trace:l}];for(;D.length;){const t=D.pop();if(v.lookupOrInsertNode(t),y++>1e3)throw new m(v);for(const a of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${r} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.SyncDescriptor){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};v.insertEdge(t,s),D.push(s)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new m(v);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.SyncDescriptor){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}v.removeNode(a)}}return this.l(r)}s(r,g,l=[],v,y){if(this.f.get(r)instanceof A.SyncDescriptor)return this.t(r,g,l,v,y);if(this.h)return this.h.s(r,g,l,v,y);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(r,g,l=[],v,y){if(v){const D=new b(void 0,this.g,this,this.i);D.c=String(r);const t=new Map,a=new E.IdleValue(()=>{const i=D.j(g,l,y);for(const[s,o]of t){const u=i[s];if(typeof u=="function")for(const h of o)u.apply(i,h)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let h=t.get(s);return h||(h=new c.LinkedList,t.set(s,h)),(M,C,O)=>{const W=h.push([M,C,O]);return(0,n.toDisposable)(W)}}if(s in i)return i[s];const o=a.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),i[s]=u),u},set(i,s,o){return a.value[s]=o,!0},getPrototypeOf(i){return g.prototype}})}else return this.j(g,l,y)}u(r,g){if(g&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=b;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class S{static traceInvocation(r,g){return r?new S(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(r,g){return r?new S(1,g.name):S.c}constructor(r,g){this.type=r,this.name=g,this.g=Date.now(),this.h=[]}branch(r,g){const l=new S(3,r.toString());return this.h.push([r,g,l]),l}stop(){const r=Date.now()-this.g;S.f+=r;let g=!1;function l(y,D){const t=[],a=new Array(y+1).join("	");for(const[i,s,o]of D.h)if(s&&o){g=!0,t.push(`${a}CREATES -> ${i}`);const u=l(y+1,o);u&&t.push(u)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(r>2||g)&&S.all.add(v.join(`
`))}}e.Trace=S,S.all=new Set,S.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}},S.f=0}),define(ee[213],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(n){n[n.Bug=0]="Bug",n[n.PerformanceIssue=1]="PerformanceIssue",n[n.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,E.createDecorator)("issueService")}),define(ee[5],te([0,1,49,3,56,2,35,4,18,11,8,203,6]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function f(){return new Date().toISOString()}function S(M){return(0,c.isNumber)(M)}e.isLogLevel=S;var w;(function(M){M[M.Off=0]="Off",M[M.Trace=1]="Trace",M[M.Debug=2]="Debug",M[M.Info=3]="Info",M[M.Warning=4]="Warning",M[M.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function r(M,C,O){switch(C){case w.Trace:M.trace(O);break;case w.Debug:M.debug(O);break;case w.Info:M.info(O);break;case w.Warning:M.warn(O);break;case w.Error:M.error(O);break;case w.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=r;function g(M,C=!1){let O="";for(let W=0;W<M.length;W++){let q=M[W];if(q instanceof Error&&(q=(0,E.toErrorMessage)(q,C)),typeof q=="object")try{q=JSON.stringify(q)}catch{}O+=(W>0?" ":"")+q}return O}class l extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==w.Off&&this.b<=C}}e.AbstractLogger=l;class v extends l{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...O){this.f(w.Trace)&&this.g(w.Trace,g([C,...O],!0))}debug(C,...O){this.f(w.Debug)&&this.g(w.Debug,g([C,...O]))}info(C,...O){this.f(w.Info)&&this.g(w.Info,g([C,...O]))}warn(C,...O){this.f(w.Warning)&&this.g(w.Warning,g([C,...O]))}error(C,...O){if(this.f(w.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(w.Error,g(W))}else this.g(w.Error,g([C,...O]))}flush(){}}e.AbstractMessageLogger=v;class y extends l{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.g=!P.isWindows}trace(C,...O){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...O):console.log(`[main ${f()}]`,C,...O))}debug(C,...O){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...O):console.log(`[main ${f()}]`,C,...O))}info(C,...O){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...O):console.log(`[main ${f()}]`,C,...O))}warn(C,...O){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,C,...O):console.warn(`[main ${f()}]`,C,...O))}error(C,...O){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,C,...O):console.error(`[main ${f()}]`,C,...O))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class D extends l{constructor(C=e.DEFAULT_LOG_LEVEL,O=!0){super(),this.g=O,this.setLevel(C)}trace(C,...O){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...O):console.log(C,...O))}debug(C,...O){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...O):console.log(C,...O))}info(C,...O){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...O):console.log(C,...O))}warn(C,...O){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...O):console.log(C,...O))}error(C,...O){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...O):console.error(C,...O))}dispose(){}flush(){}}e.ConsoleLogger=D;class t extends l{constructor(C,O=e.DEFAULT_LOG_LEVEL){super(),this.g=C,this.setLevel(O)}trace(C,...O){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(C),...O])}debug(C,...O){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(C),...O])}info(C,...O){this.f(w.Info)&&this.g.log(w.Info,[this.h(C),...O])}warn(C,...O){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(C),...O])}error(C,...O){this.f(w.Error)&&this.g.log(w.Error,[this.h(C),...O])}h(C){return typeof C=="string"?C:(0,E.toErrorMessage)(C,this.f(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends l{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const O of this.g)O.setLevel(C);super.setLevel(C)}trace(C,...O){for(const W of this.g)W.trace(C,...O)}debug(C,...O){for(const W of this.g)W.debug(C,...O)}info(C,...O){for(const W of this.g)W.info(C,...O)}warn(C,...O){for(const W of this.g)W.warn(C,...O)}error(C,...O){for(const W of this.g)W.error(C,...O)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose()}}e.MultiplexLogger=a;class i extends A.Disposable{constructor(C,O,W){if(super(),this.h=C,this.j=O,this.b=new R.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,W)for(const q of W)this.b.set(q.resource,{logger:void 0,info:q})}k(C){return(0,c.isString)(C)?[...this.b.values()].find(O=>O.info.id===C):this.b.get(C)}getLogger(C){return this.k(C)?.logger}createLogger(C,O){const W=this.l(C),q=(0,c.isString)(C)?C:O?.id??(0,n.hash)(W.toString()).toString(16);let V=this.b.get(W)?.logger;const _=O?.logLevel==="always"?w.Trace:O?.logLevel;V||(V=this.m(W,_??this.getLogLevel(W)??this.h,{...O,id:q}));const ne={logger:V,info:{resource:W,id:q,logLevel:_,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(ne.info),this.b.set(W,ne),V}l(C){return(0,c.isString)(C)?(0,d.joinPath)(this.j,`${C}.log`):C}setLogLevel(C,O){if(p.URI.isUri(C)){const W=C,q=O,V=this.b.get(W);V&&q!==V.info.logLevel&&(V.info.logLevel=q===this.h?void 0:q,V.logger?.setLevel(q),this.b.set(V.info.resource,V),this.f.fire([W,q]))}else{this.h=C;for(const[W,q]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,O){const W=this.k(C);W&&O!==!W.info.hidden&&(W.info.hidden=!O,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,O]))}getLogLevel(C){let O;return C&&(O=this.b.get(C)?.info.logLevel),O??this.h}registerLogger(C){const O=this.b.get(C.resource);O?O.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const O=this.b.get(C);O&&(O.logger&&O.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=i;class s{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(C){}getLevel(){return w.Info}trace(C,...O){}debug(C,...O){}info(C,...O){}warn(C,...O){}error(C,...O){}critical(C,...O){}dispose(){}flush(){}}e.NullLogger=s;class o extends s{}e.NullLogService=o;function u(M){if(M.verbose)return w.Trace;if(typeof M.logLevel=="string"){const C=I(M.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function h(M){switch(M){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=h;function I(M){switch(M){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",h(w.Info))});var Q=this&&this.__param||function(G,e){return function(E,L){e(E,L,G)}};define(ee[214],te([0,1,74,3,2,5,4,7]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let d=e.BaseCredentialsMainService=class dt extends n.Disposable{constructor(p){super(),this.h=p,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new P.SequencerByKey}async getPassword(p,m){this.h.trace("Going to get password from keytar:",p,m);let b;try{b=await this.i()}catch{return null}return await this.g.queue(p+m,()=>this.k(b,p,m))}async k(p,m,b){this.h.trace("Doing get password from keytar:",m,b);const f=await(0,P.retry)(()=>p.getPassword(m,b),50,3);if(!f)return this.h.trace("Did not get a password from keytar for account:",b),f;let S,w;try{const r=JSON.parse(f);S=r.content,w=r.hasNextChunk}catch{}if(!S||!w)return this.h.trace("Got password from keytar for account:",b),f;try{let r=1;for(;w;){const g=await(0,P.retry)(()=>p.getPassword(m,`${b}-${r}`),50,3),l=JSON.parse(g);S+=l.content,w=l.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,b),S}catch(r){return this.h.error(r),f}}async setPassword(p,m,b){this.h.trace("Going to set password using keytar:",p,m);let f;try{f=await this.i()}catch(S){throw this.j?.(S),S}await this.g.queue(p+m,()=>this.l(f,p,m,b)),this.c.fire({service:p,account:m})}async l(p,m,b,f){if(this.h.trace("Doing set password from keytar:",m,b),!R.isWindows){await(0,P.retry)(()=>p.setPassword(m,b,f),50,3),this.h.trace("Set password from keytar for account:",b);return}if(await this.m(p,m,b),f.length<=dt.b){await(0,P.retry)(()=>p.setPassword(m,b,f),50,3),this.h.trace("Set password from keytar for account:",b);return}let S=0,w=0,r=!0;for(;r;){const g=f.substring(S,S+dt.b);S+=dt.b,r=f.length-S>0;const l={content:g,hasNextChunk:r};await(0,P.retry)(()=>p.setPassword(m,w?`${b}-${w}`:b,JSON.stringify(l)),50,3),w++}this.h.trace(`Set${w?` ${w}-chunked`:""} password from keytar for account:`,b)}async deletePassword(p,m){this.h.trace("Going to delete password using keytar:",p,m);let b;try{b=await this.i()}catch(S){throw this.j?.(S),S}const f=await this.g.queue(p+m,()=>this.m(b,p,m));return f&&this.c.fire({service:p,account:m}),f}async m(p,m,b){this.h.trace("Doing delete password from keytar:",m,b);const f=await p.getPassword(m,b);if(!f)return this.h.trace("Did not get a password to delete from keytar for account:",b),!1;let S,w;try{const g=JSON.parse(f);S=g.content,w=g.hasNextChunk}catch{}let r=0;if(S&&w)try{for(r++;w;){const g=`${b}-${r}`,l=await p.getPassword(m,g);await p.deletePassword(m,g),w=JSON.parse(l).hasNextChunk,r++}}catch(g){this.h.error(g)}return await p.deletePassword(m,b)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,b),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,b),!1)}async findPassword(p){let m;try{m=await this.i()}catch{return null}return await m.findPassword(p)}async findCredentials(p){let m;try{m=await this.i()}catch{return[]}return await m.findCredentials(p)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};d.a=2500,d.b=d.a-100,e.BaseCredentialsMainService=d=ye([Q(0,A.ILogService)],d)}),define(ee[215],te([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(A,R){this.a=A,this.b=R}c(){return new Promise((A,R)=>G(["vscode-encrypt"],A,R))}async encrypt(A){let R;try{R=await this.c()}catch{return A}try{return R.encrypt(this.a,A)}catch(P){return this.b.error(P),A}}async decrypt(A){let R;try{R=await this.c()}catch{return A}try{return R.decrypt(this.a,A)}catch(P){return this.b.error(P),A}}};e.EncryptionMainService=L=ye([Q(1,E.ILogService)],L)}),define(ee[216],te([0,1,23,7,13,3,2,9,75,5]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends R.Disposable{constructor(b,f){super(),this.a=b,this.b=f,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(b,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(b,f):this.u(b,f)}l(b,f){const S={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,E.insert)(this.j,S);return this.m(),(0,R.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,n.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,d.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const f of this.j)(0,d.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const f of this.j)(0,d.isRecursiveWatchRequest)(f)&&b.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,f){const S={path:this.C(b),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,E.insert)(this.s,S);return this.v(),(0,R.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,n.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,d.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,P.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(ee[217],te([0,1,23,7,17,22,3,56,68,2,61,15,64,18,60,170,16,111,5,13]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=e.FileService=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new R.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new R.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new R.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.R.fire(new r.FileChangesEvent(s,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await L.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return d.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,f.isAbsolutePath)(t))throw new r.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new v.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(a)||(0,r.hasReadWriteCapability)(a)||(0,r.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(a)||(0,r.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,r.toFileSystemProviderErrorCode)(i)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,r.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),s=this.O(i),o=a?.resolveTo,u=a?.resolveSingleChildDescendants,h=a?.resolveMetadata,I=await i.stat(t);let M;return this.p(i,t,I,void 0,!!h,(C,O)=>(M||(M=p.TernarySearchTree.forUris(()=>!s),M.set(t,!0),o&&M.fill(!0,o)),M.get(C.resource)||M.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&u?O===1:!1))}async p(t,a,i,s,o,u){const{providerExtUri:h}=this.N(t),I={resource:a,name:h.basename(a),isFile:(i.type&r.FileType.File)!==0,isDirectory:(i.type&r.FileType.Directory)!==0,isSymbolicLink:(i.type&r.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&r.FilePermission.Readonly)||!!(t.capabilities&2048),etag:(0,r.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&u(I,s)){try{const M=await t.readdir(a),C=await L.Promises.settled(M.map(async([O,W])=>{try{const q=h.joinPath(a,O),V=o?await t.stat(q):{type:W};return await this.p(t,q,V,M.length,o,u)}catch(q){return this.b.trace(q),null}}));I.children=(0,E.coalesce)(C)}catch(M){this.b.trace(M),I.children=[]}return I}return I}async resolveAll(t){return L.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=n.VSBuffer.fromString(""),i){await this.r(t,i);const s=await this.writeFile(t,a);return this.m.fire(new r.FileOperationEvent(t,0,s)),s}async writeFile(t,a,i){const s=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(s);try{await this.s(s,t,i)||await this.P(s,o.dirname(t));let h;if((0,r.hasReadWriteCapability)(s)&&!(a instanceof n.VSBuffer))if((0,S.isReadableStream)(a)){const I=await(0,S.peekStream)(a,3);I.ended?h=n.VSBuffer.concat(I.buffer):h=I}else h=(0,S.peekReadable)(a,I=>n.VSBuffer.concat(I),3);else h=a;!(0,r.hasOpenReadWriteCloseCapability)(s)||(0,r.hasReadWriteCapability)(s)&&h instanceof n.VSBuffer?await this.cb(s,t,i,h):await this.Y(s,t,i,h instanceof n.VSBuffer?(0,n.bufferToReadable)(h):h),this.m.fire(new r.FileOperationEvent(t,4))}catch(u){throw new r.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,r.ensureFileSystemProviderError)(u).toString()),(0,r.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(a)));let o;try{o=await t.stat(a)}catch{return}if(o.type&r.FileType.Directory)throw new r.FileOperationError((0,w.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==r.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,r.etag)({mtime:i.mtime,size:o.size}))throw new r.FileOperationError((0,w.localize)(7,null),3,i);return o}async readFile(t,a,i){const s=await this.k(t);return a?.atomic?this.t(s,t,a,i):this.u(s,t,a,i)}async t(t,a,i,s){return new Promise((o,u)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const h=await this.u(t,a,i,s);o(h)}catch(h){u(h)}})})}async u(t,a,i,s){const o=await this.v(t,a,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,n.streamToBuffer)(o.value)}}async readFileStream(t,a,i){const s=await this.k(t);return this.v(s,t,a,i)}async v(t,a,i,s){const o=new A.CancellationTokenSource(s),u=this.F(a,i).then(I=>I,I=>{throw o.cancel(),I});let h;try{return typeof i?.etag=="string"&&i.etag!==r.ETAG_DISABLED&&await u,i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&i?.preferUnbuffered?h=this.D(t,a,i):(0,r.hasFileReadStreamCapability)(t)?h=this.z(t,a,o.token,i):h=this.C(t,a,o.token,i),{...await u,value:h}}catch(I){throw h&&await(0,S.consumeStream)(h),this.w(I,a,i)}}w(t,a,i){const s=(0,w.localize)(8,null,this.nb(a),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(s,t.stat,i):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new r.FileOperationError(s,(0,r.toFileOperationResult)(t),i)}z(t,a,i,s=Object.create(null)){const o=t.readFileStream(a,s,i);return(0,S.transform)(o,{data:u=>u instanceof n.VSBuffer?u:n.VSBuffer.wrap(u),error:u=>this.w(u,a,s)},u=>n.VSBuffer.concat(u))}C(t,a,i,s=Object.create(null)){const o=(0,n.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,a,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.w(u,a,s)},i),o}D(t,a,i){const s=(0,S.newWriteableStream)(o=>n.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?o=await t.readFile(a,{atomic:!0}):o=await t.readFile(a),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(a,o.byteLength,i),s.end(n.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==r.ETAG_DISABLED&&a.etag===i.etag)throw new r.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new r.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),7,a,i)}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,s){if(t.toString()!==a.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),u=this.lb(await this.l(a),a);await this.M(o,t,u,a,i,s)}catch(o){return o}return!0}async move(t,a,i){const s=this.lb(await this.l(t),t),o=this.lb(await this.l(a),a),u=await this.I(s,t,o,a,"move",!!i),h=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,u==="move"?2:3,h)),h}async copy(t,a,i){const s=await this.k(t),o=this.lb(await this.l(a),a),u=await this.I(s,t,o,a,"copy",!!i),h=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,u==="copy"?3:2,h)),h}async I(t,a,i,s,o,u){if(a.toString()===s.toString())return o;const{exists:h,isSameResourceWithDifferentPathCase:I}=await this.M(t,a,i,s,o,u);if(h&&!I&&u&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),o==="copy"){if(t===i&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(a,s,{overwrite:u});else{const M=await this.resolve(a);M.isDirectory?await this.L(t,M,i,s):await this.J(t,a,i,s)}return o}else return t===i?(await t.rename(a,s,{overwrite:u}),o):(await this.I(t,a,i,s,"copy",u),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,s){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,s);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.kb(t,a,i,s);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,s);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.gb(t,a,i,s)}async L(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async o=>{const u=this.N(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,u):this.J(t,o.resource,i,u)}))}async M(t,a,i,s,o,u){let h=!1;if(t===i){const{providerExtUri:M,isPathCaseSensitive:C}=this.N(t);if(C||(h=M.isEqual(a,s)),h&&o==="copy")throw new Error((0,w.localize)(12,null,this.nb(a),this.nb(s)));if(!h&&M.isEqualOrParent(s,a))throw new Error((0,w.localize)(13,null,this.nb(a),this.nb(s)))}const I=await this.exists(s);if(I&&!h){if(!u)throw new r.FileOperationError((0,w.localize)(14,null,this.nb(a),this.nb(s)),4);if(t===i){const{providerExtUri:M}=this.N(t);if(M.isEqualOrParent(a,s))throw new Error((0,w.localize)(15,null,this.nb(a),this.nb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:h}}N(t){const a=this.O(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(a,s.dirname(a));)try{if(!((await t.stat(a)).type&r.FileType.Directory))throw new Error((0,w.localize)(16,null,this.nb(a)));break}catch(o){if((0,r.toFileSystemProviderErrorCode)(o)!==r.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(a)),a=s.dirname(a)}for(let o=i.length-1;o>=0;o--){a=s.joinPath(a,i[o]);try{await t.mkdir(a)}catch(u){if((0,r.toFileSystemProviderErrorCode)(u)!==r.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new r.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const h=await this.resolve(t);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),s=!!a?.useTrash,o=!!a?.recursive;await i.delete(t,{recursive:o,useTrash:s}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.lb(await this.l(a),a);if(i===s&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,r.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(s,this.N(s).providerExtUri.dirname(a));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,r.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,a,{overwrite:!0})):o.queue(()=>this.J(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let s=!1,o=()=>{s=!0};return i.add((0,c.toDisposable)(()=>o())),(async()=>{try{const u=await this.W(t,a);s?(0,c.dispose)(u):o=()=>(0,c.dispose)(u)}catch(u){this.b.error(u)}})(),i}async W(t,a){const i=await this.j(t),s=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let o=this.U.get(s);return o||(o={count:0,disposable:i.watch(t,a)},this.U.set(s,o)),o.count+=1,(0,c.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,c.dispose)(o.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.isReadableStream)(s)||(0,S.isReadableBufferedStream)(s)?await this.Z(t,o,s):await this.ab(t,o,s)}catch(u){throw(0,r.ensureFileSystemProviderError)(u)}finally{await t.close(o)}})}async Z(t,a,i){let s=0,o;if((0,S.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=n.VSBuffer.concat(i.buffer);await this.bb(t,a,u,u.byteLength,s,0),s+=u.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((u,h)=>{(0,S.listenStream)(o,{onData:async I=>{o.pause();try{await this.bb(t,a,I,I.byteLength,s,0)}catch(M){return h(M)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>h(I),onEnd:()=>u()})})}async ab(t,a,i){let s=0,o;for(;(o=i.read())!==null;)await this.bb(t,a,o,o.byteLength,s,0),s+=o.byteLength}async bb(t,a,i,s,o,u){let h=0;for(;h<s;){const I=await t.write(a,o+h,i.buffer,u+h,s-h);h+=I}}async cb(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,s))}async db(t,a,i,s){let o;s instanceof n.VSBuffer?o=s:(0,S.isReadableStream)(s)?o=await(0,n.streamToBuffer)(s):(0,S.isReadableBufferedStream)(s)?o=await(0,n.bufferedStreamToBuffer)(s):o=(0,n.readableToBuffer)(s),await t.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,s))}async fb(t,a,i,s){let o,u;try{o=await t.open(a,{create:!1}),u=await i.open(s,{create:!0,unlock:!1});const h=n.VSBuffer.alloc(this.a);let I=0,M=0,C=0;do C=await t.read(o,I,h.buffer,M,h.byteLength-M),await this.bb(i,u,h,C,I,M),I+=C,M+=C,M===h.byteLength&&(M=0);while(C>0)}catch(h){throw(0,r.ensureFileSystemProviderError)(h)}finally{await L.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async gb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const u=await t.readFile(a);await this.bb(i,o,n.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,r.ensureFileSystemProviderError)(u)}finally{await i.close(o)}}async kb(t,a,i,s){const o=await(0,n.streamToBuffer)(this.C(t,a,A.CancellationToken.None));await this.cb(i,s,void 0,o)}lb(t,a){if(t.capabilities&2048)throw new r.FileOperationError((0,w.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=y=ye([Q(0,l.ILogService)],y)}),define(ee[90],te([0,1,41,293,7,35,17,3,32,2,9,4,18,60,24,174,16,111,216,49,211,210]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(E)}catch(a){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(a)}`)}})();class t extends l.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s),this.onDidChangeCapabilities=P.Event.None,this.H=new A.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,m.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:o}=await S.SymlinkSupport.stat(this.C(i));return{type:this.G(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(i){try{const s=await S.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async u=>{try{let h;u.isSymbolicLink()?h=(await this.stat((0,b.joinPath)(i,u.name))).type:h=this.G(u),o.push([u.name,h])}catch(h){this.a.trace(h)}})),o}catch(s){throw this.Y(s)}}G(i,s){let o;return s?.dangling?o=r.FileType.Unknown:i.isFile()?o=r.FileType.File:i.isDirectory()?o=r.FileType.Directory:o=r.FileType.Unknown,s&&(o|=r.FileType.SymbolicLink),o}async I(i){const s=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const u=new n.Barrier;return this.H.set(i,u),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(i)===u&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),u.open()})}async readFile(i,s){let o;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const u=this.C(i);return await S.Promises.readFile(u)}catch(u){throw this.Y(u)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,s,o){const u=(0,f.newWriteableStream)(h=>R.VSBuffer.concat(h.map(I=>R.VSBuffer.wrap(I))).buffer);return(0,g.readFileIntoStream)(this,i,u,h=>h.buffer,{...s,bufferSize:256*1024},o),u}async writeFile(i,s,o){let u;try{const h=this.C(i);if(!o.create||!o.overwrite){if(await S.Promises.exists(h)){if(!o.overwrite)throw(0,r.createFileSystemProviderError)((0,w.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,r.createFileSystemProviderError)((0,w.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,s,0,s.byteLength)}catch(h){throw await this.Z(i,h)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.O=i}async open(i,s){const o=this.C(i);let u;(0,r.isFileOpenForWriteOptions)(s)&&(u=await this.I(i));let h;try{if((0,r.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:M}=await S.SymlinkSupport.stat(o);M.mode&128||await S.Promises.chmod(o,M.mode|128)}catch(M){this.a.trace(M)}let I;if((0,r.isFileOpenForWriteOptions)(s)){if(m.isWindows)try{await S.Promises.truncate(o,0),I="r+"}catch(M){M.code!=="ENOENT"&&this.a.trace(M)}I||(I="w")}else I="r";h=await S.Promises.open(o,I)}catch(I){throw u?.dispose(),(0,r.isFileOpenForWriteOptions)(s)?await this.Z(i,I):this.Y(I)}if(this.L.set(h,0),(0,r.isFileOpenForWriteOptions)(s)&&this.N.set(h,i),u){const I=this.M.get(h);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${o})`),this.M.set(h,u),I&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${o})`),I.dispose())}return h}async close(i){const s=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await S.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await S.Promises.close(i)}catch(o){throw this.Y(o)}finally{s&&(this.M.get(i)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,o,u,h){const I=this.P(i,s);let M=null;try{M=(await S.Promises.read(i,o,u,h,I)).bytesRead}catch(C){throw this.Y(C)}finally{this.Q(i,I,M)}return M}P(i,s){return s===this.L.get(i)?null:s}Q(i,s,o){const u=this.L.get(i);typeof u=="number"&&(typeof s=="number"||(typeof o=="number"?this.L.set(i,u+o):this.L.delete(i)))}async write(i,s,o,u,h){return(0,n.retry)(()=>this.R(i,s,o,u,h),100,3)}async R(i,s,o,u,h){const I=this.P(i,s);let M=null;try{M=(await S.Promises.write(i,o,u,h,I)).bytesWritten}catch(C){throw await this.Z(this.N.get(i),C)}finally{this.Q(i,I,M)}return M}async mkdir(i){try{await S.Promises.mkdir(this.C(i))}catch(s){throw this.Y(s)}}async delete(i,s){try{const o=this.C(i);s.recursive?await S.Promises.rm(o,S.RimRafMode.MOVE):await S.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,s,o){const u=this.C(i),h=this.C(s);if(u!==h)try{await this.S(i,s,"move",o.overwrite),await S.Promises.move(u,h)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,p.basename)(u),(0,p.basename)((0,p.dirname)(h)),I.toString()))),this.Y(I)}}async copy(i,s,o){const u=this.C(i),h=this.C(s);if(u!==h)try{await this.S(i,s,"copy",o.overwrite),await S.Promises.copy(u,h,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,p.basename)(u),(0,p.basename)((0,p.dirname)(h)),I.toString()))),this.Y(I)}}async S(i,s,o,u){const h=this.C(i),I=this.C(s);let M=!1;if(!!(this.capabilities&1024)||(M=(0,d.isEqual)(h,I,!0)),M&&o==="copy")throw(0,r.createFileSystemProviderError)((0,w.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(!M&&await S.Promises.exists(I)){if(!u)throw(0,r.createFileSystemProviderError)((0,w.localize)(5,null),r.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.U(i,s,!1)}async U(i,s,o){const u=this.C(i),h=this.C(s),I=!!(this.capabilities&1024);if((0,d.isEqual)(u,h,!I))return;const M=new c.DisposableStore;try{const[C,O]=await Promise.all([this.I(i),this.I(s)]);M.add(C),M.add(O),o&&await S.Promises.mkdir((0,p.dirname)(h),{recursive:!0}),await S.Promises.copyFile(u,h)}catch(C){if(C.code==="ENOENT"&&!o)return this.U(i,s,!0);throw this.Y(C)}finally{M.dispose()}}p(i,s,o){return new y.UniversalWatcherClient(u=>i(u),u=>s(u),o)}y(i,s,o){return new D.NodeJSWatcherClient(u=>i(u),u=>s(u),o)}Y(i){if(i instanceof r.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=r.FileSystemProviderErrorCode.NoPermissions;break;default:s=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(i,s)}async Z(i,s){let o=this.Y(s);if(i&&o.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await S.SymlinkSupport.stat(this.C(i));u.mode&128||(o=(0,r.createFileSystemProviderError)(s,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(ee[218],te([0,1,3,90,2,17,60,22]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends n.Disposable{constructor(m,b){super(),this.a=m,this.b=b,this.w=new Map,this.y=new Map}call(m,b,f){const S=this.c(m);switch(b){case"stat":return this.g(S,f[0]);case"readdir":return this.h(S,f[0]);case"open":return this.l(S,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(S,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(S,f[0],f[1],f[2]);case"rename":return this.t(S,f[0],f[1],f[2]);case"copy":return this.u(S,f[0],f[1],f[2]);case"cloneFile":return this.v(S,f[0],f[1]);case"mkdir":return this.r(S,f[0]);case"delete":return this.s(S,f[0],f[1]);case"watch":return this.C(S,f[0],f[1],f[2],f[3]);case"unwatch":return this.D(f[0],f[1])}throw new Error(`IPC Command ${b} not found`)}listen(m,b,f){const S=this.c(m);switch(b){case"fileChange":return this.z(S,f[0]);case"readFileStream":return this.j(S,f[0],f[1])}throw new Error(`Unknown event ${b}`)}g(m,b){const f=this.f(m,b,!0);return this.a.stat(f)}h(m,b){const f=this.f(m,b);return this.a.readdir(f)}async i(m,b,f){const S=this.f(m,b,!0),w=await this.a.readFile(S,f);return A.VSBuffer.wrap(w)}j(m,b,f){const S=this.f(m,b,!0),w=new P.CancellationTokenSource,r=new E.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),g=this.a.readFileStream(S,f,w.token);return(0,R.listenStream)(g,{onData:l=>r.fire(A.VSBuffer.wrap(l)),onError:l=>r.fire(l),onEnd:()=>{r.fire("end"),r.dispose(),w.dispose()}}),r.event}k(m,b,f,S){const w=this.f(m,b);return this.a.writeFile(w,f.buffer,S)}l(m,b,f){const S=this.f(m,b,!0);return this.a.open(S,f)}m(m){return this.a.close(m)}async n(m,b,f){const S=A.VSBuffer.alloc(f),w=0,r=await this.a.read(m,b,S.buffer,w,f);return[S,r]}p(m,b,f,S,w){return this.a.write(m,b,f.buffer,S,w)}r(m,b){const f=this.f(m,b);return this.a.mkdir(f)}s(m,b,f){const S=this.f(m,b);return this.a.delete(S,f)}t(m,b,f,S){const w=this.f(m,b),r=this.f(m,f);return this.a.rename(w,r,S)}u(m,b,f,S){const w=this.f(m,b),r=this.f(m,f);return this.a.copy(w,r,S)}v(m,b,f){const S=this.f(m,b),w=this.f(m,f);return this.a.cloneFile(S,w)}z(m,b){const f=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(m,f))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(b)),this.w.delete(b)}});return f.event}async C(m,b,f,S,w){const r=this.w.get(b);if(r){const g=this.f(m,S),l=r.watch(f,g,w);this.y.set(b+f,l)}}async D(m,b){const f=m+b,S=this.y.get(f);S&&((0,n.dispose)(S),this.y.delete(f))}dispose(){super.dispose();for(const[,m]of this.y)m.dispose();this.y.clear();for(const[,m]of this.w)m.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class c extends n.Disposable{constructor(m,b,f,S){super(),this.c=m,this.f=f,this.g=S,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(m){const b=this.B(new E.Emitter);this.B(b.event(f=>{m.fire(f.map(S=>({resource:this.c.transformOutgoingURI(S.resource),type:S.type})))})),this.B(this.b.onDidChangeFile(f=>b.fire(f))),this.B(this.b.onDidWatchError(f=>m.fire(f)))}i(m){}j(m){}watch(m,b,f){const S=this.j(this.g);return Array.isArray(S)&&(f.excludes=[...f.excludes,...S]),this.a.set(m,this.b.watch(b,f)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(m)),this.a.delete(m)})}dispose(){super.dispose();for(const[,m]of this.a)m.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=c}),define(ee[219],te([0,1,14,173,4,8,16,9,218,148]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends d.AbstractDiskFileSystemProviderChannel{constructor(f,S,w){super(f,S),this.G=w}c(f){return c.DefaultURITransformer}f(f,S){return A.URI.revive(S)}async s(f,S,w){if(!w.useTrash)return super.s(f,S,w);const r=this.f(f,S),g=(0,P.normalize)(r.fsPath);try{await E.shell.trashItem(g)}catch{throw(0,R.createFileSystemProviderError)(n.isWindows?(0,L.localize)(0,null,(0,P.basename)(g)):(0,L.localize)(1,null,(0,P.basename)(g)),R.FileSystemProviderErrorCode.Unknown)}}F(f,S){return new m(f,S,this.b,this.G)}}e.DiskFileSystemProviderChannel=p;class m extends d.AbstractSessionFileWatcher{watch(f,S,w){if(w.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(f,S,w)}}}),define(ee[220],te([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends E.AbstractMessageLogger{constructor(A=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(A),this.B(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(A){this.l=A;for(const{level:R,message:P}of this.k)(0,E.log)(A,R,P);this.k=[]}g(A,R){this.l?(0,E.log)(this.l,A,R):this.getLevel()<=A&&this.k.push({level:A,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=L}),define(ee[221],te([0,1,2,5]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends E.Disposable{constructor(R,P=[]){super(),this.a=new L.MultiplexLogger([R,...P]),this.B(R.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...P){this.a.trace(R,...P)}debug(R,...P){this.a.debug(R,...P)}info(R,...P){this.a.info(R,...P)}warn(R,...P){this.a.warn(R,...P)}error(R,...P){this.a.error(R,...P)}flush(){this.a.flush()}}e.LogService=n}),define(ee[222],te([0,1,35,8,5]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class A{constructor(P){this.b=P,this.a=new E.ResourceMap}listen(P,d,c){switch(d){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,c){switch(d){case"createLogger":this.c(L.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,n.isLogLevel)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(L.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(L.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:L.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(L.URI.revive(c[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,c){this.a.set(P,this.b.createLogger(P,d,c))}d(P,d){let c=console.log;switch(P){case n.LogLevel.Error:c=console.error;break;case n.LogLevel.Warning:c=console.warn;break;case n.LogLevel.Info:c=console.info;break}c.call(console,...d)}e(P,d){const c=this.a.get(P);if(!c)throw new Error("Create the logger before logging");for(const[p,m]of d)(0,n.log)(c,p,m)}}e.LoggerChannel=A}),define(ee[223],te([0,1,16,5]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(n||(n={}));async function A(c,p,m,b,f){try{const S=await new Promise((r,g)=>{G(["@vscode/spdlog"],r,g)});S.setFlushOn(n.Trace);const w=await S.createAsyncRotatingLogger(c,p,m,b);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function R(c,p,m){switch(p){case L.LogLevel.Trace:c.trace(m);break;case L.LogLevel.Debug:c.debug(m);break;case L.LogLevel.Info:c.info(m);break;case L.LogLevel.Warning:c.warn(m);break;case L.LogLevel.Error:c.error(m);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function P(c,p){switch(p){case L.LogLevel.Trace:c.setLevel(n.Trace);break;case L.LogLevel.Debug:c.setLevel(n.Debug);break;case L.LogLevel.Info:c.setLevel(n.Info);break;case L.LogLevel.Warning:c.setLevel(n.Warning);break;case L.LogLevel.Error:c.setLevel(n.Error);break;case L.LogLevel.Off:c.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class d extends L.AbstractMessageLogger{constructor(p,m,b,f,S){super(),this.k=[],this.setLevel(S),this.l=this.n(p,m,b,f),this.B(this.onDidChangeLogLevel(w=>{this.m&&P(this.m,w)}))}async n(p,m,b,f){const S=b?6:1,w=30/S*E.ByteSize.MB,r=await A(p,m,w,S,f);if(r){this.m=r,P(this.m,this.getLevel());for(const{level:g,message:l}of this.k)R(this.m,g,l);this.k=[]}}g(p,m){this.m?R(this.m,p,m):this.getLevel()<=p&&this.k.push({level:p,message:m})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(ee[224],te([0,1,31,5,223]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(P,d,c){return new n.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,d)}}e.LoggerService=A}),define(ee[65],te([0,1,35,3,6,5,224]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(A.ILoggerService);class P extends R.LoggerService{constructor(){super(...arguments),this.p=new E.ResourceMap}createLogger(c,p,m){m!==void 0&&this.p.set(this.l(c),m);try{return super.createLogger(c,p)}catch(b){throw this.p.delete(this.l(c)),b}}registerLogger(c,p){p!==void 0&&this.p.set(c.resource,p),super.registerLogger(c)}deregisterLogger(c){this.p.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const p=[];for(const m of super.getRegisteredLoggers())c===this.p.get(m.resource)&&p.push(m);return p}getOnDidChangeLogLevelEvent(c){return L.Event.filter(this.onDidChangeLogLevel,p=>(0,A.isLogLevel)(p)||this.s(p[0],c))}getOnDidChangeVisibilityEvent(c){return L.Event.filter(this.onDidChangeVisibility,([p])=>this.s(p,c))}getOnDidChangeLoggersEvent(c){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(b=>this.s(b.resource,c)),removed:[...p.removed].filter(b=>this.s(b.resource,c))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(c){for(const[p,m]of this.p)m===c&&this.deregisterLogger(p)}s(c,p){const m=this.p.get(c);return m===void 0||m===p}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=P}),define(ee[225],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function L(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function n(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function A(R){return!E(R)&&!L(R)&&!n(R)}e.isMenubarMenuItemAction=A}),define(ee[37],te([0,1,3,68,2,6]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class R extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const p=Object.keys(this.f).length;return this.f={...c,...this.f},p!==Object.keys(this.f).length&&await this.i(c),L.Iterable.reduce(this.g.entries(),(m,[b,f])=>({...m,[b]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(c,[p,m])=>({...c,[p]:{definition:m,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=R;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[226],te([0,1,7,3,68,11,16,5,37]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(m,b){const f=[];for(const S of new Set(n.Iterable.concat(m.keys(),b.keys())))m.get(S)!==b.get(S)&&f.push(S);return f}let p=e.FilePolicyService=class extends d.AbstractPolicyService{constructor(b,f,S){super(),this.j=b,this.k=f,this.l=S,this.c=this.B(new E.ThrottledDelayer(500));const w=L.Event.filter(f.onDidFilesChange,r=>r.affects(b));this.B(f.watch(b)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const f=await this.k.readFile(this.j),S=JSON.parse(f.value.toString());if(!(0,A.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(S))this.f[w]&&b.set(w,S[w])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return b}async p(){const b=await this.n(),f=c(this.g,b);this.g=b,f.length>0&&this.h.fire(f)}};e.FilePolicyService=p=ye([Q(1,R.IFileService),Q(2,P.ILogService)],p)}),define(ee[227],te([0,1,3,2,37]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(d){this.b=d,this.a=new L.DisposableStore}listen(d,c){switch(c){case"onDidChange":return E.Event.map(this.b.onDidChange,p=>p.reduce((m,b)=>({...m,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(d,c,p){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class R extends n.AbstractPolicyService{constructor(d,c){super(),this.a=c;for(const p in d){const{definition:m,value:b}=d[p];this.f[p]=m,b!==void 0&&this.g.set(p,b)}this.a.listen("onDidChange")(p=>{for(const m in p){const b=p[m];b===null?this.g.delete(m):this.g.set(m,b)}this.h.fire(Object.keys(p))})}async i(d){const c=await this.a.call("updatePolicyDefinitions",d);for(const p in c)this.g.set(p,c[p])}}e.PolicyChannelClient=R}),define(ee[228],te([0,1,37,7,294,2,5]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=e.NativePolicyService=class extends E.AbstractPolicyService{constructor(c,p){super(),this.j=c,this.k=p,this.a=new L.Throttler,this.b=this.B(new A.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((p,m)=>{try{this.b.value=(0,n.createWatcher)(this.k,c,b=>{this.m(b),p()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),m(b)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const p in c){const m=c[p];m===void 0?this.g.delete(p):this.g.set(p,m)}this.h.fire(Object.keys(c))}};e.NativePolicyService=P=ye([Q(0,R.ILogService)],P)}),define(ee[76],te([0,1,4,36]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const A=E.globals.vscode.context.configuration();if(A)n=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:A.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(ee[21],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[229],te([0,1,69,5,21]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let A=e.ExtensionUrlTrustService=class{constructor(P,d){this.b=P,this.c=d,this.a=new Map}async isExtensionUrlTrusted(P,d){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const c=/^(.*)#([^#]+)$/.exec(d);if(!c)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,p,m]=c;let b=this.a.get(P);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[P],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...b])}const f=Buffer.from(decodeURIComponent(m),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const S=f.slice(0,6),w=f.readUIntBE(0,6),r=Date.now()-w;if(r<0||r>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const g=f.slice(6),l=E.createVerify("SHA256");l.write(S),l.write(Buffer.from(p)),l.end();for(let v=0;v<b.length;v++){let y=b[v];if(y!==null){if(typeof y=="string")try{y=E.createPublicKey({key:Buffer.from(y,"base64"),format:"der",type:"spki"}),b[v]=y}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${v+1} for ${P}:`,D),b[v]=null;continue}if(l.verify(y,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};e.ExtensionUrlTrustService=A=ye([Q(0,n.IProductService),Q(1,L.ILogService)],A)}),define(ee[230],te([0,1,7,5]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=e.WindowProfiler=class{constructor(R,P,d){this.a=R,this.b=P,this.c=d}async inspect(R){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(R);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.WindowProfiler=n=ye([Q(2,L.ILogService)],n)}),define(ee[77],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[51],te([0,1,126,11]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(R,P){E.ok(L.isString(R)),E.ok(L.isObject(P)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,P)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new n}),define(ee[231],te([0,1,3,51]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[n(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;L.Registry.add(e.Extensions.JSONContribution,R)}),define(ee[66],te([0,1,23,3,11,158,19,231,51]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=d.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:o}of t)for(const u in s)if(a.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const h=this.a.get(u),I=h?.valuesSources??new Map;if(o)for(const W of Object.keys(s[u]))I.set(W,o);const M={...h?.value||{},...s[u]};this.a.set(u,{source:o,value:M,valuesSources:I});const C=(0,R.getLanguageTagSettingPlainKey)(u),O={type:"object",default:M,description:A.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:n.isString(o)?void 0:o,defaultValueSource:o};i.push(...w(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:s[u],source:o});const h=this.d[u];h&&(this.w(u,h),this.r(u,h))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const o in i){const u=this.a.get(o),h=n.isString(s)?s:s?.id,I=n.isString(u?.source)?u?.source:u?.source?.id;if(h===I)if(a.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const M=this.d[o];M&&(this.w(o,M),this.r(o,M))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const o in s.properties){a.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>i(o))};for(const s of t){i(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(t,a=!0,i,s,o=3,u){o=n.isUndefinedOrNull(t.scope)?o:t.scope;const h=t.properties;if(h)for(const M in h){const C=h[M];if(a&&v(M,C)){delete h[M];continue}if(C.source=i,C.defaultDefaultValue=h[M].default,this.w(M,C),e.OVERRIDE_PROPERTY_REGEX.test(M)?C.scope=void 0:(C.scope=n.isUndefinedOrNull(C.scope)?o:C.scope,C.restricted=n.isUndefinedOrNull(C.restricted)?!!s?.includes(M):C.restricted),h[M].hasOwnProperty("included")&&!h[M].included){this.f[M]=h[M],delete h[M];continue}else this.d[M]=h[M],h[M].policy?.name&&this.e.set(h[M].policy.name,M);!h[M].deprecationMessage&&h[M].markdownDeprecationMessage&&(h[M].deprecationMessage=h[M].markdownDeprecationMessage),u.add(M)}const I=t.allOf;if(I)for(const M of I)this.p(M,a,i,s,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const u in s)this.r(u,s[u]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,o=i?.source;n.isUndefined(s)&&(s=a.defaultDefaultValue,o=void 0),n.isUndefined(s)&&(s=g(a.type)),a.default=s,a.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let a=S.exec(D);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(D)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=w;function r(D){return D.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=r;function g(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const l=new b;d.Registry.add(e.Extensions.Configuration,l);function v(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?A.localize(7,null,D):l.getConfigurationProperties()[D]!==void 0?A.localize(8,null,D):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,D,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=v;function y(){const D=[],t=l.getConfigurationProperties();for(const a of Object.keys(t))D.push([a,t[a].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=y}),define(ee[112],te([0,1,23,3,43,2,35,40,11,8,19,66,51]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:P.deepFreeze(a)}class S{constructor(i={},s=[],o=[],u){this.b=i,this.c=s,this.d=o,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof S)return s;const o=new w("");return o.parseRaw(s),o.configurationModel});this.f=i.reduce((s,o)=>o===s?o:s.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,p.getConfigurationValue)(this.contents,i):this.contents}inspect(i,s){const o=this.rawConfiguration.getValue(i),u=s?this.rawConfiguration.getOverrideValue(i,s):void 0,h=s?this.rawConfiguration.override(s).getValue(i):o;return{value:o,override:u,merged:h}}getOverrideValue(i,s){const o=this.i(s);return o?i?(0,p.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const o of this.overrides)o.identifiers.includes(i)&&s.push(...o.keys);return E.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return E.distinct(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=P.deepClone(this.contents),o=P.deepClone(this.overrides),u=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const I of i)if(h.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(s,I.contents);for(const M of I.overrides){const[C]=o.filter(O=>E.equals(O.identifiers,M.identifiers));C?(this.h(C.contents,M.contents),C.keys.push(...M.keys),C.keys=E.distinct(C.keys)):o.push(P.deepClone(M))}for(const M of I.keys)u.indexOf(M)===-1&&u.push(M)}return new S(s,u,o,h.every(I=>I instanceof S)?void 0:h)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const u of E.distinct([...Object.keys(this.contents),...Object.keys(s)])){let h=this.contents[u];const I=s[u];I&&(typeof h=="object"&&typeof I=="object"?(h=P.deepClone(h),this.h(h,I)):h=I),o[u]=h}return new S(o,this.keys,this.overrides)}h(i,s){for(const o of Object.keys(s)){if(o in i&&d.isObject(i[o])&&d.isObject(s[o])){this.h(i[o],s[o]);continue}i[o]=P.deepClone(s[o])}}i(i){let s=null,o=null;const u=h=>{h&&(o?this.h(o,h):o=P.deepClone(h))};for(const h of this.overrides)E.equals(h.identifiers,[i])?s=h.contents:h.identifiers.includes(i)&&u(h.contents);return u(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,p.removeFromValueTree)(this.contents,i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,m.overrideIdentifiersFromKey)(i))),1))}j(i,s,o){(0,p.addToValueTree)(this.contents,i,s,u=>console.error(u)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,m.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,p.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=S;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!d.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:o,keys:u,overrides:h,restricted:I,hasExcludedProperties:M}=this.h(i,s);this.b=new S(o,u,h,M?[i]:void 0),this.c=I||[]}g(i){let s={},o=null,u=[];const h=[],I=[];function M(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const C={onObjectBegin:()=>{const O={};M(O),h.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{const O=[];M(O),h.push(u),u=O,o=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:M,onError:(O,W,q)=>{I.push({error:O,offset:W,length:q})}};if(i)try{n.visit(i,C),s=u[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return s}h(i,s){const o=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),u=this.i(i,o,!0,s);i=u.raw;const h=(0,p.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),I=Object.keys(i),M=this.j(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:h,keys:I,overrides:M,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(i,s,o,u){let h=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:h};const I={},M=[];for(const C in i)if(m.OVERRIDE_PROPERTY_REGEX.test(C)&&o){const O=this.i(i[C],s,!1,u);I[C]=O.raw,h=h||O.hasExcludedProperties,M.push(...O.restricted)}else{const O=s[C],W=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&M.push(C),(W===void 0||u.scopes===void 0||u.scopes.includes(W))&&!(u.skipRestricted&&O?.restricted)?I[C]=i[C]:h=!0}return{raw:I,restricted:M,hasExcludedProperties:h}}j(i,s){const o=[];for(const u of Object.keys(i))if(m.OVERRIDE_PROPERTY_REGEX.test(u)){const h={};for(const I in i[u])h[I]=i[u][I];o.push({identifiers:(0,m.overrideIdentifiersFromKey)(u),keys:Object.keys(h),contents:(0,p.toValuesTree)(h,s)})}return o}}e.ConfigurationModelParser=w;class r extends A.Disposable{constructor(i,s,o,u){super(),this.f=i,this.g=s,this.h=u,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,h=>h.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&o.isEqual(h.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new S}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class g{constructor(i,s,o,u,h,I,M,C,O,W,q,V,_){this.a=i,this.b=s,this.c=o,this.overrideIdentifiers=u,this.d=h,this.f=I,this.g=M,this.h=C,this.i=O,this.j=W,this.k=q,this.l=V,this.m=_}get value(){return f(this.c)}n(i,s,o){const u=i.inspect(s,o);return{get value(){return f(u.value)},get override(){return f(u.override)},get merged(){return f(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(i,s,o,u,h=new S,I=new S,M=new R.ResourceMap,C=new S,O=new R.ResourceMap){this.c=i,this.d=s,this.f=o,this.g=u,this.h=h,this.i=I,this.j=M,this.l=C,this.m=O,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(i,s,o){return this.q(i,s,o).getValue(i)}updateValue(i,s,o={}){let u;o.resource?(u=this.m.get(o.resource),u||(u=new S,this.m.set(o.resource,u))):u=this.l,s===void 0?u.removeValue(i):u.setValue(i,s),o.resource||(this.a=null)}inspect(i,s,o){const u=this.q(i,s,o),h=this.u(s.resource,o),I=s.resource?this.m.get(s.resource)||this.l:this.l,M=new Set;for(const C of u.overrides)for(const O of C.identifiers)u.getOverrideValue(i,O)!==void 0&&M.add(O);return new g(i,s,u.getValue(i),M.size?[...M]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,h||void 0,I)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const o=[];if(!s){const{added:u,updated:h,removed:I}=D(this.c,i);s=[...u,...h,...I]}for(const u of s)for(const h of(0,m.overrideIdentifiersFromKey)(u)){const I=this.c.getKeysForOverrideIdentifier(h),M=i.getKeysForOverrideIdentifier(h),C=[...M.filter(O=>I.indexOf(O)===-1),...I.filter(O=>M.indexOf(O)===-1),...I.filter(O=>!P.equals(this.c.override(h).getValue(O),i.override(h).getValue(O)))];o.push([h,C])}return this.updateDefaultConfiguration(i),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:o,removed:u}=D(this.d,i),h=[...s,...o,...u];return h.length&&this.updatePolicyConfiguration(i),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:o,removed:u,overrides:h}=D(this.applicationConfiguration,i),I=[...s,...o,...u];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:h}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:o,removed:u,overrides:h}=D(this.localUserConfiguration,i),I=[...s,...o,...u];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:h}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:o,removed:u,overrides:h}=D(this.remoteUserConfiguration,i),I=[...s,...o,...u];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:h}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:o,removed:u,overrides:h}=D(this.workspaceConfiguration,i),I=[...s,...o,...u];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:h}}compareAndUpdateFolderConfiguration(i,s){const o=this.p.get(i),{added:u,updated:h,removed:I,overrides:M}=D(o,s),C=[...u,...h,...I];return(C.length||!o)&&this.updateFolderConfiguration(i,s),{keys:C,overrides:M}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:u,removed:h,overrides:I}=D(s,void 0);return{keys:[...o,...u,...h],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,o){let u=this.r(s,o);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(u=u.merge(this.d)),u}r({resource:i},s){let o=this.s();if(s&&i){const u=s.getFolder(i);u&&(o=this.t(u.uri)||o);const h=this.m.get(i);h&&(o=o.merge(h))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const o=this.s(),u=this.j.get(i);u?(s=o.merge(u),this.b.set(i,s)):s=o}return s}u(i,s){if(s&&i){const o=s.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:o,overrides:u,keys:h}=this.j.get(s);return i.push([s,{contents:o,overrides:u,keys:h}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u))),[...s.values()]}static parse(i){const s=this.x(i.defaults),o=this.x(i.policy),u=this.x(i.application),h=this.x(i.user),I=this.x(i.workspace),M=i.folders.reduce((C,O)=>(C.set(c.URI.revive(O[0]),this.x(O[1])),C),new R.ResourceMap);return new l(s,o,u,h,new S,I,M,new S,new R.ResourceMap)}static x(i){return new S(i.contents,i.keys,i.overrides)}}e.Configuration=l;function v(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const u of a)u.keys.forEach(h=>i.add(h)),u.overrides.forEach(([h,I])=>{const M=(0,R.getOrSet)(s,h,new Set);I.forEach(C=>M.add(C))});const o=[];return s.forEach((u,h)=>o.push([h,[...u.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=v;class y{constructor(i,s,o,u){this.change=i,this.f=s,this.g=o,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const h of i.keys)this.affectedKeys.add(h);for(const[,h]of i.overrides)for(const I of h)this.affectedKeys.add(I);this.d=this.a;for(const h of this.affectedKeys)this.d+=h+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(i,s){const o=this.a+i,u=this.d.indexOf(o);if(u<0)return!1;const h=u+o.length;if(h>=this.d.length)return!1;const I=this.d.charCodeAt(h);if(I!==this.b&&I!==this.c)return!1;if(s){const M=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,C=this.g.getValue(i,s,this.h);return!P.equals(M,C)}return!0}}e.ConfigurationChangeEvent=y;function D(a,i){const{added:s,removed:o,updated:u}=t(i?.rawConfiguration,a?.rawConfiguration),h=[],I=a?.getAllOverrideIdentifiers()||[],M=i?.getAllOverrideIdentifiers()||[];if(i){const C=M.filter(O=>!I.includes(O));for(const O of C)h.push([O,i.getKeysForOverrideIdentifier(O)])}if(a){const C=I.filter(O=>!M.includes(O));for(const O of C)h.push([O,a.getKeysForOverrideIdentifier(O)])}if(i&&a){for(const C of I)if(M.includes(C)){const O=t({contents:a.getOverrideValue(void 0,C)||{},keys:a.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});h.push([C,[...O.added,...O.removed,...O.updated]])}}return{added:s,removed:o,updated:u,overrides:h}}function t(a,i){const s=a?i?a.keys.filter(h=>i.keys.indexOf(h)===-1):[...a.keys]:[],o=i?a?i.keys.filter(h=>a.keys.indexOf(h)===-1):[...i.keys]:[],u=[];if(a&&i){for(const h of i.keys)if(a.keys.indexOf(h)!==-1){const I=(0,p.getConfigurationValue)(i.contents,h),M=(0,p.getConfigurationValue)(a.contents,h);P.equals(I,M)||u.push(h)}}return{added:s,removed:o,updated:u}}}),define(ee[232],te([0,1,23,3,2,40,11,112,66,5,37,51]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(m.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:g})=>this.c(Array.from(r),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,g){this.h(r,m.Registry.as(d.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new P.ConfigurationModel;const r=m.Registry.as(d.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,g){const l=this.f();for(const v of r){const y=l[v],D=g[v];y!==void 0?this.b.addValue(v,y):D?this.b.addValue(v,D.default):this.b.removeValue(v)}}}e.DefaultConfiguration=b;class f{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let S=e.PolicyConfiguration=class extends n.Disposable{get configurationModel(){return this.b}constructor(r,g,l){super(),this.c=r,this.f=g,this.g=l,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(r=>this.i(r))),this.B(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const g={},l=[],v=m.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const y of r){const D=v[y];if(!D){l.push(y);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}l.push(y),g[D.policy.name]={type:D.type}}}return(0,R.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),l}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const g=m.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),l=(0,E.coalesce)(r.map(v=>g.get(v)));this.j(l,!0)}j(r,g){this.g.trace("PolicyConfiguration#update",r);const l=m.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),v=[],y=this.b.isEmpty();for(const D of r){const t=l[D]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(y?a!==void 0:!(0,A.equals)(this.b.getValue(D),a))&&v.push([D,a])}else this.b.getValue(D)!==void 0&&v.push([D,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const D=this.b;this.b=new P.ConfigurationModel;for(const t of D.keys)this.b.setValue(t,D.getValue(t));for(const[t,a]of v)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);g&&this.a.fire(this.b)}}};e.PolicyConfiguration=S=ye([Q(1,p.IPolicyService),Q(2,c.ILogService)],S)}),define(ee[233],te([0,1,7,3,2,18,19,112,232,37]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends n.Disposable{constructor(b,f,S,w){super(),this.i=b,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=S instanceof c.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,S,w)),this.f=this.B(new P.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,f)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:g})=>this.k(r,g))),this.B(this.c.onDidChangeConfiguration(r=>this.l(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,f,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(b,f,new P.ConfigurationModel,S)}getConfigurationData(){return this.a.toData()}getValue(b,f){const S=typeof b=="string"?b:void 0,w=(0,R.isConfigurationOverrides)(b)?b:(0,R.isConfigurationOverrides)(f)?f:{};return this.a.getValue(S,w,void 0)}updateValue(b,f,S,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const f=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(S,f,2)}k(b,f){const S=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(b,f);this.m(w,S,7)}l(b){const f=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(b);this.m(S,f,7)}m(b,f,S){const w=new P.ConfigurationChangeEvent(b,{data:f},this.a);w.source=S,w.sourceConfig=this.n(S),this.h.fire(w)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(ee[234],te([0,1,13,6]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var n;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(n||(e.RemoteAuthorityResolverErrorCode=n={}));class A extends E.ErrorNoTelemetry{static isNotAvailable(d){return d instanceof A&&d._code===n.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof A&&d._code===n.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof A&&d._code===n.NoResolverFound}static isHandled(d){return d instanceof A&&d.isHandled}constructor(d,c=n.Unknown,p){super(d),this._message=d,this._code=c,this._detail=p,this.isHandled=c===n.NotAvailable&&p===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function R(P){const d=P.indexOf("+");return d===-1?P:P.substring(0,d)}e.getRemoteAuthorityPrefix=R}),define(ee[57],te([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(c){return c.scheme===E.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=L;function n(c){if(!c)return;const p=c.indexOf("+");return p<0?c:c.substr(0,p)}e.getRemoteName=n;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=A;function R(c){const{host:p,port:m}=d(c);if(typeof m>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:m}}e.parseAuthorityWithPort=R;function P(c,p){let{host:m,port:b}=d(c);return typeof b>"u"&&(b=p),{host:m,port:b}}e.parseAuthorityWithOptionalPort=P;function d(c){const p=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const m=c.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const b=c.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:c,port:void 0}}}),define(ee[113],te([0,1,27,6,57]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(R||(e.ExtensionType=R={}));var P;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class d{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,g){if(typeof r>"u"||r===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof r=="string"||typeof g=="string"){const l=typeof r=="string"?r:r.value,v=typeof g=="string"?g:g.value;return E.equalsIgnoreCase(l,v)}return r.c===g.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=d;class c{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const g of r)this.add(g)}add(r){this.c.add(d.toKey(r))}delete(r){return this.c.delete(d.toKey(r))}has(r){return this.c.has(d.toKey(r))}}e.ExtensionIdentifierSet=c;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(d.toKey(r))}get(r){return this.c.get(d.toKey(r))}has(r){return this.c.has(d.toKey(r))}set(r,g){this.c.set(d.toKey(r),g)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=p;function m(w){return b(w)}e.isApplicationScopedExtension=m;function b(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function S(w,r){if(r){const g=`onResolveRemoteAuthority:${(0,n.getRemoteName)(r)}`;return!!w.activationEvents?.includes(g)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[235],te([0,1,7,17,22,13,3,2,64,83,31,104,234,57]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var w;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function r(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(k){const F=new n.CancellationTokenSource;return setTimeout(()=>F.cancel(),k),F.token}function l(k,F){if(k.isCancellationRequested||F.isCancellationRequested)return n.CancellationToken.Cancelled;const N=new n.CancellationTokenSource;return k.onCancellationRequested(()=>N.cancel()),F.onCancellationRequested(()=>N.cancel()),N.token}class v{get didTimeout(){return this.c==="timedout"}constructor(F){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((N,U)=>{this.f=N,this.g=U}),F.isCancellationRequested?this.h():this.d.add(F.onCancellationRequested(()=>this.h()))}registerDisposable(F){this.c==="pending"?this.d.add(F):F.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(F))}reject(F){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(F))}}function y(k,F){const N=new v(F);return N.registerDisposable(k.onControlMessage(U=>{const $=JSON.parse(U.toString()),x=X($);x?N.reject(x):N.resolve($)})),N.promise}function D(k,F,N,U,$,x,K,se,de){const Ee=new v(de),De=c.StopWatch.create(!1);return k.info(`Creating a socket (${se})...`),d.mark(`code/willCreateSocket/${K}`),F.connect(N,U,$,x,se,(Se,Ae)=>{Ee.didTimeout?(d.mark(`code/didCreateSocketError/${K}`),k.info(`Creating a socket (${se}) finished after ${De.elapsed()} ms, but this is too late and has timed out already.`),Se&&k.error(Se),Ae?.dispose()):Se||!Ae?(d.mark(`code/didCreateSocketError/${K}`),k.info(`Creating a socket (${se}) returned an error after ${De.elapsed()} ms.`),Ee.reject(Se)):(d.mark(`code/didCreateSocketOK/${K}`),k.info(`Creating a socket (${se}) was successful after ${De.elapsed()} ms.`),Ee.resolve(Ae))}),Ee.promise}function t(k,F){const N=new v(F);return k.then(U=>{N.didTimeout||N.resolve(U)},U=>{N.didTimeout||N.reject(U)}),N.promise}async function a(k,F,N,U){const $=B(k,F);k.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let x;try{x=await D(k.logService,k.socketFactory,k.host,k.port,(0,f.getRemoteServerRootPath)(k),`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,r(F),`renderer-${r(F)}-${k.reconnectionToken}`,U)}catch(De){throw k.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),k.logService.error(De),De}k.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let K,se;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(x,null),K=k.reconnectionProtocol,se=!1):(K=new m.PersistentProtocol({socket:x,measureRoundTripTime:!0}),se=!0),k.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const de=await t(k.signService.createNewMessage((0,p.generateUuid)()),U),Ee={type:"auth",auth:k.connectionToken||"00000000000000000000",data:de.data};K.sendControl(L.VSBuffer.fromString(JSON.stringify(Ee)));try{const De=await y(K,l(U,g(1e4)));if(De.type!=="sign"||typeof De.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(k.logService.trace(`${$} 4/6. received SignRequest control message.`),!await t(k.signService.validate(de,De.signedData),U)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const Ae=await t(k.signService.sign(De.data),U),ze={type:"connectionType",commit:k.commit,signedData:Ae,desiredConnectionType:F};return N&&(ze.args=N),k.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(L.VSBuffer.fromString(JSON.stringify(ze))),{protocol:K,ownsProtocol:se}}catch(De){throw De&&De.code==="ETIMEDOUT"&&(k.logService.error(`${$} the handshake timed out. Error:`),k.logService.error(De)),De&&De.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${$} received error control message when negotiating connection. Error:`),k.logService.error(De)),se&&z(K),De}}async function i(k,F,N,U){const $=Date.now(),x=B(k,F),{protocol:K,ownsProtocol:se}=await a(k,F,N,U),de=new v(U);return de.registerDisposable(K.onControlMessage(Ee=>{const De=JSON.parse(Ee.toString()),Se=X(De);Se?(k.logService.error(`${x} received error control message when negotiating connection. Error:`),k.logService.error(Se),se&&z(K),de.reject(Se)):(k.reconnectionProtocol?.endAcceptReconnection(),k.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${T($)}!`),de.resolve({protocol:K,firstMessage:De}))})),de.promise}async function s(k,F){const{protocol:N}=await i(k,1,void 0,F);return{protocol:N}}async function o(k,F,N){const{protocol:U,firstMessage:$}=await i(k,2,F,N),x=$&&$.debugPort;return{protocol:U,debugPort:x}}async function u(k,F,N){const U=Date.now(),$=B(k,3),{protocol:x}=await a(k,3,F,N);return k.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${T(U)}!`),x}async function h(k,F,N){const{host:U,port:$,connectionToken:x}=await k.addressProvider.getAddress();return{commit:k.commit,quality:k.quality,host:U,port:$,connectionToken:x,reconnectionToken:F,reconnectionProtocol:N,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function I(k,F,N){return C(k,async U=>{const{protocol:$}=await s(U,n.CancellationToken.None);return new H(k,F,N,U.reconnectionToken,$)})}e.connectRemoteAgentManagement=I;async function M(k,F){return C(k,async N=>{const{protocol:U,debugPort:$}=await o(N,F,n.CancellationToken.None);return new j(k,F,N.reconnectionToken,U,$)})}e.connectRemoteAgentExtensionHost=M;async function C(k,F){for(let U=1;;U++)try{const $=(0,p.generateUuid)(),x=await h(k,$,null);return await F(x)}catch($){if(U<5)k.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),k.logService.error($);else throw k.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),k.logService.error($),J.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled($)),$}}async function O(k,F,N){const U=await h(k,(0,p.generateUuid)(),null);return await u(U,{host:F,port:N},n.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function W(k){return(0,E.createCancelablePromise)(F=>new Promise((N,U)=>{const $=setTimeout(N,k*1e3);F.onCancellationRequested(()=>{clearTimeout($),N()})}))}var q;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain",k[k.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(q||(e.PersistentConnectionEventType=q={}));class V{constructor(F,N){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=V;class _{constructor(F,N,U,$){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.durationSeconds=U,this.c=$,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=_;class ne{constructor(F,N,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=U,this.type=2}}e.ReconnectionRunningEvent=ne;class re{constructor(F,N,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=U,this.type=4}}e.ConnectionGainEvent=re;class ue{constructor(F,N){this.reconnectionToken=F,this.connectionHealth=N,this.type=5}}e.ConnectionHealthChangedEvent=ue;class ce{constructor(F,N,U,$){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=U,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class J extends P.Disposable{static triggerPermanentFailure(F,N,U){this._permanentFailure=!0,this.f=F,this.g=N,this.h=U,this.i.forEach($=>$.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(F=>F.s())}static debugPauseSocketWriting(){this.i.forEach(F=>F.w())}get k(){return this.c||J._permanentFailure}constructor(F,N,U,$,x){super(),this.n=F,this.p=N,this.reconnectionToken=U,this.protocol=$,this.r=x,this.j=this.B(new R.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new re(this.reconnectionToken,0,0)),this.B($.onSocketClose(K=>{const se=ae(this.n,this.reconnectionToken,!0);K?K.type===0?(this.p.logService.info(`${se} received socket close event (hadError: ${K.hadError}).`),K.error&&this.p.logService.error(K.error)):(this.p.logService.info(`${se} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this.p.logService.error(K.event)):this.p.logService.info(`${se} received socket close event.`),this.s()})),this.B($.onSocketTimeout(K=>{const se=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${K.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${K.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${K.timeSinceLastReceivedSomeData}).`),this.s()})),this.B($.onHighRoundTripTime(K=>{const se=oe(this.n,this.reconnectionToken);this.p.logService.info(`${se} high roundtrip time: ${K.roundTripTime}ms (${K.recentHighRoundTripCount} of 5 recent samples)`)})),this.B($.onDidChangeConnectionHealth(K=>{this.j.fire(new ue(this.reconnectionToken,K))})),J.i.push(this),this.B((0,P.toDisposable)(()=>{const K=J.i.indexOf(this);K>=0&&J.i.splice(K,1)})),this.k&&this.v(J.f,J.g,J.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const F=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const $=U<N.length?N[U]:N[N.length-1];try{if($>0){const K=W($);this.j.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,K)),this.p.logService.info(`${F} waiting for ${$} seconds before reconnecting...`);try{await K}catch{}}if(this.k){this.p.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.p.logService.info(`${F} resolving connection...`);const x=await h(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${F} connecting to ${x.host}:${x.port}...`),await this.y(x,g(S)),this.p.logService.info(`${F} reconnected!`),this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(x),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.p.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(x),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this.p.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this.p.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(x);continue}if((0,A.isCancellationError)(x)){this.p.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(x);continue}if(x instanceof b.RemoteAuthorityResolverError){this.p.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(x),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,b.RemoteAuthorityResolverError.isHandled(x));break}this.p.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(x),this.u(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.k&&!this.m)}u(F,N,U){this.r?J.triggerPermanentFailure(F,N,U):this.v(F,N,U)}v(F,N,U){this.j.fire(new ce(this.reconnectionToken,F,N,U)),z(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=J,J._permanentFailure=!1,J.f=0,J.g=0,J.h=!1,J.i=[];class H extends J{constructor(F,N,U,$,x){super(1,F,$,x,!0),this.client=this.B(new m.Client(x,{remoteAuthority:N,clientId:U},F.ipcLogger))}async y(F,N){await s(F,N)}}e.ManagementPersistentConnection=H;class j extends J{constructor(F,N,U,$,x){super(2,F,U,$,!1),this.z=N,this.debugPort=x}async y(F,N){await o(F,this.z,N)}}e.ExtensionHostPersistentConnection=j;function z(k){try{k.acceptDisconnect();const F=k.getSocket();k.dispose(),F.dispose()}catch(F){(0,A.onUnexpectedError)(F)}}function X(k){if(k&&k.type==="error"){const F=new Error(`Connection error: ${k.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function Z(k,F){for(;k.length<F;)k+=" ";return k}function oe(k,F){return`[remote-connection][${Z(r(k),13)}][${F.substr(0,5)}\u2026]`}function ae(k,F,N){return`${oe(k,F)}[${N?"reconnect":"initial"}]`}function B(k,F){return`${ae(F,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function T(k){return`${Date.now()-k} ms`}}),define(ee[236],te([0,1,26,50,41,195]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function P(f=!1){return(R===void 0||f)&&(R=d()),R}e.hasWSLFeatureInstalled=P;async function d(){const f=c();if(f===void 0)return!1;if(f>=22e3){const S=m();if(S)return new Promise(w=>{L.execFile(S,["--status"],r=>w(!r))})}else{const S=b();if(S)try{if((await n.promises.stat(S)).isFile())return!0}catch{}}return!1}function c(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(f)return parseInt(f[3])}function p(f){const S=process.env.SystemRoot;if(S){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return A.join(S,w?"Sysnative":"System32",f)}}function m(){return p("wsl.exe")}function b(){return p("lxss\\LxssManager.dll")}}),define(ee[52],te([0,1,17,13,2,178,66,6,5,51]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");class p{constructor(D){this.b=D}toJSON(){if(!this.a){const D=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?D[t]="*****":D[t]=this.b[t];this.a=D}return this.a}}class m extends n.Disposable{constructor(D,t){super(),this.b=0,this.a=t.createLogger(D?"remotenetwork":"network",{name:D?(0,A.localize)(0,null):(0,A.localize)(1,null),when:d.CONTEXT_LOG_LEVEL.isEqualTo((0,d.LogLevelToString)(d.LogLevel.Trace)).serialize()})}async c(D,t,a){const i=`${D} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new p(t.headers??{}));try{const s=await a();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,L.getErrorMessage)(s)),s}}}e.AbstractRequestService=m;function b(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=b;function f(y){return y.res.statusCode===204}async function S(y){return f(y)?null:(await(0,E.streamToBuffer)(y.stream)).toString()}e.asText=S;async function w(y){if(!b(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=w;async function r(y){if(!b(y))throw new Error("Server returned "+y.res.statusCode);if(f(y))return null;const t=(await(0,E.streamToBuffer)(y.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=r;function g(y){v(y)}e.updateProxyConfigurationsScope=g;let l;function v(y){const D=c.Registry.as(R.Extensions.Configuration),t=l;l={id:"http",order:15,title:(0,A.localize)(2,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},D.updateConfigurations({add:[l],remove:t?[t]:[]})}v(1)}),define(ee[237],te([0,1,17,22]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,c,p=L.CancellationToken.None){switch(d){case"request":return this.a.request(c[0],p).then(async({res:m,stream:b})=>{const f=await(0,E.streamToBuffer)(b);return[{statusCode:m.statusCode,headers:m.headers},f]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class A{constructor(P){this.a=P}async request(P,d){const[c,p]=await this.a.call("request",[P],d);return{res:c,stream:(0,E.bufferToStream)(p)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=A}),define(ee[238],te([0,1,239,11]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(R,P){return R.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:R.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function A(R,P,d={}){const c=(0,E.parse)(R),p=d.proxyUrl||n(c,P);if(!p)return null;const m=(0,E.parse)(p);if(!/^https?:$/.test(m.protocol||""))return null;const b={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,L.isBoolean)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,S)=>{G(["http-proxy-agent"],f,S)}))(b):new(await new Promise((f,S)=>{G(["https-proxy-agent"],f,S)}))(b)}e.getProxyAgent=A}),define(ee[114],te([0,1,50,9,179,22,49,13,4,31,151,62,7,130]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let S;async function w(g,l,v,y){return v["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(y)&&!v["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(y)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=b.Promises.withAsyncBody(async(D,t)=>{const a=new A.CancellationTokenSource;let i=1e4;const s=g.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,f.clamp)(s,1,120)*1e3);const o=setTimeout(()=>{a.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{D(await r(l,a.token))}catch(u){!(0,P.isCancellationError)(u)&&!a.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,R.toErrorMessage)(u)))):D({})}finally{clearTimeout(o),a.dispose()}})),S)}e.getResolvedShellEnv=w;async function r(g,l){const v=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",v);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",y);const D=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",a);const i=await(0,p.getSystemShell)(d.OS,a);return g.trace("getUnixShellEnvironment#shell",i),new Promise((s,o)=>{if(l.isCancellationRequested)return o(new P.CancellationError);const u=(0,L.basename)(i);let h,I;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(h=`& '${process.execPath}' ${M} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,I=["-Login","-Command"]):(h=`'${process.execPath}' ${M} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,u==="tcsh"||u==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),h);const C=(0,E.spawn)(i,[...I,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});l.onCancellationRequested(()=>(C.kill(),o(new P.CancellationError))),C.on("error",q=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(q)),o(q)});const O=[];C.stdout.on("data",q=>O.push(q));const W=[];C.stderr.on("data",q=>W.push(q)),C.on("close",(q,V)=>{const _=Buffer.concat(O).toString("utf8");g.trace("getUnixShellEnvironment#raw",_);const ne=Buffer.concat(W).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),q||V)return o(new Error((0,n.localize)(2,null,q,V)));const re=t.exec(_),ue=re?re[1]:"{}";try{const ce=JSON.parse(ue);v?ce.ELECTRON_RUN_AS_NODE=v:delete ce.ELECTRON_RUN_AS_NODE,y?ce.ELECTRON_NO_ATTACH_CONSOLE=y:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),s(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ce)),o(ce)}})})}}),define(ee[91],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[240],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((n,A)=>G(["vsda"],n,A))}async createNewMessage(n){try{const A=await this.c(),R=new A.validator;if(R){const P=String(E.a++);return this.b.set(P,R),{id:P,data:R.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,A){if(!n.id)return!0;const R=this.b.get(n.id);if(!R)return!1;this.b.delete(n.id);try{return R.validate(A)==="ok"}catch{return!1}}async sign(n){try{const A=await this.c(),R=new A.signer;if(R)return R.sign(n)}catch{}return n}}e.SignService=E,E.a=1}),define(ee[33],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[115],te([0,1,7,17,11,34,16,5]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var d;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(d||(e.SaveStrategy=d={}));class c{constructor(f,S,w,r){this.f=f,this.g=w,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=S===0?void 0:new E.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==1&&this.g.error(f)}}getItem(f,S){const w=this.a[f];return(0,n.isUndefinedOrNull)(w)?S:w}setItem(f,S){this.setItems([{key:f,data:S}])}setItems(f){let S=!1;for(const{key:w,data:r}of f)this.a[w]!==r&&((0,n.isUndefinedOrNull)(r)?(0,n.isUndefined)(this.a[w])||(this.a[w]=void 0,S=!0):(this.a[w]=r,S=!0));S&&this.j()}removeItem(f){(0,n.isUndefined)(this.a[f])||(this.a[f]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(f)),this.b=f}catch(S){this.g.error(S)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let p=e.StateReadonlyService=class{constructor(f,S,w,r){this.a=new c(S.stateResource,f,w,r)}async init(){await this.a.init()}getItem(f,S){return this.a.getItem(f,S)}};e.StateReadonlyService=p=ye([Q(1,A.IEnvironmentService),Q(2,P.ILogService),Q(3,R.IFileService)],p);class m extends p{setItem(f,S){this.a.setItem(f,S)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.StateService=m}),define(ee[92],te([0,1,4,36,31]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(d){if(E.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function R(d,c,p,m,b,f,S,w){const r=Object.create(null);r["common.machineId"]=f,r.sessionID=(0,n.generateUuid)()+Date.now(),r.commitHash=m,r.version=b,r["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,E.PlatformToString)(E.platform),r["common.nodePlatform"]=L.platform,r["common.nodeArch"]=p,r["common.product"]=w||"desktop",S&&(r["common.msftInternal"]=S);let g=0;const l=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),E.isLinuxSnap&&(r["common.snap"]="true");const v=A(c);return v&&(r["common.platformDetail"]=v),r}e.resolveCommonProperties=R;function P(d){const c=L.env.USERDNSDOMAIN;if(!c)return!1;const p=c.toLowerCase();return d.some(m=>p===m)}e.verifyMicrosoftInternalDomain=P}),define(ee[25],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var n;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(n||(e.TelemetryConfiguration=n={}))}),define(ee[241],te([0,1,26,7,43,15,9,4,8,85,24,103,87,16,21,25]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function g(t,a){const i=`${t}::${a.join(":")}`,s=r.get(i);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,h=new Map,I=2e4;function M(O,W,q,V){const _=W.substring(O.length+1);return L.Promises.withAsyncBody(async ne=>{let re;try{re=await p.Promises.readdir(W,{withFileTypes:!0})}catch{ne();return}if(V.count>=I){V.count+=re.length,V.maxReached=!0,ne();return}let ue=re.length;if(ue===0){ne();return}let ce=re;V.count+re.length>I&&(V.maxReached=!0,ue=I-V.count,ce=re.slice(0,ue)),V.count+=re.length;for(const J of ce)if(J.isDirectory()){if(q.includes(J.name)||await M(O,(0,R.join)(W,J.name),q,V),--ue===0){ne();return}}else{const H=J.name.lastIndexOf(".");if(H>=0){const j=J.name.substring(H+1);j&&u.set(j,(u.get(j)??0)+1)}for(const j of o)j.relativePathPattern?.test(_)!==!1&&j.filePattern.test(J.name)&&h.set(j.tag,(h.get(j.tag)??0)+1);if(--ue===0){ne();return}}})}const C=L.Promises.withAsyncBody(async O=>{const W={count:0,maxReached:!1};await M(t,t,a,W);const q=await y(t);O({configFiles:l(h),fileTypes:l(u),fileCount:W.count,maxFilesReached:W.maxReached,launchConfigFiles:q})});return r.set(i,C),C}e.collectWorkspaceStats=g;function l(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function v(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.virtualMachineHint.value()*100)}%`},a=E.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=v;async function y(t){try{const a=new Map,i=(0,R.join)(t,".vscode","launch.json"),s=await p.Promises.readFile(i),o=[],u=(0,n.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(u)==="object"&&u.configurations)for(const h of u.configurations){const I=h.type;I&&(a.has(I)?a.set(I,a.get(I)+1):a.set(I,1))}return l(a)}catch{return[]}}e.collectLaunchConfigs=y;let D=e.DiagnosticsService=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const s=E.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(c.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,m.listProcesses)(a.mainPID),this.k(a)]).then(async s=>{let[o,u]=s,h=this.m(a,o);return i.forEach(I=>{if((0,b.isRemoteDiagnosticError)(I))h+=`
${I.errorMessage}`,u+=`
${I.errorMessage}`;else if(h+=`

Remote: ${I.hostName}`,I.processes&&(h+=`
${this.m(a,I.processes)}`),I.workspaceMetadata){u+=`
|  Remote: ${I.hostName}`;for(const M of Object.keys(I.workspaceMetadata)){const C=I.workspaceMetadata[M];let O=`${C.fileCount} files`;C.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${M}): ${O}`,u+=this.h(C)}}}),{processInfo:h,workspaceInfo:u}})}async getSystemInfo(a,i){const{memory:s,vmHint:o,os:u,cpus:h}=v(),I={os:u,memory:s,cpus:h,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(I.load=`${E.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(a,i){const s=[];return(0,m.listProcesses)(a.mainPID).then(async o=>(s.push(""),s.push(this.g(a)),s.push(""),s.push(this.m(a,o)),a.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(a))),i.forEach(u=>{if((0,b.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.f(u.machineInfo)),u.processes&&s.push(this.m(a,u.processes)),u.workspaceMetadata)for(const h of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[h];let M=`${I.fileCount} files`;I.maxFilesReached&&(M=`more than ${M}`),s.push(`Folder (${h}): ${M}`),s.push(this.h(I))}}),s.push(""),s.push(""),s.join(`
`)))}h(a){const i=[];let o=0;const u=(C,O)=>{const W=` ${C}(${O})`;o+W.length>60?(i.push(h),h="|                 ",o=h.length):o+=W.length,h+=W};let h="|      File types:";const I=10,M=a.fileTypes.length>I?I:a.fileTypes.length;for(let C=0;C<M;C++){const O=a.fileTypes[C];u(O.name,O.count)}if(i.push(h),a.configFiles.length>=0&&(h="|      Conf files:",o=0,a.configFiles.forEach(C=>{u(C.name,C.count)}),i.push(h)),a.launchConfigFiles.length>0){let C="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{const W=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;C+=W}),i.push(C)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(s=>s.length));return Object.keys(a).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${a[s]}`).join(`
                  `)}k(a){const i=[],s=[];return a.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const h=d.URI.revive(u);if(h.scheme===A.Schemas.file){const I=h.fsPath;s.push(g(I,["node_modules",".git"]).then(M=>{let C=`${M.fileCount} files`;M.maxFilesReached&&(C=`more than ${C}`),i.push(`|    Folder (${(0,R.basename)(I)}): ${C}`),i.push(this.h(M))}).catch(M=>{i.push(`|      Error: Unable to collect workspace stats for folder ${I} (${M.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(a,i){const s=new Map;a.windows.forEach(u=>s.set(u.pid,`window [${u.id}] (${u.title})`)),a.pidToNames.forEach(({pid:u,name:h})=>s.set(u,h));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,s,o,i,0),o.join(`
`)}n(a,i,s,o,u){const h=u===0;let I;h?I=o.pid===a?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?I=i.get(o.pid):I=`${"  ".repeat(u)} ${o.name}`;const M=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(M/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(o.children)&&o.children.forEach(C=>this.n(a,i,s,C,u+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:s}of a.folders){const o=d.URI.revive(s);if(o.scheme!==A.Schemas.file)continue;const u=o.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(I=>i.add(I.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const s=d.URI.revive(i);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{const u=await g(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),u.fileTypes.forEach(h=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})}),u.launchConfigFiles.forEach(h=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})}),u.configFiles.forEach(h=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};e.DiagnosticsService=D=ye([Q(0,w.ITelemetryService),Q(1,S.IProductService)],D)}),define(ee[242],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(A){this.b=A}listen(A,R){throw new Error(`Event not found: ${R}`)}call(A,R,{eventName:P,data:d}){return this.b.forEach(c=>c.log(P,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class L{constructor(A){this.b=A}log(A,R){return this.b.call("log",{eventName:A,data:R}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[46],te([0,1,40,11,3,19,57,92,25]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=c;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class m{async publicLog(o,u,h){}async publicLogError(o,u,h){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(s,o){return n.Event.debounce(o.onDidChangeConfiguration,(h,I)=>{const M=h?new Set([...h.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:M}},1e3,!0)(h=>{h.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(h.source),configurationKeys:Array.from(h.affectedKeys)})})}e.configurationTelemetry=b;function f(s,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!s.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=f;function S(s,o){return!(o.isBuilt||o.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=S;function w(s){const o=s.getValue(d.TELEMETRY_SETTING_ID),u=s.getValue(d.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(d.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function r(s){const o={},u={},h={};v(s,h);for(let I in h){I=I.length>150?I.substr(I.length-149):I;const M=h[I];typeof M=="number"?u[I]=M:typeof M=="boolean"?u[I]=M?1:0:typeof M=="string"?(M.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${M.length}`),o[I]=M.substring(0,8191)):typeof M<"u"&&M!==null&&(o[I]=M)}return{properties:o,measurements:u}}e.validateTelemetryData=r;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(s){if(!s)return"none";const o=(0,R.getRemoteName)(s);return g.has(o)?o:"other"}e.cleanRemoteAuthority=l;function v(s,o,u=0,h){if(s)for(const I of Object.getOwnPropertyNames(s)){const M=s[I],C=h?h+I:I;Array.isArray(M)?o[C]=(0,E.safeStringify)(M):M instanceof Date?o[C]=M.toISOString():(0,L.isObject)(M)?u<2?v(M,o,u+1,C+"."):o[C]=(0,E.safeStringify)(M):o[C]=M}}function y(s,o){const u=s.msftInternalDomains||[],h=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(u)||h}e.isInternalTelemetry=y;function D(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=D;function t(s,o){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let u=s;const h=[];for(const O of o)for(;;){const W=O.exec(s);if(!W)break;h.push([W.index,O.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,M=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(u="";;){const O=M.exec(s);if(!O)break;const W=h.some(([q,V])=>O.index<V&&q<M.lastIndex);!I.test(O[0])&&!W&&(u+=s.substring(C,O.index)+"<REDACTED: user-file-path>",C=M.lastIndex)}return C<s.length&&(u+=s.substr(C)),u}function a(s){if(!s)return s;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of o)if(u.regex.test(s))return`<REDACTED: ${u.label}>`;return s}function i(s,o){return(0,E.cloneAndChange)(s,u=>{if(u instanceof c||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let h=u.replaceAll("%20"," ");h=t(h,o);for(const I of o)h=h.replace(I,"");return h=a(h),h}})}e.cleanData=i}),define(ee[116],te([0,1,27,109,113,4,8,13,36,46]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,E.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=p;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(s){const o=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new b(s.identifier,o,u)}static parse(s){const o=m.exec(s);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof b?p(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=b;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const s=f.exec(i);return s&&s[1]?[r(s[1]),s[2]]:[r(i),void 0]}e.getIdAndVersion=S;function w(i,s){return`${i}.${s}`}e.getExtensionId=w;function r(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=r;function g(i,s){return r(w(i??n.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=g;function l(i,s){const o=[],u=h=>{for(const I of o)if(I.some(M=>p(s(M),s(h))))return I;return null};for(const h of i){const I=u(h);I?I.push(h):o.push([h])}return o}e.groupByExtension=l;function v(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function y(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function D(i,s){const o=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const h=u.shift();if(h&&o.every(I=>!p(I.identifier,{id:h}))){const I=i.filter(M=>p(M.identifier,{id:h}));I.length===1&&(o.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=D;async function t(i,s){if(!A.isLinux)return!1;let o;try{o=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){s.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(h))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,s){const o=await t(i,s),u=(0,L.getTargetPlatform)(o?"alpine":A.platform,d.arch);return s.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=a}),define(ee[243],te([0,1,200,46]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(A,R,P,d,c,p,m){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,L.supportsTelemetry)(R,P)&&(0,L.getTelemetryLevel)(d)===3){const f=await(0,E.getServiceMachineId)(P,c,p);b["X-Market-User-Id"]=f,b["VSCode-SessionId"]=m.machineId||f}return b}e.resolveMarketplaceHeaders=n}),define(ee[244],te([0,1,13,40,46]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function P(c,p,m){const b=await new Promise((g,l)=>{G(["@microsoft/1ds-core-js"],g,l)}),f=await new Promise((g,l)=>{G(["@microsoft/1ds-post-js"],g,l)}),S=new b.AppInsightsCore,w=new f.PostChannel,r={instrumentationKey:c,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(m){r.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:m};r.extensionConfig[w.identifier]=g}return S.initialize(r,[]),S.addTelemetryInitializer(g=>{p&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),S}class d{constructor(p,m,b,f,S){this.e=p,this.f=m,this.g=b,this.h=S,this.c=A,this.d=R,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(p){if(this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(m=>{p(m)},m=>{(0,E.onUnexpectedError)(m),console.error(m)})}}log(p,m){if(!this.a)return;m=(0,L.mixin)(m,this.g),m=(0,n.validateTelemetryData)(m);const b=this.f+"/"+p;try{this.i(f=>{f.pluginVersionString=m?.properties.version??"Unknown",f.track({name:b,baseData:{name:b,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(ee[117],te([0,1,2,40,4,27,180,19,66,76,21,51,25,46]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=e.TelemetryService=class{constructor(g,l,v){this.k=l,this.l=v,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(b.TELEMETRY_SETTING_ID)||y.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(g,l){this.d[g]=l}m(){let g=(0,f.getTelemetryLevel)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const v=l.usage?3:l.error?2:0;g=Math.min(g,v)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,l,v){this.g<l||(v=(0,L.mixin)(v,this.d),v=(0,f.cleanData)(v,this.j),v=(0,L.mixin)(v,this.c),this.b.forEach(y=>y.log(g,v)))}publicLog(g,l){this.n(g,3,l)}publicLog2(g,l){this.publicLog(g,l)}publicLogError(g,l){this.h&&this.n(g,2,l)}publicLogError2(g,l){this.publicLogError(g,l)}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=S=ye([Q(1,P.IConfigurationService),Q(2,p.IProductService)],S);function w(){const r=(0,R.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=n.isWeb?"":(0,R.localize)(3,null),v=(0,R.localize)(4,null),y=(0,R.localize)(5,null),D=(0,R.localize)(6,null),t=(0,R.localize)(7,null),a=`
|       | ${v} | ${y} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${r} ${g} ${l}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}m.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,R.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,R.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[245],te([0,1,295,244]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends L.AbstractOneDataSystemAppender{constructor(R,P,d,c){const p={sendPOST:(m,b)=>{const f={method:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data)}};try{const S=E.request(m.urlString,f,w=>{w.on("data",function(r){b(w.statusCode??200,w.headers,r.toString())}),w.on("error",function(r){b(0,{})})});S.write(m.data),S.end()}catch{b(0,{})}}};super(R,P,d,c,p)}}e.OneDataSystemAppender=n}),define(ee[246],te([0,1,4,85,25]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function A(R,P){let d=R.getItem(n.machineIdKey);return(typeof d!="string"||E.isMacintosh&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,L.getMachineId)(P.error.bind(P))),d}e.resolveMachineId=A}),define(ee[118],te([0,1,25,246]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(A,R){const P=await(0,L.resolveMachineId)(A,R);return A.setItem(E.machineIdKey,P),P}e.resolveMachineId=n}),define(ee[78],te([0,1,14,3,2,4,19,6,33]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const c="#FFFFFF",p="#1E1E1E",m="#000000",b="#FFFFFF",f="theme",S="themeBackground",w="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let r=e.ThemeMainService=class extends n.Disposable{constructor(l,v){super(),this.b=l,this.c=v,this.a=this.B(new L.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(A.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(A.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(A.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const l=this.getColorScheme();if(l.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return l.dark?m:b;let v=this.b.getItem(S,null);if(!v)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":v=c;break;case"hc-black":v=m;break;case"hc-light":v=b;break;default:v=p}return A.isMacintosh&&v.toUpperCase()===p&&(v="#171717"),v}saveWindowSplash(l,v){this.b.setItems([{key:f,data:v.baseTheme},{key:S,data:v.colorInfo.background},{key:w,data:v}]),typeof l=="number"&&this.f(l,v)}f(l,v){for(const y of E.BrowserWindow.getAllWindows())if(y.id===l){y.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.ThemeMainService=r=ye([Q(0,d.IStateService),Q(1,R.IConfigurationService)],r)}),define(ee[119],te([0,1,3,19,6,5]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var R;(function(w){w.Http="http",w.Https="https"})(R||(e.TunnelProtocol=R={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P||(e.TunnelPrivacyId=P={}));var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function c(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=c,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=m;function b(w,r,g,l){if(g===1)return!1;if(g===2&&m(r)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(v?.length===4&&parseInt(v[1])>=18)return!1}return w<1024}e.isPortPrivileged=b;class f{constructor(r,g,l){this.remoteAddress=r,this.localAddress=g,this.b=l,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let S=e.AbstractTunnelService=class{constructor(r,g){this.i=r,this.j=g,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],g=Array.from(this.d.values());for(const l of g){const v=Array.from(l.values());for(const y of v){const D=await y.value;D&&r.push(D)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:g}of r.values())await g.then(l=>l?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,g,l,v,y){this.o(r,g,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:g,localAddress:l,privacy:v,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,g){(m(r)||p(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const l=this.q(r,g);if(l)return++l.refcount,l.value}openTunnel(r,g,l,v,y,D=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${l} on local port ${y}.`),!r)return;if(g||(g="localhost"),v||(v=this.k),this.e&&this.h.has(l)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(r,g,l,v,y,D,t,a);return i?i.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(g,l);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(s);return(s.tunnelRemoteHost!==g||s.tunnelRemotePort!==l)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const g=this.d.get(r.tunnelRemoteHost);if(g){const l=g.get(r.tunnelRemotePort);l&&(l.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,l))}}}}async n(r,g,l){if(l.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${g}.`);const v=l.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(g),v}}async closeTunnel(r,g){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${g} `);const l=this.d.get(r);if(l&&l.has(g)){const v=l.get(g);v.refcount=0,await this.n(r,g,v)}}o(r,g,l){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(g,{refcount:1,value:l})}async p(r,g){const l=this.d.get(r);l&&(await l.get(g)||l.delete(g),l.size===0&&this.d.delete(r))}q(r,g){const l=[r];p(r)?(l.push(...e.LOCALHOST_ADDRESSES),l.push(...e.ALL_INTERFACES_ADDRESSES)):m(r)&&l.push(...e.ALL_INTERFACES_ADDRESSES);const v=l.map(y=>this.d.get(y));for(const y of v){const D=y?.get(g);if(D)return D}}canTunnel(r){return!!c(r)}s(r,g,l,v,y,D,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${l} on local port ${v}.`);const a=l;this.h.add(a);const i=v===void 0?l:v,s={elevationRequired:y?this.isPortPrivileged(i):!1},o={remoteAddress:{host:g,port:l},localAddressPort:v,privacy:D,public:D?D!==P.Private:void 0,protocol:t},u=r.forwardPort(o,s);return u?(this.o(g,l,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),u}};e.AbstractTunnelService=S=ye([Q(0,A.ILogService),Q(1,L.IConfigurationService)],S)}),define(ee[47],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(L||(e.StateType=L={}));var n;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(n||(e.UpdateType=n={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(A,R)=>({type:"idle",updateType:A,error:R}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[247],te([0,1,4,181,66,51]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),A.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[248],te([0,1,3,47]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,c){switch(d){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=n;class A{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=L.State.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=A}),define(ee[38],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[249],te([0,1,38,201,16,18,131,3,2]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(b){this.uri=b,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let p=e.UriIdentityService=class{constructor(b){this.g=b,this.c=new d.DisposableStore,this.f=2**16;const f=new Map,S=w=>{let r=f.get(w.scheme);return r===void 0&&(r=b.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,r)),r};this.c.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new A.ExtUri(S),this.d=new R.SkipList((w,r)=>this.extUri.compare(w,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.normalizePath)(b));const f=this.d.get(b);return f?f.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new c(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((S,w)=>S[1].time<w[1].time?1:S[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let S=0;S<f;S++)this.d.set(b[S][0],b[S][1].touch())}};e.UriIdentityService=p=ye([Q(0,n.IFileService)],p),(0,L.registerSingleton)(E.IUriIdentityService,p,1)}),define(ee[120],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[250],te([0,1,8]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,c){switch(d){case"handleURL":return this.a.handleURL(E.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=L;class n{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.URLHandlerChannelClient=n;class A{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,c,p){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(c)&&c.length>0){const m=E.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",m.toString(!0)),m.query){const b=/\bwindowId=(\d+)/.exec(m.query);if(b){const f=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,m.toString(!0));const S=new RegExp(`window:${f}`),w=P.connections.find(r=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",r.ctx),S.test(r.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",m.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",m.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",m.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,c,p)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=A}),define(ee[251],te([0,1,7,2,8,21]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends L.Disposable{constructor(){super(...arguments),this.a=new Set}open(c,p){const m=[...this.a.values()];return(0,E.first)(m.map(b=>()=>b.handleURL(c,p)),void 0,!1).then(b=>b||!1)}registerHandler(c){return this.a.add(c),(0,L.toDisposable)(()=>this.a.delete(c))}}e.AbstractURLService=R;let P=e.NativeURLService=class extends R{constructor(c){super(),this.b=c}create(c){let{authority:p,path:m,query:b,fragment:f}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&m&&m.indexOf("/")!==0&&(m=`/${m}`),n.URI.from({scheme:this.b.urlProtocol,authority:p,path:m,query:b,fragment:f})}};e.NativeURLService=P=ye([Q(0,A.IProductService)],P)}),define(ee[252],te([0,1,14,7,3,2,4,8]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class d{constructor(p,m,b,f,S,w){if(this.f=m,this.g=w,this.a=[],this.b=0,this.c=A.Disposable.None,this.d=new A.DisposableStore,p&&(w.trace("ElectronURLListener initialUrisToHandle:",p.map(l=>l.originalUrl)),this.a=p),R.isWindows){const l=f.isBuilt?[]:[`"${f.appRoot}"`];l.push("--open-url","--"),E.app.setAsDefaultProtocolClient(S.urlProtocol,process.execPath,l)}const r=n.Event.map(n.Event.fromNodeEventEmitter(E.app,"open-url",(l,v)=>({event:l,url:v})),({event:l,url:v})=>(l.preventDefault(),v));this.d.add(r(l=>{const v=this.h(l);v&&this.f.open(v,{originalUrl:l})})),b.getWindows().filter(l=>l.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(p){try{return P.URI.parse(p)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const m of this.a)await this.f.open(m.uri,{originalUrl:m.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",m.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",m.originalUrl),p.push(m));p.length!==0&&(this.a=p,this.c=(0,L.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=d}),define(ee[253],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ee[254],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[255],te([0,1,14,2,15,8]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends L.Disposable{constructor(){super();const d=this.b.bind(this);E.protocol.registerFileProtocol(n.Schemas.vscodeWebview,d)}b(d,c){try{const p=A.URI.parse(d.url),m=R.a.get(p.path);if(typeof m=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${m}`,f=n.FileAccess.asFileUri(b);return c({path:f.fsPath,headers:{...n.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.WebviewProtocolProvider=R,R.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[79],te([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(p){return!!p.workspaceUri}e.isWorkspaceToOpen=L;function n(p){return!!p.folderUri}e.isFolderToOpen=n;function A(p){return!!p.fileUri}e.isFileToOpen=A;function R(p){const m=P(p),b=p.getValue("window.menuBarVisibility");return b==="default"||m==="native"&&b==="compact"||E.isMacintosh&&E.isNative?"classic":b}e.getMenuBarVisibility=R;function P(p){if(E.isWeb)return"custom";const m=p.getValue("window");if(m){if(E.isMacintosh&&m.nativeTabs===!0||E.isMacintosh&&m.nativeFullScreen===!1)return"native";const S=m.titleBarStyle;if(S==="native"||S==="custom")return S}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function d(p){if(!E.isWindows||E.isWeb||P(p)==="native")return!1;const m=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof m=="boolean"?m:!0}e.useWindowControlsOverlay=d;function c(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=c}),define(ee[121],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var L;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const n=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=n;var A;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(A||(e.WindowMode=A={}));var R;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(ee[28],te([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var L;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(L||(e.OpenContext=L={}))}),define(ee[256],te([0,1,14,22,3,56,2,31,74,108,5,21,28]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let S=e.ProxyAuthHandler=class extends R.Disposable{constructor(r,g,l,v,y){super(),this.g=r,this.h=g,this.i=l,this.j=v,this.k=y,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const r=n.Event.fromNodeEventEmitter(E.app,"login",(g,l,v,y,D)=>({event:g,webContents:l,req:v,authInfo:y,callback:D}));this.B(r(this.m,this))}async m({event:r,authInfo:g,req:l,callback:v}){if(!g.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&l.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}r.preventDefault();let y;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),y=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(g);try{y=await this.b}finally{this.b=void 0}}v(y?.username,y?.password)}async n(r){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.p(r);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(r){this.g.trace("auth#doResolveProxyCredentials - enter",r);const g=String((0,A.hash)({scheme:r.scheme,host:r.host,port:r.port}));let l,v;try{const a=await this.i.getPassword(this.a,g);if(a){const i=JSON.parse(await this.j.decrypt(a));l=i.username,v=i.password}}catch(a){this.g.error(a)}if(this.c!==f.StoredCredentialsUsed&&typeof l=="string"&&typeof v=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:l,password:v};const y=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!y){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${y.id} to handle proxy login`);const D={authInfo:r,username:this.f?.username??l,password:this.f?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};y.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,D),this.c=f.LoginDialogShown;const t=await new Promise(a=>{const i=async(s,o,u)=>{if(o===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${y.id}`),y.win?.webContents.off("ipc-message",i),u){const h={username:u.username,password:u.password};try{if(u.remember){const I=await this.j.encrypt(JSON.stringify(h));await this.i.setPassword(this.a,g,I)}else await this.i.deletePassword(this.a,g)}catch(I){this.g.error(I)}a({username:h.username,password:h.password})}else a(void 0)};y.win?.webContents.on("ipc-message",i)});return this.f=t,t}};e.ProxyAuthHandler=S=ye([Q(0,p.ILogService),Q(1,b.IWindowsMainService),Q(2,d.ICredentialsMainService),Q(3,c.IEncryptionMainService),Q(4,m.IProductService)],S)}),define(ee[257],te([0,1,74,5,34,21,28,214]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let d=e.CredentialsNativeMainService=class extends P.BaseCredentialsMainService{constructor(p,m,b,f){super(p),this.n=m,this.p=b,this.r=f,this.j=S=>{this.r.sendToFocused("vscode:showCredentialsError",S.message??S)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const p=await new Promise((m,b)=>{G(["keytar"],m,b)});return await p.findCredentials("test-keytar-loads"),this.f=p,this.f}};e.CredentialsNativeMainService=d=ye([Q(0,L.ILogService),Q(1,n.INativeEnvironmentService),Q(2,A.IProductService),Q(3,R.IWindowsMainService)],d)}),define(ee[258],te([0,1,14,23,4,8,24,19,62,6,5,120,28]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let f=e.LaunchMainService=class{constructor(w,r,g,l){this.a=w,this.b=r,this.c=g,this.d=l}async start(w,r){this.a.trace("Received data from other instance: ",w,r),n.isMacintosh&&E.app.focus({steal:!0});const g=this.e(w);if(g.length){let l=Promise.resolve();if(this.b.getWindowCount()===0){const v=(0,L.firstOrDefault)(await this.b.openEmptyWindow({context:4}));v&&(l=v.ready())}l.then(()=>{for(const{uri:v,originalUrl:y}of g)this.c.open(v,{originalUrl:y})})}else return this.f(w,r)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,L.coalesce)(w._urls.map(r=>{try{return{uri:A.URI.parse(r),originalUrl:r}}catch{return null}})):[]}async f(w,r){const g=(0,d.isLaunchedFromCli)(r)?0:4;let l=[];const v=w.wait&&w.waitMarkerFilePath?A.URI.file(w.waitMarkerFilePath):void 0,y=w.remote||void 0,D={context:g,cli:w,userEnv:r,waitMarkerFileURI:v,remoteAuthority:y,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,D);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)l=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,D),l=[a]):l=await this.b.open({...D,forceEmpty:!0})}}else l=await this.b.open({...D,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(v&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,R.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=f=ye([Q(0,p.ILogService),Q(1,b.IWindowsMainService),Q(2,m.IURLService),Q(3,P.IConfigurationService)],f)}),define(ee[259],te([0,1,14,3,2,255,28]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=e.WebviewMainService=class extends n.Disposable{constructor(c){super(),this.b=c,this.a=this.B(new L.Emitter),this.onFoundInFrame=this.a.event,this.B(new A.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,p){let m;if(typeof c.windowId=="number"){const{windowId:b}=c,f=this.b.getWindowById(b);if(!f?.win)throw new Error(`Invalid windowId: ${b}`);m=f.win.webContents}else{const{webContentsId:b}=c;if(m=E.webContents.fromId(b),!m)throw new Error(`Invalid webContentsId: ${b}`)}m.isDestroyed()||m.setIgnoreMenuShortcuts(p)}async findInFrame(c,p,m,b){const S=this.c(c,p);if(typeof S.findInFrame=="function"){S.findInFrame(m,{findNext:b.findNext,forward:b.forward});const w=(r,g)=>{g.finalUpdate&&(this.a.fire(g),S.removeListener("found-in-frame",w))};S.on("found-in-frame",w)}}async stopFindInFrame(c,p,m){const f=this.c(c,p);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(m.keepSelection?"keepSelection":"clearSelection")}c(c,p){const m=this.b.getWindowById(c.windowId);if(!m?.win)throw new Error(`Invalid windowId: ${c}`);const b=m.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===p);if(!b)throw new Error(`Unknown frame: ${p}`);return b}};e.WebviewMainService=P=ye([Q(0,R.IWindowsMainService)],P)}),define(ee[260],te([0,1,7,3,2]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends n.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:d,getActiveWindowId:c}){super(),this.a=this.B(new n.DisposableStore),L.Event.latch(L.Event.any(P,d))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>c()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(ee[29],te([0,1,185,9,61,18,8,6,15]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function c(s){const o=s;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=c;function p(s){return typeof s?.id=="string"&&!c(s)&&!b(s)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(s,o){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.basename)(s)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=s;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.toWorkspaceIdentifier=m;function b(s){const o=s;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=b;function f(s){const o=s;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const u=s;if(u?.configPath)return{id:u.id,configPath:R.URI.revive(u.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=f;var S;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(s){const o=s;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=w;function r(s){const o=s;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=r;class g{constructor(o,u,h,I,M){this.h=o,this.j=h,this.k=I,this.l=M,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class l{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,A.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function v(s){return new l({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(s,o){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,o.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function D(s){let o;return R.URI.isUri(s)?o=s:o=s.configuration,o?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=D,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(s,o){return!y(s,o)&&!D(s)}e.isSavedWorkspace=a;function i(s){return(typeof s=="string"?(0,L.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ee[58],te([0,1,14,7,56,44,2,82,4,11,24,162,88,6,5,21,29]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,f.createDecorator)("dialogMainService");let g=e.DialogMainService=class{constructor(v,y){this.d=v,this.e=y,this.a=new Map,this.b=new Map,this.c=new L.Queue}pickFileFolder(v,y){return this.f({...v,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},y)}pickFolder(v,y){return this.f({...v,pickFolders:!0,title:(0,m.localize)(1,null)},y)}pickFile(v,y){return this.f({...v,pickFiles:!0,title:(0,m.localize)(2,null)},y)}pickWorkspace(v,y){const D=(0,m.localize)(3,null),t=(0,A.mnemonicButtonLabel)((0,m.localize)(4,null)),a=r.WORKSPACE_FILTER;return this.f({...v,pickFiles:!0,title:D,filters:a,buttonLabel:t},y)}async f(v,y){const D={title:v.title,buttonLabel:v.buttonLabel,filters:v.filters,defaultPath:v.defaultPath};(typeof v.pickFiles=="boolean"||typeof v.pickFolders=="boolean")&&(D.properties=void 0,v.pickFiles&&v.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",v.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,c.withNullAsUndefined)(y||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(v){if(v){let y=this.b.get(v.id);return y||(y=new L.Queue,this.b.set(v.id,y)),y}else return this.c}showMessageBox(v,y){return this.g(y).queue(async()=>{const{options:D,buttonIndeces:t}=(0,b.massageMessageBoxOptions)(v,this.e);let a;return y?a=await E.dialog.showMessageBox(y,D):a=await E.dialog.showMessageBox(D),{response:t[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(v,y){const D=this.j(v,y);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(y).queue(async()=>{let t;return y?t=await E.dialog.showSaveDialog(y,v):t=await E.dialog.showSaveDialog(v),t.filePath=this.h(t.filePath),t})}finally{(0,R.dispose)(D)}}h(v){return v&&d.isMacintosh&&(v=(0,P.normalizeNFC)(v)),v}i(v){return v.map(y=>this.h(y))}async showOpenDialog(v,y){v.defaultPath&&(await p.Promises.exists(v.defaultPath)||(v.defaultPath=void 0));const D=this.j(v,y);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(y).queue(async()=>{let t;return y?t=await E.dialog.showOpenDialog(y,v):t=await E.dialog.showOpenDialog(v),t.filePaths=this.i(t.filePaths),t})}finally{(0,R.dispose)(D)}}j(v,y){if(!y)return R.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",v);let D=this.a.get(y.id);D||(D=new Set,this.a.set(y.id,D));const t=(0,n.hash)(v);if(!D.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",v),D.add(t),(0,R.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",v),D?.delete(t),D?.size===0&&this.a.delete(y.id)})}};e.DialogMainService=g=ye([Q(0,S.ILogService),Q(1,w.IProductService)],g)}),define(ee[261],te([0,1,3,2,84,29]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends L.Disposable{constructor(d,c){super(),this.f=d,this.g=c,this.b=this.B(new E.Emitter),this.c=new Map,this.h(c.applicationStorage,this.b)}h(d,c){this.B(E.Event.debounce(d.onDidChangeStorage,(p,m)=>(p?p.push(m):p=[m],p),R.a)(p=>{p.length&&c.fire(this.i(p,d))}))}i(d,c){const p=new Map,m=new Set;return d.forEach(b=>{const f=c.get(b.key);typeof f=="string"?p.set(b.key,f):m.add(b.key)}),{changed:Array.from(p.entries()),deleted:Array.from(m.values())}}listen(d,c,p){switch(c){case"onDidChangeStorage":{const m=p.profile?(0,n.revive)(p.profile):void 0;if(!m)return this.b.event;let b=this.c.get(m.id);return b||(b=this.B(new E.Emitter),this.h(this.g.profileStorage(m),b),this.c.set(m.id,b)),b.event}}throw new Error(`Event not found: ${c}`)}async call(d,c,p){const m=p.profile?(0,n.revive)(p.profile):void 0,b=(0,A.reviveIdentifier)(p.workspace),f=await this.j(m,b);switch(c){case"getItems":return Array.from(f.items.entries());case"updateItems":{const S=p;if(S.insert)for(const[w,r]of S.insert)f.set(w,r);S.delete?.forEach(w=>f.delete(w));break}case"isUsed":{const S=p.payload;if(typeof S=="string")return this.g.isUsed(S)}default:throw new Error(`Call not found: ${c}`)}}async j(d,c){let p;c?p=this.g.workspaceStorage(c):d?p=this.g.profileStorage(d):p=this.g.applicationStorage;try{await p.init()}catch(m){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":d?"profile":"application"} storage due to ${m}`)}return p}}e.StorageDatabaseChannel=R,R.a=100}),define(ee[39],te([0,1,56,3,2,18,8,182,34,16,6,5,29,35,38,7,31,27,11]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&R.URI.isUri(s.location)&&R.URI.isUri(s.globalStorageHome)&&R.URI.isUri(s.settingsResource)&&R.URI.isUri(s.keybindingsResource)&&R.URI.isUri(s.tasksResource)&&R.URI.isUri(s.snippetsHome)&&R.URI.isUri(s.extensionsResource))}e.isUserDataProfile=v,e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function y(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:s}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=y;function D(i,s,o,u,h){return{id:i,name:s,location:o,isDefault:!1,shortName:h?.shortName,globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:(0,A.joinPath)(o,"extensions.json"),cacheHome:(0,A.joinPath)(u,i),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}e.toUserDataProfile=D;let t=e.UserDataProfilesService=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(s,o,u,h){super(),this.n=s,this.r=o,this.s=u,this.t=h,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(s){this.f!==s&&(this.u=void 0,this.f=s)}isEnabled(){return this.f}get v(){if(!this.u){const s=[];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,l.isString)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}s.push(D((0,A.basename)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}))}}catch(I){this.t.error(I)}const o=new f.ResourceMap,u=new Map,h=this.w();if(s.unshift({...h,extensionsResource:this.O()??h.extensionsResource,isDefault:!0}),s.length)try{const I=this.M();if(I.workspaces)for(const[M,C]of Object.entries(I.workspaces)){const O=R.URI.parse(M),W=s.find(q=>q.id===C);W&&o.set(O,W)}if(I.emptyWindows)for(const[M,C]of Object.entries(I.emptyWindows)){const O=s.find(W=>W.id===C);O&&u.set(M,O)}}catch(I){this.t.error(I)}this.u={profiles:s,workspaces:o,emptyWindows:u}}return this.u}w(){return D("__default__profile__",(0,P.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let h=0;for(const M of this.profiles){const C=u.exec(M.name),O=C?parseInt(C[1]):0;h=O>h?O:h}const I=`${o} ${h+1}`;return this.createProfile((0,E.hash)((0,r.generateUuid)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,E.hash)((0,r.generateUuid)()).toString(16),s,o,u)}async createProfile(s,o,u,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(s,o,u);return h&&await this.setProfileForWorkspace(h,I),I}async y(s,o,u){if(!(0,l.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.l.get(o);return h||(h=(async()=>{try{const I=this.profiles.find(O=>O.name===o||O.id===s);if(I)return I;const M=D(s,o,(0,A.joinPath)(this.profilesHome,s),this.g,u);await this.r.createFolder(M.location);const C=[];return this.i.fire({profile:M,join(O){C.push(O)}}),await w.Promises.settled(C),this.D([M],[],[]),M}finally{this.l.delete(o)}})(),this.l.set(o,h)),h}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(h=>h.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=D(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags}),this.D([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(h=>h.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.j.fire({profile:o,join(h){u.push(h)}});try{await Promise.allSettled(u)}catch(h){this.t.error(h)}for(const h of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(h)?.id&&this.v.emptyWindows.delete(h);for(const h of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(h)?.id&&this.v.workspaces.delete(h);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(h){(0,c.toFileOperationResult)(h)!==1&&this.t.error(h)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(o.location,{recursive:!0})}catch(h){this.t.error(h)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(h=>h.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.G(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(s,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const s=await this.r.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.s.extUri.isEqual(u.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.z(s);return R.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(s){return(0,b.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,b.isWorkspaceIdentifier)(s)?s.configPath:s.id}C(s){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,s.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,s.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,s.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,s.location)))}D(s,o,u){const h=[...this.profiles,...s],I=[];this.m.profiles=[];for(let M of h)M.isDefault||o.some(C=>M.id===C.id)||(M=u.find(C=>M.id===C.id)??M,M.isTransient?this.m.profiles.push(M):I.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.L(I),this.u=void 0,this.F(s,o,u)}F(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}G(s,o,u){u=o?.isTransient?!0:u,u||this.G(s,void 0,!0);const h=this.z(s),I=u?this.m:this.v;R.URI.isUri(h)?(I.workspaces.delete(h),o&&I.workspaces.set(h,o)):(I.emptyWindows.delete(h),o&&I.emptyWindows.set(h,o)),u||this.H()}H(){const s={};for(const[u,h]of this.v.workspaces.entries())s[u.toString()]=h.id;const o={};for(const[u,h]of this.v.emptyWindows.entries())o[u.toString()]=h.id;this.N({workspaces:s,emptyWindows:o}),this.u=void 0}I(s){const o={},u=this.w();if(s.workspaces)for(const[I,M]of Object.entries(s.workspaces)){const C=R.URI.parse(M);o[I]=this.s.extUri.isEqual(C,u.location)?u.id:this.s.extUri.basename(C)}const h={};if(s.emptyWindows)for(const[I,M]of Object.entries(s.emptyWindows)){const C=R.URI.parse(M);h[I]=this.s.extUri.isEqual(C,u.location)?u.id:this.s.extUri.basename(C)}return{workspaces:o,emptyWindows:h}}J(){return[]}L(s){throw new Error("not implemented")}M(){return{}}N(s){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=ye([Q(0,d.IEnvironmentService),Q(1,c.IFileService),Q(2,S.IUriIdentityService),Q(3,m.ILogService)],t);class a extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(s){this.a=s}M(){return this.R}N(s){this.R=s}}e.InMemoryUserDataProfilesService=a}),define(ee[80],te([0,1,7,17,2,3,35,8,109,116,16,6,5,39,38,11,13,25]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class v extends Error{constructor(i,s){super(i),this.code=s}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let y=e.AbstractExtensionsProfileScannerService=class extends n.Disposable{constructor(i,s,o,u,h,I){super(),this.i=i,this.j=s,this.k=o,this.l=u,this.m=h,this.n=I,this.b=this.B(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new R.ResourceMap}scanProfileExtensions(i,s){return this.p(i,void 0,s)}async addExtensionsToProfile(i,s){const o=[],u=[];try{return await this.p(s,h=>{const I=[];for(const M of h)i.some(([C])=>(0,c.areSameExtensions)(C.identifier,M.identifier)&&C.manifest.version!==M.version)?o.push(M):I.push(M);for(const[M,C]of i)if(!I.some(O=>(0,c.areSameExtensions)(O.identifier,M.identifier)&&O.version===M.manifest.version)){const O={identifier:M.identifier,version:M.manifest.version,location:M.location,metadata:C};u.push(O),I.push(O)}return u.length&&this.b.fire({extensions:u,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),I}),u.length&&this.c.fire({extensions:u,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),u}catch(h){throw u.length&&this.c.fire({extensions:u,error:h,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:h,profileLocation:s}),h}}async updateMetadata(i,s){const o=[];return await this.p(s,u=>{const h=[];for(const I of u){const M=i.find(([C])=>(0,c.areSameExtensions)(C.identifier,I.identifier)&&C.manifest.version===I.version);M&&(I.metadata={...I.metadata,...M[1]},o.push(I)),h.push(I)}return h}),o}async removeExtensionFromProfile(i,s){const o=[];this.f.fire({extensions:o,profileLocation:s});try{await this.p(s,u=>{const h=[];for(const I of u)(0,c.areSameExtensions)(I.identifier,i.identifier)?o.push(I):h.push(I);return o.length&&this.f.fire({extensions:o,profileLocation:s}),h}),o.length&&this.g.fire({extensions:o,profileLocation:s})}catch(u){throw o.length&&this.g.fire({extensions:o,error:u,profileLocation:s}),u}}async p(i,s,o){return this.w(i).queue(async()=>{let u=[],h;try{const I=await this.j.readFile(i);h=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,p.toFileOperationResult)(I)!==1)throw I;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(h=await this.v()),!h&&o?.bailOutWhenFileNotFound)throw new v((0,r.getErrorMessage)(I),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.r(i);let I=!1;for(const M of h){D(M)||this.r(i);let C;if((0,w.isString)(M.relativeLocation)&&M.relativeLocation)C=this.t(M.relativeLocation);else if((0,w.isString)(M.location))C=this.t(M.location),I=!0,M.relativeLocation=M.location,M.location=C.toJSON();else{C=P.URI.revive(M.location);const O=this.s(C);O&&(I=!0,M.relativeLocation=O)}u.push({identifier:M.identifier,location:C,version:M.version,metadata:M.metadata})}I&&await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(h)))}if(s){u=s(u);const I=u.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.s(M.location),metadata:M.metadata}));await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(I)))}return u})}r(i){const s=new v(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(i)).value.toString()}catch(h){if((0,p.toFileOperationResult)(h)===1)return;throw h}this.n.info("Migrating extensions from old default profile location",i.toString());let u;try{const h=JSON.parse(o);Array.isArray(h)&&h.every(I=>D(I))?u=h:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.n.error(h)}if(u)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(h){if((0,p.toFileOperationResult)(h)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw h}try{await this.j.del(i)}catch(h){(0,p.toFileOperationResult)(h)!==1&&this.n.error(h)}try{await this.j.del(s)}catch(h){(0,p.toFileOperationResult)(h)!==1&&this.n.error(h)}return u})()),this.u}w(i){let s=this.h.get(i);return s||(s=new E.Queue,this.h.set(i,s)),s}};e.AbstractExtensionsProfileScannerService=y=ye([Q(1,p.IFileService),Q(2,f.IUserDataProfilesService),Q(3,S.IUriIdentityService),Q(4,g.ITelemetryService),Q(5,b.ILogService)],y);function D(a){return(0,w.isObject)(a)&&(0,d.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,w.isString)(a.location)&&a.location)&&((0,w.isUndefined)(a.relativeLocation)||(0,w.isString)(a.relativeLocation))&&a.version&&(0,w.isString)(a.version)}function t(a){return a?(0,w.isString)(a.path)&&(0,w.isString)(a.scheme):!1}}),define(ee[122],te([0,1,23,7,40,17,13,43,144,2,15,9,4,18,199,72,11,8,167,34,116,113,198,16,6,5,21,3,84,80,39,38,197]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u,h,I,M,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var W;(function(ce){function J(H,j){if(H===j)return!0;const z=Object.keys(H),X=new Set;for(const Z of Object.keys(j))X.add(Z);if(z.length!==X.size)return!1;for(const Z of z){if(H[Z]!==j[Z])return!1;X.delete(Z)}return X.size===0}ce.equals=J})(W||(e.Translations=W={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let q=e.AbstractExtensionsScannerService=class extends c.Disposable{constructor(J,H,j,z,X,Z,oe,ae,B,T,k,F){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=H,this.l=j,this.m=z,this.n=X,this.r=Z,this.s=oe,this.t=ae,this.u=B,this.v=T,this.w=k,this.y=F,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ne,this.m,this.h)),this.j=this.B(this.y.createInstance(ne,this.m,this.h)),this.k=this.B(this.y.createInstance(_,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,y.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(J,H,j){const[z,X]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(H)]),Z=j?await this.scanExtensionsUnderDevelopment(J,[...z,...X]):[];return this.G(z,X,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const H=[];H.push(this.H(!!J.useCache,J.language)),H.push(this.I(J.language,!!J.checkControlFile));const[j,z]=await Promise.all(H);return this.F([...j,...z],0,J,!1)}async scanUserExtensions(J){const H=J.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",H);const j=this.w.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.L(H,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,j),X=J.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let Z;try{Z=await X.scanExtensions(z)}catch(oe){if(oe instanceof I.ExtensionsProfileScanningError&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),Z=await X.scanExtensions(z);else throw oe}return Z=await this.F(Z,1,J,!0),this.t.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(J,H){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const j=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(z=>z.scheme===p.Schemas.file).map(async z=>{const X=await this.L(z,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(X)).map(oe=>(oe.type=H.find(ae=>(0,y.areSameExtensions)(ae.identifier,oe.identifier))?.type??oe.type,this.k.validate(oe,X)))}))).flat();return this.F(j,"development",J,!0)}return[]}async scanExistingExtension(J,H,j){const z=await this.L(J,!1,H,!0,j.language,!0,void 0),X=await this.k.scanExtension(z);return!X||!j.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(J,H,j){const z=await this.L(J,!1,H,!0,j.language,!0,void 0),X=await this.k.scanOneOrMultipleExtensions(z);return this.F(X,H,j,!0)}async scanMetadata(J){const H=(0,f.joinPath)(J,"package.json"),j=(await this.s.readFile(H)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(J,H){const j=(0,f.joinPath)(J,"package.json"),z=(await this.s.readFile(j)).value.toString(),X=JSON.parse(z);H.isMachineScoped=H.isMachineScoped||void 0,H.isBuiltin=H.isBuiltin||void 0,X.__metadata={...X.__metadata,...H},await this.s.writeFile((0,f.joinPath)(J,"package.json"),A.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof I.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw J}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.r.addExtensionsToProfile(J.map(H=>[H,H.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(H){(0,a.toFileOperationResult)(H)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(H))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.t.error(J)}finally{this.C=void 0}})()),this.C}async F(J,H,j,z){return j.includeAllVersions||(J=this.G(H===0?J:void 0,H===1?J:void 0,H==="development"?J:void 0,await this.getTargetPlatform(),z)),j.includeInvalid||(J=J.filter(X=>X.isValid)),J.sort((X,Z)=>{const oe=m.basename(X.location.fsPath),ae=m.basename(Z.location.fsPath);return oe<ae?-1:oe>ae?1:0})}G(J,H,j,z,X){const Z=(ae,B,T)=>{if(ae.isValid&&!B.isValid)return!1;if(ae.isValid===B.isValid){if(X&&S.gt(ae.manifest.version,B.manifest.version))return this.t.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(S.eq(ae.manifest.version,B.manifest.version)){if(ae.type===0)return this.t.debug(`Skipping extension ${B.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===z)return this.t.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return T?this.t.warn(`Overwriting user extension ${ae.location.path} with ${B.location.path}.`):this.t.debug(`Overwriting user extension ${ae.location.path} with ${B.location.path}.`),!0},oe=new D.ExtensionIdentifierMap;return J?.forEach(ae=>{const B=oe.get(ae.identifier.id);(!B||Z(B,ae,!1))&&oe.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const B=oe.get(ae.identifier.id);if(!B&&J&&ae.type===0){this.t.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!B||Z(B,ae,!1))&&oe.set(ae.identifier.id,ae)}),j?.forEach(ae=>{const B=oe.get(ae.identifier.id);(!B||Z(B,ae,!0))&&oe.set(ae.identifier.id,ae),oe.set(ae.identifier.id,ae)}),[...oe.values()]}async H(J,H){this.t.trace("Started scanning system extensions");const j=await this.L(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0),X=await(J&&!j.devMode?this.i:this.k).scanExtensions(j);return this.t.trace("Scanned system extensions:",X.length),X}async I(J,H){const j=this.u.isBuilt?[]:this.v.builtInExtensions;if(!j?.length)return[];this.t.trace("Started scanning dev system extensions");const z=H?await this.J():{},X=[],Z=g.URI.file(m.normalize(m.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of j){const B=z[ae.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":X.push((0,f.joinPath)(Z,ae.name));break;default:X.push(g.URI.file(B));break}}const oe=await Promise.all(X.map(async ae=>this.k.scanExtension(await this.L(ae,!1,0,!0,J,!0,void 0))));return this.t.trace("Scanned dev system extensions:",oe.length),(0,E.coalesce)(oe)}async J(){try{const J=await this.s.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async L(J,H,j,z,X,Z,oe){const ae=await this.f(X??b.language),B=await this.M(J),T=H&&!this.w.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,k=T?await this.M(T):void 0;return new V(J,B,T,k,H,oe,j,z,Z,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,X,ae)}async M(J){try{const H=await this.s.stat(J);if(typeof H.mtime=="number")return H.mtime}catch{}}};e.AbstractExtensionsScannerService=q=ye([Q(4,M.IUserDataProfilesService),Q(5,I.IExtensionsProfileScannerService),Q(6,a.IFileService),Q(7,s.ILogService),Q(8,v.IEnvironmentService),Q(9,o.IProductService),Q(10,C.IUriIdentityService),Q(11,i.IInstantiationService)],q);class V{constructor(J,H,j,z,X,Z,oe,ae,B,T,k,F,N,U,$){this.location=J,this.mtime=H,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=z,this.profile=X,this.profileScanOptions=Z,this.type=oe,this.excludeObsolete=ae,this.validate=B,this.productVersion=T,this.productDate=k,this.productCommit=F,this.devMode=N,this.language=U,this.translations=$}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,H){return(0,f.isEqual)(J.location,H.location)&&J.mtime===H.mtime&&(0,f.isEqual)(J.applicationExtensionslocation,H.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&J.profile===H.profile&&n.equals(J.profileScanOptions,H.profileScanOptions)&&J.type===H.type&&J.excludeObsolete===H.excludeObsolete&&J.validate===H.validate&&J.productVersion===H.productVersion&&J.productDate===H.productDate&&J.productCommit===H.productCommit&&J.devMode===H.devMode&&J.language===H.language&&W.equals(J.translations,H.translations)}}e.ExtensionScannerInput=V;let _=class extends c.Disposable{constructor(J,H,j,z,X){super(),this.f=J,this.g=H,this.h=j,this.i=z,this.j=X}async scanExtensions(J){const H=J.profile?await this.l(J):await this.k(J);let j={};if(J.excludeObsolete&&J.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();j=JSON.parse(z)}catch{}return(0,r.isEmptyObject)(j)?H:H.filter(z=>!j[y.ExtensionKey.create(z).toString()])}async k(J){const H=await this.i.resolve(J.location);if(!H.children?.length)return[];const j=await Promise.all(H.children.map(async z=>{if(!z.isDirectory||J.type===1&&(0,f.basename)(z.resource).indexOf(".")===0)return null;const X=new V(z.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(X)}));return(0,E.coalesce)(j).sort((z,X)=>z.location.path<X.location.path?-1:1)}async l(J){let H=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){H=H.filter(z=>!z.metadata?.isApplicationScoped);const j=await this.m(J.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,J);H.push(...j)}return H}async m(J,H,j){const z=await this.g.scanProfileExtensions(J,j.profileScanOptions);if(!z.length)return[];const X=await Promise.all(z.map(async Z=>{if(H(Z)){const oe=new V(Z.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(oe,Z.metadata)}return null}));return(0,E.coalesce)(X)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,f.joinPath)(J.location,"package.json"))){const H=await this.scanExtension(J);return H?[H]:[]}else return await this.scanExtensions(J)}catch(H){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,R.getErrorMessage)(H)),[]}}async scanExtension(J,H){try{let j=await this.scanExtensionManifest(J.location);if(j){j.publisher||(j.publisher=D.UNDEFINED_PUBLISHER),H=H??j.__metadata,delete j.__metadata;const z=(0,y.getGalleryExtensionId)(j.publisher,j.name),X=H?.id?{id:z,uuid:H.id}:{id:z},Z=H?.isSystem?0:J.type,oe=Z===0||!!H?.isBuiltin;j=await this.n(J.location,j,V.createNlsConfiguration(J));const ae={type:Z,identifier:X,manifest:j,location:J.location,isBuiltin:oe,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return J.validate?this.validate(ae,J):ae}}catch(j){J.type!==0&&this.j.error(j)}return null}validate(J,H){let j=!0;const z=(0,t.validateExtensionManifest)(H.productVersion,H.productDate,H.location,J.manifest,J.isBuiltin);for(const[X,Z]of z)X===w.default.Error&&(j=!1,this.j.error(this.u(H.location,Z)));return J.isValid=j,J.validations=z,J}async scanExtensionManifest(J){const H=(0,f.joinPath)(J,"package.json");let j;try{j=(await this.i.readFile(H)).value.toString()}catch(X){return(0,a.toFileOperationResult)(X)!==1&&this.j.error(this.u(J,(0,l.localize)(0,null,H.path,X.message))),null}let z;try{z=JSON.parse(j)}catch{const Z=[];(0,P.parse)(j,Z);for(const oe of Z)this.j.error(this.u(J,(0,l.localize)(1,null,H.path,oe.offset,oe.length,(0,d.getParseErrorMessage)(oe.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.j.error(this.u(J,(0,l.localize)(2,null,H.path))),null):z}async n(J,H,j){const z=await this.r(J,H,j);if(z)try{const X=[],Z=await this.s(z.default,X);if(X.length>0)return X.forEach(ae=>{this.j.error(this.u(J,(0,l.localize)(3,null,z.default?.path,(0,d.getParseErrorMessage)(ae.error))))}),H;if((0,P.getNodeType)(z)!=="object")return this.j.error(this.u(J,(0,l.localize)(4,null,z.default?.path))),H;const oe=z.values||Object.create(null);return(0,O.localizeManifest)(H,oe,Z)}catch{}return H}async r(J,H,j){const z=(0,f.joinPath)(J,"package.nls.json"),X=(B,T)=>{T.forEach(k=>{this.j.error(this.u(J,(0,l.localize)(5,null,B?.path,(0,d.getParseErrorMessage)(k.error))))})},Z=B=>{this.j.error(this.u(J,(0,l.localize)(6,null,B?.path)))},oe=`${H.publisher}.${H.name}`,ae=j.translations[oe];if(ae)try{const B=g.URI.file(ae),T=(await this.i.readFile(B)).value.toString(),k=[],F=(0,P.parse)(T,k);return k.length>0?(X(B,k),{values:void 0,default:z}):(0,P.getNodeType)(F)!=="object"?(Z(B),{values:void 0,default:z}):{values:F.contents?F.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let T;try{T=await this.t(J,j)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const k=(await this.i.readFile(T.localized)).value.toString(),F=[],N=(0,P.parse)(k,F);return F.length>0?(X(T.localized,F),{values:void 0,default:T.original}):(0,P.getNodeType)(N)!=="object"?(Z(T.localized),{values:void 0,default:T.original}):{values:N,default:T.original}}catch{return{values:void 0,default:T.original}}}}async s(J,H){if(J)try{const j=(await this.i.readFile(J)).value.toString();return(0,P.parse)(j,H)}catch{}}t(J,H){return new Promise((j,z)=>{const X=Z=>{const oe=(0,f.joinPath)(J,`package.nls.${Z}.json`);this.i.exists(oe).then(ae=>{ae&&j({localized:oe,original:(0,f.joinPath)(J,"package.nls.json")});const B=Z.lastIndexOf("-");B===-1?j({localized:(0,f.joinPath)(J,"package.nls.json"),original:null}):(Z=Z.substring(0,B),X(Z))})};if(H.devMode||H.pseudo||!H.language)return j({localized:(0,f.joinPath)(J,"package.nls.json"),original:null});X(H.language)})}u(J,H){return`[${J.path}]: ${H}`}};_=ye([Q(1,I.IExtensionsProfileScannerService),Q(2,C.IUriIdentityService),Q(3,a.IFileService),Q(4,s.ILogService)],_);let ne=class extends _{constructor(J,H,j,z,X,Z,oe){super(H,z,X,Z,oe),this.z=J,this.C=j,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new u.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(J){const H=this.H(J),j=await this.D(H);if(this.v=J,j&&j.input&&V.equals(j.input,this.v))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.w.trigger(()=>this.G()),j.result.map(X=>(X.location=g.URI.revive(X.location),X));const z=await super.scanExtensions(J);return await this.F(H,{input:J,result:z}),z}async D(J){try{const H=await this.i.readFile(J),j=JSON.parse(H.value.toString());return{result:j.result,input:(0,h.revive)(j.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",J.path,(0,R.getErrorMessage)(H))}return null}async F(J,H){try{await this.i.writeFile(J,A.VSBuffer.fromString(JSON.stringify(H)))}catch(j){this.j.debug("Error while writing the extension cache file:",J.path,(0,R.getErrorMessage)(j))}}async G(){if(!this.v)return;const J=this.H(this.v),H=await this.D(J);if(!H)return;const j=H.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!n.equals(z,j))try{this.j.info("Invalidating Cache",j,z),await this.i.del(J),this.y.fire()}catch(X){this.j.error(X)}}H(J){const H=this.I(J);return this.h.extUri.joinPath(H.cacheHome,J.type===0?D.BUILTIN_MANIFEST_CACHE_FILE:D.USER_MANIFEST_CACHE_FILE)}I(J){return J.type===0?this.C.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.z.extensionsResource)?this.z:this.C.profiles.find(H=>this.h.extUri.isEqual(J.location,H.extensionsResource))??this.z:this.C.defaultProfile}};ne=ye([Q(2,M.IUserDataProfilesService),Q(3,I.IExtensionsProfileScannerService),Q(4,C.IUriIdentityService),Q(5,a.IFileService),Q(6,s.ILogService)],ne);function re(ce,J){const H=(0,y.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:H,identifier:new D.ExtensionIdentifier(H),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:J,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=re;class ue extends q{constructor(J,H,j,z,X,Z,oe,ae,B,T,k,F){super(J,H,(0,f.joinPath)(j,".vscode-oss-dev","extensions","control.json"),z,X,Z,oe,ae,B,T,k,F),this.N=(async()=>{if(b.translationsConfigFile)try{const N=await this.s.readFile(g.URI.file(b.translationsConfigFile));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(J){return this.N}}e.NativeExtensionsScannerService=ue}),define(ee[262],te([0,1,5,39,38,25,80,16,34,8]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=e.ExtensionsProfileScannerService=class extends R.AbstractExtensionsProfileScannerService{constructor(b,f,S,w,r,g){super(c.URI.file(b.extensionsPath),f,S,w,r,g)}};e.ExtensionsProfileScannerService=p=ye([Q(0,d.INativeEnvironmentService),Q(1,P.IFileService),Q(2,L.IUserDataProfilesService),Q(3,n.IUriIdentityService),Q(4,A.ITelemetryService),Q(5,E.ILogService)],p)}),define(ee[263],te([0,1,8,34,80,122,16,6,5,21,38,39]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=e.ExtensionsScannerService=class extends A.NativeExtensionsScannerService{constructor(S,w,r,g,l,v,y,D){super(E.URI.file(l.builtinExtensionsPath),E.URI.file(l.extensionsPath),l.userHome,S.defaultProfile,S,w,r,g,l,v,y,D)}};e.ExtensionsScannerService=b=ye([Q(0,m.IUserDataProfilesService),Q(1,n.IExtensionsProfileScannerService),Q(2,R.IFileService),Q(3,d.ILogService),Q(4,L.INativeEnvironmentService),Q(5,c.IProductService),Q(6,p.IUriIdentityService),Q(7,P.IInstantiationService)],b)}),define(ee[264],te([0,1,14,2,15,9,4,61,8,31,42,34,5,39]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=e.ProtocolMainService=class extends L.Disposable{constructor(r,g,l){super(),this.c=r,this.f=l,this.a=P.TernarySearchTree.forPaths(!R.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(r.appRoot),this.addValidFileRoot(r.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(r.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:r}=E.session;r.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(g,l)=>this.i(g,l)),r.protocol.interceptFileProtocol(n.Schemas.file,(g,l)=>this.h(g,l)),this.B((0,L.toDisposable)(()=>{r.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),r.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(r){const g=(0,A.normalize)(r);return this.a.get(g)?L.Disposable.None:(this.a.set(g,!0),(0,L.toDisposable)(()=>this.a.delete(g)))}h(r,g){const l=d.URI.parse(r.url);return this.f.error(`Refused to load resource ${l.fsPath} from ${n.Schemas.file}: protocol (original URL: ${r.url})`),g({error:-3})}i(r,g){const l=this.j(r);let v;return this.c.crossOriginIsolated&&((0,A.basename)(l)==="workbench.html"||(0,A.basename)(l)==="workbench-dev.html"?v=n.COI.CoopAndCoep:v=n.COI.getHeadersFromQuery(r.url)),this.a.findSubstr(l)?g({path:l,headers:v}):this.b.has((0,A.extname)(l).toLowerCase())?g({path:l}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${l} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${r.url})`),g({error:-3}))}j(r){const g=d.URI.parse(r.url),l=n.FileAccess.uriToFileUri(g);return(0,A.normalize)(l.fsPath)}createIPCObjectUrl(){let r;const g=d.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),l=g.toString(),v=async()=>r;return p.validatedIpcMain.handle(l,v),this.f.trace(`IPC Object URL: Registered new channel ${l}.`),{resource:g,update:y=>r=y,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${l}.`),p.validatedIpcMain.removeHandler(l)}}}};e.ProtocolMainService=S=ye([Q(0,m.INativeEnvironmentService),Q(1,f.IUserDataProfilesService),Q(2,b.ILogService)],S)}),define(ee[93],te([0,1,7,3,2,64,11,105,6,39]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var p;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var m;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var b;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function f(l){const v=l.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=f;class S extends n.Disposable{constructor(v={flushInterval:S.a}){super(),this.j=v,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(v,y){if(y===e.TARGET_KEY){switch(v){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:y,target:this.F(v)[y]})}r(v){this.f.fire({reason:v})}get(v,y,D){return this.L(y)?.get(v,D)}getBoolean(v,y,D){return this.L(y)?.getBoolean(v,D)}getNumber(v,y,D){return this.L(y)?.getNumber(v,D)}store(v,y,D,t){if((0,R.isUndefinedOrNull)(y)){this.remove(v,D);return}this.t(()=>{this.u(v,D,t),this.L(D)?.set(v,y)})}remove(v,y){this.t(()=>{this.u(v,y,void 0),this.L(y)?.delete(v)})}t(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,y){const D=[],t=this.F(v);for(const a of Object.keys(t))t[a]===y&&D.push(a);return D}u(v,y,D){const t=this.F(y);typeof D=="number"?t[v]!==D&&(t[v]=D,this.L(y)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[v]=="number"&&(delete t[v],this.L(y)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(v){switch(v){case-1:return this.D;case 0:return this.z;default:return this.w}}G(v){const y=this.L(v);return y?f(y):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=p.NONE){this.f.fire({reason:v});const y=this.L(-1),D=this.L(0),t=this.L(1);switch(v){case p.NONE:await E.Promises.settled([y?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await E.Promises.settled([y?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.L(-1)?.items??new Map,y=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return g(v,y,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(v,y){return this.r(p.NONE),(0,c.isUserDataProfile)(v)?this.N(v,y):this.O(v,y)}H(v,y){return!(v.id===y.id||w(y)&&w(v))}I(v,y,D,t){this.t(()=>{if(t)for(const[a,i]of v)y.set(a,i);else{const a=new Set;for(const[i,s]of v)a.add(i),y.get(i)!==s&&this.n(D,i);for(const[i]of y.items)a.has(i)||this.n(D,i)}})}}e.AbstractStorageService=S,S.a=60*1e3;function w(l){return l.isDefault||!!l.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class r extends S{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(v=>this.n(1,v))),this.B(this.P.onDidChangeStorage(v=>this.n(0,v))),this.B(this.p.onDidChangeStorage(v=>this.n(-1,v)))}L(v){switch(v){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(v){return!1}}e.InMemoryStorageService=r;async function g(l,v,y,D,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},s=new Map,o=new Map;l.forEach((W,q)=>{s.set(q,W),o.set(q,i(W))});const u=new Map,h=new Map;v.forEach((W,q)=>{u.set(q,W),h.set(q,i(W))});const I=new Map,M=new Map;y.forEach((W,q)=>{I.set(q,W),M.set(q,i(W))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const C=[];if(s.forEach((W,q)=>{C.push({key:q,value:W})}),console.table(C),console.groupEnd(),console.log(o),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];u.forEach((q,V)=>{W.push({key:V,value:q})}),console.table(W),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${a})`);const O=[];I.forEach((W,q)=>{O.push({key:q,value:W})}),console.table(O),console.groupEnd(),console.log(M)}e.logStorage=g}),define(ee[265],te([0,1,23,7,3,2,9,83,8,24,105,156,5,93,25,29]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class r extends A.Disposable{get storage(){return this.f}constructor(a,i){super(),this.j=a,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new L.DeferredPromise,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(s=>this.b.fire({key:s}))),await this.m(a);const i=a.getBoolean(f.IS_NEW_KEY);i===void 0?a.set(f.IS_NEW_KEY,!0):i&&a.set(f.IS_NEW_KEY,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,i){return this.f.get(a,i)}set(a,i){return this.f.set(a,i)}delete(a){return this.f.delete(a)}async close(){const a=new P.StopWatch(!1);await this.s(),a.stop(),a.elapsed()>r.a&&await this.r(a),this.c.fire()}async r(a){if(this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([o,u])=>({key:o,length:u.length})),(o,u)=>u.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),s=(await this.k.stat(d.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}r.a=2e3;class g extends r{get path(){if(!this.v.useInMemoryStorage)return(0,R.join)(this.u.globalStorageHome.fsPath,g.t)}constructor(a,i,s,o){super(s,o),this.u=a,this.v=i}async n(){return new p.Storage(new m.SQLiteStorageDatabase(this.path??m.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}g.t="state.vscdb";class l extends g{constructor(a,i,s,o){super(a,i,s,o)}}e.ProfileStorageMain=l;class v extends g{constructor(a,i,s,o){super(i.defaultProfile,a,s,o)}async m(a){await super.m(a),this.z(a)}z(a){a.get(S.firstSessionDateStorageKey,void 0)===void 0&&a.set(S.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(S.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();a.set(S.lastSessionDateStorageKey,typeof s>"u"?null:s),a.set(S.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=v;class y extends r{get path(){if(!this.w.useInMemoryStorage)return(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id,y.t)}constructor(a,i,s,o,u){super(s,u),this.v=a,this.w=i,this.y=o}async n(){const{storageFilePath:a,wasCreated:i}=await this.C();return new p.Storage(new m.SQLiteStorageDatabase(a,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:m.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,R.join)(a,y.t);return await c.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(a,{recursive:!0}),this.D(a),{storageFilePath:i,wasCreated:!0})}async D(a){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const s=(0,R.join)(a,y.u);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.WorkspaceStorageMain=y,y.t="state.vscdb",y.u="workspace.json";class D extends r{get path(){}async n(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(ee[266],te([0,1,3,2,93]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class A extends L.Disposable{constructor(P,d,c){super(),this.b=P,this.c=d,this.f=c;const p=this.B(new L.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new L.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,c)=>(d?d.push(c.key):d=[c.key],d),100)(d=>this.h(d))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(d,c)=>{d||(d=new Map);let p=d.get(c.profile.id);return p||d.set(c.profile.id,p={profile:c.profile,keys:[],storage:c.storage}),p.keys.push(c.key),d},100)(d=>this.i(d))),P}h(P){const d=P.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],c=[];if(P=P.filter(p=>p!==n.TARGET_KEY),P.length){const p=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:P.map(m=>({key:m,scope:0,target:p[m]}))})}this.j(d,c)}i(P){const d=[],c=new Map;for(const[p,m]of P.entries()){m.keys.includes(n.TARGET_KEY)&&d.push(m.profile);const b=m.keys.filter(f=>f!==n.TARGET_KEY);if(b.length){const f=(0,n.loadKeyTargets)(m.storage.storage);c.set(p,{profile:m.profile,changes:b.map(S=>({key:S,scope:0,target:f[S]}))})}}this.j(d,[...c.values()])}j(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,c){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.ProfileStorageChangesListenerChannel=A}),define(ee[267],te([0,1,8,34,16,5,33,38,39,11,115]),function(G,e,E,L,n,A,R,P,d,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=e.UserDataProfilesReadonlyService=class ft extends d.UserDataProfilesService{constructor(w,r,g,l,v){super(g,l,r,v),this.P=w,this.Q=g}J(){return this.P.getItem(ft.b,[]).map(r=>({...r,location:(0,c.isString)(r.location)?this.s.extUri.joinPath(this.profilesHome,r.location):E.URI.revive(r.location)}))}M(){const w=this.P.getItem(ft.c,{});return this.P.getItem(ft.a,!1)?w:this.I(w)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=m=ye([Q(0,R.IStateReadService),Q(1,P.IUriIdentityService),Q(2,L.INativeEnvironmentService),Q(3,n.IFileService),Q(4,A.ILogService)],m);let b=e.UserDataProfilesService=class st extends m{constructor(w,r,g,l,v){super(w,r,g,l,v),this.W=w}L(w){w.length?this.W.setItem(st.b,w.map(r=>({...r,location:this.s.extUri.basename(r.location)}))):this.W.removeItem(st.b)}J(){const w=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(w),this.W.setItem("userDataProfilesMigration",!0)),w}N(w){w.emptyWindows||w.workspaces?this.W.setItem(st.c,w):this.W.removeItem(st.c)}M(){const w="workspaceAndProfileInfo",r=this.W.getItem(w,void 0);if(r){this.W.removeItem(w);const l=r.reduce((v,{workspace:y,profile:D})=>(v[E.URI.revive(y).toString()]=E.URI.revive(D).toString(),v),{});this.W.setItem(st.c,{workspaces:l})}const g=super.M();return this.W.getItem(st.a,!1)||(this.N(g),this.W.setItem(st.a,!0)),g}};e.UserDataProfilesService=b=ye([Q(0,R.IStateService),Q(1,P.IUriIdentityService),Q(2,L.INativeEnvironmentService),Q(3,n.IFileService),Q(4,A.ILogService)],b);let f=e.ServerUserDataProfilesService=class extends b{constructor(w,r,g,l){super(new p.StateService(0,r,l,g),w,r,g,l)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=f=ye([Q(0,P.IUriIdentityService),Q(1,L.INativeEnvironmentService),Q(2,n.IFileService),Q(3,A.ILogService)],f)}),define(ee[53],te([0,1,34,16,6,5,38,39,267,33]),function(G,e,E,L,n,A,R,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,n.refineServiceDecorator)(P.IUserDataProfilesService);let p=e.UserDataProfilesMainService=class extends d.UserDataProfilesService{constructor(b,f,S,w,r){super(b,f,S,w,r)}getAssociatedEmptyWindows(){const b=[];for(const f of this.v.emptyWindows.keys())b.push({id:f});return b}};e.UserDataProfilesMainService=p=ye([Q(0,c.IStateService),Q(1,R.IUriIdentityService),Q(2,E.INativeEnvironmentService),Q(3,L.IFileService),Q(4,A.ILogService)],p)}),define(ee[123],te([0,1,18,8,29]),function(G,e,E,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function A(d,c,p){for(const b of d){const f=b.openedWorkspace;if((0,n.isWorkspaceIdentifier)(f)){const S=await p(f);if(S){if(S.folders.some(w=>E.extUriBiasedIgnorePathCase.isEqualOrParent(c,w.uri)))return b}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(c,f.configPath))return b}}const m=d.filter(b=>(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(c,b.openedWorkspace.uri));if(m.length)return m.sort((b,f)=>-(b.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=A;function R(d,c){for(const p of d)if((0,n.isWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,c)||(0,n.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,c))return p}e.findWindowOnWorkspaceOrFolder=R;function P(d,c){const p=m=>c.some(b=>E.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(m)));for(const m of d)if(m.config?.extensionDevelopmentPath?.some(b=>p(b)))return m}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[94],te([0,1,32,43,128,44,15,9,4,18,8,6,57,29]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function S(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function w(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=w;function r(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=r;function g(M){return l(M)||v(M)}e.isStoredWorkspaceFolder=g;function l(M){const C=M;return typeof C?.path=="string"&&(!C.name||typeof C.name=="string")}function v(M){const C=M;return typeof C?.uri=="string"&&(!C.name||typeof C.name=="string")}function y(M,C,O,W,q){if(M.scheme!==W.scheme)return{name:O,uri:M.toString(!0)};let V=C?void 0:q.relativePath(W,M);if(V!==void 0)V.length===0?V=".":d.isWindows&&(V=D(V));else if(M.scheme===R.Schemas.file)V=M.fsPath,d.isWindows&&(V=D(V));else if(q.isEqualAuthority(M.authority,W.authority))V=M.path;else return{name:O,uri:M.toString(!0)};return{name:O,path:V}}e.getStoredWorkspaceFolder=y;function D(M){return M=(0,A.normalizeDriveLetter)(M),(0,E.isUNC)(M)||(M=(0,E.toSlashes)(M)),M}function t(M,C,O){const W=[],q=new Set,V=O.dirname(C);for(const _ of M){let ne;if(l(_))_.path&&(ne=O.resolvePath(V,_.path));else if(v(_))try{ne=p.URI.parse(_.uri),ne.path[0]!==P.posix.sep&&(ne=ne.with({path:P.posix.sep+ne.path}))}catch(re){console.warn(re)}if(ne){const re=O.getComparisonKey(ne);if(!q.has(re)){q.add(re);const ue=_.name||O.basenameOrAuthority(ne);W.push(new f.WorkspaceFolder({uri:ne,name:ue,index:W.length},_))}}}return W}e.toWorkspaceFolders=t;function a(M,C,O,W,q){const V=i(C,M),_=q.dirname(C),ne=q.dirname(W),re=[];for(const H of V.folders){const j=l(H)?q.resolvePath(_,H.path):p.URI.parse(H.uri);let z;O?z=!1:z=!l(H)||(0,P.isAbsolute)(H.path),re.push(y(j,z,H.name,ne,q))}const ue={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},ce=n.setProperty(M,["folders"],re,ue);let J=n.applyEdits(M,ce);return(0,c.isEqualAuthority)(V.remoteAuthority,(0,b.getRemoteAuthority)(W))&&(J=n.applyEdits(J,n.removeProperty(J,["remoteAuthority"],ue))),J}e.rewriteWorkspaceFileForNewLocation=a;function i(M,C){const O=L.parse(C);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(W=>g(W));else throw new Error(`${M} looks like an invalid workspace file.`);return O}function s(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function u(M){return typeof M.fileUri=="string"}function h(M,C){const O={workspaces:[],files:[]};if(M){const W=function(V,_){for(let ne=0;ne<V.length;ne++)try{_(V[ne],ne)}catch(re){C.warn(`Error restoring recent entry ${JSON.stringify(V[ne])}: ${re.toString()}. Skip entry.`)}},q=M;Array.isArray(q.entries)&&W(q.entries,V=>{const _=V.label,ne=V.remoteAuthority;s(V)?O.workspaces.push({label:_,remoteAuthority:ne,workspace:{id:V.workspace.id,configPath:p.URI.parse(V.workspace.configPath)}}):o(V)?O.workspaces.push({label:_,remoteAuthority:ne,folderUri:p.URI.parse(V.folderUri)}):u(V)&&O.files.push({label:_,remoteAuthority:ne,fileUri:p.URI.parse(V.fileUri)})})}return O}e.restoreRecentlyOpened=h;function I(M){const C={entries:[]};for(const O of M.workspaces)w(O)?C.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):C.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of M.files)C.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return C}e.toStoreData=I}),define(ee[95],te([0,1,69,15,4,18]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(c){function p(){let m=c.scheme===L.Schemas.file?(0,A.originalFSPath)(c):c.toString();return n.isLinux||(m=m.toLowerCase()),(0,E.createHash)("md5").update(m).digest("hex")}return{id:p(),configPath:c}}e.getWorkspaceIdentifier=R;function P(c,p){function m(){if(c.scheme!==L.Schemas.file)return(0,E.createHash)("md5").update(c.toString()).digest("hex");if(!p)return;let f;return n.isLinux?f=p.ino:n.isMacintosh?f=p.birthtime.getTime():n.isWindows&&(typeof p.birthtimeMs=="number"?f=Math.floor(p.birthtimeMs):f=p.birthtime.getTime()),(0,E.createHash)("md5").update(c.fsPath).update(f?String(f):"").digest("hex")}const b=m();if(typeof b=="string")return{id:b,uri:c}}e.getSingleFolderWorkspaceIdentifier=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=d}),define(ee[96],te([0,1,69,70,26,268,17,13,3,2,9,4,31,45,104]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(C,O){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,O)}constructor(C,O=""){this.f=!0,this.debugLabel=O,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=W=>{if(this.traceSocketEvent("error",{code:W?.code,message:W?.message}),W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}},this.socket.on("error",this.a),this.b=W=>{this.traceSocketEvent("close",{hadError:W}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const O=W=>{this.traceSocketEvent("read",W),C(R.VSBuffer.wrap(W))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(C){const O=W=>{C({type:0,hadError:W,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(C){const O=()=>{C()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,P.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,P.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.NodeSocket=w;var r;(function(M){M[M.MinHeaderByteSize=2]="MinHeaderByteSize",M[M.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var g;(function(M){M[M.PeekHeader=1]="PeekHeader",M[M.ReadHeader=2]="ReadHeader",M[M.ReadBody=3]="ReadBody",M[M.Fin=4]="Fin"})(g||(g={}));class l extends c.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,O){this.socket.traceSocketEvent(C,O)}constructor(C,O,W,q){super(),this.f=this.B(new d.Emitter),this.g=this.B(new d.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:W?.byteLength||0,recordInflateBytes:q}),this.a=this.B(new v(this,O,W,q,this.f,(V,_)=>this.k(V,_))),this.B(this.a.onError(V=>{console.error(V),(0,P.onUnexpectedError)(V),this.g.fire({type:0,hadError:!0,error:V})})),this.b=new S.ChunkStream,this.B(this.socket.onData(V=>this.l(V))),this.B(this.socket.onClose(async V=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(V)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let O=0;for(;O<C.byteLength;)this.a.writeMessage(C.slice(O,Math.min(O+262144,C.byteLength))),O+=262144}k(C,O){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let W=2;C.byteLength<126?W+=0:C.byteLength<2**16?W+=2:W+=8;const q=R.VSBuffer.alloc(W);if(O?q.writeUInt8(194,0):q.writeUInt8(130,0),C.byteLength<126)q.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){q.writeUInt8(126,1);let V=1;q.writeUInt8(C.byteLength>>>8&255,++V),q.writeUInt8(C.byteLength>>>0&255,++V)}else{q.writeUInt8(127,1);let V=1;q.writeUInt8(0,++V),q.writeUInt8(0,++V),q.writeUInt8(0,++V),q.writeUInt8(0,++V),q.writeUInt8(C.byteLength>>>24&255,++V),q.writeUInt8(C.byteLength>>>16&255,++V),q.writeUInt8(C.byteLength>>>8&255,++V),q.writeUInt8(C.byteLength>>>0&255,++V)}this.socket.write(R.VSBuffer.concat([q,C]))}end(){this.h=!0,this.socket.end()}l(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),W=O.readUInt8(0),q=(W&128)>>>7,V=(W&64)>>>6,_=O.readUInt8(1),ne=(_&128)>>>7,re=_&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=q,this.j.firstFrameOfMessage&&(this.j.compressed=!!V),this.j.firstFrameOfMessage=!!q,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),W=O.readUInt8(1),q=(W&128)>>>7;let V=W&127,_=1;V===126?V=O.readUInt8(++_)*2**8+O.readUInt8(++_):V===127&&(V=O.readUInt8(++_)*0+O.readUInt8(++_)*0+O.readUInt8(++_)*0+O.readUInt8(++_)*0+O.readUInt8(++_)*2**24+O.readUInt8(++_)*2**16+O.readUInt8(++_)*2**8+O.readUInt8(++_));let ne=0;q&&(ne=O.readUInt8(++_)*2**24+O.readUInt8(++_)*2**16+O.readUInt8(++_)*2**8+O.readUInt8(++_)),this.j.state=3,this.j.readLen=V,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(O,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=l;class v extends c.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(C,O,W,q,V,_){super(),this.l=C,this.m=V,this.n=_,this.a=this.B(new d.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new d.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,O?(this.b=this.B(new y(this.l,q,W,{windowBits:15})),this.f=this.B(new D(this.l,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(C){this.g.push(C),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const C=this.g.shift();if(this.f){const O=await this.s(this.f,C);this.n(O,!0)}else this.n(C,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(C,O){return new Promise((W,q)=>{C.write(O),C.flush(V=>W(V))})}acceptFrame(C,O,W){this.h.push({data:C,isCompressed:O,isLastFrameOfMessage:W}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const O=await this.w(this.b,C.data,C.isLastFrameOfMessage);this.m.fire(O)}else this.m.fire(C.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(C,O,W){return new Promise((q,V)=>{C.write(O),W&&C.write(R.VSBuffer.fromByteArray([0,0,255,255])),C.flush(_=>q(_))})}}class y extends c.Disposable{get recordedInflateBytes(){return this.j?R.VSBuffer.concat(this.f):R.VSBuffer.alloc(0)}constructor(C,O,W,q){super(),this.h=C,this.j=O,this.a=this.B(new d.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(q),this.b.on("error",V=>{this.h.traceSocketEvent("zlibInflateError",{message:V?.message,code:V?.code}),this.a.fire(V)}),this.b.on("data",V=>{this.h.traceSocketEvent("zlibInflateData",V),this.g.push(R.VSBuffer.wrap(V))}),W&&(this.h.traceSocketEvent("zlibInflateInitialWrite",W.buffer),this.b.write(W.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=R.VSBuffer.concat(this.g);this.g.length=0,C(O)})}}class D extends c.Disposable{constructor(C,O){super(),this.g=C,this.a=this.B(new d.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",W=>{this.g.traceSocketEvent("zlibDeflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.g.traceSocketEvent("zlibDeflateData",W),this.f.push(R.VSBuffer.wrap(W))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=R.VSBuffer.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),C(O)})}}function t(M,C){if(C===0)return;const O=M.byteLength>>>2;for(let re=0;re<O;re++){const ue=M.readUInt32BE(re*4);M.writeUInt32BE(ue^C,re*4)}const W=O*4,q=M.byteLength-W,V=C>>>24&255,_=C>>>16&255,ne=C>>>8&255;q>=1&&M.writeUInt8(M.readUInt8(W)^V,W),q>=2&&M.writeUInt8(M.readUInt8(W+1)^_,W+1),q>=3&&M.writeUInt8(M.readUInt8(W+2)^ne,W+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const M=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${M}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,n.tmpdir)(),O=(0,p.join)(C,`vscode-ipc-${M}.sock`);return o(O),O}e.createRandomIPCHandle=i;function s(M,C,O){const W=(0,E.createHash)("md5").update(M).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${C}-sock`;const q=O.substr(0,4),V=C.substr(0,6),_=W.substr(0,8);let ne;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ne=(0,p.join)(e.XDG_RUNTIME_DIR,`vscode-${_}-${q}-${V}.sock`):ne=(0,p.join)(M,`${q}-${V}.sock`),o(ne),ne}e.createStaticIPCHandle=s;function o(M){const C=a[m.platform];typeof C=="number"&&M.length>=C&&console.warn(`WARNING: IPC handle "${M}" is longer than ${C} chars, try a shorter --user-data-dir`)}class u extends f.IPCServer{static b(C){const O=d.Event.fromNodeEventEmitter(C,"connection");return d.Event.map(O,W=>({protocol:new S.Protocol(new w(W,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(W,"close"))}))}constructor(C){super(u.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=u;function h(M){return new Promise((C,O)=>{const W=(0,L.createServer)();W.on("error",O),W.listen(M,()=>{W.removeListener("error",O),C(new u(W))})})}e.serve=h;function I(M,C){return new Promise((O,W)=>{const q=(0,L.createConnection)(M,()=>{q.removeListener("error",W),O(S.Client.fromSocket(new w(q,`ipc-client${C}`),C))});q.once("error",W)})}e.connect=I}),define(ee[30],te([0,1,55,9,96,34,107,6]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(A.IEnvironmentService);class d extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}e.EnvironmentMainService=d,ye([E.memoize],d.prototype,"cachedLanguagesPath",null),ye([E.memoize],d.prototype,"backupHome",null),ye([E.memoize],d.prototype,"mainIPCHandle",null),ye([E.memoize],d.prototype,"mainLockfile",null),ye([E.memoize],d.prototype,"disableUpdates",null),ye([E.memoize],d.prototype,"disableKeytar",null),ye([E.memoize],d.prototype,"crossOriginIsolated",null),ye([E.memoize],d.prototype,"codeCachePath",null),ye([E.memoize],d.prototype,"useCodeCache",null)}),define(ee[269],te([0,1,69,32,15,9,4,18,24,189,19,30,33,16,5,188,29,95]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let l=e.BackupMainService=class vt{constructor(y,D,t,a){this.j=y,this.k=D,this.l=t,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(i,s)=>(0,L.isEqual)(i,s,!R.isLinux)}}async initialize(){const y=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(y.emptyWindows),this.d=await this.u((0,c.deserializeWorkspaceInfos)(y)),this.e=await this.v((0,c.deserializeFolderInfos)(y)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.HotExitConfiguration.OFF}q(){return this.s()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(y,D){this.d.some(a=>y.workspace.id===a.workspace.id)||(this.d.push(y),this.C());const t=(0,A.join)(this.c,y.workspace.id);return D?this.t(t,D).then(()=>t):t}async t(y,D){if(await d.Promises.exists(y)&&await this.z(y),await d.Promises.exists(D))try{await d.Promises.rename(D,y)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(y){return this.e.some(D=>this.h.isEqual(y.folderUri,D.folderUri))||(this.e.push(y),this.C()),(0,A.join)(this.c,this.D(y))}registerEmptyWindowBackup(y){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,y.backupFolder))||(this.g.push(y),this.C()),(0,A.join)(this.c,y.backupFolder)}async u(y){if(!Array.isArray(y))return[];const D=new Set,t=[];for(const a of y){const i=a.workspace;if(!(0,r.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const s=(0,A.join)(this.c,i.id);await this.B(s)?i.configPath.scheme!==n.Schemas.file||await d.Promises.exists(i.configPath.fsPath)?t.push(a):await this.z(s):await this.x(s)}}return t}async v(y){if(!Array.isArray(y))return[];const D=[],t=new Set;for(const a of y){const i=a.folderUri,s=this.h.getComparisonKey(i);if(!t.has(s)){t.add(s);const o=(0,A.join)(this.c,this.D(a));await this.B(o)?i.scheme!==n.Schemas.file||await d.Promises.exists(i.fsPath)?D.push(a):await this.z(o):await this.x(o)}}return D}async w(y){if(!Array.isArray(y))return[];const D=[],t=new Set;for(const a of y){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const s=(0,A.join)(this.c,i);await this.B(s)?D.push(a):await this.x(s)}}return D}async x(y){try{await d.Promises.rm(y,d.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let y=(0,g.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,y.id));)y=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:y.id}}async z(y){const D=this.y(),t=(0,A.join)(this.c,D.backupFolder);try{await d.Promises.rename(y,t)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const y=[];for(const D of this.d)await this.A(D)&&y.push(D);for(const D of this.e)await this.A(D)&&y.push(D);return y}A(y){let D;return(0,c.isEmptyWindowBackupInfo)(y)?D=(0,A.join)(this.c,y.backupFolder):(0,w.isFolderBackupInfo)(y)?D=(0,A.join)(this.c,this.D(y)):D=(0,A.join)(this.c,y.workspace.id),this.B(D)}async B(y){try{const D=await d.Promises.readdir(y);for(const t of D)try{if((await d.Promises.readdir((0,A.join)(y,t))).length>0)return!0}catch{}}catch{}return!1}C(){const y={workspaces:this.d.map(({workspace:D,remoteAuthority:t})=>{const a={id:D.id,configURIPath:D.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.e.map(({folderUri:D,remoteAuthority:t})=>{const a={folderUri:D.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:t})=>{const a={backupFolder:D};return t&&(a.remoteAuthority=t),a})};this.m.setItem(vt.a,y)}D(y){const D=y.folderUri;let t;return D.scheme===n.Schemas.file?t=R.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};l.a="backupWorkspaces",e.BackupMainService=l=ye([Q(0,m.IEnvironmentMainService),Q(1,p.IConfigurationService),Q(2,S.ILogService),Q(3,b.IStateService)],l)}),define(ee[20],te([0,1,14,42,7,3,2,4,36,11,6,5,33,30]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var S;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(S||(e.ShutdownReason=S={}));var w;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let r=e.LifecycleMainService=class gt extends R.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(l,v,y){super(),this.v=l,this.w=v,this.y=y,this.c=this.B(new A.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new A.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new A.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new A.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(gt.b),this.j&&this.w.removeItem(gt.b)}C(){const l=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",l);const v=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",v),E.app.once("will-quit",y=>{this.L("Lifecycle#app.on(will-quit) - begin"),y.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),E.app.removeListener("before-quit",l),E.app.removeListener("window-all-closed",v),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}D(l){if(this.s)return this.s;const v=this.v;this.L("Lifecycle#onWillShutdown.fire()");const y=[];return this.f.fire({reason:l,join(D,t){v.trace(`Lifecycle#onWillShutdown - begin '${D}'`),y.push(t.finally(()=>{v.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.s=(async()=>{try{await n.Promises.settled(y)}catch(D){this.v.error(D)}try{await this.w.close()}catch(D){this.v.error(D)}})(),this.s}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===l)return;this.L(`lifecycle (main): phase changed (value: ${l})`),this.k=l;const v=this.u.get(this.k);v&&(v.open(),this.u.delete(this.k))}async when(l){if(l<=this.k)return;let v=this.u.get(l);v||(v=new n.Barrier,this.u.set(l,v)),await v.wait()}registerWindow(l){const v=new R.DisposableStore;this.n++,v.add(l.onWillLoad(D=>this.g.fire({window:l,workspace:D.workspace,reason:D.reason})));const y=(0,c.assertIsDefined)(l.win);y.on("close",D=>{const t=l.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${l.id}`),D.preventDefault(),this.unload(l,1).then(a=>{if(a){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(l),l.close()})}),y.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.n--,v.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(l,v){await this.unload(l,3)||l.reload(v)}unload(l,v){const y=this.t.get(l.id);if(y)return y;const D=this.F(l,v).finally(()=>{this.t.delete(l.id)});return this.t.set(l.id,D),D}async F(l,v){if(!l.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${l.id}`);const y=this.i?2:v,D=await this.I(l,y);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.G(D)):(await this.J(l,y),!1)}G(l){return l?(this.H(!0),this.i=!1,!0):!1}H(l){this.r&&(this.r(l),this.r=void 0,this.p=void 0)}I(l,v){return new Promise(y=>{const D=this.m++,t=`vscode:ok${D}`,a=`vscode:cancel${D}`;L.validatedIpcMain.once(t,()=>{y(!1)}),L.validatedIpcMain.once(a,()=>{y(!0)}),l.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:v})})}J(l,v){return new Promise(y=>{const t=`vscode:reply${this.m++}`;L.validatedIpcMain.once(t,()=>y()),l.send("vscode:onWillUnload",{replyChannel:t,reason:v})})}quit(l){return this.L(`Lifecycle#quit() - begin (willRestart: ${l})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(l&&this.w.setItem(gt.b,!0),this.p=new Promise(v=>{this.r=v,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(l){this.y.args["enable-smoke-test-driver"]?this.v.info(l):this.v.trace(l)}async relaunch(l){this.L("Lifecycle#relaunch()");const v=process.argv.slice(1);if(l?.addArgs&&v.push(...l.addArgs),l?.removeArgs)for(const t of l.removeArgs){const a=v.indexOf(t);a>=0&&v.splice(a,1)}const y=()=>{try{if(P.isWindows){const t=(0,d.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:v})};E.app.once("quit",y),await this.quit(!0)&&E.app.removeListener("quit",y)}async kill(l){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of E.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let y;v.webContents&&!v.webContents.isDestroyed()?y=new Promise(D=>v.once("closed",D)):y=Promise.resolve(),v.destroy(),await y}})()]),E.app.exit(l)}};r.b="lifecycle.quitAndRestart",e.LifecycleMainService=r=ye([Q(0,m.ILogService),Q(1,b.IStateService),Q(2,f.IEnvironmentMainService)],r)}),define(ee[270],te([0,1,4,3,2,6,20]),function(G,e,E,L,n,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,A.createDecorator)("keyboardLayoutMainService");let P=e.KeyboardLayoutMainService=class extends n.Disposable{constructor(p){super(),this.a=this.B(new L.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((m,b)=>{G(["native-keymap"],m,b)});this.c=d(p),E.isCI||p.onDidChangeKeyboardLayout(()=>{this.c=d(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.KeyboardLayoutMainService=P=ye([Q(0,R.ILifecycleMainService)],P);function d(c){const p=c.getKeyMap(),m=c.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:m}}}),define(ee[271],te([0,1,70,96]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,A,R,P,d,c){const p=b=>c(b,void 0),m=E.createConnection({host:n,port:A},()=>{m.removeListener("error",p);const b=Buffer.alloc(16);for(let r=0;r<16;r++)b[r]=Math.round(Math.random()*256);const f=b.toString("base64"),S=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${A}${R}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];m.write(S.join(`\r
`)+`\r
\r
`);const w=r=>{r.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",w),c(void 0,new L.NodeSocket(m,d)))};m.on("data",w)});m.setNoDelay(!0),m.once("error",p)}}}),define(ee[272],te([0,1,239,7,17,13,11,19,34,114,5,52,238,268]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let S=e.RequestService=class extends m.AbstractRequestService{constructor(l,v,y,D){super(!!v.isRemoteServer,D),this.j=l,this.k=v,this.l=y,this.m(),this.B(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const l=this.j.getValue("http");this.f=l?.proxy,this.g=!!l?.proxyStrictSSL,this.h=l?.proxyAuthorization}async request(l,v){const{f:y,g:D}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(s){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(s)))}const a={...process.env,...t},i=l.agent?l.agent:await(0,b.getProxyAgent)(l.url||"",a,{proxyUrl:y,strictSSL:D});return l.agent=i,l.strictSSL=D,this.h&&(l.headers={...l.headers||{},"Proxy-Authorization":this.h}),this.c(l.isChromiumNetwork?"electron":"node",l,()=>r(l,v))}async resolveProxy(l){}};e.RequestService=S=ye([Q(0,P.IConfigurationService),Q(1,d.INativeEnvironmentService),Q(2,p.ILogService),Q(3,p.ILoggerService)],S);async function w(g){return((0,E.parse)(g.url).protocol==="https:"?await new Promise((y,D)=>{G(["https"],y,D)}):await new Promise((y,D)=>{G(["http"],y,D)})).request}async function r(g,l){return L.Promises.withAsyncBody(async(v,y)=>{const D=(0,E.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await w(g),a={hostname:D.hostname,port:D.port?parseInt(D.port):D.protocol==="https:"?443:80,protocol:D.protocol,path:D.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(a.auth=g.user+":"+g.password);const i=t(a,s=>{const o=(0,R.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&o>0&&s.headers.location)r({...g,url:s.headers.location,followRedirects:o-1},l).then(v,y);else{let u=s;!g.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(u=s.pipe((0,f.createGunzip)())),v({res:s,stream:(0,n.streamToBufferReadableStream)(u)})}});i.on("error",y),g.timeout&&i.setTimeout(g.timeout),g.isChromiumNetwork&&i.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&i.write(g.data),i.end(),l.onCancellationRequested(()=>{i.abort(),y(new A.CancellationError)})})}e.nodeRequest=r}),define(ee[273],te([0,1,14,272]),function(G,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(R){return E.net.request}class A extends L.RequestService{request(P,d){return super.request({...P||{},getRawRequest:n,isChromiumNetwork:!0},d)}}e.RequestMainService=A}),define(ee[97],te([0,1,8,48,3,2,34,16,6,20,5,93,265,39,53,38]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,d.createDecorator)("storageMainService");let r=e.StorageMainService=class extends A.Disposable{constructor(v,y,D,t,a,i){super(),this.c=v,this.f=y,this.g=D,this.h=t,this.i=a,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this.B(this.h.onWillShutdown(v=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,y]of this.n)v.join("profileStorage",y.close());for(const[,y]of this.r)v.join("workspaceStorage",y.close())})),this.B(this.g.onWillCreateProfile(v=>{v.join((async()=>{await this.i.exists(v.profile.globalStorageHome)||await this.i.createFolder(v.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(v=>{const y=this.n.get(v.profile.id);y&&v.join(y.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const v=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,L.once)(v.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),v}profileStorage(v){if((0,m.isProfileUsingDefaultStorage)(v))return this.applicationStorage;let y=this.n.get(v.id);if(!y){this.c.trace(`StorageMainService: creating profile storage (${v.name})`),y=this.p(v),this.n.set(v.id,y);const D=this.B(y.onDidChangeStorage(t=>this.b.fire({...t,storage:y,profile:v})));(0,L.once)(y.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${v.name})`),this.n.delete(v.id),D.dispose()})}return y}p(v){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(v,this.k(),this.c,this.i)}workspaceStorage(v){let y=this.r.get(v.id);return y||(this.c.trace(`StorageMainService: creating workspace storage (${v.id})`),y=this.s(v),this.r.set(v.id,y),(0,L.once)(y.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${v.id})`),this.r.delete(v.id)})),y}s(v){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(v,this.k(),this.c,this.f,this.i)}isUsed(v){const y=E.URI.file(v);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(D.path&&this.j.extUri.isEqualOrParent(E.URI.file(D.path),y))return!0;return!1}};e.StorageMainService=r=ye([Q(0,p.ILogService),Q(1,R.IEnvironmentService),Q(2,S.IUserDataProfilesMainService),Q(3,c.ILifecycleMainService),Q(4,P.IFileService),Q(5,w.IUriIdentityService)],r),e.IApplicationStorageMainService=(0,d.createDecorator)("applicationStorageMainService");let g=e.ApplicationStorageMainService=class extends m.AbstractStorageService{constructor(v,y){super(),this.p=v,this.s=y,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(v){if(v===-1)return this.s.applicationStorage.storage}M(v){if(v===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g=ye([Q(0,f.IUserDataProfilesService),Q(1,e.IStorageMainService)],g)}),define(ee[274],te([0,1,70,26,100,271,7,2,19,5,21,235,119,91,4]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(y,D,t,a,i){let s;for(let o=3;o&&(s?.dispose(),s=await new r(y,D,t,a,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));o--);return s}class r extends P.Disposable{constructor(D,t,a,i,s){super(),this.j=t,this.k=s,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=E.createServer(),this.c=new R.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,t=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,n.findFreePortFaster)(D,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const t=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,m.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,s=a.readEntireBuffer();a.dispose(),s.byteLength>0&&D.write(s.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let g=e.BaseTunnelService=class extends b.AbstractTunnelService{constructor(D,t,a,i,s){super(t,s),this.t=D,this.u=a,this.v=i}isPortPrivileged(D){return(0,b.isPortPrivileged)(D,this.k,S.OS,L.release())}r(D,t,a,i,s,o,u,h){const I=this.q(t,a);if(I)return++I.refcount,I.value;if(this.e)return this.s(this.e,t,a,s,o,u,h);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${s}.`);const M={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},C=w(M,i,t,a,s);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,C),C}}};e.BaseTunnelService=g=ye([Q(1,c.ILogService),Q(2,f.ISignService),Q(3,p.IProductService),Q(4,d.IConfigurationService)],g);let l=e.TunnelService=class extends g{constructor(D,t,a,i){super(A.nodeSocketFactory,D,t,a,i)}};e.TunnelService=l=ye([Q(0,c.ILogService),Q(1,f.ISignService),Q(2,p.IProductService),Q(3,d.IConfigurationService)],l);let v=e.SharedTunnelsService=class extends P.Disposable{constructor(D,t,a,i){super(),this.b=D,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(D,t,a,i,s,o,u,h,I){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${o}.`),!this.a.has(D)){const M=new l(this.b,this.f,this.c,this.g);this.B(M),this.a.set(D,M),M.onTunnelClosed(async()=>{(await M.tunnels).length===0&&(M.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(t,a,i,s,o,u,h,I)}};e.SharedTunnelsService=v=ye([Q(0,c.ILogService),Q(1,p.IProductService),Q(2,f.ISignService),Q(3,d.IConfigurationService)],v)}),define(ee[98],te([0,1,7,22,3,19,30,20,5,21,52,47]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(S,w,r){return`${r.updateUrl}/api/update/${S}/${w}/${r.commit}`}e.createUpdateURL=b;let f=e.AbstractUpdateService=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,r,g,l,v,y){this.f=w,this.g=r,this.h=g,this.i=l,this.j=v,this.k=y,this.b=m.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),r=this.m(w);if(!r){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(r),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(m.State.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,E.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},L.CancellationToken.None)).res.statusCode===204}catch(r){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(r);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.AbstractUpdateService=f=ye([Q(0,P.ILifecycleMainService),Q(1,A.IConfigurationService),Q(2,R.IEnvironmentMainService),Q(3,p.IRequestService),Q(4,d.ILogService),Q(5,c.IProductService)],f)}),define(ee[275],te([0,1,14,55,3,2,19,30,20,5,21,52,25,47,98]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=e.DarwinUpdateService=class extends S.AbstractUpdateService{get v(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"error",(g,l)=>l)}get w(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(g,l,v)=>({url:l,version:v,productVersion:v}))}get y(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(g,l,v,y)=>({releaseNotes:l,version:v,productVersion:v,date:y}))}constructor(g,l,v,y,D,t,a){super(g,l,y,D,t,a),this.z=v,this.u=new A.DisposableStore}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const v=(this.state.type==="checking for updates"?this.state.explicit:!0)?g:void 0;this.d(f.State.Idle(1,v))}s(g){let l;this.k.darwinUniversalAssetId?l=this.k.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const v=(0,S.createUpdateURL)(l,g,this.k);try{E.autoUpdater.setFeedURL({url:v})}catch(y){this.j.error("Failed to set update feed URL",y);return}return v}t(g){this.d(f.State.CheckingForUpdates(g)),E.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(f.State.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(f.State.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};ye([L.memoize],w.prototype,"v",null),ye([L.memoize],w.prototype,"w",null),ye([L.memoize],w.prototype,"x",null),ye([L.memoize],w.prototype,"y",null),e.DarwinUpdateService=w=ye([Q(0,d.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,b.ITelemetryService),Q(3,P.IEnvironmentMainService),Q(4,m.IRequestService),Q(5,c.ILogService),Q(6,p.IProductService)],w)}),define(ee[276],te([0,1,50,41,7,3,9,30,20,5,25,47]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,r,g){if(this.f=w,this.g=g,this.a=m.State.Uninitialized,this.b=new A.Emitter,this.onStateChange=this.b.event,r.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(m.State.Idle(this.k())),this.h(30*1e3).then(void 0,l=>this.g.error(l))}h(w=60*60*1e3){return(0,n.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};b=ye([Q(0,d.ILifecycleMainService),Q(1,P.IEnvironmentMainService),Q(2,c.ILogService)],b);let f=e.SnapUpdateService=class extends b{constructor(w,r,g,l,v,y){super(g,l,v),this.o=w,this.p=r,this.q=y;const D=(0,L.watch)(R.dirname(this.o)),t=A.Event.fromNodeEventEmitter(D,"change",(o,u)=>u),a=A.Event.filter(t,o=>o==="current"),s=A.Event.debounce(a,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{s.dispose(),D.close()})}m(){this.d(m.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(m.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(m.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(m.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((g,l)=>(0,L.realpath)(`${R.dirname(this.o)}/current`,(v,y)=>v?l(v):g(y))),r=R.basename(w);return this.p!==r}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=f=ye([Q(2,d.ILifecycleMainService),Q(3,P.IEnvironmentMainService),Q(4,c.ILogService),Q(5,p.ITelemetryService)],f)}),define(ee[277],te([0,1,2,20,53,29,7,28]),function(G,e,E,L,n,A,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let d=e.UserDataProfilesHandler=class extends E.Disposable{constructor(p,m,b){super(),this.a=m,this.b=b,this.B(p.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(p.onBeforeCloseWindow(f=>this.c(f))),this.B(new R.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(p){const m=this.f(p),b=this.a.getProfileForWorkspace(m);b?.isTransient&&(this.a.unsetWorkspace(m,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,A.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const m=this.b.getWindows().map(b=>this.f(b));for(const b of p)m.some(f=>f.id===b.id)||this.a.unsetWorkspace(b,!1)}};e.UserDataProfilesHandler=d=ye([Q(0,L.ILifecycleMainService),Q(1,n.IUserDataProfilesMainService),Q(2,P.IWindowsMainService)],d)}),define(ee[67],te([0,1,14,2,3,5,296,7,15,28,72,25,20,71,40]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function w(l){return typeof l.responseWindowId=="number"}let r=e.UtilityProcess=class ht extends L.Disposable{static getAll(){return Array.from(ht.b.values())}constructor(v,y,D){super(),this.n=v,this.p=y,this.r=D,this.c=String(++ht.a),this.f=this.B(new n.Emitter),this.onStdout=this.f.event,this.g=this.B(new n.Emitter),this.onStderr=this.g.event,this.h=this.B(new n.Emitter),this.onMessage=this.h.event,this.i=this.B(new n.Emitter),this.onExit=this.i.event,this.j=this.B(new n.Emitter),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(v,y){let D;switch(this.m?.correlationId?D=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${v}`:D=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${v}`,y){case p.default.Error:this.n.error(D);break;case p.default.Warning:this.n.warn(D);break;case p.default.Info:this.n.trace(D);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(v){const y=this.u(v,!1);return y&&v.payload&&this.postMessage(v.payload),y}u(v,y){if(!this.t())return!1;this.m=v;const D=`${this.m.type}-${this.c}`,t=d.FileAccess.asFileUri("bootstrap-fork.js").fsPath,a=this.m.args??[],i=this.m.execArgv??[],s=this.m.allowLoadingUnsignedLibraries,o=this.m.forceAllocationsToV8Sandbox,u="pipe",h=this.v(v,y);return this.s("creating new...",p.default.Info),this.k=E.utilityProcess.fork(t,a,{serviceName:D,env:h,execArgv:i,allowLoadingUnsignedLibraries:s,forceAllocationsToV8Sandbox:o,stdio:u}),this.w(this.k,this.m,D,y),!0}v(v,y){const D=v.env?{...v.env}:{...(0,S.deepClone)(process.env)};D.VSCODE_AMD_ENTRYPOINT=v.entryPoint,typeof v.parentLifecycleBound=="number"&&(D.VSCODE_PARENT_PID=String(v.parentLifecycleBound)),y&&(D.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),D.VSCODE_CRASH_REPORTER_PROCESS_TYPE=v.type,(0,f.removeDangerousEnvVariables)(D);for(const t of Object.keys(D))D[t]=String(D[t]);return D}w(v,y,D,t){if(v.stdout){const a=new R.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(v.stdout,"data")(i=>this.f.fire(typeof i=="string"?i:a.write(i))))}if(v.stderr){const a=new R.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(v.stderr,"data")(i=>this.g.fire(typeof i=="string"?i:a.write(i))))}this.B(n.Event.fromNodeEventEmitter(v,"message")(a=>this.h.fire(a))),this.B(n.Event.fromNodeEventEmitter(v,"spawn")(()=>{this.l=v.pid,typeof v.pid=="number"&&ht.b.set(v.pid,{pid:v.pid,name:w(y)?`${y.type} [${y.responseWindowId}]`:y.type}),this.s("successfully created",p.default.Info)})),this.B(n.Event.fromNodeEventEmitter(v,"exit")(a=>{this.s(`received exit event with code ${a}`,p.default.Info),this.i.fire({pid:this.l,code:a,signal:"unknown"}),this.y()})),this.B(n.Event.fromNodeEventEmitter(E.app,"child-process-gone",(a,i)=>({event:a,details:i}))(({details:a})=>{a.type==="Utility"&&a.name===D&&(this.s(`crashed with code ${a.exitCode} and reason '${a.reason}'`,p.default.Error),this.p.publicLog2("utilityprocesscrash",{type:y.type,reason:a.reason,code:a.exitCode,sandboxed:t?"1":"0"}),this.j.fire({pid:this.l,code:a.exitCode,reason:a.reason}),this.y())}))}once(v,y){const D=this.B(this.h.event(t=>{t===v&&(D.dispose(),y())}))}postMessage(v,y){this.k&&this.k.postMessage(v,y)}connect(v){const{port1:y,port2:D}=new E.MessageChannelMain;return this.postMessage(v,[D]),y}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",p.default.Info);const v=process;return typeof v._debugProcess=="function"?(v._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",p.default.Info),this.k.kill()?(this.s("successfully killed the process",p.default.Info),this.y()):this.s("unable to kill the process",p.default.Warning)}y(){typeof this.l=="number"&&ht.b.delete(this.l),this.k=void 0}async waitForExit(v){this.k&&(this.s("waiting to exit...",p.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,P.timeout)(v)]),this.k&&(this.s(`did not exit within ${v}ms, will kill it now...`,p.default.Info),this.kill()))}};r.a=0,r.b=new Map,e.UtilityProcess=r=ye([Q(0,A.ILogService),Q(1,m.ITelemetryService),Q(2,b.ILifecycleMainService)],r);let g=e.WindowUtilityProcess=class extends r{constructor(v,y,D,t){super(v,D,t),this.z=y}start(v){const y=this.z.getWindowById(v.responseWindowId);if(!y?.win||y.win.isDestroyed()||y.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.u(v,y.isSandboxed))return!1;this.C(y.win,v);const t=this.connect(v.payload);return y.win.webContents.postMessage(v.responseChannel,v.responseNonce,[t]),!0}C(v,y){y.windowLifecycleBound&&(this.B(n.Event.filter(this.r.onWillLoadWindow,D=>D.window.win===v)(()=>this.kill())),this.B(n.Event.fromNodeEventEmitter(v,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=g=ye([Q(0,A.ILogService),Q(1,c.IWindowsMainService),Q(2,m.ITelemetryService),Q(3,b.ILifecycleMainService)],g)}),define(ee[278],te([0,1,13,5,20,7,67,28,25]),function(G,e,E,L,n,A,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let c=e.ExtensionHostStarter=class Dt{constructor(m,b,f,S){this.d=m,this.f=b,this.g=f,this.h=S,this.b=new Map,this.c=!1,this.f.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(m){const b=this.b.get(m);if(!b)throw new Error("Unknown extension host!");return b}onDynamicStdout(m){return this.i(m).onStdout}onDynamicStderr(m){return this.i(m).onStderr}onDynamicMessage(m){return this.i(m).onMessage}onDynamicExit(m){return this.i(m).onExit}async createExtensionHost(){if(this.c)throw(0,E.canceled)();const m=String(++Dt.a),b=new R.WindowUtilityProcess(this.d,this.g,this.h,this.f);return this.b.set(m,b),b.onExit(({pid:f,code:S,signal:w})=>{this.d.info(`Extension host with pid ${f} exited with code: ${S}, signal: ${w}.`),setTimeout(()=>{b.dispose(),this.b.delete(m)})}),{id:m}}async start(m,b){if(this.c)throw(0,E.canceled)();this.i(m).start({...b,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:b.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m})}async enableInspectPort(m){if(this.c)throw(0,E.canceled)();const b=this.b.get(m);return b?b.enableInspectPort():!1}async kill(m){if(this.c)throw(0,E.canceled)();const b=this.b.get(m);b&&b.kill()}async _killAllNow(){for(const[,m]of this.b)m.kill()}async _waitForAllExit(m){const b=[];for(const[,f]of this.b)b.push(f.waitForExit(m));return A.Promises.settled(b).then(()=>{})}};c.a=0,e.ExtensionHostStarter=c=ye([Q(0,L.ILogService),Q(1,n.ILifecycleMainService),Q(2,P.IWindowsMainService),Q(3,d.ITelemetryService)],c)}),define(ee[279],te([0,1,42,7,2,30,20,5,39,37,65,67,46,107,11]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=e.SharedProcess=class extends n.Disposable{constructor(g,l,v,y,D,t,a){super(),this.c=g,this.f=l,this.g=v,this.h=y,this.i=D,this.j=t,this.k=a,this.a=new L.Barrier,this.b=void 0,this.r=void 0,this.s=void 0,this.l()}l(){E.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(g,l)=>this.m(g,l)),this.B(this.h.onWillShutdown(()=>this.n()))}async m(g,l){this.i.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const v=await this.connect();if(g.sender.isDestroyed())return v.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[v])}n(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage("vscode:electron-main->shared-process=exit"),this.b=void 0}whenReady(){return this.r||(this.r=(async()=>{await this.t;const g=new L.DeferredPromise;this.b?this.b.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] Overall ready")})()),this.r}get t(){return this.s||(this.s=(async()=>{await this.a.wait(),this.u();const g=new L.DeferredPromise;this.b?this.b.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] IPC ready")})()),this.s}u(){this.b=this.B(new m.UtilityProcess(this.i,b.NullTelemetryService,this.h));const g=(0,f.parseSharedProcessDebugPort)(this.f.args,this.f.isBuilt);let l;g.port&&(l=["--nolazy"],g.break?l.push(`--inspect-brk=${g.port}`):l.push(`--inspect=${g.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.v(),execArgv:l})}v(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(){return await this.t,(0,S.assertIsDefined)(this.b).connect()}};e.SharedProcess=w=ye([Q(1,A.IEnvironmentMainService),Q(2,d.IUserDataProfilesService),Q(3,R.ILifecycleMainService),Q(4,P.ILogService),Q(5,p.ILoggerMainService),Q(6,c.IPolicyService)],w)}),define(ee[280],te([0,1,2,6,5,28,67,25,56,3,7,20]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let b=e.UtilityProcessWorkerMainService=class extends E.Disposable{constructor(w,r,g,l){super(),this.b=w,this.c=r,this.f=g,this.g=l,this.a=new Map}async createWorker(w){const r=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${r})`);const g=this.h(w);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${r})`),this.disposeWorker(w));const l=new f(this.b,this.c,this.f,this.g,w);if(!l.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,l);const v=new p.DeferredPromise;return c.Event.once(l.onDidTerminate)(y=>{y.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${y.code}, signal: ${y.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${y.code}, signal: ${y.signal}`),this.a.delete(g),v.complete({reason:y})}),v.p}h(w){return(0,d.hash)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const r=this.h(w),g=this.a.get(r);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),g.kill(),this.a.delete(r))}};e.UtilityProcessWorkerMainService=b=ye([Q(0,n.ILogService),Q(1,A.IWindowsMainService),Q(2,P.ITelemetryService),Q(3,m.ILifecycleMainService)],b);let f=class extends E.Disposable{constructor(w,r,g,l,v){super(),this.c=w,this.f=r,this.g=g,this.h=l,this.i=v,this.a=this.B(new c.Emitter),this.onDidTerminate=this.a.event,this.b=new R.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const r=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:r,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};f=ye([Q(0,n.ILogService),Q(1,A.IWindowsMainService),Q(2,P.ITelemetryService),Q(3,m.ILifecycleMainService)],f)}),define(ee[281],te([0,1,14,2,4,18,8,19,20,5,33,28,121,29]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=e.WindowsStateHandler=class yt extends L.Disposable{get state(){return this.b}constructor(y,D,t,a,i){super(),this.g=y,this.h=D,this.i=t,this.j=a,this.k=i,this.b=w(this.h.getItem(yt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(y=>this.p(y)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(y=>{y.newCount-y.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(y=>this.p(y))}m(){this.f=!0,this.n()}n(){const y=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.r(i),D.lastActiveWindow.uiState.mode===3&&y.add(D.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.r(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(y.has(D.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):y.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.r(i);return s.uiState.mode===3&&(y.has(s.uiState.display)?n.isMacintosh&&s.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):y.add(s.uiState.display)),s}));const a=g(D);this.h.setItem(yt.a,a),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",a)}p(y){if(this.i.quitRequested)return;const D=this.r(y);y.isExtensionDevelopmentHost&&!y.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!y.isExtensionDevelopmentHost&&y.openedWorkspace&&this.b.openedWindows.forEach(t=>{const a=(0,f.isWorkspaceIdentifier)(y.openedWorkspace)&&t.workspace?.id===y.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&t.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(t.folderUri,y.openedWorkspace.uri);(a||i)&&(t.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(y){return{windowId:y.id,workspace:(0,f.isWorkspaceIdentifier)(y.openedWorkspace)?y.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)?y.openedWorkspace.uri:void 0,backupPath:y.backupPath,remoteAuthority:y.remoteAuthority,uiState:y.serializeWindowState()}}getNewWindowState(y){const D=this.s(y),t=this.k.getValue("window");if(D.mode===3){let a;D.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.i.wasRestarted||t?.restoreFullscreen),a||(D.mode=1)}return D}s(y){const D=this.g.getLastActiveWindow();if(!y.extensionTestsPath){if(y.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=y.workspace;if((0,f.isWorkspaceIdentifier)(u)){const I=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===u.id).map(M=>M.uiState);if(I.length)return I[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(u)){const I=this.state.openedWindows.filter(M=>M.folderUri&&A.extUriBiasedIgnorePathCase.isEqual(M.folderUri,u.uri)).map(M=>M.uiState);if(I.length)return I[0]}else if(y.backupPath){const I=this.state.openedWindows.filter(M=>M.backupPath===y.backupPath).map(M=>M.uiState);if(I.length)return I[0]}const h=this.c||this.state.lastActiveWindow;if(!D&&h)return h.uiState}let t;const a=E.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(n.isMacintosh){const u=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(u)}!t&&D&&(t=E.screen.getDisplayMatching(D.getBounds())),t||(t=E.screen.getPrimaryDisplay()||a[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const s=this.k.getValue("window");let o=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&D){const u=D.serializeWindowState();u.mode===3?i.mode=3:i=u,o=i.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(y){if(this.g.getWindows().length===0)return y;y.x=typeof y.x=="number"?y.x:0,y.y=typeof y.y=="number"?y.y:0;const D=this.g.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===y.x||t.y===y.y);)y.x+=30,y.y+=30;return y}};S.a="windowsState",e.WindowsStateHandler=S=ye([Q(0,m.IWindowsMainService),Q(1,p.IStateService),Q(2,d.ILifecycleMainService),Q(3,c.ILogService),Q(4,P.IConfigurationService)],S);function w(v){const y={openedWindows:[]},D=v||{openedWindows:[]};return D.lastActiveWindow&&(y.lastActiveWindow=r(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(y.lastPluginDevelopmentHostWindow=r(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(y.openedWindows=D.openedWindows.map(t=>r(t))),y}e.restoreWindowsState=w;function r(v){const y={uiState:v.uiState};return v.backupPath&&(y.backupPath=v.backupPath),v.remoteAuthority&&(y.remoteAuthority=v.remoteAuthority),v.folder&&(y.folderUri=R.URI.parse(v.folder)),v.workspaceIdentifier&&(y.workspace={id:v.workspaceIdentifier.id,configPath:R.URI.parse(v.workspaceIdentifier.configURIPath)}),y}function g(v){return{lastActiveWindow:v.lastActiveWindow&&l(v.lastActiveWindow),lastPluginDevelopmentHostWindow:v.lastPluginDevelopmentHostWindow&&l(v.lastPluginDevelopmentHostWindow),openedWindows:v.openedWindows.map(y=>l(y))}}e.getWindowsStateStoreData=g;function l(v){return{workspaceIdentifier:v.workspace&&{id:v.workspace.id,configURIPath:v.workspace.configPath.toString()},folder:v.folderUri&&v.folderUri.toString(),backupPath:v.backupPath,remoteAuthority:v.remoteAuthority,uiState:v.uiState}}}),define(ee[54],te([0,1,14,3,43,2,15,9,18,11,24,187,63,58,30,6,5,53,123,29,94,95]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let t=e.WorkspacesManagementMainService=class extends A.Disposable{constructor(i,s,o,u,h){super(),this.g=i,this.h=s,this.i=o,this.j=u,this.k=h,this.a=this.B(new L.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new L.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await p.Promises.readdir(this.c.fsPath)).map(s=>(0,d.joinPath)(this.c,s,v.UNTITLED_WORKSPACE_NAME));for(const s of i){const o=(0,D.getWorkspaceIdentifier)(s),u=await this.resolveLocalWorkspace(s);u?this.f.push({workspace:o,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,s=>p.Promises.readFile(s,"utf8"))}l(i,s){if(this.m(i)&&i.scheme===R.Schemas.file)try{const o=s(i.fsPath);return o instanceof Promise?o.then(u=>this.n(i,u),u=>{}):this.n(i,o)}catch{return}}m(i){return(0,v.isUntitledWorkspace)(i,this.g)||(0,v.hasWorkspaceFileExtension)(i)}n(i,s){try{const o=this.p(i,s),u=(0,D.getWorkspaceIdentifier)(i);return{id:u.id,configPath:u.configPath,folders:(0,y.toWorkspaceFolders)(o.folders,u.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(i,s){const o=(0,n.parse)(s);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(u=>(0,y.isStoredWorkspaceFolder)(u));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,s){const{workspace:o,storedWorkspace:u}=this.r(i,s),h=o.configPath.fsPath;return await p.Promises.mkdir((0,P.dirname)(h),{recursive:!0}),await p.Promises.writeFile(h,JSON.stringify(u,null,"	")),this.f.push({workspace:o,remoteAuthority:s}),o}r(i=[],s){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,d.joinPath)(this.c,o),h=(0,d.joinPath)(u,v.UNTITLED_WORKSPACE_NAME),I=[];for(const M of i)I.push((0,y.getStoredWorkspaceFolder)(M.uri,!0,M.name,u,d.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(h),storedWorkspace:{folders:I,remoteAuthority:s}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,v.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const s=(0,d.originalFSPath)(i.configPath);try{await p.Promises.rm((0,P.dirname)(s));const o=(0,P.join)(this.g.workspaceStorageHome.fsPath,i.id);await p.Promises.exists(o)&&await p.Promises.writeFile((0,P.join)(o,"obsolete"),""),this.f=this.f.filter(u=>u.workspace.id!==i.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${s} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,s,o){if(!i||!i.win||!i.isReady||!await this.t(i,s,o))return;const h=await this.u(i,(0,D.getWorkspaceIdentifier)(o));if(h)return this.b.fire({window:i,workspace:h.workspace}),h}async t(i,s,o){return o?(0,v.isWorkspaceIdentifier)(i.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,l.findWindowOnWorkspaceOrFolder)(s,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,d.basename)(o)),detail:(0,m.localize)(2,null)},(0,c.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,s){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:s,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:s,remoteAuthority:i.remoteAuthority})),(0,v.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=s,i.config.backupPath=o,{workspace:s,backupPath:o}}};e.WorkspacesManagementMainService=t=ye([Q(0,S.IEnvironmentMainService),Q(1,r.ILogService),Q(2,g.IUserDataProfilesMainService),Q(3,b.IBackupMainService),Q(4,f.IDialogMainService)],t)}),define(ee[124],te([0,1,14,42,22,6,28,29,54,11,5,67]),function(G,e,E,L,n,A,R,P,d,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,A.createDecorator)(e.ID);let b=e.DiagnosticsMainService=class{constructor(S,w,r){this.a=S,this.b=w,this.c=r}async getRemoteDiagnostics(S){const w=this.a.getWindows();return(await Promise.all(w.map(async g=>{const l=g.remoteAuthority;if(!l)return;const v=`vscode:getDiagnosticInfoResponse${g.id}`,y={includeProcesses:S.includeProcesses,folders:S.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(D=>{g.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:v,args:y}),L.validatedIpcMain.once(v,(t,a)=>{a||D({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),D(a)}),setTimeout(()=>{D({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const S=[];for(const r of E.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(r.id);g?S.push(await this.d(g)):S.push(this.e(r))}const w=[];for(const{pid:r,name:g}of m.UtilityProcess.getAll())w.push({pid:r,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:S,pidToNames:w,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(S){const w=await this.f(S),r=(0,c.assertIsDefined)(S.win);return this.e(r,w,S.remoteAuthority)}e(S,w=[],r){return{id:S.id,pid:S.webContents.getOSProcessId(),title:S.getTitle(),folderURIs:w,remoteAuthority:r}}async f(S){const w=[],r=S.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(r))w.push(r.uri);else if((0,P.isWorkspaceIdentifier)(r)){const g=await this.b.resolveLocalWorkspace(r.configPath);g&&g.folders.forEach(v=>{w.push(v.uri)})}return w}};e.DiagnosticsMainService=b=ye([Q(0,R.IWindowsMainService),Q(1,d.IWorkspacesManagementMainService),Q(2,p.ILogService)],b)}),define(ee[59],te([0,1,50,14,26,149,55,3,2,15,9,4,8,102,85,24,100,177,58,30,6,20,5,21,78,28,29,54,17,236,230,33]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u,h,I,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,y.createDecorator)("nativeHostMainService");let O=e.NativeHostMainService=class extends d.Disposable{constructor(q,V,_,ne,re,ue,ce,J,H){super(),this.a=q,this.b=V,this.c=_,this.f=ne,this.g=re,this.h=ue,this.i=ce,this.j=J,this.k=H,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:z,y:X})=>({windowId:j.id,x:z,y:X})),({windowId:j})=>!!this.a.getWindowById(j)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(j,z)=>z.id),j=>!!this.a.getWindowById(j)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(j,z)=>z.id),j=>!!this.a.getWindowById(j)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(j,z)=>z.id),j=>!!this.a.getWindowById(j)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),P.Event.filter(P.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(j,z)=>z.id),j=>!!this.a.getWindowById(j))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.l=this.B(new P.Emitter),this.onDidChangePassword=this.l.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(j,z,X)=>X),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),P.Event.fromNodeEventEmitter(L.screen,"display-added"),P.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(V=>({id:V.id,workspace:V.openedWorkspace??(0,o.toWorkspaceIdentifier)(V.backupPath,V.isExtensionDevelopmentHost),title:V.win?.getTitle()??"",filename:V.getRepresentedFilename(),dirty:V.isDocumentEdited()}))}async getWindowCount(q){return this.a.getWindowCount()}async getActiveWindowId(q){const V=L.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(V)return V.id}openWindow(q,V,_){return Array.isArray(V)?this.m(q,V,_):this.n(q,V)}async m(q,V,_=Object.create(null)){V.length>0&&await this.a.open({context:5,contextWindowId:q,urisToOpen:V,cli:this.f.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,mergeMode:_.mergeMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile})}async n(q,V){await this.a.openEmptyWindow({context:5,contextWindowId:q},V)}async toggleFullScreen(q){this.v(q)?.toggleFullScreen()}async handleTitleDoubleClick(q){this.v(q)?.handleTitleDoubleClick()}async isMaximized(q){const V=this.v(q);return V?.win?V.win.isMaximized():!1}async maximizeWindow(q){const V=this.v(q);V?.win&&V.win.maximize()}async unmaximizeWindow(q){const V=this.v(q);V?.win&&V.win.unmaximize()}async minimizeWindow(q){const V=this.v(q);V?.win&&V.win.minimize()}async updateWindowControls(q,V){const _=this.v(q);_&&_.updateWindowControls(V)}async focusWindow(q,V){V&&typeof V.windowId=="number"&&(q=V.windowId),this.v(q)?.focus({force:V?.force??!1})}async setMinimumSize(q,V,_){const ne=this.v(q);if(ne?.win){const[re,ue]=ne.win.getSize(),[ce,J]=ne.win.getMinimumSize(),[H,j]=[V??ce,_??J],[z,X]=[Math.max(re,H),Math.max(ue,j)];(ce!==H||J!==j)&&ne.win.setMinimumSize(H,j),(re!==z||ue!==X)&&ne.win.setSize(z,X)}}async saveWindowSplash(q,V){this.i.saveWindowSplash(q,V)}async installShellCommand(q){const{source:V,target:_}=await this.p();try{const{symbolicLink:ne}=await w.SymlinkSupport.stat(V);if(ne&&!ne.dangling){const re=await(0,f.realpath)(V);if(_===re)return}await w.Promises.unlink(V)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await w.Promises.symlink(_,V)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:re}=await this.showMessageBox(q,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(re===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${V}'\\" with administrator privileges"`;await(0,A.promisify)(E.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,V))}}}async uninstallShellCommand(q){const{source:V}=await this.p();try{await w.Promises.unlink(V)}catch(_){switch(_.code){case"EACCES":{const{response:ne}=await this.showMessageBox(q,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(ne===0)try{const re=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,A.promisify)(E.exec)(re)}catch{throw new Error((0,g.localize)(7,null,V))}break}case"ENOENT":break;default:throw _}}}async p(){const q=(0,p.resolve)(this.f.appRoot,"bin","code"),V=`/usr/local/bin/${this.h.applicationName}`;if(!await w.Promises.exists(q))throw new Error((0,g.localize)(8,null,q));return{source:V,target:q}}async showMessageBox(q,V){return this.b.showMessageBox(V,this.r(q))}async showSaveDialog(q,V){return this.b.showSaveDialog(V,this.r(q))}async showOpenDialog(q,V){return this.b.showOpenDialog(V,this.r(q))}r(q){const V=this.v(q);if(V?.win)return V.win}async pickFileFolderAndOpen(q,V){const _=await this.b.pickFileFolder(V);_&&await this.s(await Promise.all(_.map(async ne=>await w.SymlinkSupport.existsDirectory(ne)?{folderUri:b.URI.file(ne)}:{fileUri:b.URI.file(ne)})),V,q)}async pickFolderAndOpen(q,V){const _=await this.b.pickFolder(V);_&&await this.s(_.map(ne=>({folderUri:b.URI.file(ne)})),V,q)}async pickFileAndOpen(q,V){const _=await this.b.pickFile(V);_&&await this.s(_.map(ne=>({fileUri:b.URI.file(ne)})),V,q)}async pickWorkspaceAndOpen(q,V){const _=await this.b.pickWorkspace(V);_&&await this.s(_.map(ne=>({workspaceUri:b.URI.file(ne)})),V,q)}async s(q,V,_){await this.a.open({context:3,contextWindowId:_,cli:this.f.args,urisToOpen:q,forceNewWindow:V.forceNewWindow})}async showItemInFolder(q,V){L.shell.showItemInFolder(V)}async setRepresentedFilename(q,V){this.v(q)?.setRepresentedFilename(V)}async setDocumentEdited(q,V){this.v(q)?.setDocumentEdited(V)}async openExternal(q,V){return m.isLinuxSnap?this.t(V):L.shell.openExternal(V),!0}t(q){const V=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR,ne=process.env.GTK_IM_MODULE_FILE,re=process.env.GDK_BACKEND,ue=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX,J=process.env.GSETTINGS_SCHEMA_DIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,delete process.env.GSETTINGS_SCHEMA_DIR,L.shell.openExternal(q),process.env.GDK_PIXBUF_MODULE_FILE=V,process.env.GDK_PIXBUF_MODULEDIR=_,process.env.GTK_IM_MODULE_FILE=ne,process.env.GDK_BACKEND=re,process.env.GIO_MODULE_DIR=ue,process.env.GTK_EXE_PREFIX=ce,process.env.GSETTINGS_SCHEMA_DIR=J}moveItemToTrash(q,V){return L.shell.trashItem(V)}async isAdmin(){let q;return m.isWindows?q=(await new Promise((V,_)=>{G(["native-is-elevated"],V,_)}))():q=process.getuid()===0,q}async writeElevated(q,V,_,ne){const re=await new Promise((ue,ce)=>{G(["@vscode/sudo-prompt"],ue,ce)});return new Promise((ue,ce)=>{const J=[`"${this.u}"`];ne?.unlock&&J.push("--file-chmod"),J.push("--file-write",`"${V.fsPath}"`,`"${_.fsPath}"`);const H={name:this.h.nameLong.replace("-",""),icns:m.isMacintosh&&this.f.isBuilt?(0,p.join)((0,p.dirname)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};re.exec(J.join(" "),H,(j,z,X)=>{z&&this.g.trace(`[sudo-prompt] received stdout: ${z}`),X&&this.g.trace(`[sudo-prompt] received stderr: ${X}`),j?ce(j):ue(void 0)})})}get u(){return m.isWindows?this.f.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,p.join)(this.f.appRoot,"scripts","code-cli.bat"):m.isLinux?this.f.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.h.applicationName}`):(0,p.join)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,p.join)(this.f.appRoot,"bin","code"):(0,p.join)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return S.virtualMachineHint.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return m.isWindows&&(0,I.hasWSLFeatureInstalled)()}async killProcess(q,V,_){process.kill(V,_)}async readClipboardText(q,V){return L.clipboard.readText(V)}async writeClipboardText(q,V,_){return L.clipboard.writeText(V,_)}async readClipboardFindText(q){return L.clipboard.readFindText()}async writeClipboardFindText(q,V){return L.clipboard.writeFindText(V)}async writeClipboardBuffer(q,V,_,ne){return L.clipboard.writeBuffer(V,Buffer.from(_.buffer),ne)}async readClipboardBuffer(q,V){return h.VSBuffer.wrap(L.clipboard.readBuffer(V))}async hasClipboard(q,V,_){return L.clipboard.has(V,_)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(q,V){this.v(q)?.updateTouchBar(V)}async notifyReady(q){this.v(q)?.setReady()}async relaunch(q,V){return this.c.relaunch(V)}async reload(q,V){const _=this.v(q);if(_){if((0,o.isWorkspaceIdentifier)(_.openedWorkspace)){const ne=_.openedWorkspace.configPath;if(ne.scheme===c.Schemas.file&&(await this.k.resolveLocalWorkspace(ne))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.c.reload(_,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(q){this.closeWindowById(q,q)}async closeWindowById(q,V){const _=this.v(V);if(_?.win)return _.win.close()}async quit(q){const V=this.a.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&V.win?V.win.close():this.c.quit()}async exit(q,V){await this.c.kill(V)}async resolveProxy(q,V){return this.v(q)?.win?.webContents?.session?.resolveProxy(V)}findFreePort(q,V,_,ne,re=1){return(0,r.findFreePort)(V,_,ne,re)}async openDevTools(q,V){const _=this.v(q);_?.win&&_.win.webContents.openDevTools(V)}async toggleDevTools(q){const V=this.v(q);V?.win&&V.win.webContents.toggleDevTools()}async sendInputEvent(q,V){const _=this.v(q);_?.win&&(V.type==="mouseDown"||V.type==="mouseUp")&&_.win.webContents.sendInputEvent(V)}async enableSandbox(q,V){V?this.j.setItem("window.experimental.useSandbox",!0):this.j.removeItem("window.experimental.useSandbox")}async profileRenderer(q,V,_){const ne=this.v(q);if(!ne||!ne.win)throw new Error;return await new M.WindowProfiler(ne.win,V,this.g).inspect(_)}async windowsGetStringRegKey(q,V,_,ne){if(!m.isWindows)return;const re=await new Promise((ue,ce)=>{G(["@vscode/windows-registry"],ue,ce)});try{return re.GetStringRegKey(V,_,ne)}catch{return}}v(q){if(typeof q=="number")return this.a.getWindowById(q)}};ye([R.memoize],O.prototype,"u",null),e.NativeHostMainService=O=ye([Q(0,s.IWindowsMainService),Q(1,l.IDialogMainService),Q(2,D.ILifecycleMainService),Q(3,v.IEnvironmentMainService),Q(4,t.ILogService),Q(5,a.IProductService),Q(6,i.IThemeMainService),Q(7,C.IStateService),Q(8,u.IWorkspacesManagementMainService)],O)}),define(ee[282],te([0,1,14,42,26,2,15,4,103,175,87,124,58,30,5,59,76,21,77,79,32,11,33,67,22,8,28,7]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const h="issue.processExplorerWindowState";let I=e.IssueMainService=class Ct{constructor(O,W,q,V,_,ne,re,ue,ce,J,H){this.g=O,this.h=W,this.i=q,this.j=V,this.k=_,this.l=ne,this.m=re,this.n=ue,this.o=ce,this.p=J,this.q=H,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){L.validatedIpcMain.on("vscode:listProcesses",async O=>{const W=[];try{W.push({name:(0,c.localize)(0,null),rootProcess:await(0,d.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(V=>{(0,p.isRemoteDiagnosticError)(V)?W.push({name:V.hostName,rootProcess:V}):V.processes&&W.push({name:V.hostName,rootProcess:V.processes})})}catch(q){this.i.error(`Listing processes failed: ${q}`)}this.t(O,"vscode:listProcessesResponse",W)}),L.validatedIpcMain.on("vscode:workbenchCommand",(O,W)=>{const{id:q,from:V,args:_}=W;let ne;switch(V){case"processExplorer":ne=this.f;break;default:throw new Error(`Unexpected command source: ${V}`)}ne?.webContents.send("vscode:runAction",{id:q,from:V,args:_})}),L.validatedIpcMain.on("vscode:closeProcessExplorer",O=>{this.d?.close()}),L.validatedIpcMain.on("vscode:pidToNameRequest",async O=>{const W=await this.k.getMainDiagnostics(),q=[];for(const V of W.windows)q.push([V.pid,`window [${V.id}] (${V.title})`]);for(const{pid:V,name:_}of a.UtilityProcess.getAll())q.push([V,_]);this.t(O,"vscode:pidToNameResponse",q)})}async openReporter(O){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const W=new A.DisposableStore,q=W.add(this.n.createIPCObjectUrl()),V=this.v(this.c,700,800);this.b=this.u(V,q,{backgroundColor:O.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:O.zoomLevel,alwaysOnTop:!1},"issue-reporter"),q.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:O,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:r.default}),this.b.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,W.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,W.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(O){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const W=new A.DisposableStore,q=W.add(this.n.createIPCObjectUrl()),V=this.p.getItem(h,void 0),_=M(V)?V:this.v(this.f,800,500);this.d=this.u(_,q,{backgroundColor:O.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:O.zoomLevel,alwaysOnTop:!0},"process-explorer"),q.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:O,product:r.default}),this.d.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,W.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,W.dispose())});const ne=()=>{if(!this.d)return;const re=this.d.getSize(),ue=this.d.getPosition();if(!re||!ue)return;const ce={width:re[0],height:re[1],x:ue[0],y:ue[1]};this.p.setItem(h,ce)};this.d.on("moved",ne),this.d.on("resized",ne)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const O=await E.contentTracing.stopRecording(`${(0,y.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,O),buttons:[(0,c.localize)(5,null)]},(0,D.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,O)}async getSystemStatus(){const[O,W]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(O,W)}async $getSystemInfo(){const[O,W]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(O,W)}async $getPerformanceInfo(){try{const[O,W]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(O,W)}catch(O){throw this.i.warn("issueService#getPerformanceInfo ",O.message),O}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(O){this.i.error(O)}}async $showConfirmCloseDialog(){if(this.b){const{response:O}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);O===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:O}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return O===0}return!1}async $getIssueReporterUri(O){if(!this.c)throw new Error("Issue reporter window not available");const W=this.q.getWindowById(this.c.id);if(!W)throw new Error("Window not found");const q=`vscode:triggerIssueUriRequestHandlerResponse${W.id}`;return u.Promises.withAsyncBody(async(V,_)=>{const ne=new i.CancellationTokenSource;W.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:q,extensionId:O}),L.validatedIpcMain.once(q,(re,ue)=>{V(s.URI.parse(ue))});try{await(0,u.timeout)(5e3),ne.cancel(),_(new Error("Timed out waiting for issue reporter URI"))}finally{L.validatedIpcMain.removeHandler(q)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(O){O.isMinimized()&&O.restore(),O.focus()}t(O,W,...q){O.sender.isDestroyed()||O.sender.send(W,...q)}u(O,W,q,V){const _=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:O.width,height:O.height,minWidth:300,minHeight:200,x:O.x,y:O.y,title:q.title,backgroundColor:q.backgroundColor||Ct.a,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${W.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,v.zoomLevelToZoomFactor)(q.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:q.alwaysOnTop,experimentalDarkMode:!0});return _.setMenuBarVisibility(!1),_}v(O,W,q){let V;const _=E.screen.getAllDisplays();if(_.length===1)V=_[0];else{if(P.isMacintosh){const ue=E.screen.getCursorScreenPoint();V=E.screen.getDisplayNearestPoint(ue)}!V&&O&&(V=E.screen.getDisplayMatching(O.getBounds())),V||(V=E.screen.getPrimaryDisplay()||_[0])}const ne=V.bounds,re={width:W,height:q,x:ne.x+ne.width/2-W/2,y:ne.y+ne.height/2-q/2};return ne.width>0&&ne.height>0&&(re.x<ne.x&&(re.x=ne.x),re.y<ne.y&&(re.y=ne.y),re.x>ne.x+ne.width&&(re.x=ne.x),re.y>ne.y+ne.height&&(re.y=ne.y),re.width>ne.width&&(re.width=ne.width),re.height>ne.height&&(re.height=ne.height)),re}};I.a="#1E1E1E",e.IssueMainService=I=ye([Q(1,f.IEnvironmentMainService),Q(2,S.ILogService),Q(3,p.IDiagnosticsService),Q(4,m.IDiagnosticsMainService),Q(5,b.IDialogMainService),Q(6,w.INativeHostMainService),Q(7,l.IProtocolMainService),Q(8,g.IProductService),Q(9,t.IStateService),Q(10,o.IWindowsMainService)],I);function M(C){return typeof C!="object"||C===null?!1:"x"in C&&"y"in C&&"width"in C&&"height"in C}}),define(ee[283],te([0,1,22,19,30,20,5,59,21,52,25,47,98]),function(G,e,E,L,n,A,R,P,d,c,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=e.LinuxUpdateService=class extends b.AbstractUpdateService{constructor(w,r,g,l,v,y,D,t){super(w,r,l,v,y,t),this.e=g,this.u=D}s(w){return(0,b.createUpdateURL)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(m.State.CheckingForUpdates(w)),this.i.request({url:this.a},E.CancellationToken.None).then(c.asJson).then(r=>{!r||!r.url||!r.version||!r.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(m.State.Idle(1))):this.d(m.State.AvailableForDownload(r))}).then(void 0,r=>{this.j.error(r),this.e.publicLog2("update:notAvailable",{explicit:!!w});const g=w?r.message||r:void 0;this.d(m.State.Idle(1,g))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(m.State.Idle(1))}};e.LinuxUpdateService=f=ye([Q(0,A.ILifecycleMainService),Q(1,L.IConfigurationService),Q(2,p.ITelemetryService),Q(3,n.IEnvironmentMainService),Q(4,c.IRequestService),Q(5,R.ILogService),Q(6,P.INativeHostMainService),Q(7,d.IProductService)],f)}),define(ee[284],te([0,1,50,41,26,7,22,55,9,8,135,24,19,30,16,20,5,59,21,52,25,47,98]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(u,h=1e3){for(;!u();)await(0,A.timeout)(h)}let i;function s(){return typeof i>"u"&&(i=L.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=e.Win32UpdateService=class extends t.AbstractUpdateService{get cachePath(){const h=d.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return m.Promises.mkdir(h,{recursive:!0}).then(()=>h)}constructor(h,I,M,C,O,W,q,V,_){super(h,I,C,O,W,_),this.u=M,this.v=q,this.w=V}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(h){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),s()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.createUpdateURL)(I,h,this.k)}t(h){this.a&&(this.d(D.State.CheckingForUpdates(h)),this.i.request({url:this.a},R.CancellationToken.None).then(v.asJson).then(I=>{const M=s();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!h}),this.d(D.State.Idle(M)),Promise.resolve(null)):M===1?(this.d(D.State.AvailableForDownload(I)),Promise.resolve(null)):(this.d(D.State.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>m.Promises.exists(C).then(O=>{if(O)return Promise.resolve(C);const W=I.url,q=I.hash,V=`${C}.tmp`;return this.i.request({url:W},R.CancellationToken.None).then(_=>this.v.writeFile(c.URI.file(V),_.stream)).then(q?()=>(0,p.checksum)(V,I.hash):()=>{}).then(()=>m.Promises.rename(V,C)).then(()=>C)})).then(C=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},O&&I.supportsFastUpdate?this.k.target==="user"?this.p():this.d(D.State.Downloaded(I)):this.d(D.State.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!h});const M=h?I.message||I:void 0;this.d(D.State.Idle(s(),M))}))}async o(h){h.update.url&&this.w.openExternal(void 0,h.update.url),this.d(D.State.Idle(s()))}async B(h){const I=await this.cachePath;return d.join(I,`CodeSetup-${this.k.quality}-${h}.exe`)}async C(h=null){const I=h?W=>!new RegExp(`${this.k.quality}-${h}\\.exe$`).test(W):()=>!0,M=await this.cachePath,O=(await m.Promises.readdir(M)).filter(I).map(async W=>{try{await m.Promises.unlink(d.join(M,W))}catch{}});await Promise.all(O)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const h=this.state.update;this.d(D.State.Updating(h));const I=await this.cachePath;this.e.updateFilePath=d.join(I,`CodeSetup-${this.k.quality}-${h.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(s()))});const C=`${this.k.win32MutexName}-ready`,O=await new Promise((W,q)=>{G(["@vscode/windows-mutex"],W,q)});a(()=>O.isActive(C)).then(()=>this.d(D.State.Ready(h)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?L.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(h){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!I};this.d(D.State.Downloading(M)),this.e={packagePath:h},I?this.k.target==="user"?this.p():this.d(D.State.Downloaded(M)):this.d(D.State.Ready(M))}};ye([P.memoize],o.prototype,"cachePath",null),e.Win32UpdateService=o=ye([Q(0,w.ILifecycleMainService),Q(1,b.IConfigurationService),Q(2,y.ITelemetryService),Q(3,f.IEnvironmentMainService),Q(4,v.IRequestService),Q(5,r.ILogService),Q(6,S.IFileService),Q(7,g.INativeHostMainService),Q(8,l.IProductService)],o)}),define(ee[285],te([0,1,14,7,22,49,3,2,15,9,64,4,8,183,63,19,58,30,62,16,20,5,21,77,243,97,25,134,78,79,28,29,54,121,125,37,33,53,59,245,117,46,92,26,118,65,23]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u,h,I,M,C,O,W,q,V,_,ne,re,ue,ce,J,H,j,z,X,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var oe;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(oe||(oe={}));let ae=e.CodeWindow=class at extends P.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const T=this.Q.profiles.find(k=>k.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&T?T:this.Q.getProfileForWorkspace(this.config.workspace??(0,C.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(T,k,F,N,U,$,x,K,se,de,Ee,De,Se,Ae,ze,ge,we,Me,ie,he,fe){super(),this.M=k,this.N=F,this.O=N,this.P=U,this.Q=$,this.R=x,this.S=K,this.U=se,this.W=de,this.X=Ee,this.Y=De,this.Z=Se,this.ab=Ae,this.bb=ze,this.db=ge,this.eb=we,this.fb=Me,this.gb=ie,this.hb=he,this.ib=fe,this.c=this.B(new R.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new R.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new R.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new R.Emitter),this.onDidClose=this.h.event,this.j=this.B(new R.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.u=void 0,this.v=void 0,this.C=!1,this.D=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.B(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let Ie=!1;{const[Ce,Oe]=this.ub(T.state);this.s=Ce,this.M.trace("window#ctor: using window state",Ce);const Fe=this.s.mode===0||this.s.mode===3;typeof at.b>"u"&&(at.b=this.hb.getItem("window.experimental.useSandbox",!1));const He=this.W.getValue("window");typeof He?.experimental?.useSandbox=="boolean"?Ie=He.experimental.useSandbox:this.eb.quality==="stable"&&at.b?Ie=!0:Ie=this.eb.quality!=="stable",this.n=Ie;const Ne={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.X.getBackgroundColor(),minWidth:I.WindowMinimumSize.WIDTH,minHeight:I.WindowMinimumSize.HEIGHT,show:!Fe,title:this.eb.nameLong,webPreferences:{preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.zoomLevelToZoomFactor)(He?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ie?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};m.isLinux?Ne.icon=(0,c.join)(this.O.appRoot,"resources/linux/code.png"):m.isWindows&&!this.O.isBuilt&&(Ne.icon=(0,c.join)(this.O.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.Bb()&&(Ne.fullscreenable=!1),m.isMacintosh&&(Ne.acceptFirstMouse=!0,He?.clickThroughInactive===!1&&(Ne.acceptFirstMouse=!1));const $e=m.isMacintosh&&He?.nativeTabs===!0;$e&&(Ne.tabbingIdentifier=this.eb.nameShort);const qe=(0,I.getTitleBarStyle)(this.W)==="custom";if(qe&&(Ne.titleBarStyle="hidden",m.isMacintosh||(Ne.frame=!1),(0,I.useWindowControlsOverlay)(this.W))){const We=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),Y=q.Color.fromHex(We).isDarker()?"#FFFFFF":"#000000";Ne.titleBarOverlay={height:29,color:We,symbolColor:Y},this.C=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Ne),(0,p.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,m.isMacintosh&&qe&&this.l.setSheetOffset(22),qe&&(m.isWindows&&(0,I.useWindowControlsOverlay)(this.W)||m.isMacintosh)){const We=this.hb.getItem(at.a);We&&this.updateWindowControls({height:We})}m.isWindows&&qe&&this.l.hookWindowMessage(278,()=>{const[Y,le]=this.l.getPosition(),pe=E.screen.getCursorScreenPoint(),me=pe.x-Y,be=pe.y-le;return(()=>!(me>30&&be>=0&&be<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:me,y:be})),0}),(m.isMacintosh||m.isWindows)&&Oe&&(!$e||E.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(We=>typeof We=="number")&&this.l.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),Fe&&((0,p.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.s.mode===3&&this.xb(!0),this.l.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(Ie)}setRepresentedFilename(T){m.isMacintosh?this.l.setRepresentedFilename(T):this.w=T}getRepresentedFilename(){return m.isMacintosh?this.l.getRepresentedFilename():this.w}setDocumentEdited(T){m.isMacintosh&&this.l.setDocumentEdited(T),this.z=T}isDocumentEdited(){return m.isMacintosh?this.l.isDocumentEdited():!!this.z}focus(T){m.isMacintosh&&T?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.D.length;)this.D.pop()(this);this.f.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.D.push(T)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(T=>{function k(){F.dispose(),N.dispose(),T()}const F=this.onDidClose(()=>k()),N=this.onWillLoad(()=>k())})}kb(T){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:T})),this.l.webContents.on("render-process-gone",(F,N)=>this.nb(2,{...N,sandboxed:T})),this.l.webContents.on("did-fail-load",(F,N,U)=>this.nb(3,{reason:U,exitCode:N,sandboxed:T})),this.l.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.r=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",F=>{this.r&&(this.r.maximized=!0),E.app.emit("browser-window-maximize",F,this.l)}),this.l.on("unmaximize",F=>{this.r&&(this.r.maximized=!1),E.app.emit("browser-window-unmaximize",F,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.B(this.W.onDidChangeConfiguration(F=>this.rb(F))),this.B(this.Y.onDidDeleteUntitledWorkspace(F=>this.qb(F)));const k=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:k},async(F,N)=>{const U=await this.mb();N({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,U)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(T,k){switch(T){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${k?.reason||"<unknown>"}, code: ${k?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${k?.reason||"<unknown>"}, code: ${k?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:T,reason:k?.reason,code:k?.exitCode,sandboxed:k?.sandboxed?"1":"0"}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:F,checkboxChecked:N}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.l);if(F!==2){const U=F===0;await this.pb(U,N)}}else if(T===2)if(m.isWindows&&k?.reason==="launch-failed"&&k.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(k);else{let F;k?F=(0,f.localize)(7,null,k.reason,k.exitCode??"<unknown>"):F=(0,f.localize)(6,null);const{response:N,checkboxChecked:U}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:F,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.l),$=N===0;await this.pb($,U)}break}}async ob(T){const k=[],F=(0,J.isInternalTelemetry)(this.eb,this.W);if((0,J.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&k.push(new ue.OneDataSystemAppender(F,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const U=await(0,z.resolveMachineId)(this.hb,this.M),$={appenders:k,sendErrorTelemetry:!1,commonProperties:(0,H.resolveCommonProperties)((0,j.release)(),(0,j.hostname)(),process.arch,this.eb.commit,this.eb.version,U,F),piiPaths:(0,J.getPiiPathsFromEnvironment)(this.O)};await new ce.TelemetryService($,this.W,this.eb).publicLog2("windowadminerror",{reason:T.reason,code:T.exitCode})}const{response:N}=await this.bb.showMessageBox({type:"error",buttons:[(0,f.localize)(14,null),(0,f.localize)(15,null)],message:(0,f.localize)(16,null),detail:(0,f.localize)(17,null,this.eb.nameLong)},this.l);N===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(k.map(U=>U.flush())),await this.pb(!1,!1)}async pb(T,k){const F=this.r?.workspace;if(k&&F)try{const N=this.U.workspaceStorage(F);await N.init(),N.delete("memento/workbench.parts.editor"),await N.close()}catch(N){this.M.error(N)}if(this.j.fire(),this.l?.destroy(),T&&this.r){let N,U;(0,C.isSingleFolderWorkspaceIdentifier)(F)?N={folderUri:F.uri}:(0,C.isWorkspaceIdentifier)(F)?N={workspaceUri:F.configPath}:U=!0,(0,Z.firstOrDefault)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.O.args,_:[]},urisToOpen:N?[N]:void 0,forceEmpty:U,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}qb(T){this.r?.workspace?.id===T.id&&(this.r.workspace=void 0)}rb(T){if(!T||T.affectsConfiguration("window.menuBarVisibility")){const k=this.Cb();k!==this.t&&(this.t=k,this.Db(k))}if(!T||T.affectsConfiguration("http.proxy")){let k=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;k?.endsWith("/")&&(k=k.substr(0,k.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((k||"").indexOf("@")===-1&&(k!==this.G||F!==this.H)){this.G=k,this.H=F;const N=k||"",U=F?`${F},<local>`:"<local>";this.M.trace(`Setting proxy to '${N}', bypassing '${U}'`),this.l.webContents.session.setProxy({proxyRules:N,proxyBypassRules:U,pacScript:""})}}}addTabbedWindow(T){m.isMacintosh&&T.win&&this.l.addTabbedWindow(T.win)}load(T,k=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!k.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),k.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(T,k),this.jb===0?this.r=T:this.J=T,this.jb=1,this.l.loadURL(d.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const F=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.B(new L.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:T.workspace,reason:k.isReload?3:F?2:1})}sb(T,k){const F=(this.r??this.J)?.userEnv;if(F){const N=(0,l.isLaunchedFromCli)(F)&&!(0,l.isLaunchedFromCli)(T.userEnv),U=this.isExtensionDevelopmentHost;(N||U)&&(T.userEnv={...F,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),k.disableExtensions!==void 0&&(T["disable-extensions"]=k.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this.l.isMaximized(),T.partsSplash=this.X.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),T.perfMarks=(0,p.getMarks)(),this.I.update(T)}async reload(T){const k=Object.assign({},this.r);k.workspace=await this.tb(k),delete k.filesToOpenOrCreate,delete k.filesToDiff,delete k.filesToMerge,delete k.filesToWait,this.isExtensionDevelopmentHost&&T&&(k.verbose=T.verbose,k.debugId=T.debugId,k.extensionEnvironment=T.extensionEnvironment,k["inspect-extensions"]=T["inspect-extensions"],k["inspect-brk-extensions"]=T["inspect-brk-extensions"],k["extensions-dir"]=T["extensions-dir"]),k.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),k.isInitialStartup=!1,k.policiesData=this.P.serialize(),k.continueOn=this.O.continueOn,k.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},k.logLevel=this.N.getLogLevel(),k.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(k,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async tb(T){if((0,C.isWorkspaceIdentifier)(T.workspace)){const k=T.workspace.configPath;if(k.scheme===d.Schemas.file&&!await this.R.exists(k))return}else if((0,C.isSingleFolderWorkspaceIdentifier)(T.workspace)){const k=T.workspace.uri;if(k.scheme===d.Schemas.file&&!await this.R.exists(k))return}return T.workspace}serializeWindowState(){if(!this.l)return(0,W.defaultWindowState)();if(this.isFullScreen){let F;try{F=E.screen.getDisplayMatching(this.getBounds())}catch{}const N=(0,W.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.s.width||N.width,height:this.s.height||N.height,x:this.s.x||0,y:this.s.y||0}}const T=Object.create(null);let k;if(!m.isMacintosh&&this.l.isMaximized()?k=0:k=1,k===0?T.mode=0:T.mode=1,k===1||k===0){let F;k===1?F=this.getBounds():F=this.l.getNormalBounds(),T.x=F.x,T.y=F.y,T.width=F.width,T.height=F.height}return T}updateWindowControls(T){if(T.height&&this.hb.setItem(at.a,T.height),m.isWindows&&this.C)this.l.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0});else if(m.isMacintosh&&T.height!==void 0){const k=(T.height-15)/2;this.l.setTrafficLightPosition({x:k,y:k})}}ub(T){(0,p.mark)("code/willRestoreCodeWindowState");let k=!1;if(T)try{const F=E.screen.getAllDisplays();k=F.length>1,T=this.vb(T,F)}catch(F){this.M.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[T||(0,W.defaultWindowState)(),k]}vb(T,k){if(this.M.trace(`window#validateWindowState: validating window state on ${k.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(k.length===1){const U=this.wb(k[0]);if(U){let $=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!U||(T.x<U.x&&(T.x=U.x),T.y<U.y&&(T.y=U.y))};this.M.trace("window#validateWindowState: 1 monitor working area",U),$(),T.width>U.width&&(T.width=U.width),T.height>U.height&&(T.height=U.height),T.x>U.x+U.width-128&&(T.x=U.x+U.width-T.width),T.y>U.y+U.height-128&&(T.y=U.y+U.height-T.height),$()}return T}if(T.display&&T.mode===3){const U=k.find($=>$.id===T.display);if(U&&typeof U.bounds?.x=="number"&&typeof U.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,W.defaultWindowState)(3);return $.x=U.bounds.x,$.y=U.bounds.y,$}}let F,N;try{F=E.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),N=this.wb(F)}catch{}if(F&&N&&T.x+T.width>N.x&&T.y+T.height>N.y&&T.x<N.x+N.width&&T.y<N.y+N.height)return this.M.trace("window#validateWindowState: multi-monitor working area",N),T}wb(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,k]=this.l.getPosition(),[F,N]=this.l.getSize();return{x:T,y:k,width:F,height:N}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(T){this.Bb()?this.yb(T):this.Ab(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.t&&this.Db(this.t,!1)}get isFullScreen(){return m.isMacintosh&&typeof this.u=="boolean"?this.u:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(T){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(T)}zb(T){m.isMacintosh&&(this.u=T,this.v=new L.DeferredPromise,Promise.race([this.v.p,(0,L.timeout)(1e3)]).finally(()=>this.u=void 0)),this.l.setFullScreen(T)}Ab(T){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(T),this.l.webContents.focus()}Bb(){const T=this.W.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let T=(0,I.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}Db(T,k=!0){m.isMacintosh||(T==="toggle"&&k&&this.send("vscode:showInfoMessage",(0,f.localize)(18,null)),T==="hidden"?setTimeout(()=>{this.Eb(T)}):this.Eb(T))}Eb(T){const k=this.isFullScreen;switch(T){case"classic":this.l.setMenuBarVisibility(!k),this.l.autoHideMenuBar=k;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(T,k,...F){this.isReady?this.send(T,...F):this.ready().then(()=>{k.isCancellationRequested||this.send(T,...F)})}send(T,...k){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this.l.webContents.send(T,...k)}catch(F){this.M.warn(`Error sending IPC message to channel '${T}' of window ${this.k}: ${(0,A.toErrorMessage)(F)}`)}}}updateTouchBar(T){m.isMacintosh&&this.F.forEach((k,F)=>{const N=T[F];k.segments=this.Hb(N)})}Fb(){if(m.isMacintosh){for(let T=0;T<10;T++){const k=this.Gb();this.F.push(k)}this.l.setTouchBar(new E.TouchBar({items:this.F}))}}Gb(T=[]){const k=this.Hb(T),F=new E.TouchBar.TouchBarSegmentedControl({segments:k,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:F.segments[N].id,from:"touchbar"})}});return F}Hb(T=[]){return T.map(F=>{let N;F.icon&&!u.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===d.Schemas.file&&(N=E.nativeImage.createFromPath(b.URI.revive(F.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let U;return typeof F.title=="string"?U=F.title:U=F.title.value,{id:F.id,label:N?void 0:U,icon:N}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};ae.a="windowControlHeight",ae.b=void 0,e.CodeWindow=ae=ye([Q(1,D.ILogService),Q(2,X.ILoggerMainService),Q(3,g.IEnvironmentMainService),Q(4,V.IPolicyService),Q(5,ne.IUserDataProfilesMainService),Q(6,v.IFileService),Q(7,s.IApplicationStorageMainService),Q(8,s.IStorageMainService),Q(9,w.IConfigurationService),Q(10,h.IThemeMainService),Q(11,O.IWorkspacesManagementMainService),Q(12,S.IBackupMainService),Q(13,o.ITelemetryService),Q(14,r.IDialogMainService),Q(15,y.ILifecycleMainService),Q(16,t.IProductService),Q(17,a.IProtocolMainService),Q(18,M.IWindowsMainService),Q(19,_.IStateService),Q(20,re.INativeHostMainService)],ae)}),define(ee[81],te([0,1,14,23,7,3,44,2,15,4,18,8,24,186,6,20,5,97,94,29,54,35]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,S.createDecorator)("workspacesHistoryMainService");let t=e.WorkspacesHistoryMainService=class it extends P.Disposable{constructor(i,s,o,u){super(),this.f=i,this.g=s,this.h=o,this.j=u,this.c=this.B(new A.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let s=[],o=[];for(const h of i)if((0,l.isRecentWorkspace)(h))!this.g.isUntitledWorkspace(h.workspace)&&!this.r(s,h.workspace)&&s.push(h);else if((0,l.isRecentFolder)(h))this.s(s,h.folderUri)||s.push(h);else{const I=this.t(o,h.fileUri),M=h.fileUri.scheme===d.Schemas.file&&it.y.indexOf((0,p.basename)(h.fileUri))>=0;!I&&!M&&(o.push(h),c.isWindows&&h.fileUri.scheme===d.Schemas.file&&E.app.addRecentDocument(h.fileUri.fsPath))}const u=await this.l({workspaces:s,files:o});s=u.workspaces,o=u.files,s.length>it.a&&(s.length=it.a),o.length>it.a&&(o.length=it.a),await this.n({workspaces:s,files:o}),this.c.fire(),c.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const s=I=>{const M=this.p(I);for(const C of i)if(p.extUriBiasedIgnorePathCase.isEqual(C,M))return!1;return!0},o=await this.getRecentlyOpened(),u=o.workspaces.filter(s),h=o.files.filter(s);(u.length!==o.workspaces.length||h.length!==o.files.length)&&(await this.n({files:h,workspaces:u}),this.c.fire(),c.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const s=new D.ResourceMap(h=>p.extUriBiasedIgnorePathCase.getComparisonKey(h));if(i?.workspaces)for(const h of i.workspaces)s.set(this.p(h),h);const o=new D.ResourceMap(h=>p.extUriBiasedIgnorePathCase.getComparisonKey(h));if(i?.files)for(const h of i.files)o.set(this.p(h),h);const u=await this.m();for(const h of u.workspaces){const I=s.get(this.p(h));I?I.label=I.label??h.label:s.set(this.p(h),h)}for(const h of u.files){const I=o.get(this.p(h));I?I.label=I.label??h.label:o.set(this.p(h),h)}return{workspaces:[...s.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const s=this.j.get(it.b,-1);if(typeof s=="string")try{i=JSON.parse(s)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,l.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(it.b,JSON.stringify((0,l.toStoreData)(i)),-1,1)}p(i){return(0,l.isRecentFolder)(i)?i.folderUri:(0,l.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,s){return!!i.find(o=>(0,l.isRecentWorkspace)(o)&&o.workspace.id===s.id)}s(i,s){return!!i.find(o=>(0,l.isRecentFolder)(o)&&p.extUriBiasedIgnorePathCase.isEqual(o.folderUri,s))}t(i,s){return!!i.find(o=>p.extUriBiasedIgnorePathCase.isEqual(o.fileUri,s))}async C(){c.isWindows&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!c.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const s=[];for(const h of E.app.getJumpListSettings().removedItems){const I=h.args;if(I){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);M&&s.push(m.URI.parse(M[2]))}}await this.removeRecentlyOpened(s);let o=!1;const u=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.w).map(h=>{const I=(0,l.isRecentWorkspace)(h)?h.workspace:h.folderUri,{title:M,description:C}=this.F(I,h.label);let O;return m.URI.isUri(I)?O=`--folder-uri "${I.toString()}"`:(o=!0,O=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:C.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));u.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:u})}i.push({type:"recent"});try{const s=E.app.setJumpList(i);s&&s!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${s}`)}catch(s){this.f.warn("updateWindowsJumpList#setJumpList",s)}}F(i,s){if(s)return{title:(0,R.splitName)(s).name,description:s};if(m.URI.isUri(i))return{title:(0,p.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,p.basename)(i.configPath);return o.endsWith(v.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-v.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,R.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!c.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),s=[];let o=0;for(let h=0;h<i.workspaces.length&&o<it.u;h++){const I=this.p(i.workspaces[h]);if(I.scheme===d.Schemas.file){const M=(0,p.originalFSPath)(I);await b.Promises.exists(M)&&(s.push(M),o++)}}const u=[];for(let h=0;h<i.files.length&&o<it.v;h++){const I=this.p(i.files[h]);if(I.scheme===d.Schemas.file){const M=(0,p.originalFSPath)(I);if(it.y.includes((0,p.basename)(I))||s.includes(M))continue;await b.Promises.exists(M)&&(u.push(M),o++)}}u.reverse().forEach(h=>E.app.addRecentDocument(h)),s.reverse().forEach(h=>E.app.addRecentDocument(h))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],e.WorkspacesHistoryMainService=t=ye([Q(0,r.ILogService),Q(1,y.IWorkspacesManagementMainService),Q(2,w.ILifecycleMainService),Q(3,g.IApplicationStorageMainService)],t)}),define(ee[286],te([0,1,14,7,22,44,4,8,176,19,30,20,5,225,59,21,33,25,47,79,28,81]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let a=e.Menubar=class bt{constructor(o,u,h,I,M,C,O,W,q,V,_){this.n=o,this.o=u,this.p=h,this.q=I,this.r=M,this.s=C,this.t=O,this.u=W,this.v=q,this.w=V,this.x=_,this.m=Object.create(null),this.g=new L.RunOnceScheduler(()=>this.E(),0),this.h=new L.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.isMacintosh||(0,v.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(bt.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(C,O,W)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(C,O,W)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(C,O,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(W),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(C,O,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(W),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(C,O,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(W),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const u=this.x.requestFeatureUrl;u&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(u,"openUserVoiceUrl"));const h=this.x.reportIssueUrl;h&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(h,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.language){const C=I.indexOf("?")>0?"&":"?";this.Z(`${I}${C}lang=${R.language}`,"openLicenseUrl")}else this.Z(I,"openLicenseUrl")});const M=this.x.privacyStatementUrl;M&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(M,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!R.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,u){this.k=o.menus,this.l=o.keybindings,this.t.setItem(bt.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){R.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){R.isMacintosh&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=E.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(R.isMacintosh?new E.Menu:null);return}const u=new E.Menu;let h;if(R.isMacintosh){const M=new E.Menu;h=new E.MenuItem({label:this.x.nameShort,submenu:M}),this.I(M),u.append(h)}if(R.isMacintosh&&!this.c){this.c=!0;const M=new E.Menu;M.append(new E.MenuItem({label:this.bb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(M)}if(this.K("File")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(1,null)),submenu:M});this.M(M,"File"),u.append(C)}if(this.K("Edit")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(2,null)),submenu:M});this.M(M,"Edit"),u.append(C)}if(this.K("Selection")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(3,null)),submenu:M});this.M(M,"Selection"),u.append(C)}if(this.K("View")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(4,null)),submenu:M});this.M(M,"View"),u.append(C)}if(this.K("Go")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(5,null)),submenu:M});this.M(M,"Go"),u.append(C)}if(this.K("Run")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(6,null)),submenu:M});this.M(M,"Run"),u.append(C)}if(this.K("Terminal")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(7,null)),submenu:M});this.M(M,"Terminal"),u.append(C)}let I;if(this.K("Window")){const M=new E.Menu;I=new E.MenuItem({label:this.bb(d.localize(8,null)),submenu:M,role:"window"}),this.S(M)}if(I&&u.append(I),this.K("Help")){const M=new E.Menu,C=new E.MenuItem({label:this.bb(d.localize(9,null)),submenu:M,role:"help"});this.M(M,"Help"),u.append(C)}u.items&&u.items.length>0?E.Menu.setApplicationMenu(u):E.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const u=this.U(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),h=this.T();let I;if(this.K("Preferences")){const ne=new E.Menu;this.M(ne,"Preferences"),I=new E.MenuItem({label:this.bb(d.localize(11,null)),submenu:ne})}const M=new E.Menu,C=new E.MenuItem({label:d.localize(12,null),role:"services",submenu:M}),O=new E.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new E.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new E.MenuItem({label:d.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.Y("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(ne,re,ue)=>{const ce=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),_=[u];_.push(...h),I&&_.push(i(),I),_.push(i(),C,i(),O,W,q,i(),V),_.forEach(ne=>o.append(ne))}async J(o){if(this.p.getWindowCount()===0)return!0;const u=this.o.getValue("window.confirmBeforeClose");if(u==="always"||u==="keyboardOnly"&&this.Q(o)){const{response:h}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return h===0}return!0}K(o){if(!R.isMacintosh&&(0,v.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,u){u.forEach(h=>{if((0,f.isMenubarMenuItemSeparator)(h))o.append(i());else if((0,f.isMenubarMenuItemSubmenu)(h)){const I=new E.Menu,M=new E.MenuItem({label:this.bb(h.label),submenu:I});this.L(I,h.submenu.items),o.append(M)}else(0,f.isMenubarMenuItemRecentAction)(h)?o.append(this.O(h)):(0,f.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.N(o),R.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[h.id]?o.append(new E.MenuItem(this.Y(h.id,{label:this.bb(h.label),click:this.m[h.id]}))):o.append(this.U(h.label,h.id,!1,h.checked)):o.append(this.U(h.label,h.id,h.enabled!==!1,!!h.checked)):o.append(this.U(h.label,h.id,h.enabled!==!1,!!h.checked)))})}M(o,u){this.k&&this.k[u]&&this.L(o,this.k[u].items)}N(o){const u=this.T();u.length&&(u.forEach(h=>o.append(h)),o.append(i()))}O(o){const u=P.URI.revive(o.uri),h=o.id,I=h==="openRecentFile"?{fileUri:u}:h==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new E.MenuItem(this.Y(h,{label:o.label,click:async(M,C,O)=>{const W=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([u])}},!1))}P(o){return!!(o&&(!R.isMacintosh&&(o.ctrlKey||o.shiftKey)||R.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,u,h){const I={label:this.bb(o),role:h,enabled:!0};return new E.MenuItem(this.X(u,I))}S(o){const u=new E.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),h=new E.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new E.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),M=this.U(d.localize(23,null),"workbench.action.switchWindow"),C=[];this.C&&(C.push(i()),C.push(this.U(d.localize(24,null),"workbench.action.newWindowTab")),C.push(this.R(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.R(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.R(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.R(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,h,i(),M,...C,i(),I].forEach(O=>o.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(d.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(d.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(d.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,u,h,I){const M=this.bb(o),C=typeof u=="function"?u:(_,ne,re)=>{const ue=_?_.userSettingsLabel:null;let ce=u;Array.isArray(u)&&(ce=this.P(re)?u[1]:u[0]),ue&&re.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:ce})},O=typeof h=="boolean"?h:this.p.getWindowCount()>0,W=typeof I=="boolean"?I:!1,q={label:M,click:C,enabled:O};W&&(q.type="checkbox",q.checked=W);let V;return typeof u=="string"?V=u:Array.isArray(u)&&(V=u[0]),R.isMacintosh&&(V==="editor.action.clipboardCutAction"?q.role="cut":V==="editor.action.clipboardCopyAction"?q.role="copy":V==="editor.action.clipboardPasteAction"&&(q.role="paste"),V==="undo"?q.click=this.V(C,{inDevTools:_=>_.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?q.click=this.V(C,{inDevTools:_=>_.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(q.click=this.V(C,{inDevTools:_=>_.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(V,q))}V(o,u){return(h,I,M)=>{const C=E.BrowserWindow.getFocusedWindow();if(!C)return u.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return u.inDevTools(C.webContents.devToolsWebContents);o(h,I||C,M)}}W(o){let u=E.BrowserWindow.getFocusedWindow();if(!u){const I=this.p.getLastActiveWindow();I?.isMinimized()&&(u=I.win)}const h=u?this.p.getWindowById(u.id):void 0;if(h){if(this.v.trace("menubar#runActionInRenderer",o),R.isMacintosh&&!this.q.isBuilt&&!h.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const I={id:o.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",n.CancellationToken.None,I)}else{const I={userSettingsLabel:o.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,I)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,u){const h=typeof o=="string"?this.l[o]:void 0;if(h?.label){if(h.isNative!==!1)u.accelerator=h.label,u.userSettingsLabel=h.userSettingsLabel;else if(typeof u.label=="string"){const I=u.label.indexOf("[");I>=0?u.label=`${u.label.substr(0,I)} [${h.label}]`:u.label=`${u.label} [${h.label}]`}}else u.accelerator=void 0;return u}Y(o,u,h=!u.accelerator){h&&(u=this.X(o,u));const I=u.click;return u.click=(M,C,O)=>{this.ab(o),I?.(M,C,O)},u}Z(o,u){this.w.openExternal(void 0,o),this.ab(u)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,A.mnemonicMenuLabel)(o,!this.B)}};a.a="lastKnownMenubarData",e.Menubar=a=ye([Q(0,l.IUpdateService),Q(1,c.IConfigurationService),Q(2,y.IWindowsMainService),Q(3,p.IEnvironmentMainService),Q(4,g.ITelemetryService),Q(5,D.IWorkspacesHistoryMainService),Q(6,r.IStateService),Q(7,m.ILifecycleMainService),Q(8,b.ILogService),Q(9,S.INativeHostMainService),Q(10,w.IProductService)],a);function i(){return new E.MenuItem({type:"separator"})}}),define(ee[287],te([0,1,6,20,5,286]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let R=e.MenubarMainService=class{constructor(d,c,p){this.b=d,this.c=c,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(A.Menubar)}async updateMenubar(d,c){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(c,d)}};e.MenubarMainService=R=ye([Q(0,E.IInstantiationService),Q(1,L.ILifecycleMainService),Q(2,n.ILogService)],R)}),define(ee[288],te([0,1,14,24,26,23,22,3,32,48,44,2,15,9,64,4,36,18,11,8,184,63,19,58,30,16,6,20,5,76,77,57,33,79,285,123,281,29,95,81,54,78,37,53,65]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u,h,I,M,C,O,W,q,V,_,ne,re,ue,ce,J,H,j,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function X(ae){return(0,ne.isWorkspaceIdentifier)(ae?.workspace)}function Z(ae){return(0,ne.isSingleFolderWorkspaceIdentifier)(ae?.workspace)}let oe=e.WindowsMainService=class ct extends m.Disposable{constructor(B,T,k,F,N,U,$,x,K,se,de,Ee,De,Se,Ae,ze,ge,we){super(),this.k=B,this.l=T,this.m=k,this.n=F,this.r=N,this.s=U,this.t=$,this.u=x,this.v=K,this.w=se,this.z=de,this.C=Ee,this.D=De,this.F=Se,this.G=Ae,this.H=ze,this.I=ge,this.J=we,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new _.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(B=>this.c.fire(B.window))),this.B(this.onDidSignalReadyWindow(B=>{if(B.config?.extensionDevelopmentPath||B.config?.extensionTestsPath){const T=new m.DisposableStore;if(T.add(P.Event.any(B.onDidClose,B.onDidDestroy)(()=>T.dispose())),B.config.extensionDevelopmentPath)for(const k of B.config.extensionDevelopmentPath)T.add(this.I.addValidFileRoot(k));B.config.extensionTestsPath&&T.add(this.I.addValidFileRoot(B.config.extensionTestsPath))}}))}openEmptyWindow(B,T){const k=this.t.args,F=T?.remoteAuthority||void 0,N=!0,U=T?.forceReuseWindow,$=!U;return this.open({...B,cli:k,forceEmpty:N,forceNewWindow:$,forceReuseWindow:U,remoteAuthority:F})}openExistingWindow(B,T){B.focus(),this.M(T,[B])}async open(B){this.m.trace("windowsManager#open"),B.addMode&&(B.initialStartup||!this.getLastActiveWindow())&&(B.addMode=!1);const T=[],k=[],F=[],N=[],U=[];let $,x=0;const K=await this.S(B);this.m.trace("windowsManager#open pathsToOpen",K);for(const Se of K)Z(Se)?B.addMode?T.push(Se):k.push(Se):X(Se)?F.push(Se):Se.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),$.filesToOpenOrCreate.push(Se)):Se.backupPath?U.push({backupFolder:(0,f.basename)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):x++;B.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),B.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&B.waitMarkerFileURI&&($.filesToWait={paths:(0,A.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:B.waitMarkerFileURI}),B.initialStartup?(N.push(...this.D.getUntitledWorkspaces()),F.push(...N),U.push(...this.w.getEmptyWindowBackups())):U.length=0;const{windows:se,filesOpenedInWindow:de}=await this.N(B,F,k,U,x,$,T);if(this.m.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${F.length}, foldersToOpen: ${k.length}, emptyToRestore: ${U.length}, emptyToOpen: ${x})`),se.length>1)if(de)de.focus();else{const Se=this.j.state.lastActiveWindow&&!B.forceEmpty&&!B.cli._.length&&!B.cli["file-uri"]&&!B.cli["folder-uri"]&&!(B.urisToOpen&&B.urisToOpen.length);let Ae=!0,ze=!0;if(Se){const ge=se.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Ae=!1,ze=!1)}if(Ae)for(let ge=se.length-1;ge>=0;ge--){const we=se[ge];if(!(we.openedWorkspace&&N.some(Me=>we.openedWorkspace&&Me.workspace.id===we.openedWorkspace.id)||we.backupPath&&U.some(Me=>we.backupPath&&Me.backupFolder===(0,f.basename)(we.backupPath)))){we.focus(),ze=!1;break}}ze&&se[se.length-1].focus()}const Ee=$&&$.filesToDiff.length>0,De=$&&$.filesToMerge.length>0;if(!se.some(Se=>Se.isExtensionDevelopmentHost)&&!Ee&&!De&&!B.noRecentEntry){const Se=[];for(const Ae of K)X(Ae)&&!Ae.transient?Se.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):Z(Ae)?Se.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Se.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.C.addRecentlyOpened(Se)}return this.M(B,se),se}M(B,T){const k=B.waitMarkerFileURI;B.context===0&&k&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.H.del(k)}catch{}})()}async N(B,T,k,F,N,U,$){const x=[];let K;function se(ge,we){x.push(ge),we&&(K=ge,U=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:Ee}=this.fb(B);if(!B.initialStartup&&$.length>0){const ge=$[0].remoteAuthority,we=this.kb(ge);we&&se(this.P(we,$.map(Me=>Me.workspace.uri)))}const De=k.length+T.length+F.length;if(U&&De===0){const ge=U.filesToOpenOrCreate[0]||U.filesToDiff[0]||U.filesToMerge[3],we=this.getWindows().filter(ie=>U&&(0,g.isEqualAuthority)(ie.remoteAuthority,U.remoteAuthority));let Me;ge?.fileUri&&!Ee&&((B.context===4||B.context===0||B.context===1)&&(Me=await(0,V.findWindowOnFile)(we,ge.fileUri,async ie=>ie.configPath.scheme===b.Schemas.file?this.D.resolveLocalWorkspace(ie.configPath):void 0)),Me||(Me=this.lb(we))),Me?(0,ne.isWorkspaceIdentifier)(Me.openedWorkspace)?T.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?k.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):se(this.O(B,Me,U),!0):se(await this.gb({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:B.forceNewTabbedWindow,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile}),!0)}const Se=(0,A.distinct)(T,ge=>ge.workspace.id);if(Se.length>0){const ge=(0,A.coalesce)(Se.map(we=>(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(ge.length>0){const we=ge[0],Me=(0,g.isEqualAuthority)(U?.remoteAuthority,we.remoteAuthority)?U:void 0;se(this.O(B,we,Me),!!Me),de=!0}for(const we of Se){if(ge.some(he=>he.openedWorkspace&&he.openedWorkspace.id===we.workspace.id))continue;const Me=we.remoteAuthority,ie=(0,g.isEqualAuthority)(U?.remoteAuthority,Me)?U:void 0;se(await this.R(B,we,de,ie),!!ie),de=!0}}const Ae=(0,A.distinct)(k,ge=>g.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Ae.length>0){const ge=(0,A.coalesce)(Ae.map(we=>(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(ge.length>0){const we=ge[0],Me=(0,g.isEqualAuthority)(U?.remoteAuthority,we.remoteAuthority)?U:void 0;se(this.O(B,we,Me),!!Me),de=!0}for(const we of Ae){if(ge.some(he=>(0,ne.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(he.openedWorkspace.uri,we.workspace.uri)))continue;const Me=we.remoteAuthority,ie=(0,g.isEqualAuthority)(U?.remoteAuthority,Me)?U:void 0;se(await this.R(B,we,de,ie),!!ie),de=!0}}const ze=(0,A.distinct)(F,ge=>ge.backupFolder);if(ze.length>0)for(const ge of ze){const we=ge.remoteAuthority,Me=(0,g.isEqualAuthority)(U?.remoteAuthority,we)?U:void 0;se(await this.Q(B,!0,we,Me,ge),!!Me),de=!0}if(x.length===0||U){U&&!N&&N++;const ge=U?U.remoteAuthority:B.remoteAuthority;for(let we=0;we<N;we++)se(await this.Q(B,de,ge,U),!!U),de=!0}return{windows:(0,A.distinct)(x),filesOpenedInWindow:K}}O(B,T,k){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:k}),T.focus();const F={filesToOpenOrCreate:k?.filesToOpenOrCreate,filesToDiff:k?.filesToDiff,filesToMerge:k?.filesToMerge,filesToWait:k?.filesToWait,termProgram:B?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",R.CancellationToken.None,F),T}P(B,T){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),B.focus();const k={foldersToAdd:T};return B.sendWhenReady("vscode:addFolders",R.CancellationToken.None,k),B}Q(B,T,k,F,N){this.m.trace("windowsManager#doOpenEmpty",{restore:!!N,remoteAuthority:k,filesToOpen:F,forceNewWindow:T});let U;return!T&&typeof B.contextWindowId=="number"&&(U=this.getWindowById(B.contextWindowId)),this.gb({userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:k,forceNewWindow:T,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:F,windowToUse:U,emptyWindowBackupInfo:N,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}R(B,T,k,F,N){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:F}),!k&&!N&&typeof B.contextWindowId=="number"&&(N=this.getWindowById(B.contextWindowId)),this.gb({workspace:T.workspace,userEnv:B.userEnv,cli:B.cli,initialStartup:B.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:k,forceNewTabbedWindow:B.forceNewTabbedWindow,filesToOpen:F,windowToUse:N,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async S(B){let T,k=!1,F=!1;if(B.urisToOpen&&B.urisToOpen.length>0?(T=await this.U(B),k=!0):B.forceEmpty?T=[Object.create(null)]:B.cli._.length||B.cli["folder-uri"]||B.cli["file-uri"]?(T=await this.W(B.cli),T.length===0&&T.push(Object.create(null)),k=!0):(T=await this.Y(),T.length===0&&T.push(Object.create(null)),F=!0),!B.addMode&&k){const N=T.filter(U=>Z(U));if(N.length>1){const U=N[0].remoteAuthority;if(N.every($=>(0,g.isEqualAuthority)($.remoteAuthority,U))){const $=await this.D.createUntitledWorkspace(N.map(x=>({uri:x.workspace.uri})));T.push({workspace:$,remoteAuthority:U}),T=T.filter(x=>!Z(x))}}}if(B.initialStartup&&!F&&this.z.getValue("window")?.restoreWindows==="preserve"){const N=await this.Y();T.unshift(...N.filter(U=>X(U)||Z(U)||U.backupPath))}return T}async U(B){const T={gotoLineMode:B.gotoLineMode,remoteAuthority:B.remoteAuthority},k=await Promise.all((0,A.coalesce)(B.urisToOpen||[]).map(async F=>{const N=await this.ab(F,T);if(N)return N.label=F.label,N;const U=this.cb(F);this.G.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:U.scheme===b.Schemas.file?(0,y.localize)(1,null):(0,y.localize)(2,null),detail:U.scheme===b.Schemas.file?(0,y.localize)(3,null,(0,p.getPathLabel)(U,{os:w.OS,tildify:this.t})):(0,y.localize)(4,null,U.toString(!0))},(0,l.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,A.coalesce)(k)}async W(B){const T=[],k={ignoreFileNotFound:!0,gotoLineMode:B.goto,remoteAuthority:B.remote||void 0,forceOpenWorkspaceAsFile:B.diff&&B._.length===2||B.merge&&B._.length===4},F=B["folder-uri"];if(F){const $=await Promise.all(F.map(x=>{const K=this.X(x);if(K)return this.ab({folderUri:K},k)}));T.push(...(0,A.coalesce)($))}const N=B["file-uri"];if(N){const $=await Promise.all(N.map(x=>{const K=this.X(x);if(K)return this.ab((0,ne.hasWorkspaceFileExtension)(x)?{workspaceUri:K}:{fileUri:K},k)}));T.push(...(0,A.coalesce)($))}const U=await Promise.all(B._.map($=>k.remoteAuthority?this.eb($,k):this.db($,k)));return T.push(...(0,A.coalesce)(U)),T}X(B){try{const T=v.URI.parse(B);if(!T.scheme){this.m.error(`Invalid URI input string, scheme missing: ${B}`);return}return T}catch(T){this.m.error(`Invalid URI input string: ${B}, ${T.message}`)}}async Y(){const B=this.Z();switch(B){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];B!=="one"&&T.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&T.push(this.j.state.lastActiveWindow);const k=await Promise.all(T.map(async F=>{if(F.workspace){const N=await this.ab({workspaceUri:F.workspace.configPath},{remoteAuthority:F.remoteAuthority,rejectTransientWorkspaces:!0});if(X(N))return N}else if(F.folderUri){const N=await this.ab({folderUri:F.folderUri},{remoteAuthority:F.remoteAuthority});if(Z(N))return N}else if(B!=="folders"&&F.backupPath)return{backupPath:F.backupPath,remoteAuthority:F.remoteAuthority}}));return(0,A.coalesce)(k)}}}Z(){let B;return this.v.wasRestarted?B="all":(B=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(B)||(B="all")),B}async ab(B,T=Object.create(null)){const k=this.cb(B);return k.scheme===b.Schemas.file?((0,W.isFileToOpen)(B)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.db(k.fsPath,T)):this.bb(B,T)}bb(B,T){let k=this.cb(B);const F=(0,C.getRemoteAuthority)(k)||T.remoteAuthority;if(k=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(k)),(0,W.isFileToOpen)(B)){if(T.gotoLineMode){const{path:N,line:U,column:$}=(0,d.parseLineAndColumnAware)(k.path);return{fileUri:k.with({path:N}),options:{selection:U?{startLineNumber:U,startColumn:$||1}:void 0},remoteAuthority:F}}return{fileUri:k,remoteAuthority:F}}else if((0,W.isWorkspaceToOpen)(B))return{workspace:(0,re.getWorkspaceIdentifier)(k),remoteAuthority:F};return{workspace:(0,re.getSingleFolderWorkspaceIdentifier)(k),remoteAuthority:F}}cb(B){return(0,W.isWorkspaceToOpen)(B)?B.workspaceUri:(0,W.isFolderToOpen)(B)?B.folderUri:B.fileUri}async db(B,T){let k,F;T.gotoLineMode&&({path:B,line:k,column:F}=(0,d.parseLineAndColumnAware)(B)),B=(0,d.sanitizeFilePath)((0,f.normalize)(B),(0,r.cwd)());try{const N=await L.Promises.stat(B);if(N.isFile()){if(!T.forceOpenWorkspaceAsFile){const U=await this.D.resolveLocalWorkspace(v.URI.file(B));if(U)return U.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:s.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:v.URI.file(B),type:s.FileType.File,exists:!0,options:{selection:k?{startLineNumber:k,startColumn:F||1}:void 0}}}else{if(N.isDirectory())return{workspace:(0,re.getSingleFolderWorkspaceIdentifier)(v.URI.file(B),N),type:s.FileType.Directory,exists:!0};if(!w.isWindows&&B==="/dev/null")return{fileUri:v.URI.file(B),type:s.FileType.File,exists:!0}}}catch{const U=v.URI.file(B);if(this.C.removeRecentlyOpened([U]),T.ignoreFileNotFound)return{fileUri:U,type:s.FileType.File,exists:!1}}}eb(B,T){const k=B.charCodeAt(0),F=T.remoteAuthority;let N,U;T.gotoLineMode&&({path:B,line:N,column:U}=(0,d.parseLineAndColumnAware)(B)),k!==47&&((0,d.isWindowsDriveLetter)(k)&&B.charCodeAt(B.charCodeAt(1))===58&&(B=(0,d.toSlashes)(B)),B=`/${B}`);const $=v.URI.from({scheme:b.Schemas.vscodeRemote,authority:F,path:B});if(B.charCodeAt(B.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(B))return T.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:N?{startLineNumber:N,startColumn:U||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,re.getWorkspaceIdentifier)($),remoteAuthority:F};if(T.gotoLineMode||f.posix.basename(B).indexOf(".")!==-1)return{fileUri:$,options:{selection:N?{startLineNumber:N,startColumn:U||1}:void 0},remoteAuthority:F}}return{workspace:(0,re.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:F}}fb(B){const T=this.z.getValue("window"),k=T?.openFoldersInNewWindow||"default",F=T?.openFilesInNewWindow||"off";let N=(B.preferNewWindow||B.forceNewWindow)&&!B.forceReuseWindow;!B.forceNewWindow&&!B.forceReuseWindow&&(k==="on"||k==="off")&&(N=k==="on");let U=!1;return B.forceNewWindow||B.forceReuseWindow?U=!!B.forceNewWindow&&!B.forceReuseWindow:(w.isMacintosh?B.context===1&&(U=!0):B.context!==3&&B.context!==2&&!(B.userEnv&&B.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!B.cli.extensionDevelopmentPath&&(F==="on"||F==="off")&&(U=F==="on")),{openFolderInNewWindow:!!N,openFilesInNewWindow:U}}async openExtensionDevelopmentHostWindow(B,T){const k=(0,V.findWindowOnExtensionDevelopmentPath)(this.getWindows(),B);if(k)return this.v.reload(k,T.cli),k.focus(),[k];let F=T.cli["folder-uri"]||[],N=T.cli["file-uri"]||[],U=T.cli._;if(!U.length&&!F.length&&!N.length&&!T.cli.extensionTestsPath){const K=this.j.state.lastPluginDevelopmentHostWindow,se=K?.workspace??K?.folderUri;se&&(v.URI.isUri(se)?se.scheme===b.Schemas.file?U=[se.fsPath]:F=[se.toString()]:se.configPath.scheme===b.Schemas.file?U=[(0,g.originalFSPath)(se.configPath)]:N=[se.configPath.toString()])}let $=T.remoteAuthority;for(const K of B)if(K.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=v.URI.parse(K),de=(0,C.getRemoteAuthority)(se);de&&($?(0,g.isEqualAuthority)(de,$)||this.m.error("more than one extension development path authority"):$=de)}U=U.filter(K=>{const se=v.URI.file(K);return(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:(0,g.isEqualAuthority)((0,C.getRemoteAuthority)(se),$)}),F=F.filter(K=>{const se=this.X(K);return se&&(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,g.isEqualAuthority)((0,C.getRemoteAuthority)(se),$):!1}),N=N.filter(K=>{const se=this.X(K);return se&&(0,V.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,g.isEqualAuthority)((0,C.getRemoteAuthority)(se),$):!1}),T.cli._=U,T.cli["folder-uri"]=F,T.cli["file-uri"]=N;const x={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!U.length&&!F.length&&!N.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:$,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(x)}async gb(B){const T=this.z.getValue("window"),k=this.getLastActiveWindow(),F=k?.profile??this.u.defaultProfile;let N;!B.forceNewWindow&&!B.forceNewTabbedWindow&&(N=B.windowToUse||k,N&&N.focus());const U={...this.t.args,...B.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:B.emptyWindowBackupInfo?(0,f.join)(this.t.backupHome,B.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:F},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:B.remoteAuthority,workspace:B.workspace,userEnv:{...this.l,...B.userEnv},filesToOpenOrCreate:B.filesToOpen?.filesToOpenOrCreate,filesToDiff:B.filesToOpen?.filesToDiff,filesToMerge:B.filesToOpen?.filesToMerge,filesToWait:B.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:I.default,isInitialStartup:B.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(N){const $=N.config;!U.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=$.extensionDevelopmentPath,U.extensionDevelopmentKind=$.extensionDevelopmentKind,U["enable-proposed-api"]=$["enable-proposed-api"],U.verbose=$.verbose,U["inspect-extensions"]=$["inspect-extensions"],U["inspect-brk-extensions"]=$["inspect-brk-extensions"],U.debugId=$.debugId,U.extensionEnvironment=$.extensionEnvironment,U["extensions-dir"]=$["extensions-dir"],U["disable-extensions"]=$["disable-extensions"]),U.loggers={global:U.loggers.global,window:$?.loggers.window??U.loggers.window}}else{const $=this.j.getNewWindowState(U);(0,S.mark)("code/willCreateCodeWindow");const x=N=this.F.createInstance(q.CodeWindow,{state:$,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,S.mark)("code/didCreateCodeWindow"),B.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(x),ct.a.push(x),this.b.fire(x),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,c.once)(x.onDidSignalReady)(()=>this.c.fire(x)),(0,c.once)(x.onDidClose)(()=>this.jb(x)),(0,c.once)(x.onDidDestroy)(()=>this.f.fire(x)),x.onDidTriggerSystemContextMenu(({x:se,y:de})=>this.h.fire({window:x,x:se,y:de}));const K=(0,l.assertIsDefined)(x.win?.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.v.reload(x)),this.v.registerWindow(x)}return U.windowId=N.id,N.isReady?this.v.unload(N,4).then(async $=>{$||await this.hb(N,U,B,F)}):await this.hb(N,U,B,F),N}async hb(B,T,k,F){if(T.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.w.registerEmptyWindowBackup({backupFolder:k.emptyWindowBackupInfo?.backupFolder??(0,re.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.u.isEnabled()){const N=T.workspace??(0,ne.toWorkspaceIdentifier)(T.backupPath,!1),U=this.ib(k,N,F),$=U instanceof Promise?await U:U;T.profiles.profile=$,T.extensionDevelopmentPath||await this.u.setProfileForWorkspace(N,$)}B.load(T)}ib(B,T,k){return B.forceProfile?this.u.profiles.find(F=>F.name===B.forceProfile)??this.u.createNamedProfile(B.forceProfile):B.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(T)??k}jb(B){const T=ct.a.indexOf(B);ct.a.splice(T,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const B=E.BrowserWindow.getFocusedWindow();if(B)return this.getWindowById(B.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(B){return this.lb(this.getWindows().filter(T=>(0,g.isEqualAuthority)(T.remoteAuthority,B)))}lb(B){const T=Math.max.apply(Math,B.map(k=>k.lastFocusTime));return B.find(k=>k.lastFocusTime===T)}sendToFocused(B,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(B,R.CancellationToken.None,...T)}sendToAll(B,T,k){for(const F of this.getWindows())k&&k.indexOf(F.id)>=0||F.sendWhenReady(B,R.CancellationToken.None,T)}getWindows(){return ct.a}getWindowCount(){return ct.a.length}getWindowById(B){const T=this.getWindows().filter(k=>k.id===B);return(0,A.firstOrDefault)(T)}getWindowByWebContents(B){const T=E.BrowserWindow.fromWebContents(B);if(T)return this.getWindowById(T.id)}};oe.a=[],e.WindowsMainService=oe=ye([Q(2,h.ILogService),Q(3,z.ILoggerMainService),Q(4,O.IStateService),Q(5,H.IPolicyService),Q(6,i.IEnvironmentMainService),Q(7,j.IUserDataProfilesMainService),Q(8,u.ILifecycleMainService),Q(9,D.IBackupMainService),Q(10,t.IConfigurationService),Q(11,ue.IWorkspacesHistoryMainService),Q(12,ce.IWorkspacesManagementMainService),Q(13,o.IInstantiationService),Q(14,a.IDialogMainService),Q(15,s.IFileService),Q(16,M.IProtocolMainService),Q(17,J.IThemeMainService)],oe)}),define(ee[289],te([0,1,63,28,81,54]),function(G,e,E,L,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=e.WorkspacesMainService=class{constructor(d,c,p,m){this.a=d,this.b=c,this.c=p,this.d=m,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,c){const p=this.b.getWindowById(d);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),c)}createUntitledWorkspace(d,c,p){return this.a.createUntitledWorkspace(c,p)}deleteUntitledWorkspace(d,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(d,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(d,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.WorkspacesMainService=R=ye([Q(0,A.IWorkspacesManagementMainService),Q(1,L.IWindowsMainService),Q(2,n.IWorkspacesHistoryMainService),Q(3,E.IBackupMainService)],R)}),define(ee[290],te([0,1,14,42,26,17,49,13,32,48,43,44,2,15,9,4,11,8,31,139,45,153,154,256,157,63,269,19,74,193,87,124,58,108,215,30,62,114,204,229,205,278,110,206,207,16,219,90,73,6,89,213,282,270,258,20,5,287,59,21,57,279,91,33,261,97,92,25,242,117,46,47,248,275,283,276,284,120,250,251,252,254,259,28,288,260,29,94,81,289,54,257,37,227,53,237,52,80,122,263,277,266,7,118,262,222,65,88,280,253,23]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u,h,I,M,C,O,W,q,V,_,ne,re,ue,ce,J,H,j,z,X,Z,oe,ae,B,T,k,F,N,U,$,x,K,se,de,Ee,De,Se,Ae,ze,ge,we,Me,ie,he,fe,Ie,Ce,Oe,Fe,He,Ne,$e,qe,We,Y,le,pe,me,be,Le,Ue,Ke,Ze,Ge,Ye,tt,ot,lt,mt,Rt,Mt,At,Lt,Ot,Tt,Ft,pt,Wt,Ut,Nt,Bt,jt,wt,$t,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=e.CodeApplication=class extends b.Disposable{constructor(ke,Pe,ve,Te,Re,je,Je,Qe,Be,Ve,xe){super(),this.c=ke,this.f=Pe,this.g=ve,this.h=Te,this.i=Re,this.j=je,this.k=Je,this.l=Qe,this.m=Be,this.n=Ve,this.p=xe,this.r(),this.s()}r(){const ke=Be=>Be?.startsWith(`${f.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Be,Ve,xe,Xe)=>ke(Xe.requestingUrl)?xe(Pe.has(Ve)):xe(!1)),E.session.defaultSession.setPermissionCheckHandler((Be,Ve,xe,Xe)=>ke(Xe.requestingUrl)?Pe.has(Ve):!1);const ve=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Te=Be=>{for(let Ve=Be;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Re=Be=>Be.resourceType==="xhr"||Te(Be.frame),je=Be=>{const Ve=Be.frame;if(!Ve||!this.a)return!1;const xe=E.BrowserWindow.getAllWindows();for(const Xe of xe)if(Ve.processId===Xe.webContents.mainFrame.processId)return!0;return!1},Je=(Be,Ve)=>{if(Be.path!=="/index.html")return!0;const xe=Ve.frame;if(!xe||!this.a)return!1;for(const Xe of this.a.getWindows())if(Xe.win&&xe.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Be,Ve)=>{const xe=g.URI.parse(Be.url);return xe.scheme===f.Schemas.vscodeWebview&&!Je(xe,Be)?(this.h.error("Blocked vscode-webview request",Be.url),Ve({cancel:!0})):xe.scheme===f.Schemas.vscodeFileResource&&!je(Be)?(this.h.error("Blocked vscode-file request",Be.url),Ve({cancel:!0})):xe.path.endsWith(".svg")&&!ve.has(xe.scheme)?Ve({cancel:!Re(Be)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Be,Ve)=>{const xe=Be.responseHeaders,Xe=xe["content-type"]||xe["Content-Type"];if(Xe&&Array.isArray(Xe)){const _e=g.URI.parse(Be.url);if(_e.path.endsWith(".svg")&&ve.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(f.Schemas.vscodeRemoteResource)&&Xe.some(rt=>rt.toLowerCase().includes("image/svg")))return Ve({cancel:!Re(Be)})}return Ve({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,S.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(ve=>this.u(ve)),process.on("uncaughtException",ve=>(0,P.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,P.onUnexpectedError)(ve)),this.j.onWillShutdown(()=>this.dispose()),(0,v.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(ve,Te)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Te)}),E.app.on("activate",async(ve,Te)=>{this.h.trace("app#activate"),Te||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(ve,Te)=>{Te.on("will-navigate",Re=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),Te.setWindowOpenHandler(({url:Re})=>(this.b?.openExternal(void 0,Re),{action:"deny"}))});let ke=[],Pe;E.app.on("open-file",(ve,Te)=>{this.h.trace("app#open-file: ",Te),ve.preventDefault(),ke.push((0,Ue.hasWorkspaceFileExtension)(Te)?{workspaceUri:g.URI.file(Te)}:{fileUri:g.URI.file(Te)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),L.validatedIpcMain.handle("vscode:fetchShellEnv",ve=>{const Te=this.a?.getWindowByWebContents(ve.sender);let Re,je;return Te?.config?(Re=Te.config,je={...process.env,...Te.config.userEnv}):(Re=this.i.args,je=process.env),this.L(Re,je,!1)}),L.validatedIpcMain.handle("vscode:writeNlsFile",(ve,Te,Re)=>{const je=this.t([Te]);if(!je||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(je,A.VSBuffer.fromString(Re))}),L.validatedIpcMain.handle("vscode:readNlsFile",async(ve,...Te)=>{const Re=this.t(Te);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Re)).value.toString()}),L.validatedIpcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),L.validatedIpcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),L.validatedIpcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}t(ke){let Pe;for(const ve of ke)typeof ve=="string"&&(typeof Pe!="string"?Pe=ve:Pe=(0,S.join)(Pe,ve));if(!(typeof Pe!="string"||!(0,S.isAbsolute)(Pe)||!(0,d.isEqualOrParent)(Pe,this.i.cachedLanguagesPath,!w.isLinux)))return g.URI.file(Pe)}u(ke){if(ke){const Pe={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.h.error(ke.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const ke=this.n.win32AppUserModelId;w.isWindows&&ke&&E.app.setAppUserModelId(ke);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.h.error(Be)}const Pe=new D.Server;this.j.onWillShutdown(Be=>{Be.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const ve=await(0,Wt.resolveMachineId)(this.l,this.h);this.h.trace(`Resolved machine identifier: ${ve}`);const{sharedProcessReady:Te,sharedProcessClient:Re}=this.D(ve),je=await this.F(ve,Te);this.B(je.createInstance(a.ProxyAuthHandler)),this.B(je.createInstance(Tt.UserDataProfilesHandler)),je.invokeFunction(Be=>this.G(Be,Pe,Re));const Je=je.invokeFunction(Be=>this.v(Be,Pe));this.j.phase=2,await je.invokeFunction(Be=>this.H(Be,Je)),this.j.phase=3,this.I(),this.B(new pt.RunOnceScheduler(()=>{this.B((0,pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(ke,Pe){const ve=this.a=ke.get(me.IWindowsMainService),Te=ke.get($e.IURLService),Re=this.b=ke.get(se.INativeHostMainService),je=this;Te.registerHandler({async handleURL(Xe,_e){return je.C(ve,Te,Xe,_e)}});const Je=this.B(new Le.ActiveWindowManager({onDidOpenWindow:Re.onDidOpenWindow,onDidFocusWindow:Re.onDidFocusWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Qe=new y.StaticRouter(Xe=>Je.getActiveClientId().then(_e=>Xe===_e)),Be=new qe.URLHandlerRouter(Qe,this.h),Ve=Pe.getChannel("urlHandler",Be);Te.registerHandler(new qe.URLHandlerChannelClient(Ve));const xe=this.w();return this.B(new Y.ElectronURLListener(xe?.urls,Te,ve,this.i,this.n,this.h)),xe}w(){const ke=this.i.args["open-url"]?this.i.args._urls||[]:[];ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",ke);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),ke.length+Pe.length===0)return;const ve=[];return{urls:[...ke,...Pe].map(Re=>{try{return{uri:g.URI.parse(Re),originalUrl:Re}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Re);return}}).filter(Re=>{if(!Re)return!1;if(this.y(Re.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Re.uri.toString(!0)),!1;const je=this.z(Re.uri);return je?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Re.uri.toString(!0),je),ve.push(je),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Re.uri.toString(!0)),!0)}),openables:ve}}y(ke){if(ke.authority===f.Schemas.file&&w.isWindows){const{options:Pe,buttonIndeces:ve}=(0,jt.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,m.getPathLabel)(ke,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(ve[E.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}z(ke){if(ke.path){if(ke.authority===f.Schemas.file){const Pe=g.URI.file(ke.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(ke.authority===f.Schemas.vscodeRemote){const Pe=ke.path.indexOf(S.posix.sep,1);if(Pe!==-1){const ve=ke.path.substring(1,Pe),Te=ke.path.substring(Pe),Re=g.URI.from({scheme:f.Schemas.vscodeRemote,authority:ve,path:Te,query:ke.query,fragment:ke.fragment});return(0,Ue.hasWorkspaceFileExtension)(Te)?{workspaceUri:Re}:/:[\d]+$/.test(Te)?{fileUri:Re}:{folderUri:Re}}}}}async C(ke,Pe,ve,Te){if(this.h.trace("app#handleProtocolUrl():",ve.toString(!0),Te),ve.scheme===this.n.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:g.URI.parse(ve.query).path,query:""})),this.y(ve))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0;let Re=!1;const je=new URLSearchParams(ve.query);je.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),je.delete("windowId"),ve=ve.with({query:je.toString()}),Re=!0):w.isMacintosh&&ke.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Re=!0);const Je=je.get("continueOn");Je!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),je.delete("continueOn"),ve=ve.with({query:je.toString()}),this.i.continueOn=Je??void 0);const Qe=this.z(ve);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,ve.toString(!0)),(0,St.firstOrDefault)(await ke.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:Re,gotoLineMode:!0}))?.focus(),!0):Re?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,St.firstOrDefault)(await ke.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ee.getRemoteAuthority)(ve)}))?.ready(),Pe.open(ve,Te)):(this.h.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Te),!1)}D(ke){const Pe=this.B(this.g.createInstance(De.SharedProcess,ke)),ve=(async()=>{this.h.trace("Main->SharedProcess#connect");const Re=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(Re,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),ve))(),sharedProcessClient:ve}}async F(ke,Pe){const ve=new T.ServiceCollection;switch(process.platform){case"win32":ve.set(Ie.IUpdateService,new ae.SyncDescriptor(Ne.Win32UpdateService));break;case"linux":w.isLinuxSnap?ve.set(Ie.IUpdateService,new ae.SyncDescriptor(He.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ie.IUpdateService,new ae.SyncDescriptor(Fe.LinuxUpdateService));break;case"darwin":ve.set(Ie.IUpdateService,new ae.SyncDescriptor(Oe.DarwinUpdateService));break}ve.set(me.IWindowsMainService,new ae.SyncDescriptor(be.WindowsMainService,[ke,this.f],!1));const Te=new O.DialogMainService(this.h,this.n);ve.set(O.IDialogMainService,Te),ve.set(U.ILaunchMainService,new ae.SyncDescriptor(U.LaunchMainService,void 0,!1)),ve.set(C.IDiagnosticsMainService,new ae.SyncDescriptor(C.DiagnosticsMainService,void 0,!1)),ve.set(M.IDiagnosticsService,y.ProxyChannel.toService((0,y.getDelayedChannel)(Pe.then(Je=>Je.getChannel("diagnostics"))))),ve.set(k.IIssueMainService,new ae.SyncDescriptor(F.IssueMainService,[this.f])),ve.set(W.IEncryptionMainService,new ae.SyncDescriptor(q.EncryptionMainService,[ke])),ve.set(N.IKeyboardLayoutMainService,new ae.SyncDescriptor(N.KeyboardLayoutMainService)),ve.set(se.INativeHostMainService,new ae.SyncDescriptor(se.NativeHostMainService,void 0,!1)),ve.set(h.ICredentialsMainService,new ae.SyncDescriptor(tt.CredentialsNativeMainService)),ve.set(le.IWebviewManagerService,new ae.SyncDescriptor(pe.WebviewMainService)),ve.set(K.IMenubarMainService,new ae.SyncDescriptor(K.MenubarMainService)),ve.set(re.IExtensionUrlTrustService,new ae.SyncDescriptor(ue.ExtensionUrlTrustService)),ve.set(ce.IExtensionHostStarter,new ae.SyncDescriptor(J.ExtensionHostStarter)),ve.set(ge.IStorageMainService,new ae.SyncDescriptor(ge.StorageMainService)),ve.set(ge.IApplicationStorageMainService,new ae.SyncDescriptor(ge.ApplicationStorageMainService)),w.isWindows?ve.set(H.IExternalTerminalMainService,new ae.SyncDescriptor(j.WindowsExternalTerminalService)):w.isMacintosh?ve.set(H.IExternalTerminalMainService,new ae.SyncDescriptor(j.MacExternalTerminalService)):w.isLinux&&ve.set(H.IExternalTerminalMainService,new ae.SyncDescriptor(j.LinuxExternalTerminalService));const Re=new o.BackupMainService(this.i,this.k,this.h,this.l);ve.set(s.IBackupMainService,Re);const je=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,Re,Te);if(ve.set(Ye.IWorkspacesManagementMainService,je),ve.set(Ke.IWorkspacesService,new ae.SyncDescriptor(Ge.WorkspacesMainService,void 0,!1)),ve.set(Ze.IWorkspacesHistoryMainService,new ae.SyncDescriptor(Ze.WorkspacesHistoryMainService,void 0,!1)),ve.set($e.IURLService,new ae.SyncDescriptor(We.NativeURLService,void 0,!1)),(0,fe.supportsTelemetry)(this.n,this.i)){const Je=(0,fe.isInternalTelemetry)(this.n,this.k),Qe=(0,y.getDelayedChannel)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Be=new ie.TelemetryAppenderClient(Qe),Ve=(0,we.resolveCommonProperties)((0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,ke,Je),xe=(0,fe.getPiiPathsFromEnvironment)(this.i),Xe={appenders:[Be],commonProperties:Ve,piiPaths:xe,sendErrorTelemetry:!0};ve.set(Me.ITelemetryService,new ae.SyncDescriptor(he.TelemetryService,[Xe],!1))}else ve.set(Me.ITelemetryService,fe.NullTelemetryService);return ve.set(At.IExtensionsProfileScannerService,new ae.SyncDescriptor(Ut.ExtensionsProfileScannerService,void 0,!0)),ve.set(Lt.IExtensionsScannerService,new ae.SyncDescriptor(Ot.ExtensionsScannerService,void 0,!0)),ve.set(wt.IUtilityProcessWorkerMainService,new ae.SyncDescriptor(wt.UtilityProcessWorkerMainService,void 0,!0)),await pt.Promises.settled([Re.initialize(),je.initialize()]),this.g.createChild(ve)}G(ke,Pe,ve){const Te=y.ProxyChannel.fromService(ke.get(U.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Te);const Re=y.ProxyChannel.fromService(ke.get(C.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Re);const je=new lt.PolicyChannel(ke.get(ot.IPolicyService));Pe.registerChannel("policy",je),ve.then(et=>et.registerChannel("policy",je));const Je=this.m.getProvider(f.Schemas.file);(0,r.assertType)(Je instanceof oe.DiskFileSystemProvider);const Qe=new Z.DiskFileSystemProviderChannel(Je,this.h,this.i);Pe.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),ve.then(et=>et.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const Be=y.ProxyChannel.fromService(ke.get(mt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",Be),ve.then(et=>et.registerChannel("userDataProfiles",Be));const Ve=new Rt.RequestChannel(ke.get(Mt.IRequestService));ve.then(et=>et.registerChannel("request",Ve));const xe=new Ce.UpdateChannel(ke.get(Ie.IUpdateService));Pe.registerChannel("update",xe);const Xe=y.ProxyChannel.fromService(ke.get(k.IIssueMainService));Pe.registerChannel("issue",Xe);const _e=y.ProxyChannel.fromService(ke.get(W.IEncryptionMainService));Pe.registerChannel("encryption",_e);const rt=y.ProxyChannel.fromService(ke.get(h.ICredentialsMainService));Pe.registerChannel("credentials",rt);const nt=y.ProxyChannel.fromService(ke.get(Se.ISignService));Pe.registerChannel("sign",nt);const ut=y.ProxyChannel.fromService(ke.get(N.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",ut),this.b=ke.get(se.INativeHostMainService);const It=y.ProxyChannel.fromService(this.b);Pe.registerChannel("nativeHost",It),ve.then(et=>et.registerChannel("nativeHost",It));const zt=y.ProxyChannel.fromService(ke.get(Ke.IWorkspacesService));Pe.registerChannel("workspaces",zt);const qt=y.ProxyChannel.fromService(ke.get(K.IMenubarMainService));Pe.registerChannel("menubar",qt);const Ht=y.ProxyChannel.fromService(ke.get($e.IURLService));Pe.registerChannel("url",Ht);const Vt=y.ProxyChannel.fromService(ke.get(re.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Vt);const xt=y.ProxyChannel.fromService(ke.get(le.IWebviewManagerService));Pe.registerChannel("webview",xt);const Pt=this.B(new ze.StorageDatabaseChannel(this.h,ke.get(ge.IStorageMainService)));Pe.registerChannel("storage",Pt),ve.then(et=>et.registerChannel("storage",Pt));const Gt=this.B(new Ft.ProfileStorageChangesListenerChannel(ke.get(ge.IStorageMainService),ke.get(mt.IUserDataProfilesMainService),this.h));ve.then(et=>et.registerChannel("profileStorageListener",Gt));const Kt=y.ProxyChannel.fromService(ke.get(H.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",Kt);const kt=new Nt.LoggerChannel(ke.get(Bt.ILoggerMainService));Pe.registerChannel("logger",kt),ve.then(et=>et.registerChannel("logger",kt));const Xt=new I.ElectronExtensionHostDebugBroadcastChannel(ke.get(me.IWindowsMainService));Pe.registerChannel("extensionhostdebugservice",Xt);const Jt=y.ProxyChannel.fromService(ke.get(ce.IExtensionHostStarter));Pe.registerChannel(ce.ipcExtensionHostStarterChannelName,Jt);const Yt=y.ProxyChannel.fromService(ke.get(wt.IUtilityProcessWorkerMainService));Pe.registerChannel($t.ipcUtilityProcessWorkerChannelName,Yt)}async H(ke,Pe){const ve=this.a=ke.get(me.IWindowsMainService),Te=(0,_.isLaunchedFromCli)(process.env)?0:4,Re=this.i.args;if(Pe){if(Pe.openables.length>0)return ve.open({context:Te,cli:Re,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const nt of Pe.urls){const ut=new URLSearchParams(nt.uri.query);if(ut.get("windowId")==="_blank")return ut.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ut.toString()}),ve.open({context:Te,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const je=global.macOpenFiles,Je=Re._.length,Qe=!!Re["folder-uri"],Be=!!Re["file-uri"],Ve=Re["skip-add-to-recently-opened"]===!0,xe=Re.wait&&Re.waitMarkerFilePath?g.URI.file(Re.waitMarkerFilePath):void 0,Xe=Re.remote||void 0,_e=Re.profile,rt=Re["profile-temp"];if(!Je&&!Qe&&!Be){if(Re["new-window"]||_e||rt)return ve.open({context:Te,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:rt});if(je.length)return ve.open({context:1,cli:Re,urisToOpen:je.map(nt=>(0,Ue.hasWorkspaceFileExtension)(nt)?{workspaceUri:g.URI.file(nt)}:{fileUri:g.URI.file(nt)}),noRecentEntry:Ve,waitMarkerFileURI:xe,initialStartup:!0})}return ve.open({context:Te,cli:Re,forceNewWindow:Re["new-window"]||!Je&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Ve,waitMarkerFileURI:xe,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:rt})}I(){this.J(),E.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(ke,Pe)=>{Pe({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),this.L(this.i.args,process.env,!0),this.M()}async J(){const ke=this.n.win32MutexName;if(w.isWindows&&ke)try{const Pe=await new Promise((Te,Re)=>{G(["@vscode/windows-mutex"],Te,Re)}),ve=new Pe.Mutex(ke);(0,c.once)(this.j.onWillShutdown)(()=>ve.release())}catch(Pe){this.h.error(Pe)}}async L(ke,Pe,ve){try{return await(0,ne.getResolvedShellEnv)(this.k,this.h,ke,Pe)}catch(Te){const Re=(0,R.toErrorMessage)(Te);ve?this.a?.sendToFocused("vscode:showResolveShellEnvError",Re):this.h.error(Re)}return{}}async M(){try{const Pe=(await this.m.readFile(this.i.argvResource)).value.toString(),ve=JSON.parse((0,p.stripComments)(Pe)),Re=(0,fe.getTelemetryLevel)(this.k)>=1;if(ve["enable-crash-reporter"]===void 0){const je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.generateUuid)()}"`,"}"],Je=Pe.substring(0,Pe.length-2).concat(`,
`,je.join(`
`));await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(Je))}else{const je=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);je!==Pe&&await this.m.writeFile(this.i.argvResource,A.VSBuffer.fromString(je))}}catch(ke){this.h.error(ke)}}};e.CodeApplication=Et=ye([Q(2,B.IInstantiationService),Q(3,x.ILogService),Q(4,V.IEnvironmentMainService),Q(5,$.ILifecycleMainService),Q(6,u.IConfigurationService),Q(7,Ae.IStateService),Q(8,X.IFileService),Q(9,de.IProductService),Q(10,mt.IUserDataProfilesMainService)],Et)}),define(ee[297],te([0,1,14,41,8,23,7,49,13,32,48,44,15,9,64,4,36,27,24,45,96,290,10,19,233,241,30,62,196,16,217,90,73,212,89,20,220,5,76,21,77,264,119,274,52,273,91,240,33,46,78,53,37,228,226,2,38,249,65,221,88,115,247]),function(G,e,E,L,n,A,R,P,d,c,p,m,b,f,S,w,r,g,l,v,y,D,t,a,i,s,o,u,h,I,M,C,O,W,q,V,_,ne,re,ue,ce,J,H,j,z,X,Z,oe,ae,B,T,k,F,N,U,$,x,K,se,de,Ee,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ge){console.error(ge.message),E.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ge,we,Me,ie,he,fe,Ie,Ce]=this.b();try{try{await this.d(Me,Ce,ie,he,Ie)}catch(Oe){throw this.f(Me,Ie,Oe),Oe}await ge.invokeFunction(async Oe=>{const Fe=Oe.get(ne.ILogService),He=Oe.get(V.ILifecycleMainService),Ne=Oe.get(I.IFileService),$e=Oe.get(ne.ILoggerService),qe=await this.e(Fe,Me,He,ge,Ie,!0);return l.Promises.writeFile(Me.mainLockfile,String(process.pid)).catch(We=>{Fe.warn(`app#startup(): Error writing main lockfile: ${We.stack}`)}),fe.logger=$e.createLogger("main",{name:(0,t.localize)(0,null)}),(0,p.once)(He.onWillShutdown)(We=>{Ne.dispose(),ie.dispose(),We.join("instanceLockfile",l.Promises.unlink(Me.mainLockfile).catch(()=>{}))}),ge.createInstance(D.CodeApplication,qe,we).startup()})}catch(Oe){ge.invokeFunction(this.i,Oe)}}b(){const ge=new q.ServiceCollection,we=new $.DisposableStore;process.once("exit",()=>we.dispose());const Me={_serviceBrand:void 0,...re.default};ge.set(ue.IProductService,Me);const ie=new o.EnvironmentMainService(this.j(),Me),he=this.c(ie);ge.set(o.IEnvironmentMainService,ie);const fe=new se.LoggerMainService((0,ne.getLogLevel)(ie),ie.logsHome);ge.set(se.ILoggerMainService,fe);const Ie=new _.BufferLogger(fe.getLogLevel()),Ce=we.add(new de.LogService(Ie,[new ne.ConsoleMainLogger(fe.getLogLevel())]));ge.set(ne.ILogService,Ce);const Oe=new M.FileService(Ce);ge.set(I.IFileService,Oe);const Fe=new C.DiskFileSystemProvider(Ce);Oe.registerProvider(b.Schemas.file,Fe);const He=new K.UriIdentityService(Oe);ge.set(x.IUriIdentityService,He);const Ne=new De.StateService(1,ie,Ce,Oe);ge.set(ae.IStateReadService,Ne),ge.set(ae.IStateService,Ne);const $e=new k.UserDataProfilesMainService(Ne,He,ie,Oe,Ce);ge.set(k.IUserDataProfilesMainService,$e);const qe=w.isWindows&&Me.win32RegValueName?we.add(new N.NativePolicyService(Ce,Me.win32RegValueName)):ie.policyFile?we.add(new U.FilePolicyService(ie.policyFile,Oe,Ce)):new F.NullPolicyService;ge.set(F.IPolicyService,qe);const We=new i.ConfigurationService($e.defaultProfile.settingsResource,Oe,qe,Ce);return ge.set(a.IConfigurationService,We),ge.set(V.ILifecycleMainService,new O.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ge.set(z.IRequestService,new O.SyncDescriptor(X.RequestMainService,void 0,!0)),ge.set(T.IThemeMainService,new O.SyncDescriptor(T.ThemeMainService)),ge.set(Z.ISignService,new O.SyncDescriptor(oe.SignService,void 0,!1)),ge.set(H.ITunnelService,new O.SyncDescriptor(j.TunnelService)),ge.set(ce.IProtocolMainService,new J.ProtocolMainService(ie,$e,Ce)),[new W.InstantiationService(ge,!0),he,ie,We,Ne,Ie,Me,$e]}c(ge){const we={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Me=>{const ie=process.env[Me];typeof ie=="string"&&(we[Me]=ie)}),Object.assign(process.env,we),we}async d(ge,we,Me,ie,he){await R.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsHome.fsPath,we.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(fe=>fe?l.Promises.mkdir(fe,{recursive:!0}):void 0)),ie.init(),Me.initialize()]),we.init()}async e(ge,we,Me,ie,he,fe){let Ie;try{(0,S.mark)("code/willStartMainServer"),Ie=await(0,y.serve)(we.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,p.once)(Me.onWillShutdown)(()=>Ie.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.f(we,he,Ce),Ce;let Oe;try{Oe=await(0,y.connect)(we.mainIPCHandle,"main")}catch($e){if(!fe||w.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.g((0,t.localize)(1,null,he.nameShort),(0,t.localize)(2,null),he),$e;try{(0,L.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ge.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ge,we,Me,ie,he,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const $e=`Running extension tests from the command line is currently only supported if no other instance of ${he.nameShort} is running.`;throw ge.error($e),Oe.dispose(),new Error($e)}let Fe;!we.args.wait&&!we.args.status&&(Fe=setTimeout(()=>{this.g((0,t.localize)(3,null,he.nameShort),(0,t.localize)(4,null),he)},1e4));const He=v.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Ne=v.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return ie.invokeFunction(async()=>{const $e=new s.DiagnosticsService(B.NullTelemetryService,he),qe=await Ne.getMainDiagnostics(),We=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Y=await $e.getDiagnostics(qe,We);throw console.log(Y),new d.ExpectedError});throw w.isWindows&&await this.h(He,ge),ge.trace("Sending env to running instance..."),await He.start(we.args,process.env),Oe.dispose(),Fe&&clearTimeout(Fe),new d.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ge.warn("Warning: The --status argument can only be used if {0} is already running. Please run it again after {0} has started.",he.nameShort),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ie}f(ge,we,Me){if(Me.code==="EACCES"||Me.code==="EPERM"){const ie=(0,A.coalesce)([ge.userDataPath,ge.extensionsPath,y.XDG_RUNTIME_DIR]).map(he=>(0,m.getPathLabel)(n.URI.file(he),{os:w.OS,tildify:ge}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(Me),ie.join(`
`)),we)}}g(ge,we,Me){E.dialog.showMessageBoxSync((0,Ee.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:ge,detail:we},Me).options)}async h(ge,we){if(w.isWindows){const Me=await ge.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Me);try{(await new Promise((ie,he)=>{G(["windows-foreground-love"],ie,he)})).allowSetForegroundWindow(Me)}catch(ie){we.error(ie)}}}i(ge,we){const Me=ge.get(ne.ILogService),ie=ge.get(V.ILifecycleMainService);let he=0;we&&(we.isExpected?we.message&&Me.trace(we.message):(he=1,we.stack?Me.error(we.stack):Me.error(`Startup error: ${we.toString()}`))),ie.kill(he)}j(){const ge=this.k((0,u.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const we=(0,h.createWaitMarkerFileSync)(ge.verbose);we&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",we),ge.waitMarkerFilePath=we)}return ge}k(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const we=this.l(ge._,ge.goto);ge._=we}return ge}l(ge,we){const Me=(0,r.cwd)(),ie=ge.map(Ie=>{let Ce=String(Ie),Oe;we&&(Oe=(0,c.parseLineAndColumnAware)(Ce),Ce=Oe.path),Ce&&(Ce=this.m(Me,Ce));const Fe=(0,c.sanitizeFilePath)(Ce,Me),He=(0,f.basename)(Fe);return He&&!(0,c.isValidBasename)(He)?null:we&&Oe?(Oe.path=Fe,this.n(Oe)):Fe}),he=w.isWindows||w.isMacintosh,fe=(0,A.distinct)(ie,Ie=>Ie&&he?Ie.toLowerCase():Ie||"");return(0,A.coalesce)(fe)}m(ge,we){return w.isWindows&&(we=(0,g.rtrim)(we,'"')),we=(0,g.trim)((0,g.trim)(we," "),"	"),w.isWindows&&(we=(0,f.resolve)(ge,we),we=(0,g.rtrim)(we,".")),we}n(ge){const we=[ge.path];return typeof ge.line=="number"&&we.push(String(ge.line)),typeof ge.column=="number"&&we.push(String(ge.column)),we.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/252e5463d60e63238250799aef7375787f68b4ee/core/vs/code/electron-main/main.js.map
